/*****************************************************************************
 *
 * Program Name:  NetWare 4X ODI Command Enhancements for ANCS .h file
 *
 * Filename:	  ancs.h
 *
 * Date Created:  Oct, 1995
 *
 * Version:		  1.0
 *
 * Programmers:	  Mark Dakins
 *
 * Files used:
 *
 * Date Modified: 
 *
 * Modifications:
 *
 * 981016 mcd  Added ANCS_CMD_RTAG_MSG and ANCS_CMD_RTAG_ERR_MSG. 
 *
 * Comments:	  
 *
 * COPYRIGHT (c) 1987 by Novell, Inc.  All Rights Reserved.
 *
 ****************************************************************************/

#include <odi.h>
#include <odi_nbi.h>
#include <cmsm.h>
#include <cmsmstr.h>
#define LONG UINT32
#define BYTE UINT8
#define DIM_0_OR_1 1

/****************************************************************************/
/* temporary definitions until I am ready to mod odi.h                      */

#define MLID_REMOVE_ADAPTER             05
#define MLID_RESET_ADAPTER              06

#define MLID_REMOVE_DRIVER_INTERFACE    16
#define MLID_SHUTDOWN_DRIVER_INTERFACE  17
#define MLID_RESET_DRIVER_INTERFACE     18

#define MLID_SHUTDOWN_SROUTE            -1

/****************************************************************************/

#define ConsoleCommandSignature			0x4D4F4343			/* 'MOCC' */

#define ANCS_WHITESPACE_TXTMSG   " \t\n"
#define ANCS_SEPARATOR_TXTMSG    " ,\t\n"
#define ANCS_REMOVE_TXTMSG       "REMOVE"
#define ANCS_NETWORK_TXTMSG      "NETWORK"
#define ANCS_INTERFACE_TXTMSG    "INTERFACE"
#define ANCS_ADAPTER_TXTMSG      "ADAPTER"
#define ANCS_RESET_TXTMSG        "RESET"
#define ANCS_SHUTDOWN_TXTMSG     "SHUTDOWN"
#define ANCS_SROUTE_TXTMSG       "SROUTE"

#define ANCS_CMD_RTAG_MSG        "ODI Command Resource Tag"
#define ANCS_CMD_RTAG_ERR_MSG    "MSM: Unable to get command resource tag\r\n"
#define ANCS_BAD_COMMAND_MSG     "??? Unknown Command ???\r\n"
#define ANCS_UNSUPPORTED_FN_MSG  " This function is not supported by this driver.\r\n"
#define ANCS_NO_SUCH_BOARD_MSG   "No Such Board\r\n"
#define ANCS_NO_SUCH_ADAPTER_MSG "No Such Adapter\r\n"
#define ANCS_BAD_PARAM_MSG       "Bad Parameter\r\n"
#define ANCS_FAIL_MSG            "Operation Failed\r\n"
#define ANCS_NOSUCH_MSG          "No Such Driver\r\n"

/****************************************************************************/

extern struct LoadDefinitionStructure *MSMModuleHandle;
extern struct ResourceTagStructure *commandTag;

struct commandParserStructure
{
	struct commandParserStructure *Link;
	UINT32 (*parseRoutine)(
		struct ScreenStruct *systemConsoleScreen,
		MEON_STRING *commandLine);
	struct ResourceTagStructure *resourceTag;
};

/****************************************************************************/
/* Procedures in the NETWARE OS module */

struct ResourceTagStructure *AllocateResourceTag(
		struct LoadDefinitionStructure *LoadRecord,
		void *ResourceDescriptionString,
		UINT32 ResourceSignature);

void	RegisterConsoleCommand(struct commandParserStructure *consoleCommand);

void OutputToScreen (
                     struct ScreenStruct *screenID,
                     MEON_STRING *string);

void	UnRegisterConsoleCommand(struct commandParserStructure *consoleCommand);

/* End of procedures in the NETWARE OS module */
/****************************************************************************/
/* Routines in the ANCS module */

UINT32 CommandParseRoutine(
	struct ScreenStruct *screenID,
	UINT8 *commandLine);

MLID_CONFIG_TABLE *GetLogicalBoard(MEON_STRING *parsePointer, struct ScreenStruct *screenID);

MLID_CONFIG_TABLE *GetAdapter(MEON_STRING *parsePointer, struct ScreenStruct *screenID);

/* End of routines in the ANCS module */
/****************************************************************************/
/* Routines in the MSM module */

UINT32 MSMDriverControlShim(UINT32 function, 
                          UINT32 boardNumber,
                          MLID_CONFIG_TABLE *configTable);

MLID_CONFIG_TABLE *MSMGetConfigFromLogicalBoardNumber(UINT32 boardNumber);
MLID_CONFIG_TABLE *MSMGetConfigFromLogicalBoardName(UINT8 *name);
MLID_CONFIG_TABLE *MSMGetConfigFromAdapterName(
                          UINT8  *name,
                          UINT32 instanceNumber);

/* End of routines in the MSM module */
/****************************************************************************/
