;
;***********************************************************************\
;                                                                       *
; MSMSTRUC.INC                                                          *
;                                                                       *
; Adapter data space and Frame data space structures used by            *
; the MSM and MEDIA modules.                                            *
;                                                                       *
; Written by:   DFS                                                     *
; Date:         November 1990                                           *
;                                                                       *
; 11-04-94 JCP  - Removed 0 Dup(0).                                     *
;                                                                       *
; 28 July 1995 12:46	DGM                                             *
;	Added struc ProtBIOSCallParamStruc for Prottected Mode BIOS calls *
;                                                                       *
; 01 September 1995 14:42   JRT                                         *
;	Added comments about location usage by NWCACS shim.		*
;									*
; 13 August 1996 16:27  JRT						*
;	Removed struc ProtBIOSCallParamStruc.				*
;	Changed MSMVersionNumber to 6, MSMAdapterDataSpace struc is	*
;	changing. Added SMPInterruptCounter to MSMAdapterDataSpace.	*
;									*
; 18 September 1996 14:18  JRT						*
;	Changed MSMVersionNumber to 7. Added timer pointers and		*
;	expansion room to MSMAdapterDataSpace. Added pointers for	*
;	NWCACS shim in MSMAdapterDataSpace and MSMFrameDataSpace.	*
;	Added expansion room to MSMFrameDataSpace.			*
;                                                                       *
; 30 september 1996 AYD                                             	*
;	Added ReRegisterStructure in ADS and separately			*
;                                                                       *
; 10 October 1996 09:01  JRT						*
;	Changed MSMVersionNumber to 8.					*
;									*
; 11 October 1996 14:39  JRT						*
;	Replaced Adapter Data Space Reserved3 with ExtraConfigList.	*
;                                                                       *
; 16 October 1996 14:29  JRT						*
;	Added MSMDelayedWorkToDoStructure struc.			*
;									*
; 22 October 1996 11:16  JRT						*
;	Added support for Second ISR and returned Reserved3.		*
;	Changed MSMVersionNumber to 9.                                  *
;                                                                       *
; 18 November 1996 08:21 JRT                                            *
;       Added comments to MLIDStatusFlags.                              *
;                                                                       *
; 20 November 1996 MCD                                                  *
;       Added definition of ODINEB Parameter Block so MSM code          *
;       call ODINEB entry points.                                       *
;                                                                       *
; 06 December 1996 LON                                                  *
;	Changed MSMVersionNumber to 11 due to including Timer struc     *
;       within adapter data space.                                      *
;                                                                       *
; 16 January 1997 LON                                                   *
;      Added PriorityTxFreeCount to MSMAdapterDataSpace struc. and      *
;      changed the start of the fixed area. MSMVersionNumber is now 12  *
;                                                                       *
; 03 February 1997 JRT                                                  *
;       Replace Temp3 with PhysicalBoardID. Number is used by MSM to    *
;       identify a physical board in multi-processor systems.           *
;                                                                       *
; 27 February 1997 JRT                                                  *
;       Added server loader types.                                      *
;                                                                       *
; 03 October 1997 09:10  JRT                                            *
;       Removed absolute path to include of msm.inc.                    *
;                                                                       *
;                                                                       *
; 30 January 1998 mcd  SPD #177356                                      *
;       Added marcos MSMGetCTCB and MSMRtnCTCB                          *
;                                                                       *
; 19 January 1999 JRT							*
;	SPD #222399 - "When Calling CMSMReRegisterHarewareOptions a bad	*
;	pointer to the Parameter Block is getting passed." Added	*
;	DrvParamBlkPtr to the Adapter Data Space.			*
;									*
; 14 March 2000 mcd                                                     *
;   Added MM_C_HSM_BIT for use in MSMRegisterHardwareOptions as part    *
;   of configuration checks for support of ECB Aux Data.                *
;       (c) Copyright 1991 - 1999 Novell, Inc. All rights reserved.     *
;                                                                       *
;***********************************************************************/
;
USE_BELOW       equ     0

;;include \odi32\inc\aspec331\msm.inc
include msm.inc
;
;***********************************************************************\
;                                                                       *
; The following version number changes when the MSM changes or          *
; anything in this file changes to keep TSM's and MSM in sync.          *
;                                                                       *
; Version 1-4 - MSM/TSM betas for 3rd party adapters.                   *
; Version 5   - MSM/TSM interface locked for NetWare v4.0.              *
; Version 6-11-	MSM/TSM for 3.31 spec beta.				*
; Version 12  -	MSM/TSM for 3.31 spec and newer.			*
;                                                                       *
;***********************************************************************/
;
MSMVersionNumber        equ     12
;
;***********************************************************************\
;                                                                       *
; Resource Tab Table Structure.                                         *
;                                                                       *
;***********************************************************************/
;
RTagTableStructure      struc
        RTagSignature   dd      0
        RTagMessage     dd      0
        RTagPointer     dd      0
RTagTableStructure      ends
;
;***********************************************************************\
;                                                                       *
; MSM Virtual Board Structure.                                          *
;                                                                       *
; This structure contains all the variables unique to each virtual      *
; board and lives directly above the drivers configuration table.       *
;                                                                       *
;***********************************************************************/
;
MSMFrameDataSpace       struc

;
; AdapterLink keeps track of parent adapter structure.
;
        AdapterLink             dd      0
;
;***************************************************************\
;                                                               *
; InternalMediaID                                               *
; Ethernet: 0 = 802.3, 1=E2, 2=802.2, 3=802.2SNAP               *
; Token-RIng: 0 = 802.2(802.5), 1=802.2SNAP                     *
;                                                               *
;***************************************************************/
;
        InternalMediaID         dd      0
;
;***************************************************************\
;                                                               *
; MediaHeaderSize allows media routines to quickly obtain its   *
; proper Header length.                                         *
;                                                               *
; Ethernet: 14 for 802.3 & E2, 17 for 802.2, 22 for 802.2SNAP.  *
; Token-Ring:                                                   *
;                                                               *
;***************************************************************/
;
        MediaHeaderSize         dd      0
        PacketType              db      6 dup (0)
        BitSwapAddressFlag      db      0
;
; MediaSendRoutine -> Media specific start send routine.
;
        MediaSendRoutine        dd      0

;
; Pointer to media parameter block, used by NWCACS (CHSM Shim)
;
	MediaParmBlockPtr	dd	0

;
; Reserver for future table expansion
;
	MediaReserved0		dd	0
	MediaReserved1		dd	0
	MediaReserved2		dd	0
	MediaReserved3		dd	0

;
;***************************************************************\
;                                                               *
; MSM Driver Control Entry point for this virtual board.        *
; This allows MSMDriverControl to determine address of Virtual  *
; adapter and Virtual board by referencing the return address   *
; off of the stack.                                             *
;                                                               *
;***************************************************************/
;
        MSMDriverControlJump    db      0FFh, 15h       ; Absolute Call Indirect
                                dd      OFFSET MSMDriverControlCall
;
;***************************************************************\
;                                                               *
; MSM Driver Send Entry point for this virtual board.           *
; This allows MSMDriverSend to determine address of Virtual     *
; adapter and Virtual board by referencing the return address   *
; off of the stack.                                             *
;                                                               *
;***************************************************************/
;
        MSMDriverSendJump       db      0FFh, 15h
                                dd      OFFSET MSMDriverSendCall
;
;***************************************************************\
;                                                               *
; The following custom table may be used by the media section   *
; as needed.                                                    *
;                                                               *
;***************************************************************/
;
        CustomJump1             db      0FFh, 15h
                                dd      0
        CustomJump2             db      0FFh, 15h
                                dd      0
        CustomJump3             db      0FFh, 15h
                                dd      0
        CustomJump4             db      0FFh, 15h
                                dd      0
        CustomJump5             db      0FFh, 15h
				dd	0


AlignEndVB      db      (4 - OFFSET (AlignEndVB and 3)) and 3 dup (0)

MSMFrameDataSpace       ends
FrameSize               equ     offset AlignEndVB + ((4-OFFSET (AlignEndVB and 3)) and 3)
MSMDriverSendOffset     equ     offset MSMDriverSendJump + 6
MSMDriverControlOffset  equ     offset MSMDriverControlJump + 6

TCBAWARE_AUXDATA_MIN_SGCNT equ 3
ECBAWARE_AUXDATA_MIN_SGCNT equ 2

;NOTE: the following bit is defined here ONLY for configuration checking
; purposes.  No assembly spec HSM is ever allowed to set this bit.
MM_C_HSM_BIT            equ     0800h

        page
;
;
; This structure must be synchronized with TIMER_STRUCTURE in MSM.INC
;
MSM_TIMER_STRUCTURE	struc

MSMTimerNextLink	dd	?	; link to next timer in chain
MSMTimerProcedurePtr	dd	?	; HSM procedure to call
MSMTimerType		dd	?	; Type of timer AES/INT oneshot/cont
MSMTimerInterval	dd	?	; time duration in milliseconds
MSMTimerContext		dd	?	; Adapter Data Space
MSMTimerDelay		dd	?	; time duration in clock tics
MSMTimerET		dd	?	; elapsed time in clock tics

MSM_TIMER_STRUCTURE	ends

;
;***********************************************************************\
;                                                                       *
; MSM Virtual Adapter Structure.                                        *
;                                                                       *
; This structure contains all the variables unique to each virtual      *
; adapter and lives directly above the drivers Virtual Adapter.         *
;                                                                       *
;***********************************************************************/
;
MSMAdapterDataSpace     struc

        InstanceNumber          dd      0
	SMPInterruptCounter     dd      0
        AdapterNodeAddress      db      6 dup (0)
        AdapterLineSpeed        dw      0
        PollingLink             dd      0
        MaxTxFreeCount          dd      0
;
;***************************************************************\
;                                                               *
; Alert String prefix variables.                                *
;                                                               *
;***************************************************************/
;
AlertPointer            dd      0
AlertMessage            db      256 dup (0)
;
;***************************************************************\
;                                                               *
; Interrupt-time Timer Control Block.                           *
;                                                               *
;***************************************************************/
;
TLink                   dd      0               ; Not used by MSM.
TCallBackProcedure      dd      OFFSET MSMCallBackProcedure
TCallBackEBXParameter   dd      0               ; Not used by MSM.
TCallBackWaitTime       dd      0               ; Interval to sleep.
TResourceTag            dd      0               ; Filled in at init.
TWorkWakeUpTime         dd      0               ; Not used by MSM.
TSignature              dd      0               ; Not used by MSM.
;
;
;***************************************************************\
;                                                               *
; AES Control Block.                                            *
;                                                               *
;***************************************************************/
;
AESLink                 dd      0               ; Not used by MSM.
AESWakeUpDelayAmount    dd      0               ; Interval to sleep.
AESWakeUpTime           dd      0               ; Not used by MSM.
AESProcessToCall        dd      OFFSET MSMAESProcedure
AESRTag                 dd      0               ; Filled in by MSM at init.
AESOldLink              dd      0               ; Not used by MSM.

;***************************************************************\
;                                                               *
; Shutdown Timer Control Block.                                            *
;                                                               *
;***************************************************************/
ShutdownTimer           dd      (size MSM_TIMER_STRUCTURE / 4) dup (0)

DriverParmBlock         dd      (size DriverBlockStructure / 4) dup (0)
MediaParmBlock          dd      (size MediaBlockStructure / 4) dup (0)

MSMInterruptProcedureJump       db      0FFh, 15h
                                dd      MSMInterruptProcedureCall

MSMInterrupt2ProcedureJump	db	0FFh, 15h
				dd	MSMInterrupt2ProcedureCall

ReRegAESLink                 	dd      0         ; Not used by MSM.
ReRegAESWakeUpDelayAmount    	dd      0         ; Interval to sleep.
ReRegAESWakeUpTime           	dd      0         ; Not used by MSM.
ReRegAESProcessToCall        	dd      0	  ; Filled in by MSM later
ReRegAESRTag                 	dd      0         ; Filled in by MSM at init.
ReRegAESOldLink              	dd      0         ; Not used by MSM.
ReRegDriverDataPtr		dd	0	  ; Ptr to adapter data space
ReRegNewIOConfigPtr		dd	0         ; Ptr to new IOConfig table
ReRegExtraConfigPtr		dd	0	  ; Ptr to ExtraConfig table
ReRegAsyncECBPtr		dd	0	  ; Ptr	to ECB whose ESR called

DriverMemoryRTag        dd      0
DriverMLIDRTag          dd      0
DriverECBRTag           dd      0
DriverBelow16MegRTag    dd      0

ExtraConfigList		dd	0	; list of extra config tables

Reserved0		dd	0	; for future expansion
Reserved1		dd	0
Reserved2		dd	0
DrvParamBlkPtr		dd	0	; ptr to driver parameter block

			db	0       ; Fixed Area starts -uses neg. offsets
AlignEndVA      db      (4 - OFFSET (AlignEndVA and 3)) and 3 dup (?)

PriorityTxFreeCount     dd      0       ; TCBs reserved for priority sends
                                        ; This neg offset must match CSPEC111.

Temp0			dd	0	; for future expansion at a known
Temp1			dd	0	;  offset from the end of the structure
Temp2			dd	0

PhysicalBoardID		dd	0       ; ID of physical board, for multi-proc

ECBBufferIndex          dd      0
ECBBufferPointers       dd      8 dup (0)
ECBBufferPool           dd      0
MaxECBAddress           dd      0
RxBelow16               dd      0

MSMTCBList              dd      0       ; Points to pool of TCB buffers.
MSMTCBHead              dd      0       ; Points to Head of TCB Link.

SendListTail            dd      0       ; Send Queue Tail.
SendListHead            dd      0       ; Send Queue Head.

AESCallBackListHead	dd	0	; AES call back timer list head
INTCallBackListHead	dd	0	; INT call back timer list head

DriverInterrupt2Number  dd      -1      ; Default to invalid interrupt.

RxErrorStatusPtr        dd      0
MaxFrameHeaderSize      dd      0
PhysNodeAddress         db      8 dup (0)

AdapterMaximumSize      dd      0       ; Used by MSMRegisterHardwareOptions.
PICMasked               dd      0       ; Used by NT.
DriverIntReschedule     dd      0       ; used to be Temp0.
CHSMp                   dd      0       ; NWCACS Shim (CHSM) data space ptr

DefaultVirtualBoard     dd      0

DriverInterruptNumber   dd      -1      ; Default to invalid interrupt.

DriverInCriticalSection dd      0

InstanceLink            dd      0

VirtualBoardLink        dd      4 dup (0)

MLIDStatusFlags         dd      0       ; 01 - SHUTDOWN
                                        ; 02 - TXQUEUED
                                        ; 04 - SHARE_INT7
                                        ; 08 - SHARE_INT15
                                        ; 10 - POLLSUSPENDED
                                        ; 20 - UNLOADING
                                        ; 40 - RETURNING_RESOURCES

TxFreeCount             dd      0       ; Default to no Tx buffers.

MSMAdapterDataSpace     ends

AdapterSize                     equ     offset TxFreeCount + 4
MSMInterruptProcedureOffset     equ     offset MSMInterruptProcedureJump + 6
MSMInterrupt2ProcedureOffset    equ     offset MSMInterrupt2ProcedureJump + 6

DO_HARDWARE_CURSOR_POSITIONING  equ     00000010h
TYPE_AHEAD_BUFFER_SIZE  equ     32
COMMAND_HISTORY_SIZE    equ     300

ifdef   MSM311
;       timer chip register and control code definitions for v3.11

TimerChipCTR0           equ     40h
TimerChipModeRegister   equ     43h

TimerChipLatchCounter   equ     00000000b
TimerChipSetMode2       equ     00110100b
endif

ScreenStruct    struc

        signature                       dd      ?

        previousScreen                  dd      ?
        nextScreen                      dd      ?
        popUpOriginalScreen             dd      ?

        CLIBScreenStructure             dd      ?

        currentPalette                  db      ?
        popUpCount                      db      ?
        screenList                      db      ?
        activeCount                     db      ?
        resourceTag                     dd      ?

        screenName                      dd      ?
        screenMemory                    dd      ?
        flags                           dd      ?
        state                           dd      ?
        outputCursorPosition            dw      ?
        inputCursorPosition             dw      ?

;       The position of variables after this point can change with
;       new versions of the OS.  They should not be accessed by NLMs

        protectedInputRegionStart       dw      ?
        protectedInputRegionEnd         dw      ?
        initialInputCursorPosition      dw      ?

        screenSemaphore                 dd      ?

        keyboardInputProcessID          dd      ?

        typeAheadBufferCount            db      ?
        typeAheadBufferStart            db      ?
        typeAheadBufferEnd              db      ?
        reserved1                       db      ?
        typeAheadBuffer                 dd      TYPE_AHEAD_BUFFER_SIZE dup (?)

        commandHistoryEnd               dw      ?
        commandHistoryCurrent           dw      ?
        commandHistoryBuffer            db      COMMAND_HISTORY_SIZE dup (?)

;       /* new stuff with 3.20 */
        SSscreenSaveBuffer                      dd      ?
        SSscreenMode                            dw      ?
        SScursorType                            dw      ?
        SSscreenHeight                          dw      ?
        SSscreenWidth                           dw      ?
        SSscreenSize                            dd      ?
        SSSetCursorMode                         dd      ?
        SSEnableCursor                          dd      ?
        SSDisableCursor                         dd      ?
        SSPositionCursor                        dd      ?
        SSSetScreenMode                         dd      ?
        SSSaveFullScreen                        dd      ?
        SSRestoreFullScreen                     dd      ?
        SSSaveScreenArea                        dd      ?
        SSRestoreScreenArea                     dd      ?
        SSFillScreenArea                        dd      ?
        SSFillScreenAreaAttribute               dd      ?
        SSScrollScreenArea                      dd      ?
        SSDisplayScreenLine                     dd      ?
        SSDisplayScreenText                     dd      ?
        SSDisplayScreenTextWithAttribute        dd      ?
        SSReadScreenCharacter                   dd      ?
        SSWriteScreenCharacter                  dd      ?
        SSWriteScreenCharacterAttribute         dd      ?

ScreenStruct    ends


MSMDelayedWorkToDoStructure	struc

MSMDelayedWorkToDoECB		db	SIZE ReceiveBufferStructure dup(?)
MSMDelayedWorkToDoTimer		db	SIZE MSM_TIMER_STRUCTURE    dup(?)
MSMDelayedWorkToDoEBX		dd	?
MSMDelayedWorkToDoECX		dd	?
MSMDelayedWorkToDoEDX		dd	?
MSMDelayedWorkToDoESI		dd	?
MSMDelayedWorkToDoEDI		dd	?

MSMDelayedWorkToDoStructure	ends

; AYD 09-30-96 	Added

;
;	This structure will be used to schedule call back to run an API(s)
; at Process Time
;

ReRegStructure	struc
ReRegLink                 dd      0               ; Not used by MSM.
ReRegWakeUpDelayAmount    dd      0               ; Interval to sleep.
ReRegWakeUpTime           dd      0               ; Not used by MSM.
ReRegProcessToCall        dd      0
ReRegRTag                 dd      0               ; Filled in by MSM at init.
ReRegOldLink              dd      0               ; Not used by MSM.
ReRegDriverData		  dd	  0		  ; Ptr to adapter data space
ReRegNewIOConfig	  dd	  0               ; Ptr to new IOConfig table
ReRegExtraConfig	  dd	  0		  ; Ptr to ExtraConfig table
ReRegAsyncECB		  dd	  0		  ; Ptr	to ECB whose ESR called
ReRegStructure	ends

;***************************************************************\
;                                                               *
; ODINEB Parameter Block (so MSM can call ODINEB routines.)     *
;                                                               *
;***************************************************************/
;
ODINEB_PARM_BLOCK   struc
   ODINEBParameterSize    dd  ?
   ODINEBParameterVersion dd  ?
   ODINEBInitParmPointer  dd  ?
   ODINEBModuleHandle     dd  ?
   ODINEBMessagesPtr      dd  ?

   NESLRegisterProducer   dd  ?
   NESLDeRegisterProducer dd  ?
   NESLRegisterConsumer   dd  ?
   NESLDeRegisterConsumer dd  ?
   NESLProduceEvent       dd  ?
   NESLProduceMLIDEvent   dd  ?
ODINEB_PARM_BLOCK   ends


;***************************************************************\
;                                                               *
; Server Loader Type Definitions                                *
;                                                               *
;***************************************************************/
;
LT_DOS          equ     1       ; server.exe loaded from DOS
LT_OS2          equ     2       ; server.exe loaded from OS/2
LT_MSWIN31      equ     3       ; server.exe loaded from WIN 3.1x

;980204 mcd start

;***************************************************************\
;                                                               *
; Macros to convert a TCB pointer (eax) from a pointer to an    *
; ASM TCB to a pointer to a CTCB and back.                      *
;                                                               *
;***************************************************************/
;
MSMGetCTCB macro

 push ebx
 mov  ebx, [eax].TCBFragStrucPtr
 mov  ebx, [ebx-RFragmentCount].RESRAddress  ; get original ECB
 mov  ebx, [ebx].ECB_BoardNumber
 mov  [eax - 4], ebx                         ;Fill in the CTCB Board Number
	sub  eax, 8                                 ;Make the ATCB ptr a CTCB ptr
 pop  ebx

	endm

MSMRtnCTCB macro

 add  eax, 8

 endm

;980204 mcd end


