;***********************************************************************
; $name: driver.inc
; $version: 5
; $date_modified: 121898
; $description: NE3200 include file
; $owner: ODI LAN Driver Manager
; Copyright (c) 1991 - 1998 Novell, Inc. All Rights Reserved.
;
; THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
; USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE LICENSE AGREEMENT
; ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK) THAT CONTAINS THIS WORK.
; PURSUANT TO THE SDK LICENSE AGREEMENT, NOVELL HEREBY GRANTS TO DEVELOPER A
; ROYALTY-FREE, NON-EXCLUSIVE LICENSE TO INCLUDE NOVELL'S SAMPLE CODE IN ITS
; PRODUCT. NOVELL GRANTS DEVELOPER WORLDWIDE DISTRIBUTION RIGHTS TO MARKET,
; DISTRIBUTE, OR SELL NOVELL'S SAMPLE CODE AS A COMPONENT OF DEVELOPER'S
; PRODUCTS. NOVELL SHALL HAVE NO OBLIGATIONS TO DEVELOPER OR DEVELOPER'S
; CUSTOMERS WITH RESPECT TO THIS CODE.
;***********************************************************************
;                                                                       *
;                                                                       *
; DRIVER.INC                                                            *
;                                                                       *
; PUBLIC's and EXTRN's needed by driver object module.                  *
;                                                                       *
; Written by:   DFS
; Date:         November 1990                                           *
;                                                                       *
; 5 May 1995 10:32      DGM
;       Removed code pertaining to conditionals AdapterProcessesRx,
;       AdapterProcessesTx, CatchIncomplete, Channel0, AddPolling,
;       TxQueue and BusMaster, and left code with the setting according 
;       to those conditionals at this point in time, ie. clean-up.
;
; 10 May 1995 9:33      DGM
;       Added extern for MSMGetPollSupportLevel
;
;                                                                       *
;***********************************************************************/
;
include msm.inc
;
ifdef TASM
OSDATA  segment READWRITE public 'DATA'
else
OSDATA  segment rw public 'DATA'
endif
;
;***************************************************************\
;                                                               *
; Externals bound to MSM.386 at link time.                      *
;                                                               *
;***************************************************************/
;

OSDATA  ends

IFDEF TASM
 OSCODE segment EXECREAD public 'CODE'
ELSE
 OSCODE segment er public 'CODE'
ENDIF
;
;***************************************************************\
;                                                               *
; Externals bound to MSM.386 at link time.                      *
;                                                               *
;***************************************************************/
;
if CheckTCBs
	extrn   GetSystemMemoryMap: near
endif
	extrn   MSMAlertFatal: near
	extrn   MSMAlertWarning: near
	extrn   MSMAllocateRCB: near
	extrn   MSMAlloc: near
	extrn   MSMAllocPages: near
	extrn   MSMDriverRemove: near
	extrn   MSMEnablePolling: near
	extrn   MSMFree: near
	extrn   MSMFreePages: near

	extrn   MSMGetCardConfigInfo: near
	extrn   MSMGetInstanceNumberMapping: near
	extrn   MSMGetUniqueIdentifierParameters: near
	extrn   MSMGetLogical: near
	extrn   MSMGetPhysical: near
	extrn   MSMGetMicroTimer: near          ; JCP, 941130.

	extrn   MSMParseDriverParameters: near
	extrn   MSMPrintString: near
	extrn   MSMPrintStringFatal: near
	extrn   MSMPrintStringWarning: near
	extrn   MSMReadEISAConfig: near
	extrn   MSMRegisterHardwareOptions: near
	extrn   MSMRegisterMLID: near
	extrn   MSMReturnDriverResources: near
	extrn   MSMScheduleIntTimeCallBack: near
	extrn   MSMScheduleAESCallBack: near
	extrn   MSMSearchAdapter: near
	extrn   MSMSetHardwareInterrupt: near

	extrn   MSMGetPollSupportLevel  :near
	extrn   MSMScanBusInfo: near

;
;***************************************************************\
;                                                               *
; Externals bound to <MEDIA>.386 at link time.                  *
;                                                               *
;***************************************************************/
;
	extrn   EtherTSMRegisterHSM: near
	extrn   EtherTSMFastSendComplete: near

	extrn   EtherTSMGetASMHSMIFLevel: near

	extrn   EtherTSMGetNextSend: near
	extrn   EtherTSMGetRCB: near
	extrn   EtherTSMProcessGetRCB: near
	extrn   EtherTSMFastProcessGetRCB: near
	extrn   EtherTSMFastRcvComplete: near
	extrn   EtherTSMFastRcvCompleteStatus: near
	extrn   EtherTSMRcvComplete: near
	extrn   EtherTSMRcvCompleteStatus: near
	extrn   EtherTSMSendComplete: near
	extrn   EtherTSMUpdateMulticast: near
;
;***************************************************************\
;                                                               *
; Publics bound to MSM.386 at link time.                        *
;                                                               *
;***************************************************************/
;
	public  DriverInit
	public  DriverRemove

OSCODE  ends
