ifdef TASM
%PAGESIZE 66,130
else
PAGE 66, 130
endif
;*****************************************************************************
;   DRIVER.INC
;
;   (C) Unpublished Work of Novell, Inc.  All Rights Reserved.
;
;	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, 
;	PROPRIETARY AND TRADESECRET INFORMATION OF NOVELL, INC.  ACCESS 
;	TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
;	NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS 
;	AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO APPROPRIATE 
;	LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED,
;	PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,
;	ABBRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
;	TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL. 
;	ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD 
;	SUBJECT THE PERPERTRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;----------------------------------------------------------------------------
;
;	Included by the HSM to
;	Setup all of the public's and extrn's in the MLID
;
;	Written by:	DCD
;	Date:		6/14/90
;
;	ODI Specification Version:	4.00
;
;    Modification History:
;	Date		By	Modification Description
;	---------------	---	------------------------------------------
;	01 August 1994   JWR,WTT  v2.00 Removed Previous history, 
;				See DOS ODI Specification Changes Doc for changes.
;
;	09 Jan. 1994	JWR	Added Declaration for MSMAtoL
;
;	21 April 1995	JWR	Added HSMResetMSM Declaration
;
; 1 April 1996	JWR	New ToolKit. v2.10
;
; 21 Nov. 1997	SMN	New ToolKit. v2.12
;*****************************************************************************
.8086			; This sets the Mode for All the Include Files.
include	msm.inc
include neslname.inc

;----------------------------------------------------------------------------
;		Macros
;----------------------------------------------------------------------------
; NumberMessage
;	Macro used to generate Message numbers preceding each Message to be
;	printed out by MSMPrintStringZero Procedures.
;	The terminator Value is given in the Term field.
;	Up to three extra parameters may be on the line. (i.e. 0Ah,0Dh,0)
;	This macro will just place them after the message.
;----------------------------------------------------------------------------
MSGNUM	= 100			; Messages particular to the HSM start at 100.

NumberMessage	Macro	name,num,stringgg,term1,term2,term3
	local	mnum
if num
	mnum=num
else
	mnum=MSGNUM
	MSGNUM=MSGNUM+1
endif
name	dw	mnum
	db	stringgg
ifnb	<term1>
	db	term1
ifnb	<term2>
	db	term2
ifnb	<term3>
	db	term3
endif
endif
endif
	endm

;****************************************************************************
;	Functions and Variables available Only During INIT Time.
;****************************************************************************
Init	segment	para public 'CODE'
;----------------------------------------------------------------------------
;	Variables provided by the HSM.
;----------------------------------------------------------------------------
	public	DriverSignOnMessage
	public	DriverMainSectionText
	public	DriverNumKeywords
	public	DriverKeywordText
	public	DriverKeywordTextLen
	public	DriverProcessKeywordTab

;----------------------------------------------------------------------------
;	Functions Provided by the HSM.
;----------------------------------------------------------------------------
	public	DriverInit

;----------------------------------------------------------------------------
;	Variables Provided by the MSM or TSM.
;----------------------------------------------------------------------------
	extrn	LSLInitEntryPoint	:dword
	extrn	LSLEntryPoints		:dword	;[0]=MPI, [1]=Gen Services
	extrn	MSMLookAheadSegment	:word
	extrn	MSMSameTypeMLIDCount	:byte
	extrn	MSMNewLine		:byte


;----------------------------------------------------------------------------
;	Functions Provided by the MSM or TSM
;----------------------------------------------------------------------------
	extrn	MSMPrintStringZero	:near
	extrn	MSMPrintCommaSpace	:near	;Parser support routines
	extrn	MSMCompareString	:near
	extrn	MSMEatLeadingZeros	:near
	extrn	MSMEatWhite		:near
	extrn	MSMAtoI			:near
        extrn   MSMAtoL                 :near
	extrn	MSMPrintDoubleHex	:near
	extrn	MSMAtoH			:near
	extrn	MSMItoA			:near
	extrn	MSMPrintSixByteHexString:near
	extrn	MSMPrintHexChar		:near
	extrn	MSMGetHexChar		:near
	extrn	MSMHexCharToInt		:near
	extrn	MSMHexToDoubleInt	:near
	extrn	MSMHexToInt		:near
	extrn	MSMHexStringToByteArray	:near
	extrn	MSMGetStringLength	:near

Init	ends

;****************************************************************************
;	Functions and Variables available during RunTime
;****************************************************************************
Code	segment para public 'CODE'

;----------------------------------------------------------------------------
;	Variables provided by the HSM
;----------------------------------------------------------------------------
	public	DriverConfigTable
	public	DriverStatTable

;----------------------------------------------------------------------------
;	Functions provided by the HSM
;----------------------------------------------------------------------------
	public	DriverChangeLookAheadSize
	public	DriverISR
	public	DriverManagement
	public	DriverMulticastChange
	public	DriverPoll
	public	DriverPromiscuousChange	
	public	DriverReset
	public	DriverSend
	public	DriverShutdown

;----------------------------------------------------------------------------
;	Variables provided by the MSM or TSM
;----------------------------------------------------------------------------
	extrn	LSLSupport		:dword
	extrn	MSMSystemFlags		:byte
	extrn	MSMTxQueueHead		:dword
	extrn	MSMTxQueueTail		:dword
	extrn	MSMTxFlags0		:byte
	extrn	MSMTxFlags1		:byte
	extrn	MSMConfigTables		:word
	extrn	MSMTxFreeCount		:byte
	extrn	MSMEOIFlag		:byte
	extrn	MSMIntMaskPort		:word
	extrn	MSMIntMaskOn		:byte
	extrn	MSMIntMaskOff		:byte
	extrn	MSMPhysNodeAddress	:byte

;----------------------------------------------------------------------------
;	Functions provided by the MSM or TSM
;----------------------------------------------------------------------------
	extrn	MSMSetIRQ		:near
	extrn	MSMUnSetIRQ		:near
	extrn	MSMClearSendQueue	:near
	extrn	MSMGetNextSend		:near
	extrn	MSMSendComplete		:near
	extrn	MSMGetRCB		:near
	extrn	MSMRcvComplete		:near
	extrn	MSMRcvCompleteStatus	:near
	extrn	MSMReturnRCB		:near
	extrn	MSMUpdateMulticast	:near	   ; Called by the HSM after a Internal Reset.
	extrn	HSMShutDownMSM		:near	   ; Called by PCMCIA on Removal Events
	extrn	HSMResetMSM		:near	   ; Called by HSM for resetting prior to a Resume Event
	extrn	MSMMediaConfigUpdate	:near	   ; Called By DriverInit if successful
	extrn	MSMBuildTransmitControlBlock :near ; Called for Priority Support by the HSM.
	extrn	MSMCallNESL		:near
	extrn	MSMGenerateNESLEvent	:near
	extrn	MSMGenerateNESLSuspendEvent :near
	extrn	MSMGenerateNESLResumeEvent  :near
	extrn	MSMGenerateNESLChangeEvent  :near

Code	ends

CGroup	group	Code,Init
	assume	cs:CGroup, ds:CGroup, es:nothing, ss:nothing


