ifdef TASM
%PAGESIZE 66,130
else
PAGE 66, 130
endif
;*****************************************************************************
; MSM.ASM
;
;	(C) Copyright Unpublished Work of Novell, Inc.  All Rights Reserved.
;
;	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, 
;	PROPRIETARY AND TRADESECRET INFORMATION OF NOVELL, INC.  ACCESS 
;	TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
;	NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS 
;	AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO APPROPRIATE 
;	LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED,
;	PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,
;	ABBRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
;	TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL. 
;	ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD 
;	SUBJECT THE PERPERTRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;----------------------------------------------------------------------------
; 
;	DOS ODI MLID Media Support Module (MSM)
;
;	Written by:	DCD
;	Date:		6/12/90
;
;	ODI Specification Version:	4.00
;
;    Modification History:
;	Date		By	Modification Description
;	---------------	---	------------------------------------------
;	01 August 1994   JWR,WTT  v2.00 Removed Previous history, 
;				See DOS ODI Specifcation Changes Doc for changes.
;	23 August 1994  JWR,WTT  Added MSMPrintStringZero at Line 3701 for Printing
;				the Card Short Name in the CouldntFindMlidSection message.
;	26 August 1994  JWR     changed some Struture Data Memory reference to use [si]. instead.
;				just prior to MSMGenerateXXXX Calls
;	14 October 1994 JWR	Added MSMUnSetIRQ call to the MSMShutDown for Permanant Case.
;
;	09 January 1995   JWR   Checkin New ToolKit. v2.02
;				Allow Case Sensitive Parameter Parsing
;				via Extra Buffer MSMOrigLineBuffer.
;				Change how Indication of NESL being displayed.
;				Correct the PCI BIOS string for PCI Detection.
;
;	28 February 1995  JWR   New ToolKit. v2.03
;				When copying the Base Config Table, the Counter for
;				 copying from MSignature to the MConfigTableMinorVer
;				 was short one byte. (Changed to use Label MNodeAddress)
;				Displaying the Minor Version had an error.
;
;	27 March 1995  JWR	New ToolKit. v2.03
;				Change Case Sensitivity to be done on a quote mark basis.
;				remove extra buffer MSMOrigLineBuffer.
;				Added MSMKeyWordFlags for signalling Sensitivity.
;				Add Check for Acer Machines. (hangs if Int 1A done for AH >0Bh)
;				SPD#94304 - indicated bit 10 in MFlags was being cleared somewhere.
;					MSMUpdateConfigTables cleared MFLAGS field rather than set one bit.
;
;	3 April 1995	JWR	New ToolKit. v2.03
;				Added MLID IOCTL 15 MSMGetMulticastInfo
;				Validation of Board Number < Max boards for IOCTLS.
;				MSMDriverManagement corrected Valid First Char
;				       value Check 41H <= char <= 7Eh.
;	21 April 1995	JWR	v2.04 Alpha 1
;				Added HSMResetMSM. Needed for HSM's that previously
;				called HSMShutDownMSM.
;
;	8 June 1995	JWR	v2.04 Alpha 2
;				Printing of Minor Version still not correct for /s option.
;				Needed to only print leading 0 in versions < .10
;
;	30 Aug 1995	JWR	v2.04 
;				ModeFlags were not updated in Call to MSMupdateConfigTables
;				Need to preserve Canonical Settings, but match settings from
;				the base table in the copies.
;				
;	25 Oct. 1995	JWR	v2.05
;				Missing Public declaration for HSMResetMSM.
;				
; 1 April 1996	JWR	New ToolKit. v2.10
;		SetLookAheadSize returning Bad Command instead of Bad Parameter.
;
; 21 Nov. 97	SMN		New ToolKit. v2.12
;
;*****************************************************************************
.8086
include	msm.inc
include	msmtxt.inc

ifdef TASM
%NEWPAGE ;
endif
;----------------------------------------------------------------------------
MSMVersion		equ	'v2.12 (971121) ' ; Set Nov. 21, 1997 SMN

Code	segment	para public 'CODE'
;----------------------------------------------------------------------------
;	Functions Provided by the MSM for the HSM/TSM
;----------------------------------------------------------------------------
	public	MSMSetIRQ
	public	MSMUnSetIRQ
	public	MSMClearSendQueue
	public	MSMCallNESL
	public	MSMGenerateNESLEvent
	public	MSMGenerateNESLSuspendEvent
	public	MSMGenerateNESLResumeEvent
	public	MSMGenerateNESLChangeEvent
	public	HSMShutDownMSM
	public	HSMResetMSM

;----------------------------------------------------------------------------
;	Functions Provided by the MSM for the TSM
;----------------------------------------------------------------------------
	public	MSMEnqueueSend
	public	MSMUpdateConfigTables

ifdef DEBUG		;Internal Use Only. 
	public	MSMISR
	public	MSMBadCtlCommand
	public	MSMGetConfigTable
	public	MSMGetStatTable
	public	MSMShutDown
	public	MSMReset
	public	MSMSetLookAheadSize
	public	MSMPromiscuousChange
	public	MSMRegTxMonitor
	public	MSMDriverManagement
	public	MSMWaitForSendsToComplete
	public	MSMSetShutDownBits
	public	MSMDeregisterAllBoards
endif

;----------------------------------------------------------------------------
;	Variables Provided by the MSM
;----------------------------------------------------------------------------
	public	LSLSupport
	public	MSMEOIFlag
	public	MSMMaxActiveTx		; TSM uses
	public	MSMTableIndex		; Converts BoardNum to Virt Word Index.
	public	MSMConfigTables		; TSM uses
	public	MSMIntMaskPort		
	public	MSMIntMaskOff
	public	MSMIntMaskOn
	public	MSMTxQueueHead		; TSM uses
	public	MSMTxQueueTail		; TSM uses
	public	MSMActivePromisMask	; TSM uses
	public	MSMActiveBoardCount	; TSM uses
	public	MSMTxFlags		; TSM uses
	public	MSMTxFlags0			; low order
	public	MSMTxFlags1			; high order
	public	MSMSystemFlags
	public	MSMPhysNodeAddress
	public	MSMTxMonPtr		; TSM uses
	public	DriverCtlTable		; TSM uses
	public	MSMPriorityQSupportPtr	; HSM may use

ifdef DEBUG		;Internal Use Only. 
	public	IntVectorSave
endif

;----------------------------------------------------------------------------
;	Functions Provided by the TSM.
;----------------------------------------------------------------------------
	extrn	MSMSendPacket		:near
	extrn	MSMGetNextSend		:near
	extrn	MSMGetMulticastInfo	:near	;Located in Media specific
	extrn	MSMAddMulticastAddress	:near	;module
	extrn	MSMDelMulticastAddress	:near	
	extrn	MSMUpdateMulticast	:near	
	extrn	MSMMediaShutdown	:near
	extrn	MSMMediaReset		:near

;----------------------------------------------------------------------------
;	Variables Provided by the TSM.
;----------------------------------------------------------------------------
	extrn	MSMTxFreeCount		:byte

;---------------------------------------------------------------------------
;	Functions Provided by the HSM
;----------------------------------------------------------------------------
	extrn	DriverISR			:near
	extrn	DriverSend			:near
	extrn	DriverPoll			:near
	extrn	DriverPromiscuousChange		:near
	extrn	DriverReset	 		:near
	extrn	DriverShutdown			:near	
	extrn	DriverManagement		:near
	extrn	DriverChangeLookAheadSize	:near

;----------------------------------------------------------------------------
;	Variables Provided by the HSM
;----------------------------------------------------------------------------
	extrn	DriverConfigTable	:byte
	extrn	DriverStatTable		:byte

;----------------------------------------------------------------------------
;	From NESL.INC assembled in the HSM
;	Class Names
;----------------------------------------------------------------------------
	extrn	NESL_Service_Suspend		:byte	; (MSM uses)
	extrn	NESL_Service_Resume		:byte	; (MSM uses)
	extrn	NESL_ServiceStatus_Change	:byte	; (MSM uses)

;----------------------------------------------------------------------------
;	NESL_Service_Suspend			; Class
;----------------------------------------------------------------------------
	extrn	NESL_MLID_ShutDown		:byte		; (MSM uses)

;----------------------------------------------------------------------------
;	NESL_Service_Resume			; Class
;----------------------------------------------------------------------------
	extrn	NESL_MLID_Reset			:byte		; (MSM uses)

ifdef TASM
%NEWPAGE ;
endif
;----------------------------------------------------------------------------
;	V A R I A B L E   D E C L A R A T I O N S 
;----------------------------------------------------------------------------
	even
LSLSupport		dd	?		; MLID Support Entry Point
NESLSupport		dd	?		; NESL Initialization Entry Point.

;----------------------------------------------------------------------------
;	IntLine1 Support Variables.
;----------------------------------------------------------------------------
IntVectorSave		dw	2 dup (0)	; Previous IntVector
IntVectorSaveLocation	dw	0		; Which Int -- Offset into Int Table.
MSMIntMaskPort		dw	?		; Port to EOI on 
MSMIntMaskOff		db	?		; Mask Values
MSMIntMaskOn		db	?		;
MSMEOIFlag		db	0		; 0=Master only, 1=Slave,Master

;----------------------------------------------------------------------------
;	Number of Transmit Resources.
;----------------------------------------------------------------------------
MSMMaxActiveTx		db	0		; Number of Active Tx supported

;----------------------------------------------------------------------------
;	Virtual Board support.
;----------------------------------------------------------------------------
MSMTableIndex		db	MaxBoards dup(0)	; Contains word Index into each of the following tables. (make upperReg = 0)
MSMConfigTables		dw	offset CGroup:DriverConfigTable
			dw	0
			dw	0
			dw	0		;Allow up to 4 Logical Boards

   even
MSMTxQueueHead		dd	0
MSMTxQueueTail		dw	offset CGroup:MSMTxQueueHead
			dw	0	; Segment value for MSMtxQueueTail

MSMActivePromisMask	dw	0	; current Promiscuous Bit Flags
MSMActiveBoardCount	dw	0	; Tracks number of active boards.

MSMTxFlags	label	word		; Track CriticalSection, and other stuff.
MSMTxFlags0		db	0	; First byte is CriticalSectionCount
MSMTxFlags1		db	0	; Defined in MSM.inc
		
MSMPhysNodeAddress	db	7 dup (0FFh)	; Set up to detect override.
				; byte 7 is for Form Specifier (i.e. L or M for LSB or MSB)
				; FF => no character given.

MSMSystemFlags		dw	0   ; defined in MSM.inc

;----------------------------------------------------------------------------
;	Transmit Monitor Routine Pointer
;----------------------------------------------------------------------------
MSMTxMonPtr		dd	0	; Ptr to Transmit Monitor Routine.

;----------------------------------------------------------------------------
;	Priority Q Support Pointer 
;	Function provided by the HSM
;----------------------------------------------------------------------------
MSMPriorityQSupportPtr	dw	0	; Ptr to Priority Q Support Routine.

;----------------------------------------------------------------------------
;	NESL Structure Allocation
;----------------------------------------------------------------------------
NESL_SuspendBlock	PECB <1,0,,,,,0> ; Producer Control Block
NESL_ResumeBlock	PECB <1,0,,,,,0> ; Producer Control Block
NESL_ChangeBlock	PECB <1,0,,,,,0> ; Producer Control Block
NESL_EPB		EPB <1,0>	 ; Event Parameter Block 

;----------------------------------------------------------------------------
;	Main Control Jump Table.
;----------------------------------------------------------------------------
	even
DriverCtlTable	dw	offset CGroup:MSMGetConfigTable		;#0
		dw	offset CGroup:MSMGetStatTable		;#1
		dw	offset CGroup:MSMAddMulticastAddress	;#2
		dw	offset CGroup:MSMDelMulticastAddress	;#3
		dw	offset CGroup:MSMRegTxMonitor		;#4 
		dw	offset CGroup:MSMShutDown		;#5
		dw	offset CGroup:MSMReset			;#6
		dw	offset CGroup:MSMBadCtlCommand		;#7 Reserved
		dw	offset CGroup:MSMBadCtlCommand		;#8 Reserved
		dw	offset CGroup:MSMSetLookAheadSize	;#9
		dw	offset CGroup:MSMPromiscuousChange	;#10
		dw	offset CGroup:MSMBadCtlCommand		;#11 Reserved
		dw	offset CGroup:DriverPoll		;#12
		dw	offset CGroup:MSMBadCtlCommand		;#13 Reserved
		dw	offset CGroup:MSMDriverManagement	;#14
		dw	offset CGroup:MSMGetMulticastInfo	;#15
NumCtlEntries 	equ	($-DriverCtlTable)/2


ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;	MSMSetIRQ
;
;	Enables and installs the interrupt vector specified in the 
;	DriverConfigTable.IntLine1.
;	The routine MSMISR is assumed to be the correct ISR.
;
;	The MSMSetIRQ and MSMUnSetIRQ routines assume only one
;	interrupt is being used by this HSM.
;
;	This routine will properly handle IRQ 2 and IRQ 9.  
;	The HSM may pass either value in the config table, 
;	and assume this routine will set the correct vector.
;
;	NOTE: This function does NOT support shareable interrupts.
;
;	assumes:
;		DS	is set to CGroup
;		Interrupts disabled
;			
;	returns:
;		BX,DS,SS,SP,BP preserved
;		Interrupts disabled
;		CLD unchanged
;
;****************************************************************************
MSMSetIRQ	proc	near
;----------------------------------------------------------------------------
;   Don't allow the Developer to give a different IRQ from the Config Table.
;----------------------------------------------------------------------------
	mov	cl, DriverConfigTable.MIRQLine1	; Get IRQ Number directly.

;----------------------------------------------------------------------------
;	Check for 2 or 9 to get the right vector
;----------------------------------------------------------------------------
	cmp	cl, 2			
	je	NeedToCheck		; e => Need to check for problem
	
	cmp	cl, 9
	jne	NoAdjustNeeded		; ne => Something other than 2 or 9

;----------------------------------------------------------------------------
;	Enable Int 2, then check if running on AT 
;----------------------------------------------------------------------------
NeedToCheck:
	in	al, 21h			; Get the current mask
slow
	and	al, not 4		; IRQ 2 bit enabled
	out	21h, al

	mov	cl, 2			; Default is IRQ 2 on a PC
	test	MSMSystemFlags, ATFlag
	jz	NoAdjustNeeded

	mov	cl, 9			; IRQ 9 on AT

;----------------------------------------------------------------------------
;	Enable the interrupt.
;----------------------------------------------------------------------------
NoAdjustNeeded:
	mov	ah, 1			; Get a bit
	cmp	cl, 8			; Is IRQ on slave?
	jb	MasterOnly			

;----------------------------------------------------------------------------
;	Interrupt is on the Slave PIC
;----------------------------------------------------------------------------
	mov	MSMEOIFlag, ah		; Signal EOI is needed on Slave, & Master PIC
	sub	cl, 8
	mov	dx, 0a1h		; PIC 2's mask port
	mov	di, 70h			; Base int of PIC 2's vectors
	jmp short DontAdjustIRQNumber

;----------------------------------------------------------------------------
;	Interrupt is on the Master PIC
;----------------------------------------------------------------------------
MasterOnly:					
	mov	MSMEOIFlag, 0		; MasterOnly = 0
	mov	dx, 21h			; PIC 1's mask port
	mov	di, 08h			; Base int of PIC 1's vectors

;----------------------------------------------------------------------------
;	Get/Save the Interrupt Mask Bit and Maskport
;----------------------------------------------------------------------------
DontAdjustIRQNumber:
	shl	ah, cl			; Get Correct bit.
	mov	MSMIntMaskPort, dx	; Save these for the HSM
	mov	MSMIntMaskOff, ah	; Disable the Interrupt
	not	ah
	mov	MSMIntMaskOn, ah	; Enable the Interrupt Mask

;----------------------------------------------------------------------------
;	Get the Current Mask
;----------------------------------------------------------------------------
	in	al, dx			; Get the current mask
slow
	and	al, ah			; Make sure our Int is Enabled.
	out	dx, al			; Enable our Interrupt.

;----------------------------------------------------------------------------
;	Save the old vector and install the new one.
;----------------------------------------------------------------------------
	xor	ax, ax
	mov	es, ax				; ES = 0; Int Table Seg
	mov	al, cl				; AX = Int number
	add	di, ax				; Move over to correct Int number
	add	di, di				; word offset
	add	di, di				; Get the Vector Address (Dword offset)
	mov	IntVectorSaveLocation, di	; Save for easy undoing later
	mov	ax, offset CGroup:MSMISR	; CX = Our ISR Routine
	xchg	ax, word ptr es:[di+0]		; Swap out old for ours
	mov	IntVectorSave+0, ax		; Save off the Offset
	mov	ax, cs				; CX = CGroup
	xchg	ax, word ptr es:[di+2]		; Swap out old for our Segment
	mov	IntVectorSave+2, ax		; Save off the Segment
	ret

MSMSetIRQ	endp

ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;	MSMUnSetIRQ
;
;	Removes the interrupt vector installed by MSMSetIRQ and 
;	restores the old interrupt vector.
;	The interrupt will be left masked off.
;
;	The MSMSetIRQ and MSMUnSetIRQ routines assume only one
;	interrupt is being used by this HSM.
;
;	NOTE: This function does NOT support shareable interrupts.
;
;	assumes:
;		ds	CGroup
;		Interrupts disabled
;			
;	returns:	
;		bx,bp,ds,ss,sp preserved
;		Interrupts disabled
;		CLD in effect
;
;****************************************************************************
MSMUnSetIRQ	proc	near
;----------------------------------------------------------------------------
;	Mask off the Interrupt controller
;----------------------------------------------------------------------------
	mov	dx, MSMIntMaskPort		;Mask the interrupt off
	in	al, dx
slow
	or	al, MSMIntMaskOff
	out	dx, al

;----------------------------------------------------------------------------
;	Put the old vector back.
;----------------------------------------------------------------------------
	xor	ax, ax
	mov	es, ax				; ES:0 = Int table.
	mov	di, IntVectorSaveLocation	; Get the vector's location
	mov	si, offset CGroup:IntVectorSave	; Source of Old Location
	movsw					; Restore Old offset
	movsw					; Restore Old Segment
	ret

MSMUnSetIRQ	endp


ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;	MSMISR
;
;	This is the main Interrupt Service Routine for the MLID.
;	
;	assumes:
;		Interrupts are disabled
;		All registers must be preserved by the MSM
;
;	returns:
;		Interrupts disabled
;
;****************************************************************************
MSMISR	proc	far
;----------------------------------------------------------------------------
;	Preserve all the Regs.
;----------------------------------------------------------------------------
	push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	si
	push	es		; Preserve All the Regs

	push	bp
	push	ds	      	; Preserved

;----------------------------------------------------------------------------
;	Set DS = CGroup
;----------------------------------------------------------------------------
	mov	ax, cs				; Set up CGroup
	mov	ds, ax

;----------------------------------------------------------------------------
;	Start Critical Section
;----------------------------------------------------------------------------
	mov	bx, MLIDSUP_START_CRITICAL_SECTION
	call	LSLSupport
	inc	MSMTxFlags0		; Enter critical section  (track num)
					
;----------------------------------------------------------------------------
;	Call the HSM's ISR
;----------------------------------------------------------------------------
	cld
	call	DriverISR

;----------------------------------------------------------------------------
;	See if there is a ECB ready to send
;----------------------------------------------------------------------------
	cmp	word ptr MSMTxQueueHead+2, 0	;Does the queue have something?
	jne	StartAnotherSend

;----------------------------------------------------------------------------
;	End Critical Section
;----------------------------------------------------------------------------
ISRExit:
	dec	MSMTxFlags0			; End Critical Section (track num)
	pop	ds				; Restore some of the stack
	pop	bp				; Critical section Preserves DS, BP
	mov	bx, MLIDSUP_END_CRITICAL_SECTION
	call	cs:LSLSupport

;----------------------------------------------------------------------------
;	Restore the Rest of the Stack
;----------------------------------------------------------------------------
	pop	es
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	iret

;----------------------------------------------------------------------------
;	There is another ECB to send, If the HSM can start it.
;----------------------------------------------------------------------------
StartAnotherSend:
	cmp	MSMTxFreeCount, 0	; Can the drv handle another one?
	je	ISRExit

	cmp	MSMTxFlags0, 1		; Is the HSM in a deep Critical Section?
	jne	ISRExit			; ne => MSMTxFlags0 > 1 (others are waiting)

	call	MSMGetNextSend		; See if one is queued up
	jnz	ISRExit

	call	DriverSend		; Got a TCB to Send
	jmp short ISRExit

MSMISR	endp


ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;	MSMControlHandler
;
;	(MLID Control Entry Point)
;	Saves critical regs, executes a CLD before calling 
;	the appropriate MLID function handler routine.
;
;	assumes:
;		AX	has the board number
;		BX	request function number
;		Other registers set as needed
;
;	returns:
;		flags set according to register AX
;		DS,BP,SS,SP preserved
;		Interrupt State preserved.
;
;****************************************************************************
MSMControlHandler	proc	far
;----------------------------------------------------------------------------
;	Save critical regs, execute a CLD, Stop Ints.
;----------------------------------------------------------------------------
	pushf
	push	bp
	push	ds
	cld
	cli

;----------------------------------------------------------------------------
;	According to Spec, we must be given a valid Board Number
;		(doesn't say it has to be one of ours! :-)  )
;----------------------------------------------------------------------------
	cmp	ax, MaxBoards		; Check for too Large.
	ja	InvalidBoardNumber

;----------------------------------------------------------------------------
;	Check if Valid request and if we are even online
;----------------------------------------------------------------------------
	push	cs
	pop	ds				; DS = CGroup

	test	MSMTxFlags1, PERMSHUTDOWN	; Are we perm shutdown?
	jnz	WeArePermShutdown

	cmp	bx, NumCtlEntries		; Invalid request?
	jae	InvalidFunctionCode

;----------------------------------------------------------------------------
;	Execute function
;----------------------------------------------------------------------------
	add	bx, bx			; Get Function # word index
	call	DriverCtlTable[bx]	; Execute funtion

;----------------------------------------------------------------------------
;	After each call
;----------------------------------------------------------------------------
InvalidFunctExit:
	pop	ds
	pop	bp
	.popf
	or	ax, ax			; Set the flags up appropriately.
	retf

;----------------------------------------------------------------------------
;	Unsupported Control Procedures come here, cheat the ret, 
;	set the AX return code to LSLERR_BAD_COMMAND continue.
;----------------------------------------------------------------------------
MSMBadCtlCommand:
	pop	ax			; Clean off return adddress

;----------------------------------------------------------------------------
;	Invalid Code given, or Not Supported function.
;----------------------------------------------------------------------------
InvalidFunctionCode:
	mov	ax, LSLERR_BAD_COMMAND
	jmp short InvalidFunctExit

;----------------------------------------------------------------------------
;	Just in case we haven't been removed yet from memory.
;----------------------------------------------------------------------------
WeArePermShutdown:
	mov	ax, LSLERR_FAIL
	jmp short InvalidFunctExit

;----------------------------------------------------------------------------
;	Board number is invalid.
;----------------------------------------------------------------------------
InvalidBoardNumber:
	mov	ax, LSLERR_BAD_PARAMETER
	jmp short InvalidFunctExit
MSMControlHandler	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMGetConfigTable
;
;	Returns a pointer to the config table representing the specified
;	logical board number.
;
;	assumes:
;		DS = CGroup
;		AX = Board Number
;		CLD has been executed
;		Interrupts are disabled
;
;	returns:
;		es:si	-> config table
;		ax	=0 always
;		bx destroyed.
;		All other registers not used.
;		Interrupts disabled
;
; Remarks:	This routine is only called by the MSMControlHandler.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMGetConfigTable	proc	near
	xchg	bx, ax			; BX = Board Num Word Index
	mov	bl, MSMTableIndex[bx]
	mov	si, MSMConfigTables[bx]

;----------------------------------------------------------------------------
;	Set up the Segment value for the return.
;----------------------------------------------------------------------------
GetTableExit:
	push	cs
	pop	es

MSMCtlSuccessful:
	xor	ax, ax
	ret

MSMGetConfigTable	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMGetStatTable
;
;	Returns a pointer to the statistics table.
;
;	assumes:
;		AX = Board Number
;		DS = CGroup
;		CLD has been executed
;		Interrupts are disabled
;
;	returns:
;		AX 	= 0 always
;		ES:SI	-> stat table
;		Interrupts disabled
;
; Remarks:	This routine is only called by the MSMControlHandler.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMGetStatTable	proc	near
	mov	si, offset CGroup:DriverStatTable
	jmp short GetTableExit

MSMGetStatTable	endp

;****************************************************************************
;	HSMShutDownMSM
;
;	Shuts down the MSM Internal State Machine.
;	A NESL Event is not generated.  DriverShutDown is not called.
;
;	assumes:
;		DS	CGroup
;		Interrupts are Disabled
;		CLD executed
;
;	returns:
;		AX	=0 always
;		DS	CGroup
;		Interrupts Disabled
;		DS, SS, SP, BP preserved
;****************************************************************************
HSMShutDownMSM	proc near
	mov	cx, ds
	mov	bl, -1
;	jmp short MSMShutDown		; Fall into MSMShutDownMSM.

HSMShutDownMSM	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMShutDown
;
;	Shuts down the physical board.
;
;	assumes:
;		DS	CGroup
;		AX	Board Number
;		BX 	-1 if HSM has called for SHutdown
;		CX	has shutdown flag
;			=0 if MLID is to deregister (Permenant ShutDown)
;			!0 if temp. shutdown
;		Interrupts are Disabled
;		CLD executed
;
;	returns:
;		AX	= 0 always
;		ES 	= CGroup
;		Interrupts Disabled
;		DS, SS, SP, BP preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMShutDown	proc	near
;----------------------------------------------------------------------------
;	Save the Shutdown flag for HSM and Media Module
;----------------------------------------------------------------------------
	push	bx			; Save the Entry Flag.
	push	cx			; Save shutdown flag.

;----------------------------------------------------------------------------
;	Clean up the System 
;----------------------------------------------------------------------------
	call	MSMSetShutDownBits	  ; Set shutdown bits in config tables
	call	MSMClearSendQueue	  ; Clear out any backed up sends
	call	MSMWaitForSendsToComplete ; Wait for active sends to complete

;----------------------------------------------------------------------------
;	Let the Media Shutdown
;----------------------------------------------------------------------------
	pop	cx			; Restore CX for Media Module
	push	cx			; Save shutdown flag
	call	MSMMediaShutdown	; Let media specific mod do its stuff

;----------------------------------------------------------------------------
;	Let the HSM Shutdown
;----------------------------------------------------------------------------
	pop	cx			; Restore CX for MLID
	pop	bx			; Restore Who Called flag.
	push	cx			; Save shutdown flag
	cmp	bl, -1			; Did the HSM Call us.
	je	LSLCallServiceEvents	; then Skip Calling the HSM and Nesl

	call	DriverShutdown		; Let the HSM Clean up.
	cli				; Can't assume anything on return
	cld
	push	cs
	pop	ds			; CGroup

;----------------------------------------------------------------------------
;	Notify NESL of ShutDown
;----------------------------------------------------------------------------
	push	cs
	pop	es				; Set CGroup
	mov	si, offset CGroup:NESL_EPB	; ES:SI -> EPB
	mov	word ptr [si].EPB_ClassName, offset CGroup:NESL_Service_Suspend
	mov	word ptr [si].EPB_EventName, offset CGroup:NESL_MLID_ShutDown
	call	MSMGenerateNESLSuspendEvent

;----------------------------------------------------------------------------
;	Service The Queue
;----------------------------------------------------------------------------
LSLCallServiceEvents:
	mov	bx, MLIDSUP_SERVICE_EVENTS
	call	LSLSupport

;----------------------------------------------------------------------------
;	Check if this is a PermShutDown
;----------------------------------------------------------------------------
	pop	cx				; Restore shut down flag
	or	cx, cx				; Perm. shutdown?
	jnz	ShutDownTemporarily

;----------------------------------------------------------------------------
;	Permenantly Shut the HSM down, and remove from memory.
;----------------------------------------------------------------------------
ShutDownPermenantly:
	or	MSMTxFlags1, PERMSHUTDOWN

;----------------------------------------------------------------------------
;	Restore the Old Interrupt Vector
;----------------------------------------------------------------------------
	call	MSMUnSetIRQ

;----------------------------------------------------------------------------
;	Deregister all the Logical Boards for this MLID with the LSL
;----------------------------------------------------------------------------
	call	MSMDeregisterAllBoards

;----------------------------------------------------------------------------
;	Remove the MLID from Memory
;----------------------------------------------------------------------------
	push	cs
	pop	es     				; Get para address of MLID.
	mov	ah, 49h				; DOS FreeMemory
	int	ENTER_DOS

;----------------------------------------------------------------------------
;	Not a permenant condition
;----------------------------------------------------------------------------
ShutDownTemporarily:
	xor	ax, ax				; Signal we made it.
	ret

MSMShutDown	endp


;****************************************************************************
;	HSMResetMSM
;
;	Resets the MSM Internal State Machine.
;	DriverReset IS Called, but a NESL event is not generated.
;
;	assumes:
;		DS	CGroup
;		Interrupts are Disabled
;		CLD executed
;
;	returns:
;		AX	=0 always
;		DS	CGroup
;		Interrupts Disabled
;		DS, SS, SP, BP preserved
;****************************************************************************
HSMResetMSM	proc near
	xor	bx, bx
;	jmp short MSMReset	; Fall into MSMreset.

HSMResetMSM	endp

ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMReset
;
;	Resets the board.  If we were temporarily shutdown we will bring
;	ourselves back into operation.
;
;	assumes:
;		DS	CGroup
;		AX	Board Number
;		CLD has been executed
;		Interrupts are disabled
;
;	returns:
;		AX	=0 always
;		Interrupts disabled
;
; Remarks:	This routine is only called by the MSMControlHandler.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMReset	proc	near
;----------------------------------------------------------------------------
;	Save the Entry flag for HSM and Media Module
;----------------------------------------------------------------------------
	push	bx			; Save the Entry Flag.

;----------------------------------------------------------------------------
;	Get the MLID cleared to go.
;----------------------------------------------------------------------------
	call	MSMWaitForSendsToComplete	; 
	call	MSMMediaReset			; Let the media mod do its thing
	call	DriverReset			; Ask MLID to reset its board
	cli
	cld	  				; Can't assume anything on return
	push	cs
	pop	ds				; DS = CGroup

;----------------------------------------------------------------------------
;	Now Update the LAN Adapter's Multicast settings.
;----------------------------------------------------------------------------
	call	MSMUpdateMulticast		; Reset the Multicast.
	cli
	cld	  				; Can't assume anything on return
	push	cs
	pop	ds				; DS = CGroup

;----------------------------------------------------------------------------
;	Mark each Config Table as NOT SHUTDOWN.
;----------------------------------------------------------------------------
	and	MSMTxFlags1, (NOT SHUTDOWN)	; Mark MLID Not shutdown anymore
	mov	bx, MSMActiveBoardCount		  ; Number of Board/Frames loaded.
	add	bx, bx				  ; Get word index.

MarkResetLoop:
	mov	di, MSMConfigTables[bx-2]	  	    ; BX is 1-based
	and	byte ptr [di].MSharingFlags, (NOT SHUTDOWN) ; Clear shutdown bit
	sub	bx, 2					    ; Next Board.
	jnz	MarkResetLoop				    ; Hit them all

;----------------------------------------------------------------------------
;   If MSMReset was called from the HSM then don't do the NESL Notification.
;----------------------------------------------------------------------------
	pop	cx
	jcxz	SkipResetNESLEvent

;----------------------------------------------------------------------------
;	Notify NESL of Reset
;----------------------------------------------------------------------------
	push	cs
	pop	es				; Set CGroup
	mov	si, offset CGroup:NESL_EPB
	mov	word ptr [si].EPB_ClassName, offset CGroup:NESL_Service_Resume
	mov	word ptr [si].EPB_EventName, offset CGroup:NESL_MLID_Reset
	call	MSMGenerateNESLResumeEvent

;----------------------------------------------------------------------------
;	Mark successful and return
;----------------------------------------------------------------------------
SkipResetNESLEvent:
	xor	ax, ax
	ret
MSMReset	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMSetLookAheadSize
;
;	assumes:
;		AX	Board Number
;		CX	New look ahead size (0-128)
;		DS 	CGroup
;		Interrupts disabled
;
;	returns:
;		AX	=0 if CX was <= to MaxLookAheadLength
;			= LSLERR_BAD_PARAMETER if too large
;		Interrupts disabled
;		DS,BP,SS,SP are preserved.
;
; Remarks:	This routine is only called by the MSMControlHandler.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMSetLookAheadSize	proc	near
;----------------------------------------------------------------------------
;	Check if the LookAheadSize is already Larger than desired.(cx)
;----------------------------------------------------------------------------
	cmp	DriverConfigTable.MLookAheadSize, cx	; Don't allow to decrease size.
	jae	DoneSettingLookAheadSize

;----------------------------------------------------------------------------
;	Check that the Size is not too Large
;----------------------------------------------------------------------------
	mov	ax, LSLERR_BAD_PARAMETER
	cmp	cx, MaxLookAheadLength
	ja	DoneSettingLookAheadSizeError

;----------------------------------------------------------------------------
;	Change the size for each Frame (board) loaded.
;----------------------------------------------------------------------------
	mov	bx, MSMActiveBoardCount			; Number of boards loaded.
	add	bx, bx					; get word index

SetLookAheadSize:
	mov	di, word ptr MSMConfigTables[bx-2]	; BX is one based.
	mov	word ptr [di].MLookAheadSize, cx	; set new size
	sub	bl, 2					; next table
	jnz	SetLookAheadSize			; nz => some remain

	call	DriverChangeLookAheadSize		; Notify the HSM

DoneSettingLookAheadSize:
	sub	ax, ax					; Signal Success

DoneSettingLookAheadSizeError:
	ret

MSMSetLookAheadSize	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMPromiscuousChange
;
;	assumes:
;		AX	Board Number
;		CX     Bit Mask for Promiscuous Mode and frame reception.
;			PROM_OFF 	(00h)	= Promiscuous Mode off.
;			PROM_MAC	(01h)	= MAC Frames
;			PROM_NON_MAC	(02h)	= Non-MAC Frames
;			PROM_SMT	(04h)	= SMT Frames
;		DS = CGroup
;
;		Interrupts disabled
;
;	returns:
;		AX	0	Successful
;			LSLERR_BAD_PARAMETER (8002h)	Board Nubmer is Invalid
;			LSLERR_BAD_COMMAND   (8008h)	Bad Command
;
;		Interrupts disabled
;
; Remarks:	This routine is only called by the MSMControlHandler.
;		who takes care of all the Preservation issues.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMPromiscuousChange	proc	near
;----------------------------------------------------------------------------
;	See if the HSM even Supports Promiscuous Mode.
;----------------------------------------------------------------------------
	mov	ax, LSLERR_BAD_COMMAND			; Possible error
	test	DriverConfigTable.MModeFlags, MPromiscuousModeBit ; Test support Promiscuous Mode
	jz	DoneSettingPromisModeError		; Flag set after ret.

;----------------------------------------------------------------------------
;	See if the Board is already in Promis mode.
;----------------------------------------------------------------------------
	cmp	cx, MSMActivePromisMask		; Test if same as current.
	je	DoneSettingPromisMode		; e - Then Done Setting mode.

;----------------------------------------------------------------------------
;	Save Promiscuous Mode flag
;----------------------------------------------------------------------------
	mov	MSMActivePromisMask, cx		; Update promiscuous mode mask.
	push	cx				; Save for DriverPromiscuousChange.

;----------------------------------------------------------------------------
;    Have the LSL Call Each Protocol Stack that is bound to one of our boards
;----------------------------------------------------------------------------
	mov	bx, MSMActiveBoardCount		  ; Number of Board/Frames loaded.
	mov	dx, -1				  ; Notify all stacks.
	mov	si, cx				  ; Get promiscuous mode.

NotifyStackLoop:
	push	bx				  ; BX = Number of active Boards word index.
	add	bx, bx				  ; Get word index.
	mov	di, MSMConfigTables[bx-2]
	mov	cx, [di].MBoardNumber		  ; CX = the board number.(for Protocol param.)
	mov	bp, cx				  ; BP= board number.
   	mov	ax, INFORM_PROMISCUOUS_CHANGE	  ; AX= Protocol control Function
	mov	bx, MLIDSUP_CONTROL_STACK_FILTER  ; BX= LSL Control Function
	call	LSLSupport
	pop	bx
	dec	bx				  ; Next Table
	jnz	NotifyStackLoop

;----------------------------------------------------------------------------
;	Notify the HSM of the Change
;----------------------------------------------------------------------------
	pop	cx
	push	cx				; Save for MSMUpateCheck.
	call	DriverPromiscuousChange		; Call HSM to change promiscuous mode.
	pop	cx	

;----------------------------------------------------------------------------
;	If we are now out of Promiscuous Mode, Need to update Multicast.
;----------------------------------------------------------------------------
	or	cx, cx		
	jnz	DoneSettingPromisMode		; nz => not out of promiscuous Mode.

	call	MSMUpdateMulticast		; Ensure NIC has valid Multicast Addr's.

DoneSettingPromisMode:
	sub	ax, ax				; Set return Code.

DoneSettingPromisModeError:
	ret

MSMPromiscuousChange	endp

ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMRegTxMonitor
;
;	assumes:	
;		AX = Board Number
;		CX	Zero		Disable Transmit Monitor
;			Non-Zero	Enable Transmit Monitor
;		ES:SI -> Transmit Monitor Routine
;		Interrupts disabled
;
;	returns:
;		ax	0	Successful
;			8001h	LSLERR_OUT_OF_RESOURCES
;
;		Flags according to AX
;		DS, BP, SS, SP preserved
;		Interrupts disabled
;
; Remarks:	This routine is only called by the MSMControlHandler.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMRegTxMonitor	proc	near
	jcxz	TestDisableTxMon		; Test for Disable Transmit Monitor

;----------------------------------------------------------------------------
;	Enable Transmit Monitor
;----------------------------------------------------------------------------
	mov	ax, LSLERR_OUT_OF_RESOURCES	; Possible error
	cmp	word ptr MSMTxMonPtr+2, 00h	; ptr. to Transmit Monitor Tx Routine
	jne	MSMRegTxMonitorError		; NE - Only 1 at a time, Error exit

	mov	word ptr MSMTxMonPtr, si	; Store Transmit Monitor Address.
	mov	word ptr MSMTxMonPtr+2, es

MSMRegTxMonitorExit:			
	sub	ax, ax		; Set Success code

MSMRegTxMonitorError:		; NZ flag already set and ax has code.
	ret

;----------------------------------------------------------------------------
;	Make sure the Monitor is the same before we disable.
;----------------------------------------------------------------------------
TestDisableTxMon:
	mov	ax, LSLERR_BAD_PARAMETER
	cmp	word ptr MSMTxMonPtr, si	; ES:SI -> Transmit Monitor Routine
	jne	MSMRegTxMonitorError		; NZ - Not the same

	mov	bx, es				; BX = Segment value of Monitor
	cmp	word ptr MSMTxMonPtr+2, bx	; See if the segments match
	jne	MSMRegTxMonitorError		; NZ - Not the same

;----------------------------------------------------------------------------
;	Simple Disable -- Place Nulls into the TxMonitor Ptrs.
;----------------------------------------------------------------------------
	mov	word ptr MSMTxMonPtr+2, cx
	mov	word ptr MSMTxMonPtr, cx
	jmp short MSMRegTxMonitorExit

MSMRegTxMonitor	endp

ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Name:		MSMDriverManagement (Driver Control Function 14)
;
; Description:	This routine will verify the PID field of the ECB 
;		passed in may be valid, and call the HSM's DriverManagement.
;
; ON ENTRY:	AX	N/A
;		BX	N/A
;		CX	N/A
;		DX	N/A
;		BP	N/A
;		SI	offset of ECB
;		DI	N/A
;		CS	CGroup
;		DS	N/A
;		ES	segment for ECB
;	
;		NOTE:	Interrupts are disabled
;
; ON RETURN:	AX	See Completion
;		BX	Destroyed
;		CX	Destroyed
;		DX	Destroyed
;		BP	Destroyed
;		SI	Destroyed
;		DI	Destroyed
;		CS	CGroup
;		DS	Destroyed
;		ES	Destroyed
;
; 		Flags:	N/A
;		
; 		Note:	Interrupts are disabled
;
;		Completion codes:
;			0000h - Successful, relinquishing ECB.
;			0001h - Successful, holding on to ECB.
;			8002h - Bad Parameter.  First byte of ECB protocol
;				 ID field is not above 40h.
;			8008h - Bad Command. Driver Management not supported.
;			800Ah - No such handle.  MLID does not support the 
;				 Protocol ID.
;
; Remarks:	This routine is only called by the MSMControlHandler.
;
; See Also:	MSMControlHandler
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMDriverManagement	proc	near
;----------------------------------------------------------------------------
;	Check for valid Control ECB ProtID
;----------------------------------------------------------------------------
	mov	ax, LSLERR_BAD_PARAMETER
	cmp	byte ptr es:[si].ProtID, 'A'	; First byte must be ASCII charater.
	jb	MSMDriverManagementExit		; 41h or greater?

	cmp	byte ptr es:[si].ProtID,'~'	; 7Eh or Less?
	ja	MSMDriverManagementExit		

	mov	ax, LSLERR_BAD_COMMAND		; Set up AX for the IOCTL not 
						;  supported by HSM.  HSM will
						;  overwrite AX if IOCTL is supported.
	jmp	DriverManagement		; Jump to HSM and return to 
						;  MSMControlHandler from there.

MSMDriverManagementExit:
	ret

MSMDriverManagement	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMEnqueueSend
;
;	Routine queues a Tx ECB.
;
;	assumes:	ds	is set to CGroup
;			es:si	-> Tx ECB
;			Interrupts are disabled and remain disabled
;
;	returns:
;		DS, BP, SS, SP, preserved
;		Interrupts disabled
;
;	Called by the TSM to Q Tx - ECB's
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMEnqueueSend	proc	near
;----------------------------------------------------------------------------
;	Check if Board supports Priority
;----------------------------------------------------------------------------
	test	DriverConfigTable.MFlags, PRIORITY_SUPPORT_BIT
	jz	NonPriority

;----------------------------------------------------------------------------
;	Check if it is a priority packet.
;----------------------------------------------------------------------------
	mov	ax, word ptr es:[si].ProtoNum
	cmp	ax, 0FFF0H
	jb	NonPriority
		
	neg	ax		; Invert to Priority level.
	and	al, 07h		; check for Non RawSend as well.
	jz	NonPriority	; 0 => No Priority.

;----------------------------------------------------------------------------
;	Check for Illegal Priority levels.
;----------------------------------------------------------------------------
	cmp	al, DriverConfigTable.MPrioritySup
	ja	NonPriority

;----------------------------------------------------------------------------
;	Priority Packet Pass on to the HSM for Priority Handling.
;	AL = Raw Priority Number
;	ES:SI -> Tx ECB.
;----------------------------------------------------------------------------
	jmp word ptr MSMPriorityQSupportPtr	; Jump to HSM's Support Function.

;----------------------------------------------------------------------------
;	Prepare the ECB to be added to the link
;----------------------------------------------------------------------------
NonPriority:
   	mov	es:[si].NextLink+0, 0		; Terminate it
	mov	es:[si].NextLink+2, 0		; 
	mov	es:[si].Status, TXQUEUED	; Mark ECB is Queued.

;----------------------------------------------------------------------------
;	Add ECB to the TAIL
;----------------------------------------------------------------------------
	mov	ax, es				; AX:SI -> ECB to Q
	les	di, dword ptr MSMTxQueueTail	; ES:DI -> ECB at Tail
	mov	word ptr MSMTxQueueTail+0, si	; Link in new ECB
	mov	word ptr MSMTxQueueTail+2, ax
	mov	es:[di].NextLink+0, si
	mov	es:[di].NextLink+2, ax
	inc	DriverStatTable.MQueueDepth	; Track the Queue Depth
	or	MSMTxFlags1, TXQUEUED		; Signal that ECB is on Q
	ret

MSMEnqueueSend	endp


;****************************************************************************
;	MSMClearSendQueue
;
;	Routine makes sure the send queue is empty.  Any Tx ECB's found
;	on the queue will have there Status field set to FAIL and the
;	corresponding ESR will be called.
;
;	assumes:
;		DS	is set to CGroup
;		Interrupts are disabled and remain disabled
;
;	returns:
;		Interrupts disabled
;		DS, BP, SS, SP preserved
;
;****************************************************************************
MSMClearSendQueue	proc	near
;----------------------------------------------------------------------------
;	Check to see if the Q has anything on it.
;----------------------------------------------------------------------------
	les	si, MSMTxQueueHead		; ES:SI -> Start of Q
	mov	ax, es	
	or	ax, si
	jz	QueueIsEmpty			; z => Empty q

;----------------------------------------------------------------------------
;	Something on Q need to unlink and return the ECB's
;----------------------------------------------------------------------------
	mov	ax, es:[si].NextLink+0		; Unlink it (Offset)
	mov	word ptr MSMTxQueueHead+0, ax
	mov	ax, es:[si].NextLink+2		; = Next ECB in Q    (Segment
	mov	word ptr MSMTxQueueHead+2, ax	; Save in Head pointer.

	mov	es:[si].Status, LSLERR_FAIL	; Mark the ECB
	mov	bx, MLIDSUP_SEND_COMPLETE	
	call	LSLSupport			; Give back to the LSL to pass on.
	jmp short MSMClearSendQueue		; Go back till Q is empty.

;----------------------------------------------------------------------------
;	Queue is now empty, mark the flags, and correct the Tail pointer.
;----------------------------------------------------------------------------
QueueIsEmpty:
	and	MSMTxFlags1, (NOT TXQUEUED)
	mov	word ptr MSMTxQueueTail+0, offset CGroup:MSMTxQueueHead
	mov	word ptr MSMTxQueueTail+2, cs
	ret

MSMClearSendQueue	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMWaitForSendsToComplete
;
;	Waits for the HSM to signal that there are no outstanding 
;	transmits.
;
;	assumes:	
;		DS	CGroup
;		Interrupts are disable 
;
;	returns:
;		AX destroyed
;		All other registers preserved
;		Interrupts are disabled, but were temporarily enabled
;
;	Internally Called by MSMReset, and MSMShutDown.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMWaitForSendsToComplete	proc	near
;----------------------------------------------------------------------------
;	How many should be free?
;----------------------------------------------------------------------------
	mov	al, MSMMaxActiveTx

;----------------------------------------------------------------------------
;	Wait till they all are returned.
;----------------------------------------------------------------------------
WaitForSends:
	sti				; Allow the Interrupts to fly
slow					; Wait a bit to let them clear
	cli				; Hold off now.
	cmp	MSMTxFreeCount, al
	jne	WaitForSends

	ret

MSMWaitForSendsToComplete	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMSetShutDownBits
;
;	Sets the shutdown bits in all active configuration tables.
;
;	assumes:
;		DS	is set to CGroup
;		Interrupts are disabled and remain disabled
;
;	returns:
;		BX,DX,DI destroyed
;		Interrupts disabled
;
;	Only Called Internally from MSMShutDown
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMSetShutDownBits	proc	near
;----------------------------------------------------------------------------
;	Mark the entire MLID as shutdown
;----------------------------------------------------------------------------
	or	MSMTxFlags1, SHUTDOWN	; Mark us as ShutDown

;----------------------------------------------------------------------------
;	Mark each individual Config Table as Shutdown
;----------------------------------------------------------------------------
	mov	bx, MSMActiveBoardCount		; get Number of Frames
	add	bx, bx				; get word index
	jz	MSMSetShutDownBitsExit		; Make sure greater than zero


SetShutDownBitLoop:
	mov	di, MSMConfigTables[bx-2]	 	; DI -> ConfigTable
	or	byte ptr [di].MSharingFlags, SHUTDOWN	; Set shutdown bit
	sub	bl, 2
	jnz	SetShutDownBitLoop		 	; z => got them all

MSMSetShutDownBitsExit:
	ret

MSMSetShutDownBits	endp

ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMDeregisterAllBoards
;
;	Deregisters all active boards
;
;	assumes:
;		DS	CGroup
;		Interrupts disabled
;
;	returns:
;		DS, SS, SP preserved
;		Interrupts disabled, however ints were enabled temp.
;
;	Only Called Internally from MSMShutdown
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMDeregisterAllBoards	proc	near
;----------------------------------------------------------------------------
;	Start up the Ints before notifying the LSL of our Leaving
;----------------------------------------------------------------------------
	mov	bx, MSMActiveBoardCount
	add	bx, bx				; get word index
	jz	NoBoardsToDeregister

	sti

DeregisterVirtBoardLoop:
	mov	si, MSMConfigTables[bx-2]
	mov	ax, [si].MBoardNumber		;Get the board number
	push	bx
	mov	bx, MLIDSUP_DEREGISTER_MLID
	call	LSLSupport
	pop	bx
	sub	bl, 2
	jnz	DeregisterVirtBoardLoop

	mov	MSMActiveBoardCount, bx		; Set to 0

;----------------------------------------------------------------------------
;	The LSL has been notified, hold off the ints, and continue.
;----------------------------------------------------------------------------
	cli

NoBoardsToDeregister:
	ret

MSMDeregisterAllBoards	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMUpdateConfigTables
;		Called by the TSM to update the various Instances of the 
;		Config table after a change may have occurred to the 
;		Base Config table.
;       	i.e. a PCMCIA card is re-inserted into a machine.
;
;	On Entry:
;		DS = ES = CGroup	
;		Interrupts are disabled.
;	
;	On Return:
;		AX = 0
;		DS, BP, SS, SP preserved.
;		Interrupts are disabled.
;
;	Called by the TSM MSMMediaConfigUpdate
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMUpdateConfigTables	proc	near
;----------------------------------------------------------------------------
;	Check on Priority Support
;----------------------------------------------------------------------------
	mov	al, DriverConfigTable.MPrioritySup	; See if HSM is expecting
	or	al, al
	jz	NoPrioritySupport

	mov	cx, word ptr MSMPriorityQSupportPtr	; Has HSM provided Support Routine.
	jcxz	NoPrioritySupport

	or	word ptr DriverConfigTable.MFlags, PRIORITY_SUPPORT_BIT	; Signal support.

;----------------------------------------------------------------------------
;	Signal the Card is ready (almost)
;	Mark Entire MLID as ALIVE
;	Mark Config Table as ALIVE, Then allow Copies to be made.
;----------------------------------------------------------------------------
NoPrioritySupport:
	and	MSMTxFlags1, (NOT SHUTDOWN)	; Not shutdown anymore
	and	byte ptr DriverConfigTable.MSharingFlags, (NOT SHUTDOWN) 

;----------------------------------------------------------------------------
;	Update Each Table Based on Config Table 0
;----------------------------------------------------------------------------
	mov	bx, MSMActiveBoardCount		; How Many Boards are Active?
	dec	bx				; BX = 0 based Count
	jz	NoOtherConfigTables		; If only one table don't need to update.

	add	bx, bx				; Word index (Zero Based)

;----------------------------------------------------------------------------
;	Get pointers to new and base tables.
;----------------------------------------------------------------------------
SetupConfigTablesLoop:
	mov	si, MSMConfigTables[0]		; SI -> Original Table
	mov	di, MSMConfigTables[bx]		; DI -> New Config Table

;----------------------------------------------------------------------------
;	Move over All values through MConfigTableMinorVer
;----------------------------------------------------------------------------
	mov	cx, MNodeAddress - MSignature	; Load Top of Table
 rep	movsb

;----------------------------------------------------------------------------
;	Skip past Node Address -> MCardLongName
;----------------------------------------------------------------------------
	add	si, 18		; Skip past
	add	di, 18 		; 

;----------------------------------------------------------------------------
;	Update From MCardLongName to MFrameString
;----------------------------------------------------------------------------
	mov	cx, MFrameString - MCardLongName
 rep	movsb

;----------------------------------------------------------------------------
;	Skip over the MFrameString
;----------------------------------------------------------------------------
	add	si, 4
	add	di, 4		; Skip past MFrameString field
	
;----------------------------------------------------------------------------
;	Move over Reserved0 
;----------------------------------------------------------------------------
	movsw			; Copy over the reserved field

;----------------------------------------------------------------------------
;	Skip over FrameID
;----------------------------------------------------------------------------
	add	si, 2
	add	di, 2				;Skip the FrameID field

;----------------------------------------------------------------------------
;	Move over From MTransporttime to end of Table.
;----------------------------------------------------------------------------
	mov	cx, MDMALine2+1 - MTransportTime
 rep	movsb


;----------------------------------------------------------------------------
;	Update the MModeFlags field
;----------------------------------------------------------------------------
	mov	di, MSMConfigTables[bx]
	mov	ax, DriverConfigTable.MModeFlags
	and	ax, NOT (MNonCanonicalBit or MSupportLSBMSB) ; Don't change Cannonical Setting.
	and	[di].MModeFlags, MNonCanonicalBit or MSupportLSBMSB ; Save Cannonical Setting clear other bits.
	or	ax, MRawSendBit or MLDataSizeBit 	; Signal our support, Set Special Reserve bit.
	or	[di].MModeFlags, ax			; Update ModeFlag Settings.

;----------------------------------------------------------------------------
;	Clear the polling bit in this configuration table. 
;	Only the first config table signals polling.
;----------------------------------------------------------------------------
	and	[di].MModeFlags, NOT MNeedsPollingBit
	sub	bl, 2				;Next config table 
	jnz	SetupConfigTablesLoop

NoOtherConfigTables:
	xor	ax, ax			; Return No Error ALWAYS
 	ret

MSMUpdateConfigTables	endp

ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;	MSMCallNESL
;	
;	On Entry:
;		BX = NESL FunctionNumber
;		ES:SI -> NESL Control Block
;		Interrupts are UnSpecified
;	
;	On Exit:
;		AX = Completion code
;			Completion Codes:
;				0 successful
;				8002h LSLERR_BAD_PARAMETER
;				8005h LSLERR_FAIL
;				8008h LSLERR_BAD_COMMAND
;
;		PSW set according to AX
;		Interrupts are preserved
;		DS, BP, SS, SP are preserved.
;
;		HSM's Entry point to the NESL services.
;	(See Netware Event Service Layer Documentation for details.)
;****************************************************************************
MSMCallNESL	proc near
	call	dword ptr cs:NESLSupport	; Pass on untouched.
	ret

;----------------------------------------------------------------------------
;	Far call procedure that NESLSupport points at if NESL not Present.
;----------------------------------------------------------------------------
NoNESL:
	mov	ax, LSLERR_BAD_COMMAND
	or	ax, ax
	retf
MSMCallNESL	endp

;****************************************************************************
;	MSMGenerateNESLSuspendEvent
;	This routine is for generating NESL Suspend Class Events for
;	each logical board.  The MSM will stuff a pointer to the correct
;	configuration table into the EBP_DATAPTR0 field.
;
;	Assumes:
;		DS	CGroup
;		ES:SI = Ptr to NESL EVENT Parameter Block (EPB)
;		Interrupts are Disabled.
;
;	Returns:
;		AX = Completion Code
;			0 = successful
;			8002h LSLERR_BAD_PARAMETER
;			8005h LSLERR_FAIL
;			8008h LSLERR_BAD_COMMAND
;		Flags set according to AX
;		Interrupts are preserved.
;		DS, BP, SS, SP are preserved.
;****************************************************************************
MSMGenerateNESLSuspendEvent	proc near
	mov	word ptr NESL_SuspendBlock.PECB_DataPtr+0, si
	mov	word ptr NESL_SuspendBlock.PECB_DataPtr+2, es
	mov	si, offset CGroup:NESL_SuspendBlock	; SI = Suspend Block
	jmp short MSMGenerateNESLEventLoadES
MSMGenerateNESLSuspendEvent	endp

;****************************************************************************
;	MSMGenerateNESLResumeEvent
;	This routine is for generating NESL Resume Class Events for
;	each logical board.  The MSM will stuff a pointer to the correct
;	configuration table into the EBP_DATAPTR0 field.
;
;	Assumes:
;		DS	CGroup
;		ES:SI = Ptr to NESL EVENT Parameter Block (EPB)
;		Interrupts are Disabled.
;
;	Returns:
;		AX = Completion Code
;			0 = successful
;			8002h LSLERR_BAD_PARAMETER
;			8005h LSLERR_FAIL
;			8008h LSLERR_BAD_COMMAND
;		Flags set according to AX
;		Interrupts are preserved.
;		DS, BP, SS, SP are preserved.
;****************************************************************************
MSMGenerateNESLResumeEvent	proc near
	mov	word ptr NESL_ResumeBlock.PECB_DataPtr+0, si
	mov	word ptr NESL_ResumeBlock.PECB_DataPtr+2, es
	mov	si, offset CGroup:NESL_ResumeBlock
	jmp short MSMGenerateNESLEventLoadES
MSMGenerateNESLResumeEvent	endp

;****************************************************************************
;	MSMGenerateNESLChangeEvent
;	This routine is for generating NESL Service Change Class Events for
;	each logical board.  The MSM will stuff a pointer to the correct
;	configuration table into the EBP_DATAPTR0 field.
;
;	Assumes:
;		DS	CGroup
;		ES:SI = Ptr to NESL EVENT Parameter Block (EPB)
;		Interrupts are Disabled.
;
;	Returns:
;		AX = Completion Code
;			0 = successful
;			8002h LSLERR_BAD_PARAMETER
;			8005h LSLERR_FAIL
;			8008h LSLERR_BAD_COMMAND
;		Flags set according to AX
;		Interrupts are preserved.
;		DS, BP, SS, SP are preserved.
;
;****************************************************************************
MSMGenerateNESLChangeEvent	proc near
	mov	word ptr NESL_ChangeBlock.PECB_DataPtr+0, si
	mov	word ptr NESL_ChangeBlock.PECB_DataPtr+2, es
	mov	si, offset CGroup:NESL_ChangeBlock	
 ;	jmp short MSMGenerateNESLEventLoadES	; Fall through code
MSMGenerateNESLChangeEvent	endp

;****************************************************************************
;	MSMGenerateNESLEvent
;
;	Generic Event Producer front end to the NetWare Event Service Layer 
;	(NESL).  This routine will generate an event for each logical board.
;	The HSM calls this for Event Clases the MSM didn't register for, and
;	which the HSM has registered directly (via MSMCallNESL).  The MSM 
;	will stuff a pointer to the correct configuration table into the 
;	EBP_DataPtr0 field.
;
;	Assumes:
;		DS	CGroup
;		ES:SI = ptr to NESL Producer Event Control Block (PECB)
;		Interrupts are Disabled
;
;	Returns:
;		AX = Completion Code
;			0 = successful
;			8002h LSLERR_BAD_PARAMETER
;			8005h LSLERR_FAIL
;			8008h LSLERR_BAD_COMMAND
;		Flags set according to AX
;		Interrupts are preserved.
;		DS, BP, SS, SP are preserved.
;
;****************************************************************************
MSMGenerateNESLEventLoadES:
	push	cs
	pop	es		; ES:SI -> NESL Producer Control Block

MSMGenerateNESLEvent	proc	near
;----------------------------------------------------------------------------
;	Preserve the required.
;----------------------------------------------------------------------------
	push	ds
	push	bp

;----------------------------------------------------------------------------
;	Set up for generating events for each Logical Board.
;----------------------------------------------------------------------------
	mov	bx, MSMActiveBoardCount		   ; BX = Number of Board/Frames loaded.
	lds	bp, dword ptr es:[si].PECB_DataPtr ; DS:BP -> EPB Block
	mov	word ptr ds:[bp].EPB_DataPtr0 + 2, cs ; Initialize the Segment value

NotifyNESLMLIDEventLoop:
	push	bx				  ; BX = Number of active Boards word index.
	add	bx, bx				  ; Get word index.
	mov	di, cs:MSMConfigTables[bx-2]	  ; BX is 1-based.
	mov	word ptr ds:[bp].EPB_DataPtr0, di	  ; Load Config offset into EPB block
	mov	bx, NESL_EVENT_NOTIFICATION	  ; Notify NESL
	call	MSMCallNESL
	pop	bx
	dec	bx
	jnz	NotifyNESLMLIDEventLoop

;----------------------------------------------------------------------------
;	Restore the preserved Segment Registers.
;----------------------------------------------------------------------------
	pop	bp
	pop	ds
	ret
MSMGenerateNESLEvent	endp

Code	ends

ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;	I N I T I A L I Z A T I O N   C O D E 
;****************************************************************************
Init	segment	para public 'CODE'
;----------------------------------------------------------------------------
;	Functions Provided by the MSM
;----------------------------------------------------------------------------
	public	MSMPrintCommaSpace		
	public	MSMCondenseString
	public	MSMCompareString		
	public	MSMEatWhite		
	public	MSMPrintStringZero	
	public	MSMPrintPlatformString
	public	MSMPrintDoubleHex	
	public	MSMAtoH			
	public	MSMItoA			
	public	MSMEatLeadingZeros		
	public	MSMPrintSixByteHexString
	public	MSMPrintHexChar
	public	MSMGetHexChar		
	public	MSMHexCharToInt		
	public	MSMAtoI			
	public  MSMAtoL
	public	MSMHexToDoubleInt	
	public	MSMHexToInt		
	public	MSMHexStringToByteArray	
	public	MSMGetStringLength	
	public	MSMAlloc		
	public	MSMBitSwapAddress


ifdef DEBUG		;Internal Use Only. 
	public	MLIDInitialization
	public	InitMSM
	public	CountExistingMLIDs
	public	PrintOutBoardsConfig
	public	InitializeTheBoard
	public	ProcessSectionTextForThisBoard
	public	ProcessNetCFG
	public	MatchSectionText
	public	FindAndOpenNetCfgFile
	public	GetALine, SetupBoardSectionHeader, FindMainSectionHeader
	public	DoDMAKeyword, DoIRQKeyword, DoMEMKeyword, DoPORTKeyword
	public	DoSlotKeyword, DoNodeKeyword, DoProtoKeyword
	public	DoFrameKeyword, DoLookAheadKeyword
	public	ShiftDXDIBy4, MSMIsHexChar
	public	UnloadDriver, FindBoard 
	public	ConvertCommandLineToUpperCase
	public	CheckForCmdSwitch
	public	MSMSetUpBitSwapTable
	public	DisplayResidentDriver
endif

;----------------------------------------------------------------------------
;	Variables Provided by the MSM
;----------------------------------------------------------------------------
	public	MSMNewLine		; MSMTxt.inc
	public	MSMSameTypeMLIDCount	
	public	LSLInitEntryPoint	
	public	LSLEntryPoints

ifdef DEBUG		;Internal Use Only. 
	public	MSMVerMSG
	public	MSMImageEnd		
	public	SectionTextPresentFlag
	public	FileHandle		
	public	MSMCurrentLine
	public	MLIDControlEntryPoint
	public	OurInitInfoBlock	
	public	LSLInfoReturnBlock
	public	NumProtoIDsToAdd	
	public	ProtoIDTable
	public	WorkBuffer, LineBuffer, CondensedLineBuffer
	public	KeywordTextTable, KeywordTextLen, KeywordProcessTable
endif

;----------------------------------------------------------------------------
;	Functions Provided by the TSM.
;----------------------------------------------------------------------------
	extrn	InitializeMedia		:near
	extrn	SupportedMedias		:word	;Found in media module

;----------------------------------------------------------------------------
;	Variables Provided by the HSM
;----------------------------------------------------------------------------
	extrn	DriverSignOnMessage	:byte
	extrn	DriverMainSectionText	:byte
	extrn	DriverNumKeywords	:abs
	extrn	DriverKeywordText	:word
	extrn	DriverKeywordTextLen	:word
	extrn	DriverProcessKeywordTab	:word


ifdef DEBUG		;Internal Use Only. 
ifdef TASM
%NEWPAGE ;
endif
	;--------------------------------------------------------------------
	;  debuging declarations  (LABELS)
	;--------------------------------------------------------------------
		; MLIDInitialization
	public	LookForLSLLoop, LookForLSL, Int2fSlotUsed
	public	WrongLSLVersion, RightLSLVersion, NotOnAPS2, NotEISABus
	public	NotOn386, MustBeOnAPCXT, NoCardServices, NoEnvironmentToFree
	public	CloseHandlesLoop, DontStayResident, ErrorExit
		; InitMSM
	public	NetcfgThere, WeAreOnlyMLIDOfOurType, SkipPrintingBoardsConfig
	public	BoardFailedInit
		; CountExistingMLIDs
	public	CountSameBoardLoop, GotoNextBoard, BoardNotThere
		; PrintOutBoardsConfig
	public	HardOptionsDefined, NoSlot, NotInt1, NotInt2
	public	NotDMA1, NotDMA2, NotIO1, NotIO2, NotMem1, NotMem2
	public	DontPrintNodeAddress, SkipEatComma
	public	MaxFrameNotKnown, Mbps, LineSpeedNotKnown, NoLineInfo
	public	PrintLogicalBoardLoop, ModeFramePrint, NextFrameNewLine
			; Initialize the Board
	public	DontBumpAddCount, AddPIDLoop, ContinueAddingPIDs
	public	ErrorAddingPID, LookForMediaStringLoop, FoundMediaString
	public	PrintMediaNameError, InitTheBoard, DriverIsPolled
		; ProcessSectionTextForThisBoard
	public	ErrorRegisteringExit, FindDefaultPIDUsingMediaLoop
	public	FoundDefaultPID, DontUseDefaultPID, SetupBoardLoop
	public	NoErrorsRegistering, DontSetSRSegmentValue, SetSegmentLoop
	public	NoCustomCounters, AllDoneSettingUpBoards
		; ProcessNetCFG
	public	TryTheNextLine, AllDoneProcessingNetCFG, ClearFrameUseFlags
	public	VarIsCorrect, FoundRealSectionText
		; MatchSectionText
	public	FindSectTextLoop, FindDriverDefinedKeywordLoop
	public	FoundDriverSectionTextMatch, MatchSectExit 
	public	FoundSectionTextMatch
		; GetALine
	public	KeepReading, CharOkay, EndOfFile, ErrReading
		; SetupBoardSectionHeader
	public	FindNextSectionHeading, NoMainSectionHeader
	public	FoundOurSectionHead, NoMainSectionHeader1
	public	NoMainSectionHeader2
		; FindMainSectionHeader
	public	LookForSectionTextLoop, CountString, NotMainSection
		; MSMCondenseString, MSMCompareString, MSMEatWhite
	public	MSMCondenseStringLoop, CompareStrExit, EatWhLoop
		; DoNodeKeyword
	public	StoreSpecifier, NoLSBMSBoverride
	public	InvalidNodeAddress1, InvalidNodeAddress
		;DoProtoKeyword
	public	FindMediaNameMatchLoop1, HandleDumbUser, ReinitFirstStackSlot
	public	DontRestoreDefaultStackInfo, FoundMediaNameMatch1
		; DoFrameKeyword
	public	FindMediaNameMatchLoop
	public	FoundMediaNameMatch, DontAllocate, MSBMode, LSBMode
	public	DuplicateFrameTypeError
		; UnloadDriver
	public	UnloadErrorExit, BoardNotFound
	public	TSRAboveResidentMLID
	public	DoTheUnload, CheckNextMCB, ForceUnload

		; CheckForCmdSwitch
	public	CommandLineHasSomething, ScanCharsLoop, CharAlreadyFound
	public	NotAChar, NoCmdLineSwitch, CheckParm, FoundHelpSwitch 
	public	NoExtraErrMsg
endif

ifdef TASM
%NEWPAGE ;
endif
;----------------------------------------------------------------------------
;	Module Version Required
;----------------------------------------------------------------------------
	MSMVerMSG	db	'MSM = ',MSMVersion,0	; Must always be present

;----------------------------------------------------------------------------
;	V A R I A B L E   D E C L A R A T I O N S 
;----------------------------------------------------------------------------
	align 4
LSLInitEntryPoint	dd	?		; LSL Initiallization Entry point.
LSLEntryPoints		LSLInitEntryPointBlock <>
MLIDControlEntryPoint	dw	2 dup (0)	; Findboard uses this variable.

MSMImageEnd		dw	offset CGroup:ResidentEnd ; End of the MSM Image.

FileHandle		dw	-1		; Filehandle variable for NET.CFG

MSMSameTypeMLIDCount	db	0		; Count of same type MLIDS

SectionTextPresentFlag	db	0		; Found SectionText

NumProtoIDsToAdd	dw	0		; Add IPX at a minimum

;----------------------------------------------------------------------------
;  Default PID is for IPX only	
;----------------------------------------------------------------------------
ProtoIDStruc	struc
	ProtIDName	db	MaxStackNameLength+2 dup (0) ; Room for Length and Terminator
	ProtIDPID	db	6 dup (0)
	ProtIDMediaID	dw	0
ProtoIDStruc	ends

ProtoIDTable		label	word
ProtoID0		db	3,'IPX',0
			db	MaxStackNameLength+2-5 dup (0)	; Stack Name
			db	6 dup(0)			; PID
			dw	0				; MediaID
ProtoID0Len		equ	$-ProtoID0

IF (ProtoID0Len) gt (size ProtoIDStruc)
	.ERR
	%OUT ProtoID Table Length of Default Not Equal to Size of Struc.
ENDIF

	REPT (MaxStacks*MaxBoards)-1
	 ProtoIDStruc <>	; Setup one for each possible combo
	ENDM
			
;----------------------------------------------------------------------------
;	Working Variables.
;----------------------------------------------------------------------------
	even
LineBuffer		db	256 dup (0)	; GetAline uses this buffer
CondensedLineBuffer	db	256 dup (0)	; FindMainSectionHeader uses this and LineBuffer.
MSMCurrentLine		dw	0		; Line Number Counter.
MLIDConfigSeg		dw	0		; Store Config Segment in DRD
WorkBuffer		db	13 dup (0)	; String Convertions Buffer
MSMKeyWordFlags		db	0		; Keyword processing flags.
OurInitInfoBlock	MLIDInfoBlockStruc <>	 ; Block to Register MLIDS with.
LSLInfoReturnBlock	MLIDRetInfoBlockStruc <> ; Pointers to LSL entry points

;----------------------------------------------------------------------------
;	Generic Keyword Support
;----------------------------------------------------------------------------
KeywordTextTable	dw	offset CGroup:DMAKeyword
			dw	offset CGroup:INTKeyword
			dw	offset CGroup:IRQKeyword
			dw	offset CGroup:MEMKeyword
			dw	offset CGroup:PORTKeyword
			dw	offset CGroup:SlotKeyword
			dw	offset CGroup:SlotKeyword1
			dw	offset CGroup:NodeKeyword
			dw	offset CGroup:ProtoKeyword
			dw	offset CGroup:FrameKeyword
			dw	offset CGroup:FrameKeyword1
			dw	offset CGroup:LookAheadKeyword
			dw	offset CGroup:NESLKeyword
			dw	offset CGroup:BusIDKeyword
NumKeywords		equ	($-KeywordTextTable)/2
		
KeywordTextLen		dw	DMAKeywordLen
			dw	INTKeywordLen
			dw	IRQKeywordLen
			dw	MEMKeywordLen
			dw	PORTKeywordLen
			dw	SlotKeywordLen
			dw	SlotKeywordLen1
			dw	NodeKeywordLen
			dw	ProtoKeywordLen
			dw	FrameKeywordLen
			dw	FrameKeywordLen1
			dw	LookAheadKeywordLen
			dw	NESLKeywordLen
			dw	BusIDKeywordLen

KeywordProcessTable	dw	offset CGroup:DoDMAKeyword
			dw	offset CGroup:DoIRQKeyword
			dw	offset CGroup:DoIRQKeyword	; IRQ keyword.
			dw	offset CGroup:DoMEMKeyword
			dw	offset CGroup:DoPORTKeyword
			dw	offset CGroup:DoSlotKeyword
			dw	offset CGroup:DoSlotKeyword
			dw	offset CGroup:DoNodeKeyword
			dw	offset CGroup:DoProtoKeyword
			dw	offset CGroup:DoFrameKeyword
			dw	offset CGroup:DoFrameKeyword
			dw	offset CGroup:DoLookAheadKeyword
			dw	offset CGroup:DoNESLKeyword
			dw	offset CGroup:DoBusIDKeyword

;----------------------------------------------------------------------------
; Card Services Information Structure
;----------------------------------------------------------------------------
CardServiceInfoStruc	struc
	CS_InfoLen	dw   ?	; Length of data returned by CS.
	CS_Signature	dw   0	; ASCII 'CS' Returned if CS installed.
	CS_Count	dw   ?	; Number of Sockets.
	CS_Revision	dw   ?	; BCD Value of Vendor's CS Revision.
	CS_CSLevel	dw   ?	; BCD Value of CS Release.
	CS_VStrOff	dw   ?	; Offset to Vendor String argument packet.
	CS_VStrLen	dw   ?	; Vendor String length (>=1)
	CS_VendorString	db   ?	; ASCIIZ vendor string buffer area.
CardServiceInfoStruc	ends

CardServiceInfo	CardServiceInfoStruc	<>	; Allocate space.

ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;	MLIDInitialization
;
;	First routine executed after the user has loaded the MLID.
;
;	assumes:	Interrupts are enabled
;			ds=es=cs=CGroup
;
;****************************************************************************
InvalidVersion:
	jmp	ErrorExit
MLIDInitialization	proc	near
;----------------------------------------------------------------------------
;	Identify ourselves.
;----------------------------------------------------------------------------
	cld						; Once and for all
	mov	dx, offset CGroup:DriverSignOnMessage	; Tell who we are.
	call	MSMPrintStringZero
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;Verify that the Config and Stat Table version is concurrent with the ToolKit.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:InvalidVerConfigTable	    ; Possible Error
 	cmp	DriverConfigTable.MConfigTableMajorVer, 1   ; Don't Touch this check
	jne 	InvalidVersion

	cmp	DriverConfigTable.MConfigTableMinorVer, 13  ; Don't Touch this check
	jne	InvalidVersion

	mov	dx, offset CGroup:InvalidVerStatsTable	    ; Possible Error
 	cmp	DriverStatTable.MStatTableMajorVer, 1   ; Don't Touch this check
	jne	InvalidVersion

 	cmp	DriverStatTable.MStatTableMinorVer, 01   ; Don't Touch this check
	jne	InvalidVersion

;----------------------------------------------------------------------------
;	Make sure someone has hooked the Int 2Fh vector.
;----------------------------------------------------------------------------
	mov	ax, (GET_INT_VEC SHL 8) OR MULTIPLEX_INT
	int	ENTER_DOS

	cmp	word ptr es:[bx], 0	; Check if someone is there
	je	LSLNotLoaded		; if Not There, then Not Even LSL is not loaded.

	cmp	word ptr es:[bx+2], 0F000h ; Check still pointing at BIOS default.
	je	LSLNotLoaded		  ; Equal then Vector is pointing at the BIOS
					  ; and the LSL is not loaded.
;----------------------------------------------------------------------------
;	Scan through the slots looking for the LSL.
;----------------------------------------------------------------------------
	mov	ax, 0C000h			;Start after DOS reserved
						;Function 0
LookForLSLLoop:
	push	ax				; AX = Slot number
	push	ds				; DS = CGroup
	int	MULTIPLEX_INT			; Int 2fh
	cmp	al, 0FFh			; Slot used?
	pop	ds				; DS = CGroup
	pop	ax				; AX = Slot Number
	je	Int2fSlotUsed			; e => Someone is on this slot.

LookForLSL:
	inc	ah				; Next slot
	jnz	LookForLSLLoop			; Try it.
	
;----------------------------------------------------------------------------
;	The LSL is not Loaded, Return the Error Message
;----------------------------------------------------------------------------
LSLNotLoaded:
	mov	dx, offset CGroup:LSLNotAroundMsg ; Well the LSL must not be loaded.
	jmp	ErrorExit			  ; Error out.

;----------------------------------------------------------------------------
;	Someone is using this slot.  See if it is the LSL.
;----------------------------------------------------------------------------
Int2fSlotUsed:
	mov	di, si				; ES:DI -> slot signature string
	mov	si, offset CGroup:LSLSignature  ; DS:SI -> What the Sig should be.
	mov	cx, 4				; Check eight chars worth.
 rep	cmpsw
	jnz	LookForLSL			; nz => Not it try the next one.

;----------------------------------------------------------------------------
;	Found the LSL. DX:BX -> LSL Init entry point.
;----------------------------------------------------------------------------
	mov	word ptr LSLInitEntryPoint, bx	 ; Save for later.
	mov	word ptr LSLInitEntryPoint+2, dx ; 

;----------------------------------------------------------------------------
; 	Now see if it is the right version. 
;	Get the LSL's general service entry point.
;----------------------------------------------------------------------------
	push	cs
	pop	es				; ES = CGroup
	mov	si, offset CGroup:LSLEntryPoints ; ES:SI -> LSL Entry Points Block
	mov	bx, LSLINIT_GET_ENTRY_POINTS	; Get ProtSup and GeneralServices
	call	LSLInitEntryPoint		; Support entry points.

	cmp	si, offset CGroup:LSLEntryPoints ;Function 4 returns all Entry points.
	jne	WrongLSLVersion			; Function 3 returns SI destroyed
	
	mov	ax, es
	mov	cx, ds
	cmp	ax, cx
	jne	WrongLSLVersion			; Function 3 returns ES destroyed.

;----------------------------------------------------------------------------
;	Now call the MPI interface to obtain the LSL's config table
;	We need to check the LSL's version to make sure it is 2.11 or 
;	later.  If it is not then fail to load.  We now require a 
;	version of the LSL that can filter packets and other bug fixes.
;----------------------------------------------------------------------------
	mov	bx, PROTSUP_GET_LSL_CONFIG	 ; Get_LSL_Config_Table
	call	LSLEntryPoints.LSLProtSupEntryPt ; Address of MPI handler

	cmp	es:[si].LMajorVersion, 2	; (Major Version number)
	jb	WrongLSLVersion

	cmp	es:[si].LMinorVersion, 11	; Verify 2.11 version of LSL.
	jae	RightLSLVersion

;----------------------------------------------------------------------------
;	Wrong LSL Version Error exit.
;----------------------------------------------------------------------------
WrongLSLVersion:
	mov	dx, offset CGroup:LSLWrongVersion
	jmp short ErrorExit			

;----------------------------------------------------------------------------
;	Now process any command line switches.
;----------------------------------------------------------------------------
RightLSLVersion:
	call	CheckforNESL			; Check for Netware Event Service Layer
	call	ConvertCommandLineToUpperCase	; Make the Commandline uppercase
	call	CheckForCmdSwitch	; Parse Commandline Parameters.
					; Doesn't return on unload or error.

;----------------------------------------------------------------------------
;	Determine the Bus Types and set the MSMSystemFlags variable.
;----------------------------------------------------------------------------
	call	SetMSMSystemFlags

;----------------------------------------------------------------------------
;	Initialize the MSM and Lets get started.
;----------------------------------------------------------------------------
	call	InitMSM				; Now initialize the NIC.
	cmp	MSMActiveBoardCount, 0		; Did it initialize any okay?
	je	DontStayResident

;----------------------------------------------------------------------------
;	Clean up before going TSR
;----------------------------------------------------------------------------
	mov	ax, word ptr cs:2ch	;Free up our environment space
	or	ax, ax		   	;Any environment to free?
	jz	NoEnvironmentToFree

	mov	es, ax			; Environment Segment
	mov	ah, FREE_MEMORY		; Free up the Environment Space 
	int	ENTER_DOS

;----------------------------------------------------------------------------
; Close all of the file handles that have been opened for us since we 
; won't be needing them any longer.  Note that we cannot output anything
; to the screen after this is done.
;----------------------------------------------------------------------------
NoEnvironmentToFree:
	mov	cx, 4			; Close handles 4-0
	
CloseHandlesLoop:
	mov	ah, CLOSE_FILE		; DOS close function
	int	ENTER_DOS
	loop	CloseHandlesLoop

;----------------------------------------------------------------------------
;	Time to Terminate yet Stay Resident.
;----------------------------------------------------------------------------
	mov	dx, MSMImageEnd		; End of our image. <kept, >freed
	add	dx, 15			; round up
	mov	cl, 4			; Make par
	shr	dx, cl			; Return num paragraphs to keep
	mov	ax, TERM_AND_STAY	; DOS Function 31 ErrCode=0
	int	ENTER_DOS		; TSR us
;=============================================================================

DontStayResident:
	mov	dx, offset CGroup:NoBoardsInitedMsg
	call	MSMPrintStringZero
	mov	dx, word ptr DriverConfigTable.MCardShortName	; Get Name of card
	inc	dx						; Skip length.
	call	MSMPrintStringZero
	mov	dx, offset CGroup:NoBoardsInitedMsg2

;----------------------------------------------------------------------------
;	Must be an Error Initializing the DRIVER
;	DX has the Message to explain.
;----------------------------------------------------------------------------
ErrorExit:
	call	MSMPrintStringZero
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero	

	mov	ax, ERROR_EXIT_1	; DOS function 4C, ErrCode=1
	int	ENTER_DOS		;
;=============================================================================

MLIDInitialization	endp

ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	CheckforNESL
;	 This procedure locates the NetWare Event Service Layer
;	 Loads the entry point and returns.
;
;	On Entry:
;		DS = CGroup
;	
;	On Return:
;		All Registers Preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
CheckforNESL	proc near
;----------------------------------------------------------------------------
;	Preserve what is used.
;----------------------------------------------------------------------------
	push	ax
	push	bx
	push	cx
	push	dx
	push	di		; Preserve what is used.
	push	si

;----------------------------------------------------------------------------
;	Default the Entry point for the NESL not present.
;----------------------------------------------------------------------------
	mov	word ptr NESLSupport, offset NoNESL	  ; Save for later.
	mov	word ptr NESLSupport+2, ds ;

;----------------------------------------------------------------------------
;	Scan through the slots looking for the NESL.
;----------------------------------------------------------------------------
	mov	ax, 0C000h			;Start after DOS reserved
						;Function 0
LookForNESLLoop:
	push	ax				; AX = Slot number
	push	ds				; DS = CGroup
	int	MULTIPLEX_INT			; Int 2fh
	cmp	al, 0FFh			; Slot used?
	pop	ds				; DS = CGroup
	pop	ax				; AX = Slot Number
	je	NESLInt2FSlotUsed		; e => Someone is on this slot.

LookForNESL:
	inc	ah				; Next slot
	jnz	LookForNESLLoop			; Try it.

	jmp short NESLNotLoaded			; NESL not loaded	

;----------------------------------------------------------------------------
;	Someone is using this slot.  See if it is the NESL.
;----------------------------------------------------------------------------
NESLInt2FSlotUsed:
	mov	di, si				; ES:DI -> slot signature string
	mov	si, offset CGroup:NESLSignature ; DS:SI -> What the Sig should be.
	mov	cx, 6				; Check 12 chars worth.
 rep	cmpsw
	jnz	LookForNESL			; nz => Not it try the next one.

;----------------------------------------------------------------------------
;	Found the NESL. DX:BX -> NESL Init entry point.
;----------------------------------------------------------------------------
	mov	word ptr NESLSupport, bx	  ; Save for later.
	mov	word ptr NESLSupport+2, dx 	  ;
	or	MSMSystemFlags, NESLFlag	  ; Signal that its available.

;----------------------------------------------------------------------------
;	 Report that the NESL is loaded.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:NESL_Loaded_Msg
	call	MSMPrintStringZero
	
NESLNotLoaded:
	pop	si
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret

CheckforNESL	endp

ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	InitMSM
;
;	assumes:
;		DS=CS	is set to CGroup
;		Interrupts are enabled
;
;	returns:
;		MSMActiveBoardCnt = number of Logical Boards that loaded.
;		If PCMCIA, The logical board will be left in the ShutDown state.
;		Interrupts enabled
;
;   	Called by MLIDInitialization
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
InitMSM	proc	near
	call	MSMClearSendQueue	; init segment value in TxQueueTail
	call	CountExistingMLIDs	; Find out if we are alone.
	push	cs
	pop	es			; ES = CGroup
	call	FindAndOpenNetCfgFile	; Name says it.
	cmp	MSMSameTypeMLIDCount, 0	; Any other MLIDs loaded like us?
	je	WeAreOnlyMLIDOfOurType

	cmp	FileHandle, -1		; Have to have NET.CFG if loading us again
	jne	NetcfgThere		; ne => Have a net.cfg available.

;----------------------------------------------------------------------------
;	No Net.cfg file so exit with Error.
;----------------------------------------------------------------------------
GottoHaveNETCFG:
	mov	dx, offset CGroup:MustHaveNetcfgMsg
	call	MSMPrintStringZero

	mov	ax, ERROR_EXIT_2	;DOS function 4C, ErrCode=2
	int	ENTER_DOS
;============================================================================

;----------------------------------------------------------------------------
;	Either the NET.CFG file is there, or we are accepting defaults.
;	Set the MLookAheadSize field in the first config table to 18.
;----------------------------------------------------------------------------
NetcfgThere:
WeAreOnlyMLIDOfOurType:
	mov	si, MSMConfigTables[0]		; SI -> ConfigTable 0
	mov	[si].MLookAheadSize, 18		; Hardcoded default.

;----------------------------------------------------------------------------
;	Mark us ShutDown
;----------------------------------------------------------------------------
	or	MSMTxFlags1, SHUTDOWN
	or	byte ptr [si].MSharingFlags, SHUTDOWN ;Set shutdown bit

;----------------------------------------------------------------------------
;	Get any Net.cfg parameters 
;----------------------------------------------------------------------------
	call	SetupBoardSectionHeader		; Get -> to board section text
	call	ProcessSectionTextForThisBoard  ; Process possible section text
	jnz	BoardFailedInit			; nz => problems

;----------------------------------------------------------------------------
;	Check if the required NESL is present
;----------------------------------------------------------------------------
	test	DriverConfigTable.[MFlags], NESL_REQUIRED_BIT
	jz	GetBoardInited
	
	test	MSMSystemFlags, NESLFlag	; Is the NESL present
	jz	NESLFailedInit			; z => NESL is Required

;----------------------------------------------------------------------------
;	Get the Board Initialized and running.
;----------------------------------------------------------------------------
GetBoardInited:
	call	InitializeTheBoard		; Internal variables set, now init board
	jnz	SkipPrintingBoardsConfig	; z => Successful => Card Present and ready to go.
						; NZ => problems, or Card not present.

;----------------------------------------------------------------------------
;	Board is there and running print out config info
;----------------------------------------------------------------------------
	call	PrintOutBoardsConfig

;----------------------------------------------------------------------------
;	Register with the NESL if present.
;----------------------------------------------------------------------------
RegisterWithNESL:
	call	MSMNESL_Reg_Suspend		  ; Register with the NESL as Producer
	call	MSMNESL_Reg_Resume		  ; Register with the NESL as Producer
	call	MSMNESL_Reg_Service_Change	  ; Register with the NESL as Producer 
	xor	ax, ax
	ret

;----------------------------------------------------------------------------
;	A PCMCIA driver loaded with out the card.
;----------------------------------------------------------------------------
PCMCIAdriver:
	push	dx				; driver Load Message
	call	MSMSetShutDownBits		; Clear Shutdown bits.
	call	PrintOutBoardsConfig		; Print out the Config tried.
	call	RegisterWithNESL		; Don't Forget the NESL
	pop	dx				; Driver Loaded Message
	jmp short PrintNotification		; Go Print it out.

;----------------------------------------------------------------------------
;  Check to see if we have had a PCMCIA driver startup, and card not present.
;----------------------------------------------------------------------------
SkipPrintingBoardsConfig:
	cmp	ax, MSMERR_CARDNOTPRESENT	
	jb	BoardFailedInit		; Error code should be below this?
	je	PCMCIAdriver		; Card not present only error?

	mov	dx, offset CGroup:BadReturnCodeFromHSM	; Invaild return code from HSM

;----------------------------------------------------------------------------
;	Bad news, this board did not initialize. Print out his Config,
;	deregister him with the LSL, and then print out the Error Message.
;----------------------------------------------------------------------------
BoardFailedInit:
	push	dx				; Save the error message
	call	PrintOutBoardsConfig		; Print out the Config tried.
	call	MSMDeregisterAllBoards		; Undo what was done
	pop	dx

;----------------------------------------------------------------------------
;	Print out the problem.
;----------------------------------------------------------------------------
PrintNotification:
	push	dx
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero
	pop	dx				; Problem Message
	call	MSMPrintStringZero
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero

	ret					; Error Exit

;----------------------------------------------------------------------------
;  NESL Failes to load remember to clear the Active Board Count as Flag.
;----------------------------------------------------------------------------
NESLFailedInit:
	mov	dx, offset CGroup:NESL_Required_Msg
	call	MSMPrintStringZero
	mov	ax, MSMERR_MSM_FAILED		; Signal error
	mov	dx, offset CGroup:MSMLoadCancelMsg
	mov	MSMActiveBoardCount, 0		; Signal the error return code.
	jmp short PrintNotification

InitMSM	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	CountExistingMLIDs
;
;	Count the number of existing (operating) MLIDs of the same type
;	as our MLID.  This will allow us to find the correct NET.CFG
;	section text.
;
;	assumes:
;		ds=cs=CGroup
;		Interrupts are enabled
;
;	returns:
;		AX = 0 (always)
;		DS, SS, SP preserved.
;		Interrupts enabled
;
;	called by InitMSM
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
CountExistingMLIDs	proc	near
;----------------------------------------------------------------------------
;	Start with board 0 and continue till all Max Num have been tried.
;----------------------------------------------------------------------------
	xor	bp, bp				; BP holds board number

CountSameBoardLoop:
	mov	ax, bp
	mov	bx, PROTSUP_GET_MLID_CTL_ENTRY	 ; Get -> MLID's control entry point
	call	LSLEntryPoints.LSLProtSupEntryPt ; Call LSL MPI Interface
	jnz	BoardNotThere			

	mov	MLIDControlEntryPoint+0, si	; Save MLIDs control entry point
	mov	MLIDControlEntryPoint+2, es

	mov	ax, bp				; Load board number
	mov	bx, GET_MLID_CONFIGURATION	; Get a -> MLIDs config table
	call	dword ptr MLIDControlEntryPoint

;----------------------------------------------------------------------------
;	Now see if this MLID is the same type as we are.
;----------------------------------------------------------------------------
	xor	cx, cx
	cmp	es:[si].MBoardInstance, cx	; See if Virtual board
	jne	GotoNextBoard			; 0 = first instance of physical card.

;----------------------------------------------------------------------------
;	It's a real physical board.
;----------------------------------------------------------------------------
	les	di, es:[si].MCardShortName	 ; ES:DI -> MLIDs short name
	mov	si, word ptr DriverConfigTable.MCardShortName ; DS:SI -> our short name
	mov	cl, byte ptr [si]		 ; Get length byte
	add	cl, 2				 ; Make room for length,zero term bytes
  repe	cmpsb
  	jne	GotoNextBoard			; ne => not our type

;----------------------------------------------------------------------------
;	Found a MLID same Type as us.
;----------------------------------------------------------------------------
	inc	MSMSameTypeMLIDCount		; Keep track.

GotoNextBoard:
	inc	bp				; Next board number
	jmp	CountSameBoardLoop

;----------------------------------------------------------------------------
;	There wasn't a board at the current spot,
;	check to see if we have tried them all.
;----------------------------------------------------------------------------
BoardNotThere:
	cmp	ax, LSLERR_NO_MORE_ITEMS	; Any more boards?
	jne	GotoNextBoard			; Yes, try next one

	xor	ax, ax				; Signal we are done
	ret

CountExistingMLIDs	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	PrintOutBoardsConfig
;
;	Prints out the configuration this board is set to.
;
;	assumes:
;		ds	is set to CGroup
;		es	is set to the Segment of the Config Table.
;
;	returns:
;		All registers preserved.
;	Note:
;		called by InitMSM and DisplayResidentDriver
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
PrintOutBoardsConfig	proc	near
	push	ax
	push	bx
	push	cx
	push	dx
	push	bp
	push	di 		; Preserve what we use.
	push	si

;----------------------------------------------------------------------------
;	Print out the Default Configuration
;----------------------------------------------------------------------------
	mov	bx, MSMConfigTables[0]		; ES:BX -> First Config Table

;----------------------------------------------------------------------------
;	Check if the Hardware Loaded.
;	If Not just print out the Board Information.
;----------------------------------------------------------------------------
	cmp	ax, MSMERR_CARDNOTPRESENT	
	jne	PrintHardWareOptions
	jmp	NoLineInfo

;----------------------------------------------------------------------------
;	See if any hardware options are used.  If not then the driver
;	is some type of virtual board and will usually print out their
;	own configuration information.
;----------------------------------------------------------------------------
PrintHardWareOptions:
	lea	di, [bx].MSlot			; ES:DI -> start of hardware options.
	mov	cx, (MIRQLine1-MSlot)		; CX = Number of Fields to check
	xor	ax, ax				; 0 => not used.
  repe	scasb
  	jnz	HardOptionsDefined

	mov	ax, word ptr es:[bx].MIRQLine1	; Int or DMA line used?
	and	ax, word ptr es:[bx].MDMALine1	; check if either are used.
	inc	ax
	jnz	HardOptionsDefined		; nz => Some are defined.

	jmp	NotMem2				; Print out the node addr

;----------------------------------------------------------------------------
;	Print out the slot the NIC is in if we are on a PS2.
;----------------------------------------------------------------------------
HardOptionsDefined:
	mov	ax, es:[bx].MSlot	; AX = Slot number
	or	ax, ax			; If 0 don't print out Slot x
	jz	NoSlot

	mov	dx, offset CGroup:SlotMsg	; DX = Slot msg
	call	MSMPrintStringZero		; Print it out.
	call	MSMItoA			; AX = Number (Also prints to screen)
	call	MSMPrintCommaSpace

;----------------------------------------------------------------------------
;	Print out the interrupt settings.
;----------------------------------------------------------------------------
NoSlot:
	xor	ah, ah
	mov	al, es:[bx].MIRQLine1
	cmp	al, 0FFh			;Interrupt1 used?
	je	NotInt1

	mov	dx, offset CGroup:IRQMsg
	call	MSMPrintStringZero
	call	MSMItoA			; AX = Number (Also prints to screen)
	call	MSMPrintCommaSpace

NotInt1:
	mov	al, es:[bx].MIRQLine2		;Interrupt2 used?
	cmp	al, 0FFh
	je	NotInt2

	mov	dx, offset CGroup:IRQMsg
	call	MSMPrintStringZero
	call	MSMItoA			; AX = Number (Also prints to screen)
	call	MSMPrintCommaSpace

;----------------------------------------------------------------------------
;	Now do the DMA settings.
;----------------------------------------------------------------------------
NotInt2:
	mov	al, es:[bx].MDMALine1		
	cmp	al, 0FFh			;DMA1 used?
	je	NotDMA1

	mov	dx, offset CGroup:DMAMsg
	call	MSMPrintStringZero
	call	MSMItoA			; AX = Number (Also prints to screen)
	call	MSMPrintCommaSpace

NotDMA1:
	mov	al, es:[bx].MDMALine2
	cmp	al, 0FFh			;DMA2 used?
	je	NotDMA2

	mov	dx, offset CGroup:DMAMsg
	call	MSMPrintStringZero
	call	MSMItoA			; AX = Number (Also prints to screen)
	call	MSMPrintCommaSpace

;----------------------------------------------------------------------------
;	Now do the IOBase settings.
;----------------------------------------------------------------------------
NotDMA2:
	mov	ax, es:[bx].MIOAddress1
	or	ax, ax				;IOAddress1 used?
	jz	NotIO1

	mov	dx, offset CGroup:IOBaseMsg
	call	MSMPrintStringZero
	call	MSMAtoH
	call	MSMEatLeadingZeros
	call	MSMPrintStringZero
	call	MSMPrintCommaSpace

NotIO1:
	mov	ax, es:[bx].MIOAddress2
	or	ax, ax				;IOAddress2 used?
	jz	NotIO2

	mov	dx, offset CGroup:IOBaseMsg
	call	MSMPrintStringZero
	call	MSMAtoH
	call	MSMEatLeadingZeros
	call	MSMPrintStringZero
	call	MSMPrintCommaSpace
	
;----------------------------------------------------------------------------
;	Now the MemBase settings.
;----------------------------------------------------------------------------
NotIO2:
	mov	ax, word ptr es:[bx].MMemoryAddress1
	mov	dx, word ptr es:[bx].MMemoryAddress1+2

	mov	cx, ax
	or	cx, dx				;Memory1 used?
	jz	NotMem1

	push	dx
	mov	dx, offset CGroup:MemBaseMsg
	call	MSMPrintStringZero
	pop	dx
	call	MSMPrintDoubleHex
	call	MSMPrintCommaSpace

NotMem1:
	mov	ax, word ptr es:[bx].MMemoryAddress2
	mov	dx, word ptr es:[bx].MMemoryAddress2+2

	mov	cx, ax
	or	cx, dx				;Memory2 used?
	jz	NotMem2

	push	dx
	mov	dx, offset CGroup:MemBaseMsg
	call	MSMPrintStringZero
	pop	dx
	call	MSMPrintDoubleHex
	call	MSMPrintCommaSpace

;----------------------------------------------------------------------------
;	Print out the Node Address.
;----------------------------------------------------------------------------
NotMem2:
	mov	dx, offset CGroup:ClearComma	    ; assume don't print Node Addr
	mov	ax, word ptr es:[bx].MNodeAddress+0 ; If all FF's then don't print
	and	ax, word ptr es:[bx].MNodeAddress+2
	and	ax, word ptr es:[bx].MNodeAddress+4
	inc	ax
	jz	DontPrintNodeAddress

	mov	dx, offset CGroup:NodeMsg
	call	MSMPrintStringZero
	lea	dx, es:[bx].MNodeAddress
	push	ds				; DS = CGroup
	push	es	
	pop	ds				; DS:DX ->Node Address.
	call	MSMPrintSixByteHexString
	pop	ds				; CGroup

	test	es:[bx].MModeFlags, MSupportLSBMSB ; New Driver?
	jz	SkipEatComma			; nz = New Driver

	mov	dx, offset CGroup:LSBNodeMsg	;assume LSB Msg
	test	es:[bx].MModeFlags, MNonCanonicalBit  ;LSB/MSB mode
	jz	DontPrintNodeAddress		;Z - Canonical Address.

	mov	dx, offset CGroup:MSBNodeMsg

DontPrintNodeAddress:
	call	MSMPrintStringZero

SkipEatComma:
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Print out the second line info.
;	Max Packet Size
;----------------------------------------------------------------------------
	mov	ax, es:[bx].MMaxPacketSize
	or	ax, ax
	jz	MaxFrameNotKnown

	mov	dx, offset CGroup:MaxFrameMsg	;Print the max frame size
	call	MSMPrintStringZero
	call	MSMItoA			; AX = Number (Also prints to screen)
	mov	dx, offset CGroup:BytesMsg
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Line Speed
;----------------------------------------------------------------------------
MaxFrameNotKnown:
	mov	ax, es:[bx].MLineSpeed
	or	ax, ax
	jz	LineSpeedNotKnown
	
	call	MSMPrintCommaSpace
	mov	dx, offset CGroup:LineSpeedMsg
	call	MSMPrintStringZero
	mov	dx, offset CGroup:MbpsMsg
	test	ah, 80h				;Is it Kbps or Mbps
	jz	Mbps

	mov	dx, offset CGroup:KbpsMsg
	and	ah, 7Fh

Mbps:
	push	dx     			; Preserve DX accross MSMItoA
	call	MSMItoA			; AX = Number (Also prints to screen)
	pop	dx			; Restored Msg to print
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Bus ID
;----------------------------------------------------------------------------
LineSpeedNotKnown:
	mov	al, es:[bx].MBusID
	or	al, al
	js	BusIDNotKnown
	
	call	MSMPrintCommaSpace		; Comma Space needed.
	mov	dx, offset CGroup:BusIDMsg
	call	MSMPrintStringZero
	call	MSMItoA				; AX = ID (Also prints to screen)

;----------------------------------------------------------------------------
;	Skip printing a new line if we haven't printed anything on line 2
;----------------------------------------------------------------------------
BusIDNotKnown:
	mov	ax, es:[bx].MMaxPacketSize	; See if line was empty
	or	ax, es:[bx].MLineSpeed
	jz	NoLineInfo
		
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Now print the virtual board stuff.
;----------------------------------------------------------------------------
NoLineInfo:
	xor	bx, bx				; Start on Instance 0

PrintLogicalBoardLoop:
	push	bx				; Save Instance Number
	add	bx, bx				; get word index
	mov	di, MSMConfigTables[bx]		; Get -> a config table

;----------------------------------------------------------------------------
;Print out the Board Number (1 based), Frame type and address mode if supported.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:BoardMsg
	call	MSMPrintStringZero
	mov	ax, es:[di].MBoardNumber
	inc	ax				;Users like starting from 1
	call	MSMItoA			; AX = Number (Also prints to screen)
 	mov	dx, offset CGroup:FrameTypeMsg
	call	MSMPrintStringZero
	mov	dx, word ptr es:[di].MFrameString ; Get -> to the Frame string
	inc	dx				  ; Go past length byte
	call	MSMPrintStringZeroES		 ; ES:DX -> String to print.
	test	word ptr es:[di].MModeFlags, MSupportLSBMSB
	jz	NextFrameNewLine		;Z - Not Supported

	mov	dx, offset CGroup:MSBModeMsg	;assume MSB Mode
	test	word ptr es:[di].MModeFlags, MNonCanonicalBit
	jnz	ModeFramePrint			;NZ - MSB Mode

	mov	dx, offset CGroup:LSBModeMsg

ModeFramePrint:
	call	MSMPrintStringZero

NextFrameNewLine:
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero
       	
	pop	bx			; BX = Instance Number
	inc	bx
	cmp	bx, MSMActiveBoardCount
	jb	PrintLogicalBoardLoop

	pop	si
	pop	di
	pop	bp
	pop	dx
	pop	cx		; Restore what we used.
	pop	bx
	pop	ax
	ret

PrintOutBoardsConfig	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMPrintCommaSpace
;		Prints out a comma and a space 

;	assumes:
;		Nothing
;
;	returns:
;		All registers preserved.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMPrintCommaSpace	proc	near
	push	dx
	mov	dx, offset CGroup:Comma
	call	MSMPrintStringZero
	pop	dx
	ret

MSMPrintCommaSpace	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	InitializeTheBoard
;
;	First add any protocol ID's with the LSL.  Then attempt to 
;	initialize the board. 
;
;	assumes:
;		ds	is set to CGroup
;		Interrupts are enabled
;
;	returns:
;		Interrupts enabled
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
InitializeTheBoard	proc	near
;----------------------------------------------------------------------------
;	Register the protocol ID's.
;----------------------------------------------------------------------------
	mov	bp, NumProtoIDsToAdd		; Get num to add
	or	bp, bp
	jnz	DontBumpAddCount		; z => Only DefaultPid available.

	inc	bp				; Only one Pid Count

;----------------------------------------------------------------------------
;	Start with the Initial ProtID table entry.
;----------------------------------------------------------------------------
DontBumpAddCount:
	xor	bx, bx				;Used to index into PID table

;----------------------------------------------------------------------------
;	Get Next Protocol ID to Add.
;----------------------------------------------------------------------------
AddPIDLoop:
	push	cs
	pop	es				; ES = CGroup
	push	cs
	pop	cx				; CX = CGroup
	lea	di, ProtoIDTable[bx]		; CX:DI -> stack name
	lea	si, [di].ProtIDPID		; ES:SI -> PID
	mov	ax, word ptr [di].ProtIDMediaID	; AX has media ID 

;----------------------------------------------------------------------------
;	Save off the Regs that MLIDSUP_ADD_PID destroys.
;----------------------------------------------------------------------------
	push	ax				; Save media ID
	push	bx				; Save index
	push	si				; Save Ptr to PID
	push	di				; Save Ptr to Stack Name

;----------------------------------------------------------------------------
;	ES:SI -> 6 byte PID
;	CX:DI -> Length-Preceeded Zero-Terminated Protocol Short name.
;	AX = Media ID
;----------------------------------------------------------------------------
	mov	bx, MLIDSUP_ADD_PID		; Add the PID
	call	LSLSupport
	mov	cx, ax				; Save return code
	pop	di				; DI -> Protocol Short name
	pop	si				; SI -> 6 byte PID
	pop	bx				; BX -> PIDIDTable offset
	pop	ax				; AX = Media ID just used.
	jz	ContinueAddingPIDs		; z=> no errors.

;----------------------------------------------------------------------------
;	check the Error, if just duplicate then it is ok.
;----------------------------------------------------------------------------
	cmp	cx, LSLERR_DUPLICATE_ENTRY	; This error is okay
	jne	ErrorAddingPID

;----------------------------------------------------------------------------
;	Get the next PID to Add.
;----------------------------------------------------------------------------
ContinueAddingPIDs:
	add	bx, size ProtoIDStruc		; BX -> next slot
	dec	bp				; Get each one
	jnz	AddPIDLoop			; nz => Still one more to add.

	jmp short InitTheBoard			; All the PIDs are in, now init the Board.

;----------------------------------------------------------------------------
;	Error  Adding PID... Tell the User, and try adding the next PID
;	DI -> Stack Short Name
;	SI -> PID
;	AX = Media ID
;----------------------------------------------------------------------------
ErrorAddingPID:
	mov	dx, offset CGroup:NoRoomForPID	; Warn the user
	call	MSMPrintStringZero

	push	di
	mov	dx, si				; Print PID
	call	MSMPrintSixByteHexString

	mov	dx, offset CGroup:NoRoomForStack
	call	MSMPrintStringZero		; Warn the User

	pop	di
	mov	dx, di				; Print the stack name
	inc	dx
	call	MSMPrintStringZero

	mov	dx, offset CGroup:NoRoomForMedia
	call	MSMPrintStringZero		; Warn the User

	mov	cx, SupportedMedias		; Get number of media names
	xor	si, si

LookForMediaStringLoop:
	cmp	ax, SupportedMedias[si+4] 	; ID's match?
	je	FoundMediaString

	add	si, 4+6				; Next media slot
	loop	LookForMediaStringLoop

	mov	dx, offset CGroup:UnknownMsg   ; We don't even support your media
	jmp short PrintMediaNameError

;----------------------------------------------------------------------------
;	Found the Name, print it.
;----------------------------------------------------------------------------
FoundMediaString:
	mov	dx, word ptr SupportedMedias[si+2]
	inc	dx			; Advance past length byte

PrintMediaNameError:
	call	MSMPrintStringZero	; Print the Media Name if we know it.
	mov	dx, offset CGroup:Period
	call	MSMPrintStringZero
	jmp short ContinueAddingPIDs		; continue with the next PID

;----------------------------------------------------------------------------
;	All the PIDs are added to the LSL's table, now init the board.
;----------------------------------------------------------------------------
InitTheBoard:
	cld
	call	MSMSetUpBitSwapTable	; Set up a Bit Swap Table for anyone's use at offset PSPTableStart
	call	InitializeMedia		; Init media and driver

;----------------------------------------------------------------------------
;	There might have been an error, Save the Code and Msg just in case.
;----------------------------------------------------------------------------
	push	ax			; Save the return code
	push	dx			; Save possible err msg offset

;----------------------------------------------------------------------------
;	Hold off on the Ints while messing with the DriverCtlTable
;----------------------------------------------------------------------------
	cli				; Wait a second, hold off the ints.

;----------------------------------------------------------------------------
;	If the driver is not polled invalidate the DriverPoll entry
;	in the driver IOCTL function jump table.
;----------------------------------------------------------------------------
	test	DriverConfigTable.MModeFlags, MNeedsPollingBit
	jnz	DriverIsPolled

	mov	DriverCtlTable[12 * 2], offset CGroup:MSMBadCtlCommand

DriverIsPolled:
	sti
	pop	dx
	pop	ax
	or	ax, ax			; Set the appropriate Flags.
	ret

InitializeTheBoard	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	ProcessSectionTextForThisBoard
;
;	Uses the information in the NET.CFG file to configure the 
;	board instance to the users desires.  This includes the 
;	following: DMA, IRQ, MEM, PORT, PS2Slot, NodeAddress, Protocol,
;	and FrameType.
;
;	assumes:
;		DS = ES = CGroup
;		Interrupts are enabled
;
;	returns:
;		AX = MSMERR_NOT		 successfull
;		   = MSMERR_MSM_FAILED   if error registering boards.
;		flag set according to AX
;		DX = Message MSMLoadCanceled if AX = MSMERR_MSM_FAILED
;		DS, SS, SP Preserved.
;		Interrupts enabled
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;----------------------------------------------------------------------------
;	Report the Error to the User
;----------------------------------------------------------------------------
ErrorRegisteringExit:
	mov	MSMActiveBoardCount, bx		; Actual number active
	shr	MSMActiveBoardCount, 1		; Undo Word indexing
	mov	dx, offset CGroup:NoRoomForThisBoard
	call	MSMPrintStringZero
	mov	bx, MSMConfigTables[bx]
	mov	dx, word ptr [bx].MFrameString	;Print out the frame name
	inc	dx				; Skip length field
	call	MSMPrintStringZero
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero
	mov	ax, MSMERR_MSM_FAILED		; Signal error
	mov	dx, offset CGroup:MSMLoadCancelMsg
	or	ax, ax				; Set flags.
	ret

ProcessSectionTextForThisBoard	proc	near
;----------------------------------------------------------------------------
;	Setup the FrameName string -> in the config table
;----------------------------------------------------------------------------
	mov	bx, MSMConfigTables[0]		; BX -> first config table
	mov	ax, SupportedMedias+2		; Get -> default Frame name
	mov	word ptr [bx].MFrameString, ax	; Store Config's Media Name
	mov	ax, SupportedMedias+4		; Get the default Media ID
	mov	[bx].MFrameID, ax		; Set default Media ID
	mov	ProtoIDTable[0].ProtIDMediaID, ax ; Store Default Media ID

;----------------------------------------------------------------------------
;	Process the section text values.
;----------------------------------------------------------------------------
	push	bx			; Save -> first config table
	call	ProcessNetCFG		; Process the Net.cfg section

;----------------------------------------------------------------------------
;	Setup for adding PIDs later on after the MLID has initialized.
;----------------------------------------------------------------------------
	pop	si				; SI -> Config Table
	cmp	NumProtoIDsToAdd, 0		; Use Boards Default IPX PID?
	ja	DontUseDefaultPID		; a = NO

;----------------------------------------------------------------------------
;	Use the Default PID
;----------------------------------------------------------------------------
	mov	dx, [si].MFrameID		    ; Store the Default Media
	mov	ProtoIDTable[0].ProtIDMediaID, dx   ; ID in Default Table entry

	mov	cx, SupportedMedias		    ; CX = Num Medias Supported.
	mov	si, offset CGroup:SupportedMedias+2 ; SI -> Default Media ID.

;----------------------------------------------------------------------------
;	Now find IPX's PID for this media type.
;----------------------------------------------------------------------------
FindDefaultPIDUsingMediaLoop:
	cmp	dx, word ptr [si+2]		;Media ID's match?
	je	FoundDefaultPID

	add	si, 4+6				;Advance to next structure
	loop	FindDefaultPIDUsingMediaLoop	;Should always find it

;----------------------------------------------------------------------------
;	Get -> first StackName/PID entry
;----------------------------------------------------------------------------
FoundDefaultPID:
	add	si, 4				; SI -> default PID
	mov	ProtoIDTable[0].ProtIDMediaID, DX ; Save for completeness.
	lea	di, ProtoIDTable[0].ProtIDPID	; DI -> PID value

	movsw					; Copy IPX's PID over
	movsw					; to ProtoIDTable     
	movsw

;----------------------------------------------------------------------------
;	Register the boards with the LSL.
;----------------------------------------------------------------------------
DontUseDefaultPID:
	xor	bx, bx		; Do for each Media type to load start at 0

;----------------------------------------------------------------------------
;	Now set up the Boards:
;	Set up the MLIDInfoBlock Struc for Registering.
;	BX = Word Index Instance Number
;----------------------------------------------------------------------------
SetupBoardLoop:
	mov	ax, offset CGroup:MSMSendPacket	;Get offset of our Tx handler
	mov	word ptr OurInitInfoBlock.MIBS_SendEntry, ax
	mov	ax, offset CGroup:MSMControlHandler ;Get offset of boards Cntrl handler
	mov	word ptr OurInitInfoBlock.MIBS_ControlEntry, ax
	mov	ax, MSMConfigTables[bx]		;Get -> boards config table
	mov	word ptr OurInitInfoBlock.MIBS_ConfigTable, ax

;----------------------------------------------------------------------------
;	Set up the Segment Values
;----------------------------------------------------------------------------
	mov	ax, cs						; AX = CGroup
	mov	word ptr OurInitInfoBlock.MIBS_SendEntry+2, ax
	mov	word ptr OurInitInfoBlock.MIBS_ControlEntry+2, ax
	mov	word ptr OurInitInfoBlock.MIBS_ConfigTable+2, ax

;----------------------------------------------------------------------------
;	Make call to LSL to Register the MLID
;----------------------------------------------------------------------------
	mov	si, offset CGroup:OurInitInfoBlock   ; ES:SI -> input buffer
	mov	di, offset CGroup:LSLInfoReturnBlock ; DS:DI -> output buffer

	push	bx			; our word index Instance number
	mov	bx, LSLINIT_MLID_REG	; LSL's MLID init function code
	call	LSLInitEntryPoint	; Request registration
	pop	bx			; BX = Word index instance number
	jz	NoErrorsRegistering	; Z = no problem carry on.

	jmp	ErrorRegisteringExit	; Problems mean trouble
	
;----------------------------------------------------------------------------
;	Save away the LSL's MLID support entry point.
;----------------------------------------------------------------------------
NoErrorsRegistering:
	push	cs
	pop	es		; Restore ES = CGroup

	mov	si, offset CGroup:LSLInfoReturnBlock
	mov	di, offset CGroup:LSLSupport
	movsw
	movsw

;----------------------------------------------------------------------------
;	Setup the boardNumber and boardInstance mapping variables.
;	DS:SI -> LSLInfoReturnBlock.MRIBS_BoardNum
;	BX = Word Index Instance Number
;----------------------------------------------------------------------------
	lodsw				; AX = the board number
	mov	di, MSMConfigTables[bx]	; Get -> current config table
	mov	[di].MBoardNumber, ax	; Set the board number
	mov	[di].MBoardInstance, bx	; Set the instance number
	shr	[di].MBoardInstance, 1	; Undo word indexing

;----------------------------------------------------------------------------
;	Initialize all far ->'s segment address for the MLID so
;	he won't have to do it.
;----------------------------------------------------------------------------
	mov	ax, cs
	mov	word ptr [di].MCardLongName+2, ax
	mov	word ptr [di].MCardShortName+2, ax
	mov	word ptr [di].MFrameString+2, ax
	cmp	word ptr [di].MRouteHandler+0, 0  ;If zero then doesn't want SR
	je	DontSetSRSegmentValue

	mov	word ptr [di].MRouteHandler+2, ax

;----------------------------------------------------------------------------
;	Get Next Board.
;----------------------------------------------------------------------------
DontSetSRSegmentValue:
	mov	cx, bx				; CX = Word Index Instance Num.
	shr	cx, 1				; CX = Virt Board Num (Instance Num)
	inc	cx				; CX = Next Virt Board num (Instance Num)
	add	bx, 2				; BX = Word Index next Virt board
	cmp	cx, MSMActiveBoardCount		; Are we done yet?
	jne	SetupBoardLoop

;----------------------------------------------------------------------------
;	Set the Segment Values in the Custom Counter String Pointers.
;	AX = CGroup
;----------------------------------------------------------------------------
AllDoneSettingUpBoards:
	lea 	di, DriverStatTable.MNumCustomCounters ; DriverStatTable+40
	mov	cx, [di]			; Get Num of Custom Counters.
	jcxz	NoCustomCounters

	add	cx, cx				; 
	add	cx, cx				; CX * 4
	add	di, cx				; -> Last Custom Counter
	add	di, 4				; -> First Seg Pointer spot
	shr	cx, 1
	shr	cx, 1				; Restore number of cust. counters

SetSegmentLoop:
	stosw					; SI -> Next String ptr
	add	di, 2				; SI -> next string Seg ptr
	loop	SetSegmentLoop

NoCustomCounters:
	xor	ax, ax				; Always successful
	ret

ProcessSectionTextForThisBoard	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	ProcessNetCFG
;
;	Takes any user specified values in the NET.CFG file and
;	performs the appropriate action so that these values will
;	be used by the MLID for initialization. 
;	Closes the NET.CFG file before Returning.
;
;	assumes:
;		ds=cs=es is set to CGroup
;		Interrupts are enabled
;
;	returns:
;		ds=es=cs preserved
;		Other regs destroyed.
;		Interrupts enabled
;		
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ProcessNetCFG	proc	near
;----------------------------------------------------------------------------
;	Check if a Section Header is even Present
;----------------------------------------------------------------------------
	cmp	SectionTextPresentFlag, 1	;Any info for us?
	jne	AllDoneProcessingNetCFG

;----------------------------------------------------------------------------
;	Get the first line
;----------------------------------------------------------------------------
TryTheNextLine:
	call	GetALine		; DS:SI -> Line
	jnz	AllDoneProcessingNetCFG

;----------------------------------------------------------------------------
;	SI -> line of configuration text.
;	Better be a comment or white space or this is the end
;	of the section text.
;----------------------------------------------------------------------------
	mov	al, byte ptr [si]		; Get the first char
	cmp	al, '#'
	je	TryTheNextLine			; Ignore Old comment lines (only for First Char)

	cmp	al, ';'				; Ignore new comment lines
	je	TryTheNextLine

	or	al, al				; Allow a blank line also
	jz	TryTheNextLine

	cmp	al, ' '				; White space here?
	je	FoundRealSectionText

	cmp	al, 09h				; White space (Tab)
	je	FoundRealSectionText

;----------------------------------------------------------------------------
;	No more section text for this board.
;----------------------------------------------------------------------------
AllDoneProcessingNetCFG:
	mov	ax, SupportedMedias		; Clear frame use flags
	mov	si, offset CGroup:SupportedMedias+2

;----------------------------------------------------------------------------
;	Initially, no frame is used.
;----------------------------------------------------------------------------
ClearFrameUseFlags:
	and	byte ptr [si+3], not 80h
	add	si, 10			; Skip over offset to Name, ID, PID
	dec	ax
	jnz	ClearFrameUseFlags

;----------------------------------------------------------------------------
;	See if there was one declared
;----------------------------------------------------------------------------
	cmp	MSMActiveBoardCount, 0	; Any 'Frame' keywords?
	jne	VarIsCorrect

	mov	MSMActiveBoardCount, 1	; Always have at least the Default.

;----------------------------------------------------------------------------
;	Make Sure that the NET.CFG handle gets closed.
;	If Remote Booting, open file hangs us later on.
;----------------------------------------------------------------------------
VarIsCorrect:
	mov	bx, FileHandle		; bx = File handle.
	mov	ah, CLOSE_FILE		; Close the NET.CFG
	int	ENTER_DOS
	mov	FileHandle, -1		; Clear File Handle variable.
	ret
	
;----------------------------------------------------------------------------
;	Found a line of text to parse, is it Valid to parse
;----------------------------------------------------------------------------
FoundRealSectionText:
	call	MSMEatWhite			; Skip the white stuff
	jnz	TryTheNextLine			; nz => Nothing left.

	cmp	byte ptr [si], '#'		; Is it a comment here?
	je	TryTheNextLine

	cmp	byte ptr [si], ';'		; Is it a new style comment?
	je	TryTheNextLine

;----------------------------------------------------------------------------
;	Go parse the line
;----------------------------------------------------------------------------
	call	MatchSectionText		; Process the line
	jmp short TryTheNextLine		; Do the next line
	
ProcessNetCFG	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MatchSectionText
;
;	Takes the keywords -> by SI and attempts to find a 
;	match with our valid keywords.  If there is a match,
;	the appropriate keyword handler will be called to process
;	the information.
;
;	assumes:	si	-> SectionTextLine
;			ds	is set to CGroup
;	
;	returns:
;		ds, ss, sp is preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MatchSectionText	proc	near
;----------------------------------------------------------------------------
;	Save current Position
;----------------------------------------------------------------------------
	mov	dx, si			; Save buffer offset Start
	push	cs
	pop	es			; CGroup

;----------------------------------------------------------------------------
;	Look for Through the Keywords for a Match
;----------------------------------------------------------------------------
	mov	bp, NumKeywords			; Num of keywords to try
	xor	bx, bx				; Keyword indexer 

FindSectTextLoop:
	mov	di, KeywordTextTable[bx]	; Get -> keyword
	mov	cx, KeywordTextLen[bx]		; Get keywords length
	call	MSMCompareString		; See if a match
	jz	FoundSectionTextMatch

	mov	si, dx				; SI->Current Char
	add	bx, 2				; Next keyword slot 
	dec	bp				; one less keyword to check
	jnz	FindSectTextLoop

;----------------------------------------------------------------------------
;	If not found in the generic parms, then try the driver defined
;	parms, if any.
;----------------------------------------------------------------------------
	mov	bp, DriverNumKeywords		; Unique keywords?
	or	bp, bp				; Does the HSM have any?
	jz	MatchSectExit			; z =>no words to search

	xor	bx, bx				; Index from 0
	
FindDriverDefinedKeywordLoop:
	mov	di, DriverKeywordText[bx]	; Get -> driver's keyword
	mov	cx, DriverKeywordTextLen[bx]	; Get keyword length
	call	MSMCompareString	        ; Compare the strings
	jz	FoundDriverSectionTextMatch	

	mov	si, dx				; SI -> Current Char
	add	bx, 2				; Next Keyword
	dec	bp				; Check each one.
	jnz	FindDriverDefinedKeywordLoop
	jmp	short MatchSectExit		; Not found

;----------------------------------------------------------------------------
;	Found a Keyword Match, Activate the Keyword Action proc.
;----------------------------------------------------------------------------
FoundDriverSectionTextMatch:
	mov	di, bx				; DI -> Keyword word index that matched.
	mov	bx, MSMConfigTables[0]		; BX = pointer to first Config table.
	jmp	DriverProcessKeywordTab[di]	; Do the action

;----------------------------------------------------------------------------
;	A Line to parse was given, but No Matches, Report the Error.
;----------------------------------------------------------------------------
MatchSectExit:
	mov	dx, offset CGroup:InvalidKeywordMsg ; Warn the user
	call	MSMPrintStringZero
	mov	ax, MSMCurrentLine	; Print out the line number
	call	MSMItoA			; AX = Number (Also prints to screen)
	mov	dx, offset CGroup:Period
	call	MSMPrintStringZero
	jmp	IgnoreNETCFGLine

;----------------------------------------------------------------------------
;	Found a Keyword Match
;----------------------------------------------------------------------------
FoundSectionTextMatch:
	mov	di, bx				; DI -> Keyword word index that matched.
	mov	bx, MSMConfigTables[0]		; BX -> first Config Table.
	jmp	KeywordProcessTable[di]		; Do the action

MatchSectionText	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	FindAndOpenNetCfgFile
;
;	Routine finds and then opens the NET.CFG file.
;
;	assumes:
;		cs=ds	is set to CGroup
;		Interrupts are enabled
;	
;	returns:
;		AX = return code.
;			zero = Successfully opened Net.cfg
;			nz => AX = DOS open File Error Code.
;		Interrupts enabled
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FindAndOpenNetCfgFile	proc	near
;----------------------------------------------------------------------------
;	Attempt to open the file in the directory the LSL found it in.
;	If LSL does not know where it is it will return a path
;	that will cause us to attempt the open in the current directory.
;----------------------------------------------------------------------------
	mov	bx, GENSERV_GET_NETCFG_PATH
	call	LSLEntryPoints.LSLGenSupEntryPt	 ; Call LSL Gen. Services

;----------------------------------------------------------------------------
;	DS:DX -> Path where the LSL Found the NET.CFG
;----------------------------------------------------------------------------
	mov	ax, OPEN_FILE_RO		; Open for reading only
	int	ENTER_DOS
	push	cs
	pop	ds				; Restore DS to CGroup
	jc	NoNETCFGFileExit		; c => File not Found

;----------------------------------------------------------------------------
;	AX has a valid file handle for NET.CFG file.
;	We can now read in the file data.
;----------------------------------------------------------------------------
	mov	FileHandle, ax			; Save the file handle
	xor	ax, ax				; Clear AX return code.

NoNETCFGFileExit:
	or	ax, ax				; Set flags 	
	ret

FindAndOpenNetCfgFile	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	GetALine
;
;	Reads in a line of text from the file specified by FileHandle.
;	If an Single or Double Quote is detected, the embedded text will not
;	be uppercased.  The rest of the line is uppercased.
;
;	assumes:
;		DS	CGroup
;
;	returns:	
;		DS:SI	-> line buffer
;		AX set according to Flags 
;		z flag set if not EOF (have some chars in the new Line)
;		z flag cleared if EOF (or have error no chars to look at.)
;		All other regs preserved.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
GetALine	proc	near
;----------------------------------------------------------------------------
;	Preserve what we destroy
;----------------------------------------------------------------------------
	push	bx
	push	cx		; Preserve regs on entrance
	push	dx

;----------------------------------------------------------------------------
;   Clear the MSMKeyWordFlags bit. This Line might Not have any Sensitivity.
;----------------------------------------------------------------------------
	and	MSMKeyWordFlags, NOT(CASE_SENSITIVE OR CASE_SENSITIVE_ACTIVE)

;----------------------------------------------------------------------------
;	Read in from the file one byte at a time till one line is in.
;----------------------------------------------------------------------------
	mov	bx, FileHandle			; File handle for Config file.
	mov	cx, 1				; Read one byte
	mov	dx, offset CGroup:LineBuffer-1	; Setup pointer to start of buffer

KeepReading:
	inc	dx				; Point to next byte
	mov	ah, READ_FILE			; DOS Read function
	int	ENTER_DOS			; Place next byte at DS:DX
	jc	ErrReading			; c => error reading.

;----------------------------------------------------------------------------
;	Check for END of FILE
;----------------------------------------------------------------------------
	or	ax, ax				; EOF
	jz	ErrReading			; z => EOF

;----------------------------------------------------------------------------
;	Set up the Buffer Pointers 
;----------------------------------------------------------------------------
	mov	si, dx				; SI -> New Char.

;----------------------------------------------------------------------------
;	Detect the Start/End of a Quoted String.
;----------------------------------------------------------------------------
	cmp	byte ptr [si], 22h     	; Double Quote
	je	FlagSensitive

	cmp	byte ptr [si], 27h	; Single Quote
	je	FlagSensitive

;----------------------------------------------------------------------------
;	Check if this char needs to be converted to uppercase
;----------------------------------------------------------------------------
CheckCase:
	test	MSMKeyWordFlags, CASE_SENSITIVE_ACTIVE
	jnz	CharOkay			; Embedded in quotes Case Sensitive.

	cmp	byte ptr [si], 'a'		; Make it upper case
	jb	CharOkay			
	cmp	byte ptr [si], 'z'		; Lower Case Letters get converted.
	ja	CharOkay

	sub	byte ptr [si], 32		; Uppercase.

;----------------------------------------------------------------------------
;	Check if this char is the End of the Line
;----------------------------------------------------------------------------
CharOkay:
	cmp	byte ptr [si], ';'		; Look for Comment to end line.
	je	GotAComment			; Rest Commented out.

	cmp	byte ptr [si], 1Ah		; Cntrl-Z?
	je	EndOfFile			; end of File?

	cmp	byte ptr [si], 0Dh		; Carriage Ret?
	jne	KeepReading

	inc	dx				; Get the 0Ah
	mov	ah, READ_FILE			; Get linefeed
	int	ENTER_DOS
	dec	dx				; Don't use it.

;----------------------------------------------------------------------------
;	End of the Line, or End of File we got our line in the buffer.
;----------------------------------------------------------------------------
EndOfFile:
	inc	MSMCurrentLine			; Track Line Number we are on.
	mov	si, dx				; SI -> End of the Line
	mov	byte ptr [si], 0		; Terminate the string
	mov	si, offset CGroup:LineBuffer	; SI -> Start of the LINE
	xor	ax, ax				; Signal success.

GetALineCleanStack:
	pop	dx
	pop	cx				; Restore What we used.
	pop	bx
	ret

;----------------------------------------------------------------------------
;	Toggle Case Sensitivity.
;----------------------------------------------------------------------------
FlagSensitive:
	dec	dx			; Quote removed.
	test	MSMKeyWordFlags, CASE_SENSITIVE_ACTIVE
	jnz	ClearSensitiveFlag

	or	MSMKeyWordFlags, CASE_SENSITIVE OR CASE_SENSITIVE_ACTIVE
	jmp short KeepReading		; get next Char

ClearSensitiveFlag:
	and	MSMKeyWordFlags, CASE_SENSITIVE_DEACTIVATE
	jmp short KeepReading		; get next char.

;----------------------------------------------------------------------------
;	An Error Occured or EOF came while reading.
;----------------------------------------------------------------------------
ErrReading:
	cmp	dx, offset CGroup:LineBuffer ; Did we get any chars before the Error?
	jne	EndOfFile		     ; ne => we have atlest one char.

	or	al, 1			     ; Set an error flag
	jmp short GetALineCleanStack

;----------------------------------------------------------------------------
;	Got a Comment on the Line.
;----------------------------------------------------------------------------
GotAComment:
	mov	byte ptr [si], 0		; Make it the End of the string.
	jmp short KeepReading

GetALine	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	SetupBoardSectionHeader
;
;	assumes:	
;		cs=ds=es is set to CGroup
;		Interrupts are enabled
;
;	returns:
;		ds preserved
;		Interrupts enabled
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SetupBoardSectionHeader	proc	near
;----------------------------------------------------------------------------
;	Check to see if we even have a File open.
;----------------------------------------------------------------------------
	cmp	FileHandle, -1			; Was there a NET.CFG?
	je	NoMainSectionHeader1		; e => have a file.

;----------------------------------------------------------------------------
;	One heading is required for each physical board.
;----------------------------------------------------------------------------
	mov	cl, MSMSameTypeMLIDCount	; Get number of section 
						; headings to pass by

FindNextSectionHeading:
	call	GetALine		; DS:SI -> Line of text
	jnz	NoMainSectionHeader	; nz => End of File

	push	cx
	call	FindMainSectionHeader	; Find it for our board
	pop	cx			; CX number of SectionHeaders to skip
	jnz	FindNextSectionHeading

	dec	cl			; Is this the one?
	js	FoundOurSectionHead	; s => Finally skipped enough headers
	jmp short FindNextSectionHeading

;----------------------------------------------------------------------------
;	No Main SectionHeader Found before running out of Load Count.
;	If we are not the first physical card there is an error here.
;----------------------------------------------------------------------------
NoMainSectionHeader:
	cmp	MSMSameTypeMLIDCount, 0	; If we are not only one
	jne	NoMainSectionHeader2	; can't go on with out new header
	jmp short NoMainSectionHeader1	; If we are the only one then we 
					; need to exit with Z-Flag, but not
					; SectionTextPresentFlag set.

;----------------------------------------------------------------------------
;	Found the Section Header we were looking for.
;----------------------------------------------------------------------------
FoundOurSectionHead:
	mov	SectionTextPresentFlag, 1
	xor	ax, ax				; Set Z flag for success.

NoMainSectionHeader1:				; No NET.cfg file jumps here.
	ret

;----------------------------------------------------------------------------
;	We are not the first physical card to load a driver,
;	and there is not another section heading, Tell the user, and 
;	error out.
;----------------------------------------------------------------------------
NoMainSectionHeader2:
	mov	dx, offset CGroup:CouldntFindMLIDSection
	call	MSMPrintStringZero
	mov	dx, word ptr DriverConfigTable.[MCardShortName]
	inc	dx				; Skip length field
	call	MSMPrintStringZero
	mov	dx, offset CGroup:CouldntFindMlidSection2
	call	MSMPrintStringZero

	mov	ax, ERROR_EXIT_3		;DOS function 4C, ErrCode=3
	int	ENTER_DOS
;============================================================================

SetupBoardSectionHeader	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	FindMainSectionHeader
;
;	Routine returns the offset in Buffer of the start of the
;	main section for this MLID.
;
;	assumes:	
;		cs=ds=es is set to CGroup
;		si	-> line buffer
;		Interrupts are enabled
;
;	returns:
;		z flag	set if section header found
;		nz flag	set if no section headers found
;		destroys ax, si, di, cx, es, 
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FindMainSectionHeader	proc	near
;----------------------------------------------------------------------------
;	First char must be non-white or it is not a main
;	section heading.
;----------------------------------------------------------------------------
LookForSectionTextLoop:
	mov	al, byte ptr [si]	; Get the first char
	or	al, al			; Null
	je	NotMainSection

	cmp	al, ' '			; Space?
	je	NotMainSection

	cmp	al, 09h			; Tab?
	je	NotMainSection

	cmp	al, '#'			; Old style Comment?
	je	NotMainSection

	cmp	al, ';'			; New style comment?
	je	NotMainSection

;----------------------------------------------------------------------------
;	Found a main section heading. See if it's ours.
;----------------------------------------------------------------------------
	mov	si, offset CGroup:LineBuffer	; si ->  current line
	mov	di, offset CGroup:CondensedLineBuffer ; ES:DI-> place to shrink to
	call	MSMCondenseString		; Remove white space.

	mov	si, offset CGroup:DriverMainSectionText 
	mov	di, offset CGroup:LineBuffer	; ES:DI ->Re-Use Line Buffer.
	call	MSMCondenseString		; Remove white space.

	mov	cx, -1				; Get the string's length
	mov	si, offset CGroup:LineBuffer	; LineBuffer now contains the 
						; condensed DriverMainSectionText.
;----------------------------------------------------------------------------
;	Get the length of the DriverMainSectionText
;----------------------------------------------------------------------------
CountString:
	inc	cx
	lodsb
	or	al, al
	jnz	CountString

;----------------------------------------------------------------------------
;	Do the Compare
;----------------------------------------------------------------------------
	push	cs
	pop	es				; CGroup
	mov	si, offset CGroup:CondensedLineBuffer ; Has condensed NET.CFG entry.
	mov	di, offset CGroup:LineBuffer	;Line Buffer now contains  
						;  condensed DriverMainSectionText.
	jmp short MSMCompareString		; sets correct Flags on ret.

NotMainSection:
	or	al, 1
	ret

FindMainSectionHeader	endp

ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMCondenseString
;
;	Remove white space from a String.
;
;	assumes:
;		ds:si	-> Buffer containing source string 
;				(MUST BE NULL TERMINATED)
;		es:di	-> Buffer to place results.
;				(Result string will be NULL terminated) 
;		
;	Returns:
;		Z flag set
;		All regs are preserved.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMCondenseString	proc	near
	push	ax
	push	si
	push	di			; Preserve Entrance Values
;----------------------------------------------------------------------------
;	Simply move any none white space chars over to the results buffer.
;----------------------------------------------------------------------------
MSMCondenseStringLoop:
	lodsb				; Get Character from Source Buffer
	cmp	al, ' '			; Is it a space?
	je	MSMCondenseStringLoop

	cmp	al, 09h			; Is it a tab?
	je	MSMCondenseStringLoop

	cmp	al, ';'			; Comment Starts here?
	jne	StoreChar		; ne => not a comment starting

	xor	al, al

StoreChar:
	stosb				; Place Character in Destination Buffer.
	or	al, al			; End of String?
	jnz	MSMCondenseStringLoop	; nz => not end get next one.
	pop	di
	pop	si
	pop	ax			; Entrance values restored.
	ret				

MSMCondenseString	endp

;****************************************************************************
;	MSMCompareString
;
;	Case sensitive string compare.
;
;	assumes:
;		ds:si	-> first string (MUST BE TERMINATED WITH A 
;		 			 ZERO,SPACE,or TAB)
;		es:di	-> second string
;		cx	Number of chars to compare this must be the
;				length of the str at ES:DI
;
;	returns:
;		CX. DI, SI destroyed		
;		z flag	set if they are equal
;		nz flag	set if compare failed, 
;		All other Regs preserved.
;
;****************************************************************************
MSMCompareString	proc	near
;----------------------------------------------------------------------------
;	Skip any leading white space in the first string.
;	Second string must be leading white space free.
;----------------------------------------------------------------------------
	call	MSMEatWhite		; Skip white space

;----------------------------------------------------------------------------
;	Do the strings match?
;----------------------------------------------------------------------------
 	repe cmpsb
	jne	CompareStrExit		; ne => not equal

;----------------------------------------------------------------------------
;	Check the length
;----------------------------------------------------------------------------
	mov	cl, byte ptr [si]	; Make sure 2nd str is not longer
	or	cl, cl			; Null is what we expect
	jz	CompareStrExit

	cmp	cl, ' '			; Ignore trailing spaces
	je	CompareStrExit

	cmp	cl, 09h			; Ignore trailing tabs

CompareStrExit:				; e (z) => Strings Match
	ret

MSMCompareString	endp


;****************************************************************************
;	MSMEatWhite
;
;	You know what it does.
;
;	assumes:	
;		DS:SI -> string to eat
;
;	returns:	
;		DS:SI -> Start of Non-White space in string
;		All other regs preserved.
;		z flag	if it was eaten okay
;		nz flag	if EOF encountered
;
;****************************************************************************
MSMEatWhite	proc	near
	push	ax			; Preserve AX
	or	ah, -1			; Set up for a possible error

EatWhLoop:
	lodsb
	or	al, al			; End of the Line?
	jz	EatWhiteEOF

	cmp	al, ' '			; Space?
	je	EatWhLoop

	cmp	al, 09h			; Tab?
	je	EatWhLoop

	cmp	al, '='			; '='? (Skip the '=' sign too)
	je	EatWhLoop

	xor	ax, ax			; Mark of Success.

EatWhiteEOF:
	dec	si			; Backup one Point to Last Char.
	or	ax, ax			; Set Flags
	pop	ax			; AX Restored
	ret

MSMEatWhite	endp


ifdef TASM
%NEWPAGE ;
endif
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoMEMKeyword
;
;	MEM [#1|#2] address [length (Pars.)]
;
;	Action routine called when the MEM keyword has been 
;	found for the current board in the NET.CFG file.
;
;	assumes:
;		ds	is set to CGroup
;		si	-> buffer holding parms
;		bx	-> boards config table
;	
;	returns:
;		Nothing
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoMEMKeyword	proc	near
;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	ParmERROR		; Report problems

;----------------------------------------------------------------------------
;	If the next char is a '#' then they are specifying which
;	MEM address to set.  If is not a '#' then we assume that it
;	is MEM address #1.
;----------------------------------------------------------------------------
	cmp	byte ptr [si], '#'
	jne     LoadMEMAddress

	call	MSMAtoI			; Automatically skips the #
	jnz	ParmERROR		; Error in parm

	cmp	al, 1
	je	LoadMEMAddress		; Will be in MMemoryAddress1

	cmp	al, 2
	jne	ParmERROR		; Error in parm

	add	bx, 6			; BX -> MMemoryAddress2

LoadMEMAddress:
	call	MSMHexToDoubleInt
	jnz	ParmERROR

	mov	word ptr [bx].MMemoryAddress1, di
	mov	word ptr [bx].MMemoryAddress1+2, dx

	call	MSMEatWhite
	jnz	DoMEMAddressExit		; nz => Only White Space left.

	call	MSMHexToInt			; Get Length in Par.
	jnz	ParmERROR

	mov	[bx].MMemorySize1, dx

DoMEMAddressExit:
	xor	ax, ax				; Set Z Flag for Success.	
	ret

DoMEMKeyword	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoDMAKeyword
;
;	DMA [#1|#2] channel
;
;	Action routine called when the DMA keyword has been 
;	found for the current board in the NET.CFG file.
;
;	assumes:	
;		ds	is set to CGroup
;		si	-> buffer holding parms
;		bx	-> boards config table
;	
;	returns:
;		Nothing
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoDMAKeyword	proc	near
	add	bx, MDMALine1		; BX -> DMALine1 to put data
	jmp short GetParmIntDMA
DoDMAKeyword	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoIRQKeyword
;
;	IRQ [#1|#2] IRQlevel
;
;	Action routine called when the IRQ (INT) keyword has been 
;	found for the current board in the NET.CFG file.
;
;	assumes:
;		DS	CGroup
;		SI	-> buffer holding parms
;		BX	-> boards config table
;	
;	returns:
;		Nothing
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoIRQKeyword	proc	near
	add	bx, MIRQLine1
;	jmp short GetParmIntDMA
DoIRQKeyword	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	GetParmIntDMA
;	Parses the Value, and sets the value where BX points.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
GetParmIntDMA	proc near
;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	ParmERROR		; Report problems

;----------------------------------------------------------------------------
;	If the next char is a '#' then they are specifying which
;	Line to set.  If is not a '#' then we assume that it
;	is Line #1.
;----------------------------------------------------------------------------
	cmp	byte ptr [si], '#'
	jne	ConvertParm		; Non specific Default to 1

	call	MSMAtoI			; Automatically skips the #
	jnz	ParmERROR		; Error in parm

	cmp	al, 1
	je	ConvertParm		; Will be in Line 1

	cmp	al, 2
	jne	ParmERROR		; Error in parm

	inc	bx			; BX -> Line2 location

ConvertParm:
	call	MSMAtoI			; Convert string into AX
	jnz	ParmERROR

	cmp	ax, 15			; Check for ??
	ja	ParmERROR

	mov	byte ptr [bx], al	; Set the value
	xor	ax, ax			; Set Z Flag for Success.	
	ret

ParmERROR:
	mov	dx, offset CGroup:MissingValueParmMsg
	call	MSMPrintStringZero
	mov	ax, MSMCurrentLine
	call	MSMItoA
	mov	dx, offset CGroup:Period
	call	MSMPrintStringZero

IgnoreNETCFGLine:
	mov	dx, offset CGroup:EntryIgnored
	call	MSMPrintStringZero
	mov	dx, offset CGroup:LineBuffer
	call	MSMPrintStringZero
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero
	ret

GetParmIntDMA	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoPORTKeyword
;
;	PORT [#1|#2] address [Length]
;
;	Action routine called when the PORT keyword has been 
;	found for the current board in the NET.CFG file.
;
;	assumes:	ds	is set to CGroup
;			si	-> buffer holding parms
;			bx	-> boards config table
;	
;	returns:	
;		si destroyed, 
;		all other regs preserved.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoPORTKeyword	proc	near
;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz 	ParmERROR

;----------------------------------------------------------------------------
;	If the next char is a '#' then they are specifying which
;	PORT address to set.  If is not a '#' then we assume that it
;	is PORT address #1.
;----------------------------------------------------------------------------
	cmp	byte ptr [si], '#'
	jne	LoadPORTAddress

	call	MSMAtoI			; Automatically skips the #
	jnz	ParmERROR		; Error in parm

	cmp	al, 1
	je	LoadPORTAddress		; Will be in MIOAddress1

	cmp	al, 2
	jne	ParmERROR		; Error in parm

	add	bx, 4			; BX -> MIOAddress2

LoadPORTAddress:
	call	MSMHexToInt
	jnz	ParmERROR

	mov	[bx].MIOAddress1, dx		; (the Value in Bx May have been Adjusted for Mem 2)

	call	MSMEatWhite
	jnz	DoPORTExit			; nz => Only White Space left.

	call	MSMHexToInt			; Load DX with Range.
	jnz	ParmERROR

	mov	[bx].MIORange1, dx

DoPORTExit:
	xor	ax, ax		; Set Z Flag for Success
	ret

DoPORTKeyword	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoSlotKeyword
;
;	Slot [?|n]
;
;	assumes:	ds	is set to CGroup
;			si	-> buffer holding parms
;			bx	-> boards config table
;	
;	returns:
;		BP, DS, SS, SP Preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoSlotKeyword	proc	near
;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	ParmERROR		; Report problems

	xor	ax, ax			; Signal for Scanning
	cmp	byte ptr [si], '?'	; Want us to scan for it?
	je	SlotBusExit

	call	MSMAtoI			; Get the slot number
	jnz	ParmERROR

SlotBusExit:
	mov	[bx].MSlot, ax		; Store slot to use
	ret

DoSlotKeyword	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoBusIDKeyword
;		
;		BUSID  <String> <Number>
;
;	assumes:	ds	is set to CGroup
;			si	-> buffer holding parms
;			bx	-> boards config table
;	
;	returns:
;		BP, DS, SS, SP Preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoBusIDKeyword	proc	near
;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	ParmERROR		; Report problems

SkipBusString:
	inc	si
	mov	al, byte ptr [si]	; Get the first char to try
	cmp	al, ' ' 	 	; Start of Some White Space
	je	BusStringSkipped

	cmp	al, 09h			; Possible a Tab.
	je	BusStringSkipped

	cmp	al, ';'			; Comment Here you have to be kidding.
	jne	SkipBusString		; ne => look some more
BusIDKeyWordERROR:
	jmp	ParmERROR		; Error out of here

BusStringSkipped:
	call	MSMEatWhite
	jnz	BusIDKeyWordERROR	; Report problems

	call	MSMAtoI			; Get the Bus ID
	jnz	BusIDKeyWordERROR

  	cmp	al, -1			; Is it a Default setting?
	je	BusIDExit

	mov	[bx].MBusID, al		; Store slot to use

BusIDExit:
	ret

DoBusIDKeyword	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoNESLKeyword
;
;	assumes:
;		ds	is set to CGroup
;		si	-> buffer holding parms
;		bx	-> boards config table
;	
;	returns:
;		BP, DS, SS, SP Preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoNESLKeyword	proc	near
	or	DriverConfigTable.[MFlags], NESL_REQUIRED_BIT
	ret

DoNESLKeyword	endp

ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
; NAME:		DoNodeKeyword
;
; DESCRIPTION:	Stores the specified node address into the MSM's Physical Node 
;		Address in the Format Given on the Line.  The Format Specifier
;		is placed at byte location MSMPhysAddress+6 for the Media 
;		Specific Modules to use.
;
;
; ON ENTRY:	AX	N/A
;		BX	-> Boards Config Table
;		CX	N/A
;		DX	N/A
;		BP	N/A
;		SI	-> Buffer Holding Parms
;		DI	N/A
;		CS	CGroup
;		DS	CGroup
;		ES	N/A
;	
;		NOTE:	cld in effect, Interrupts are unknown
;
; ON RETURN:
;		AX	Destroyed
;		BX	Preserved
;		CX
;		DX	Destroyed
;		BP	Preserved	
;		SI	Destroyed
;		DI
;		CS	CGroup
;		DS	CGroup
;		ES	Destroyed
;
;
;		NOTE:	Interrupt state is not changed during function.
;			Interrupt state is preserved.
;	
;
; REMARKS:
;
; SEE ALSO:
;
;****************************************************************************
;****************************************************************************
NodeParmERROR:
	jmp	ParmERROR

DoNodeKeyword	proc	near
;----------------------------------------------------------------------------
;	Skip over any white space
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	NodeParmERROR

	push	cs
	pop	es				; ES: CGroup

;----------------------------------------------------------------------------
;	Check for LSB/MSB ending Character.
;	DS:SI -> Buffer Holding Params.
;----------------------------------------------------------------------------
	call	MSMGetStringLength		; CX = Number of chars
	jcxz	NodeParmERROR			; Missing Address.
	cmp	cx, 13				; 12 char for Node Address 1 char for Format Specifier.
	ja	InvalidNodeAddress		; Too Many Characters Ignore it.

	xor	dx, dx				; Clear for Possible No Character.
	push	bp
	mov	bp, cx				; BP = Offset to End of String.
	mov	al, byte ptr ds:[si+bp-1]	; Get Last Char.
	call	MSMIsHexChar			; Is the last char a Hex number?
	jc	NoLSBMSBoverride		; If it is then not a Format Specifier.
	
	xchg	dl, byte ptr ds:[si+bp-1]	; Take Character off line.

	test	[bx].MModeFlags, MSupportLSBMSB	; Check if Driver Supports LSBMSB Modes
	jz	NoLSBMSBoverride		; If driver doesn't support, Ignore it.

	cmp	dl, 'L'				; Only L or M (Logical/Media) are valid chars.
	je	StoreSpecifier

	cmp	dl, 'M' 
	je	StoreSpecifier

	xchg	dl, dh				; Put a Zero in if not valid specifier.

StoreSpecifier:
NoLSBMSBoverride:
	lea	di, MSMPhysNodeAddress		; Where to put it
 	mov	byte ptr [di]+6, dl		; Save Specifier for Media Modules.
	pop	bp				; Restore BP to entry original
	call	MSMHexStringToByteArray		; Media Specific Modules need to Adjust if needed.
	jnz	InvalidNodeAddress1		; Too Long Not Valid ignore.

	ret

InvalidNodeAddress1:
	lea	di, MSMPhysNodeAddress
	mov	ax, 0FFFFh	      		;Set back to F's
	stosw
	stosw
	stosw

InvalidNodeAddress:
	mov	dx, offset CGroup:InValidNodeAddressMsg	; Tell User.
	call	MSMPrintStringZero
	jmp	IgnoreNETCFGLine

DoNodeKeyword	endp

 
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoProtoKeyword
;
;	assumes:	ds	is set to CGroup
;			si	-> buffer holding parms (Already Past KeyWord)
;			bx	-> boards config table
;	
;	returns:	Nothing
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ProtoErrorExit:
	jmp	ParmERROR		; Get Error taken care of.

DoProtoKeyword	proc	near
;----------------------------------------------------------------------------
;	Get the String sized up.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	ProtoErrorExit

	call	MSMGetStringLength
	jcxz	ProtoErrorExit

;----------------------------------------------------------------------------
;	See if this really is our Parameter
;----------------------------------------------------------------------------
	cmp	cx, MaxStackNameLength	; Too big?
	ja	ProtoErrorExit		; Not a good one to check 

;----------------------------------------------------------------------------
;	Is there Room To Add another Protocol
;----------------------------------------------------------------------------
	mov	bx, NumProtoIDsToAdd		; Get index into the PID table
	cmp	bx, (MaxStacks*MaxBoards)-1	; Each Stack can bind to each board.
	ja	ProtoErrorExit			; Too many stacks already

;----------------------------------------------------------------------------
;	Get index into the Monster PID table.
;----------------------------------------------------------------------------
	mov	ax, Size ProtoIDStruc		; Size of One Structure
	mul	bl				; AX = (BX * SizeStruc)
	xchg	ax, bx				; BX = Offset into ProtIDTable
	lea	di, word ptr ProtoIDTable[bx].ProtIDName ; Get->ProtoName space

;----------------------------------------------------------------------------
;	Copy the Protocol Stack Name into ProtID Table.
;	DI -> ProtoName Space
;	SI -> Protocol Name (NET.CFG line buffer)
;----------------------------------------------------------------------------
	push	cs
	pop	es				; ES = CGroup
	mov	dx, cx				; DX = Length of String
	mov	al, cl				; Set the ProtoName length
	stosb
 rep	movsb					; Copy the stack name over

	xor	al, al				; Zero terminate it
	stosb

;----------------------------------------------------------------------------
;	Get the PID value input into the Table	
;----------------------------------------------------------------------------
	lea	di, ProtoIDTable[bx].ProtIDPID	; DI -> where the PID should go
 	cmp	byte ptr [si], 0		; Is this the End of the NET.CFG line?
	je	HandleDumbUser			; E => must be. Restore Table.

;----------------------------------------------------------------------------
;	Get Pid converted from ASCII to HEX and store it in Table.
;----------------------------------------------------------------------------
	call	MSMHexStringToByteArray		; Convert and set the PID
	jnz	HandleDumbUser		; Restore Table as before.

;----------------------------------------------------------------------------
;	Setup the media type for this stack/PID combination.
;----------------------------------------------------------------------------
	call	MSMEatWhite		; Move to valid part of string.
	jnz	HandleDumbUser		; Restore Table as before.

	cmp	byte ptr [si], 0	; Did they forget the Frame Type
	je	HandleDumbUser		; Restore Table as before

;----------------------------------------------------------------------------
;	Find the Supported Media
;----------------------------------------------------------------------------
	mov	bx, offset CGroup:SupportedMedias+2 ;Get -> mediaName table
 	mov	dx, SupportedMedias	; Get # of media types supported

FindMediaNameMatchLoop1:
	push	di			; DI -> ProtoIDTable[].ProtIDMediaID
	push	si			; SI -> Points to Current Frame Type String
	mov	di, word ptr [bx]	; Get -> mediaName
	mov	cl, byte ptr [di]	; Get the strings length
	inc	di			; Advance past the length byte
	call	MSMCompareString	; Check if we have a match.
	pop	si			; SI -> Current Frame Type String
	pop	di			; DI -> ProtoIDTable[].ProtIDMediaID
	jz	FoundMediaNameMatch1	; z => Found a Match.

;----------------------------------------------------------------------------
;	Not yet	Found
;----------------------------------------------------------------------------
	add	bx, 4+6			; BX -> next media name/ID entry
	dec	dx			; Check each of the Supported Frame types.
	jnz	FindMediaNameMatchLoop1

;----------------------------------------------------------------------------
;	The specified media name is not supported by this board,
;	therefore this Protocol keyword entry is not valid and will
;	be ignored.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:BadMediaNameMsg
	call	MSMPrintStringZero

	mov	dx, si				;Print the media name
	call	MSMPrintStringZero

	mov	dx, offset CGroup:BadMediaNameMsg2
	call	MSMPrintStringZero
	jmp short ReinitFirstStackSlot

;----------------------------------------------------------------------------
;	Found the Media Match, now we need to store it in the Table
;	DI -> ProtoIDTable[].ProtIDMediaID
;	BX -> SupportedMedias.MediaID
;----------------------------------------------------------------------------
FoundMediaNameMatch1:
	mov	ax, word ptr [bx+2]		; Get the mediaID

	and	ah, not 80h			; Clear use bit
	mov	word ptr [di], ax		; Store in our table

	inc	NumProtoIDsToAdd		; One more PID to add, later
	ret

;----------------------------------------------------------------------------
;	User forgot to Specify which Frame Type.
;----------------------------------------------------------------------------
HandleDumbUser:
	mov	dx, offset CGroup:ForgotMediaName
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Due to an Error, the First table Entry may need to be Reinitialized.
;----------------------------------------------------------------------------
ReinitFirstStackSlot:
	cmp	NumProtoIDsToAdd, 0		;If first PID restore default stuff
	jne	DontRestoreDefaultStackInfo

;----------------------------------------------------------------------------
;	Restore the First ProtoIDTable entry to Default values.
;----------------------------------------------------------------------------
	lea	di, ProtoIDTable[0]	;Set default backup
	mov	cx, (size ProtoIDStruc)/2	; Null out the Whole Entry.
	xor	ax, ax				
	rep	stosw
	lea	di, ProtoIDTable[0].ProtIDName	;DI -> ProtIDName Field
	mov	al, 3				;Set IPX length
	stosb
	mov	al, 'I'
	stosb
	mov	ax, 'P'
	stosb
	mov	al, 'X'
	stosb				; String is null terminated anyway

DontRestoreDefaultStackInfo:
	ret

DoProtoKeyword	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoFrameKeyword
;	Frame Type Support. Envelope type was old key word.
;
;	assumes:	ds	is set to CGroup
;			si	-> buffer holding parms
;			bx	-> boards config table
;	
;	returns:	Nothing
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FrameErrorExit:
	jmp	ParmERROR		; Get Error taken care of.

;----------------------------------------------------------------------------
;	Determine the Number of Media Types we can support.
;----------------------------------------------------------------------------
DoFrameKeyword	proc	near
	mov	dx, SupportedMedias		;Get # of media types supported
	cmp	dx, 1				;If only one, skip this stuff
	je	FrameExit

	cmp	dx, MSMActiveBoardCount		;Already more than MLID supports?
	je	FrameExit

;----------------------------------------------------------------------------
;	Skip over to the Frame Name
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	FrameErrorExit			; Use short label for jmp

;----------------------------------------------------------------------------
;	Set up the ES reg for compares
;----------------------------------------------------------------------------
	push	cs
	pop	es				    ; CGroup
	mov	bx, offset CGroup:SupportedMedias+2 ; Get ->First mediaName in table

;----------------------------------------------------------------------------
;	BX = -> MediaName offset 
;	SI -> New Name
;	DX = Number of Medias to Check
;----------------------------------------------------------------------------
FindMediaNameMatchLoop:
	xor	cx, cx				; Guarentee that CX = 0
	mov	di, word ptr [bx]		; Get -> mediaName
	mov	cl, byte ptr [di]		; Get the strings length
	inc	di				; Advance past the length byte

;----------------------------------------------------------------------------
;	ES:DI -> Name to compare to 
;	SI -> Name coming in
;	BX = Offset into Media table -> at MediaName
;	CX = Len
;	DX = Number of Supported Medias
;----------------------------------------------------------------------------
	push	si				; Save starting char
	call	MSMCompareString		; Check for match

;----------------------------------------------------------------------------
;	MSMCompareString leaves SI -> at end of the Media Name.
;	SI -> Next word on the line (if there is one)
;----------------------------------------------------------------------------
	xchg	ax, si			; Save pointer to Next Param String AX
	pop	si
	je	FoundMediaNameMatch

;----------------------------------------------------------------------------
;	Media Names Didn't Match
;----------------------------------------------------------------------------
	add	bx, 4+6				; -> next media name/ID entry
	dec	dx				; Track number of Medias left.
	jnz	FindMediaNameMatchLoop

	mov	dx, offset CGroup:FrameTypeNotSupported
	call	MSMPrintStringZero

FrameExit:
	ret

;----------------------------------------------------------------------------
;	Name Matches
;----------------------------------------------------------------------------
FoundMediaNameMatch:
	test	byte ptr [bx+3], 80h		;Frame type already active?
	jnz	DuplicateFrameTypeError

	inc	MSMActiveBoardCount		; Count number of Logical Boards loaded.
	mov	di, MSMActiveBoardCount		;Get -> correct config table
	add	di, di				; get word index

	push	bx				; Save Pointer to the Media's Name.
	push	ax				; Save Pointer to the next KeyWord.
	mov	bx, offset CGroup:DriverConfigTable
	cmp	MSMActiveBoardCount, 1		;If 1st, use static config table
	je	DontAllocate

	mov	ax, size MLIDConfigurationStructure ;Alocate one
	call	MSMAlloc

	mov	MSMConfigTables[di-2], bx	;Save it in the table

;----------------------------------------------------------------------------
; Make the new config table look like the driver's DriverConfigTable
;----------------------------------------------------------------------------
	mov	si, offset CGroup:DriverConfigTable
	mov	di, bx
	push	cs
	pop	es				; ES = CGroup
	mov	cx, size MLIDConfigurationStructure
	shr	cx, 1
 rep	movsw
	adc	cl, cl
 rep	movsb
	
  	and	[bx].MModeFlags, NOT MNeedsPollingBit	; Clear out polling bit

;----------------------------------------------------------------------------
;	Check which Addressing Mode is to be used.
;----------------------------------------------------------------------------
DontAllocate:
	pop	si				; -> Next Paramater KeyWord (Maybe)
	call	MSMEatWhite			;Skip to next string
	jnz	ModeSet				;NZ - None there, use setting in Driver's Config.

	mov	di, offset CGroup:LSBKeyword	; Look for 'LSB'
	mov	cx, LSBKeywordLen
	mov	dx, si
	call	MSMCompareString
	je	LSBMode

	mov	si, dx				; Look for 'MSB'
	mov	di, offset CGroup:MSBKeyword
	mov	cx, LSBKeywordLen
	call	MSMCompareString
	jz	MSBMode

;----------------------------------------------------------------------------
;	Default is MSB for now
;----------------------------------------------------------------------------
MSBMode:
	or	[bx].MModeFlags, MNonCanonicalBit ;Set LSB/MSB Mode bit 
	jmp short ModeSet

LSBMode:
	and	[bx].MModeFlags, NOT MNonCanonicalBit ;Clear LSB/MSB Mode Bit

ModeSet: 
	pop	si				;SI -> MediaNames table
	mov	ax, word ptr [si]		;Get mediaString's offset
	mov	word ptr [bx].MFrameString, ax
	mov	ax, word ptr [si+2]		;Get the mediaID
	mov	[bx].MFrameID, ax
	or	byte ptr [si+3], 80h		;Flag this frm type used
	ret

;----------------------------------------------------------------------------
;	Already Loaded this frame type
;----------------------------------------------------------------------------
DuplicateFrameTypeError:
	mov	dx, offset CGroup:DuplicateFrameTypeMsg
	call	MSMPrintStringZero
	mov	dx, word ptr [bx]			; Get Frame Type String
	inc	dx					; Skip length byte
	call	MSMPrintStringZero
	mov	dx, offset CGroup:Period
	call	MSMPrintStringZero
	jmp	IgnoreNETCFGLine

DoFrameKeyword	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DoLookAheadKeyword
;
;	assumes:	ds	is set to CGroup
;			si	-> buffer holding parms
;			bx	-> boards config table
;	
;	returns:	Nothing
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DoLookAheadKeyword	proc	near
	call	MSMEatWhite
	jnz	LookAheadErrorExit

	call	MSMAtoI
	jnz	LookAheadErrorExit

	cmp	ax, 128				;See if more than max.
	jbe	LookAheadOkay

	mov	ax, 128				;Load maximum

LookAheadOkay:
	mov	[bx].MLookAheadSize, ax
	ret

LookAheadErrorExit:
	jmp	ParmERROR		; Go get the Error message printed out.
DoLookAheadKeyword	endp

;****************************************************************************
;	MSMPrintStringZero
;
;	Routine outputs the specified string to stdout.  The string
;	must be 0 terminated.
;
;	assumes:
;		ds:dx	-> string to print out
;	If the value of the first two bytes is < 1000 then a Platform 
;	prefix added to the string.
;		(ShortCardname-PlatformID-MessageNumber:)
;
;	returns:
;		All registers preserved
;****************************************************************************
MSMPrintStringZeroNotMSG:		; Entry point for Callers needing to 
					; Avoid Message number Checking.
	push	ax
	push	dx
	push	si
	mov	si, dx
	jmp short PrintStringOut	; Skip the Message Number Check

;------------------------------------------------------------------------------
; MSMPrintStringZero
;	Prints a zero terminated string.
;
;	Entry:
;		DS:DX	Ptr. to terminated String to Print
;
;	Exit:		
;		All preserved
;
MSMPrintStringZero	proc	near
;------------------------------------------------------------------------------
;	Preserve what we use.
;------------------------------------------------------------------------------
	push	ax
	push	dx	     		; Preserved
	push	si

;------------------------------------------------------------------------------
;	Check for a Message number preceeding 
;------------------------------------------------------------------------------
	mov	si, dx			; SI -> start of string.
	cmp	word ptr [si], 1000	; Message numbers are 1-999.
	jae	PrintStringOut

	lodsw				; AX has Message Number
	call	MSMPrintPlatformString	; Print out the Prefix

;----------------------------------------------------------------------------
;	Print the String out a char at a time.
;----------------------------------------------------------------------------
PrintStringOut:
	mov	ah, PRINT_CHAR		; DOS print char function

PrintStringLoop:
	lodsb
	or	al, al			; Done?
	jz	AllDoneWithTheString

	mov	dl, al			; Get char to print
	int	ENTER_DOS		; Print it.
	jmp short PrintStringLoop

;----------------------------------------------------------------------------
;	Finished cleanup and exit.
;----------------------------------------------------------------------------
AllDoneWithTheString:
	pop	si
	pop	dx
	pop	ax
	ret

MSMPrintStringZero	endp

;****************************************************************************
;	MSMPrintPlatFormString
;
;	Assumes:	DS: CGroup
;			AX:		Message Number to Print.
;
;	Prints out the ShortCardName, Platform ID, and Message Number.
;					
;
;	Returns:  	Nothing
;			All Registers are  preserved.
;****************************************************************************
MSMPrintPlatformString	proc near
;----------------------------------------------------------------------------
;	Get Short name out
;----------------------------------------------------------------------------
	push	dx
	mov	dx, word ptr DriverConfigTable.MCardShortName
	inc	dx					;skip length.
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Print out the Platform
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:MSMPlatformMsg
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Get the Messge Number
;----------------------------------------------------------------------------
	call	MSMItoA			; AX = Number (Also prints to screen)
	mov	dx, offset CGroup:Colon ; 
	call	MSMPrintStringZero
	pop	dx
	ret
MSMPrintPlatformString	endp

;****************************************************************************
;	MSMPrintDoubleHex
;
;	assumes:	dx:ax	has the double word to print
;
;	returns:	nothing
;
;****************************************************************************
MSMPrintDoubleHex	proc	near

	push	ax
	mov	ax, dx
	call	MSMAtoH
	call	MSMEatLeadingZeros
	call	MSMPrintStringZeroNotMSG

	pop	ax
	call	MSMAtoH
	call	MSMPrintStringZeroNotMSG
	ret

MSMPrintDoubleHex	endp


;****************************************************************************
;	MSMAtoH
;
;	assumes:
;		ax	has the value to convert
;
;	returns:
;		ds:dx	-> string
;		All regs preserved except ax
;
;****************************************************************************
MSMAtoH	proc	near
;----------------------------------------------------------------------------
;	Save regs to use
;----------------------------------------------------------------------------
	push	ax
	push	cx
	push	di
	push	es		; Preserve Regs.

;----------------------------------------------------------------------------
;	Get ES:DI loaded.
;----------------------------------------------------------------------------
	push	cs
	pop	es				; ES = CGroup
	mov	di, offset CGroup:WorkBuffer
	mov	dx, ax	 			; DX = Value to convert.
	mov	al, ah				; Do high byte first
	mov	ch, 1				; Flag for High Byte

;----------------------------------------------------------------------------
;	Convert a nibble at a time
;----------------------------------------------------------------------------
DoLowByteNow:
	mov	cl, al
	shr	al, 1				;Get high nibble
	shr	al, 1
	shr	al, 1
	shr	al, 1
	call	MSMGetHexChar	  		; Get Char and store it.
	stosb

	mov	al, cl				; Get other char
	and	al, 0fh				; Do low nibble
	call	MSMGetHexChar	  		; Get Char and store it.
	stosb

	or	ch, ch				;If CH = 0 we are done
	jz	DoneWordToHex

	mov	al, dl				; Do low byte
	xor	ch, ch
	jmp	DoLowByteNow

;----------------------------------------------------------------------------
;	Word is done, Null Terminate the String and return.
;----------------------------------------------------------------------------
DoneWordToHex:
	xor	al, al				; Null 
	stosb	
	mov	dx, offset CGroup:WorkBuffer	; Point to start of string.

	pop	es
	pop	di
	pop	cx
	pop	ax
	ret
	
MSMAtoH	endp

;****************************************************************************
;	MSMItoA
;
;	Integer to ASCII conversion.
;	Prints the Character on the Screen as well as 
;
;	assumes:	
;		ax	has the integer to convert
;		ds = CGroup
;
;	returns:	
;		ds:dx	-> converted string (Workbuffer)
;		All registers preserved except(dx)
;
;****************************************************************************
MSMItoA	proc	near
;----------------------------------------------------------------------------
;	Preserve all used Regs.
;----------------------------------------------------------------------------
	push	ax
	push	bx
	push	cx
	push	si			; Preserve what we use.
	push	di
	push	bp
	push	es

;----------------------------------------------------------------------------
;	Set ES:DI to the workbuffer
;----------------------------------------------------------------------------
	push	cs
	pop	es				; CGROUP
	mov	di, offset CGroup:WorkBuffer	
	mov	cx, 5				; Max of 5 chars
	mov	bx, 10000			; Divisor value
	mov	bp, 10				; move by powers of 10
	push	ax				; Passed in value. (prime loop)

;----------------------------------------------------------------------------
;	Pick off each digit.
;----------------------------------------------------------------------------
MSMItoALoop:
	pop	ax			; Current Value not accounted for.
	xor	dx, dx			; clear high word.
	div	bx			; Div for high order number
	add	al, '0'			; AX = High order digit
	stosb				; Store the first digit.

;----------------------------------------------------------------------------
;	Setup for next Divide to get next digit.
;----------------------------------------------------------------------------
	push	dx			; Remainder
	mov	ax, bx			; AX = Last Divisor
	xor	dx, dx			; Clear high word.
	div	bp			; next power of 10
	mov	bx, ax			; BX = new Divisor
	loop	MSMItoALoop

;----------------------------------------------------------------------------
;	Integer is converted, now print it and exit.
;----------------------------------------------------------------------------
	pop	ax				; final Remainder value is always zero
	stosb					; Place Null terminator in.
	mov	dx, offset CGroup:WorkBuffer	; DX -> start of String.
	call	MSMEatLeadingZeros		; Clear off the Leading 0's
	call	MSMPrintStringZeroNotMSG	; Put it on the screen
	pop	es
	pop	bp
	pop	di				; Restore what we used.
	pop	si
	pop	cx
	pop	bx
	pop	ax
	ret

MSMItoA	endp


;****************************************************************************
;	MSMEatLeadingZeros
;
;	assumes:	
;		DS:DX -> string to eat
;
;	returns:
;		DS:DX -> updated past leading zeros
;		All other Regs preserved.
;
;****************************************************************************
MSMEatLeadingZeros	proc	near
	push	bx			; Preserve what we use.
	mov	bx, dx			; BX -> start of string.

;----------------------------------------------------------------------------
;	Skip over the leading zeros, leave one zero if value is zero.
;----------------------------------------------------------------------------
EatLeadZeroLoop:
	cmp	byte ptr [bx], '0'	; Check for Leading zeros
	jne	DoneEating

	inc	bx			; Next char
	jmp	EatLeadZeroLoop

;----------------------------------------------------------------------------
;	Check to see if the string was all zeros
;----------------------------------------------------------------------------
DoneEating:
	cmp	byte ptr [bx], 0 ; Don't take all of the string
	jne	CharsStillLeft

	dec	bx		; Backup and point at last '0'

CharsStillLeft:
	mov	dx, bx		; DS:DX -> String without leading zeros
	pop	bx		; Restore what was used
	ret

MSMEatLeadingZeros	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMPrintSixByteHexString
;
;	Used for printing node addresses or protocol ID's.
;
;	assumes:
;		ds:dx	-> 6-byte hex array
;
;	returns:
;		All registers preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMPrintSixByteHexString	proc	near
;----------------------------------------------------------------------------
;	Preserve The regs we destroy.
;----------------------------------------------------------------------------
	push	ax
	push	cx
	push	dx
	push	si
	push	di
	push	es	

;----------------------------------------------------------------------------
;	Do this a nibble at a time.
;----------------------------------------------------------------------------
	mov	di, offset CGroup:WorkBuffer
	push	cs
	pop	es		; ES:DI -> Work Buffer.

	mov	si, dx		; DS:SI -> Hex digits to print.
	mov	cx, 6		; 6 bytes 

;----------------------------------------------------------------------------
;	Load the workbuffer with the ASCII equivalent
;----------------------------------------------------------------------------
OutputHexArrayLoop:
	lodsb
	mov	dh, al
	shr	al, 1				;Get high nibble
	shr	al, 1
	shr	al, 1
	shr	al, 1
	call	MSMGetHexChar			; Convert the nibble
	stosb
	mov	al, dh
	and	al, 0fh				;Do low nibble
	call	MSMGetHexChar			; Convert the nibble
	stosb
	loop	OutputHexArrayLoop

;----------------------------------------------------------------------------
;	Terminate the String and then print it out.
;----------------------------------------------------------------------------
	sub	al, al
	stosb
	push	ds
	push	cs
	pop	ds				; DS = CGROUP
	mov	dx, offset CGroup:WorkBuffer	; DS:DX -> Work Buffer
	call	MSMEatLeadingZeros
	call	MSMPrintStringZeroNotMSG
	pop	ds

;----------------------------------------------------------------------------
;	Restore the preserved regs.
;----------------------------------------------------------------------------
	pop	es
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	ax			; Preserved now restored.
	ret

MSMPrintSixByteHexString	endp


;****************************************************************************
;	MSMPrintHexChar
;
;	assumes:
;		al	has the value to print out
;		
;	returns:
;		All registers preserved
;
;****************************************************************************

MSMPrintHexChar	proc	near
;----------------------------------------------------------------------------
;	Preserve
;----------------------------------------------------------------------------
	push	ax
	push	dx

;----------------------------------------------------------------------------
;	Convert the and print
;----------------------------------------------------------------------------
	call	MSMGetHexChar
	mov	ah, PRINT_CHAR		;DOS print char function
	mov	dl, al
	int	ENTER_DOS

;----------------------------------------------------------------------------
;	Restore
;----------------------------------------------------------------------------
	pop	dx
	pop	ax
	ret

MSMPrintHexChar	endp


;****************************************************************************
;	MSMGetHexChar
;
;	assumes:	al	has the value to print out
;		
;	returns:	al	has the ASCII char
;
;****************************************************************************
MSMGetHexChar	proc	near
	add	al, '0'				;Convert it to ASCII
	cmp	al, '9'
	jbe	GHexValueIsOkay

	add	al, 'A'-'0'-10			;Make it alphabetic

GHexValueIsOkay:
	ret

MSMGetHexChar	endp


;
;	MSMHexCharToInt
;
;	assumes:	al	has the ASCII char to convert
;
;	returns:	al 	integer value
;			All other registers preserved
;

MSMHexCharToInt	proc	near

	cmp	al, '9'
	jbe	DecimalValue

	cmp	al, 'A'
	jb	HEXError
	cmp	al, 'F'
	ja	HEXError

	sub	al, 'A'
	add	al, 10
	ret

DecimalValue:
	cmp	al, '0'
	jb	HEXError
	sub	al, '0'
	ret

HEXError:
	mov	al, -1
	ret

MSMHexCharToInt	endp

;****************************************************************************
;	MSMAtoI
;
;	ASCII to integer conversion routine.
;
;	assumes:
;		ds:si	-> ASCII string
;			Skips Leading # char
;
;	returns:	
;		ax	converted integer
;		z flag	set if AX is valid, DS:SI -> end of String.
;		nz flag	if Error, DS:SI -> Char where Error Occured.
;		All Other Regs Preserved.
;
;****************************************************************************
MSMAtoI	proc	near
;----------------------------------------------------------------------------
;	Preserve what we use.
;----------------------------------------------------------------------------
	push	bx
	push	cx
	push	dx
	push	bp

	cmp	byte ptr [si], '#'
	jne	SkipWhiteSpace

	inc 	si			; Skip the # char.	

;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
SkipWhiteSpace:
	call	MSMEatWhite
	jnz	MSMAtoIErrorExit	; Report problems

;----------------------------------------------------------------------------
;	Check for Negative Sign even though we'd drather not.
;----------------------------------------------------------------------------
	xor	bp, bp			; Signal that we have a Positive Guy 
	cmp	byte ptr [si], '-'
	je	NegativeNumbersStink

;----------------------------------------------------------------------------
;	Check the length of the string.
;----------------------------------------------------------------------------
CheckLengthOfString:
	call	MSMGetStringLength	; CX = String Length
	jcxz	MSMAtoIErrorExit       	; z => no string to convert.

	cmp	cx, 5			; Integer is max. 5 chars
	ja	MSMAtoIErrorExit	; a => integer is to big.

	xor	ax, ax			; Will hold the result
	xor	bx, bx			; 

;----------------------------------------------------------------------------
;	Convert the String a digit at a time.
;----------------------------------------------------------------------------
ConvertASCIIToIntLoop:
	mov	bl, byte ptr [si]	; BL = Next Digit.
	
	cmp	bl, '0'			; See if valid decimal char
	jb	MSMAtoIErrorExit

	cmp	bl, '9'
	ja	MSMAtoIErrorExit

	sub	bl, '0'			; Convert to integer value
	mov	dx, 10			; dx multiplier
	mul	dx			; move total over
	add	ax, bx			; Add in new digit
	inc	si			; Next digit.
	loop	ConvertASCIIToIntLoop

;----------------------------------------------------------------------------
;	Restore Regs and exit
;----------------------------------------------------------------------------
	or	bp, bp				; Did we have a negative number
	jz	MSMAtoICleanStack		; z => No okay number.
	neg	ax
	xor	dx, dx				;Set the z flag

MSMAtoICleanStack:
	pop	bp
	pop	dx
	pop	cx
	pop	bx				; Restore Regs
	ret

MSMAtoIErrorExit:
	or	dl, 1				; Set NZ flag
	jmp short MSMAtoICleanStack

Public NegativeNumbersStink
NegativeNumbersStink:
	mov	bp, -1				; Set up for Negative Numbers
	inc	si				; Skip Neg Sign
	jmp short CheckLengthOfString

MSMAtoI	endp

;***************************************************************
;	MSMAtoL
;
;	ASCII to long integer conversion routine.
;
;	assumes:
;		ds:si	-> ASCII string
;
;	returns:
;		dx:ax	converted integer
;		z flag	set if AX is valid, DS:SI -> end of String.
;		nz flag	if Error, DS:SI -> Char where Error Occured.
;		All other Regs Preserved.
;
;***************************************************************
MSMAtoL	proc	near

;----------------------------------------------------------------------------
;	Preserve what we use.
;----------------------------------------------------------------------------
	push	bx
	push	cx

;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz	MSMAtoLErrorExit		; Report problems

;----------------------------------------------------------------------------
;	Check the length of the string.
;----------------------------------------------------------------------------
	call	MSMGetStringLength
	jcxz	MSMAtoLErrorExit

	cmp	cx, 10			; Long is max. 10 chars
	ja	MSMAtoLErrorExit

	xor	ax, ax			; Will hold the result
        xor     dx, dx
	xor	bx, bx

;----------------------------------------------------------------------------
;	Convert the String a digit at a time.
;----------------------------------------------------------------------------
ConvertASCIIToLongLoop:
        mov     bl, 10
        mul     bx                              ; Multiply current number by 10

	mov	bl, byte ptr [si]	; BL = Next Digit.

	cmp	bl, '0'
	jb	MSMAtoLErrorExit

	cmp	bl, '9'
	ja	MSMAtoLErrorExit

	sub	bl, '0'
	add	ax, bx			; Add in new digit
        adc     dx, 0
	inc	si			; Next digit.
	loop	ConvertASCIIToLongLoop

;----------------------------------------------------------------------------
;	Restore Regs and exit
;----------------------------------------------------------------------------
	xor	cx, cx				; Set the z flag
	pop	cx
	pop	bx
	ret

MSMAtoLErrorExit:
	or	cl, 1				; Set NZ Flag
	pop	cx
	pop	bx
	ret

MSMAtoL	endp

;****************************************************************************
;	MSMHexToDoubleInt
;
;	assumes:	ds:si	-> ASCII string
;		
;	returns:
;		AX set according to flags.
;		z flag	set if okay
;		nz flag	set if EOF
;		dx:di	has the converted value
;
;****************************************************************************
MSMHexToDoubleInt	proc	near
;----------------------------------------------------------------------------
;	Preserve and set up to convert.
;----------------------------------------------------------------------------
	push	cx		; Preserve what we use.

;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz 	HToDIExit

	xor	dx, dx
	xor	di, di		; Store the results

	call	MSMGetStringLength
	jcxz	HToDIExit

	cmp	cx, 8				; Max of 8 chars ffffffff
	ja	HToDIExit

	xor	ah, ah

HToDILoop:
	lodsb

	call	ShiftDXDIBy4
	call	MSMHexCharToInt
	cmp	al, -1
	jz	HToDIExit

	or	di, ax
	loop	HToDILoop

	xor	ax, ax
	pop	cx
	ret

HToDIExit:
	or	al, 1
	pop	cx
	ret

MSMHexToDoubleInt	endp


;****************************************************************************
;	MSMHexToInt
;
;	assumes:
;		ds:si	-> ASCII string
;		
;	returns:
;		z flag	set if okay
;		nz flag	set if EOF
;		dx	has the converted value
;
;****************************************************************************
MSMHexToInt	proc	near
;----------------------------------------------------------------------------
;	Skip over any white stuff and see if there is any left.
;----------------------------------------------------------------------------
	call	MSMEatWhite
	jnz 	HToIExit

	xor	dx, dx
	call	MSMGetStringLength
	jcxz	HToIExit

	cmp	cx, 4				;Max of 4 chars ffff
	ja	HToIExit

HToILoop:
	lodsb

	shl	dx, 1
	shl	dx, 1
	shl	dx, 1
	shl	dx, 1

	call	MSMHexCharToInt
	cmp	al, -1
	jz	HToIExit

	or	dl, al
	loop	HToILoop

	xor	ax, ax
	ret

HToIExit:
	or	al, 1
	ret

MSMHexToInt	endp


;****************************************************************************
;	ShiftDXDIBy4
;
;	Shifts DX:DI 4 bits to the left.
;
;	assumes:
;		dx:di are valid
;
;	returns:	
;		dx:di updated
;
;****************************************************************************
ShiftDXDIBy4	proc	near
	shl	di, 1
	rcl	dx, 1
	shl	di, 1
	rcl	dx, 1
 	shl	di, 1
	rcl	dx, 1
 	shl	di, 1
	rcl	dx, 1
	ret

ShiftDXDIBy4	endp


;****************************************************************************
;	MSMHexStringToByteArray
;
;	assumes:
;		es:di	-> destination for byte array
;		ds:si	-> string to convert
;
;	returns:
;		nothing
;
;****************************************************************************
MSMHexStringToByteArray	proc	near

	call	MSMEatWhite

	call	MSMGetStringLength
	jcxz	HToBAExit

	cmp	cx, 12				;Max of 12 chars
	ja	HToBAExit

	xor	ax, ax				;Initialize to 0's
	stosw
	stosw
	stosw

	shr	cx, 1
	jnc	BackupAdjIsOkay

	inc	cx
	sub	di, cx
	jmp	short LeftOverNibble

BackupAdjIsOkay:
	sub	di, cx

HToBALoop:
	xor	ah, ah
	lodsb
	call	MSMHexCharToInt
	cmp	al, -1
	jz	HToBAExit

	mov	ah, al

	shl	ah, 1
	shl	ah, 1
	shl	ah, 1
	shl	ah, 1

LeftOverNibble:
	lodsb
	call	MSMHexCharToInt
	cmp	al, -1
	jz	HToBAExit
	or	al, ah

	stosb
	loop	HToBALoop

	xor	ax, ax
	ret

HToBAExit:
	or	al, 1
	ret

MSMHexStringToByteArray	endp

;
; MSMIsHexChar	
;	Checks ASCII Char in AL for being a Valid Hex Digit.
;	assumes:
;		AL char to check
;	returns:
;		carry flag if Hex Digit.
;		nocarry if not.

MSMIsHexChar	proc
	cmp	al, '0'
	jb	NotAHexDigit
	cmp	al, '9'
	jbe	HexDigit
	cmp	al, 'A'
	jb	NotAHexDigit
	cmp	al, 'F'
	jbe	HexDigit
	cmp	al, 'a'
	jb	NotAHexDigit
	cmp	al, 'f'
	jbe	HexDigit

NotAHexDigit:
	clc
	ret

HexDigit:
	stc
	ret

MSMIsHexChar	endp


;****************************************************************************
;	MSMGetStringLength
;	Gets the length of the WhiteSpace Terminated String.
;		(space, tab, null)
;	assumes:	
;		ds:si	-> string
;	
;	returns:
;		cx	strings length
;		All other Regs preserved
;
;****************************************************************************
MSMGetStringLength	proc	near
;----------------------------------------------------------------------------
;	Preserve and setup, then count the chars.
;----------------------------------------------------------------------------
	push	si
	xor	cx, cx		; start at 0

CountStringLengthLoop:
	lodsb			; al = Char
	cmp	al, ' '		; Is is a Space?
	je	FoundTheLength

	cmp	al, 09h		; Is it a TAB?
	je	FoundTheLength

	or	al, al		; End of the String?
	jz	FoundTheLength

	inc	cx		; count the char and loop
	jmp short CountStringLengthLoop

FoundTheLength:
	pop	si		; DS:SI -> Start of string.
	ret

MSMGetStringLength	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMAlloc
;
;	Routine will allocate a block of memory in CGroup of the specified length.  
;	There is 1K of free space reserved for allocation of TCB's Config Tables,
;	and Media Header buffers.  Overruns are not detected.  Overruns start 
;	by destroying NET.CFG token names.
;
;	assumes:
;		ax	Number of bytes to allocate
;
;	returns:
;		cs:bx	-> memory buffer
;		All registers preserved
;		Interrupts unchanged
;		Direction flag preserved
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMAlloc	proc	near
;----------------------------------------------------------------------------
;	Get pointer to end, move to new end.
;----------------------------------------------------------------------------
	mov	bx, cs:MSMImageEnd
	add	cs:MSMImageEnd, ax
	ret
MSMAlloc	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	FindBoard
;
;	Will scan the LSL's board numbers from highest to lowest, looking
;	for a MLID that matches ourselves. If found we will return the found
;	MLID's board number and PSP address.
;
;	assumes:
;		ds	is set to CGroup
;		Interrupts are enabled
;
;	returns:	
;		bp	= ODI Board Number
;		es	= MLID's PSP
;		
;		z flag	set if board found
;		Interrupts enabled
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FindBoard	proc	near
;----------------------------------------------------------------------------
;	Start at the Highest, and work down.
;----------------------------------------------------------------------------
	mov	bp, MaxBoards-1			; Count down reg (0 based)

TryTheNextBoardNumber:
	mov	ax, bp
	mov	bx, PROTSUP_GET_MLID_CTL_ENTRY
	call	LSLEntryPoints.LSLProtSupEntryPt ; Call MPI entry point
	jnz	NotThisBoard

;----------------------------------------------------------------------------
;	Board is active, now get a -> to its config table.
;----------------------------------------------------------------------------
	mov	MLIDControlEntryPoint+0, si
	mov	MLIDControlEntryPoint+2, es	; Hold the Entry point.

	mov	ax, bp				; Must pass in board number
	mov	bx, GET_MLID_CONFIGURATION	; Setup for call using ES:SI
	call	dword ptr MLIDControlEntryPoint
	jnz	NotThisBoard

;----------------------------------------------------------------------------
;	Got its config table.  Now see if its short name matches mine.
;----------------------------------------------------------------------------
	mov	di, word ptr es:[si].MCardShortName ; di = The Loaded name

	mov	si, MSMConfigTables[0]		 ;Get -> first config table
	mov	si, word ptr [si].MCardShortName ;Get -> short name

	mov	cl, byte ptr [si]		;Get the strings length
	xor	ch, ch
	add	cl, 2				;Add two for length byte and 0 terminator
  repe	cmpsb
  	jne	NotThisBoard

;----------------------------------------------------------------------------
;	This board has the same name as us. Must be the one.
;----------------------------------------------------------------------------
	xor	ax, ax
	ret

NotThisBoard:
	dec	bp
	jns	TryTheNextBoardNumber

;----------------------------------------------------------------------------
;	All board numbers tried and couldn't find the right one.
;----------------------------------------------------------------------------
	or	al, 1
	ret

FindBoard	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	UnloadDriver
;
;	Routine is called with the 'U' command line parameter present.
;	We will do the following.
;
;	1) Check for a resident MLID of the same type and the correct version.
;
;	2) Make sure no other TSR's are above the resident MLID.
;
;	3) Tell the resident MLID to shut down permanentally.
;
;	4) Tell the NESL if Loaded We are gone and Deregister.
;
;	4) Free the resident MLID segment, exit.
;
;	NOTE: If we unload, this routine never returns to the caller.
;	Assumes:
;		CS = DS = CGroup
;		BH = CmdLine Switch Char.
;		
;	Doesn't Return:
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
UnloadDriver	proc	near
;----------------------------------------------------------------------------
;	The user wants us to unload.  Find a MLID that is the same type as
;	ourselves and located the highest in memory.  We will do this by
;	scanning the board numbers from highest to lowest.  We can be
;	sure that the highest numbered board number that is the same as us
;	will the be the highest in memory.
;	Then check if it is to be a forced unload.
;----------------------------------------------------------------------------
	push	bx			; CmdLine Switch Char
	call	FindBoard		; Find our image in memory
	pop	bx			; Check which Switch 
	jnz	BoardNotFound		; nz => not found
	cmp	bh, 'F'			;
	je	ForceUnload		; Force the unload.
	jmp short DoTheUnload		; unload the driver

;----------------------------------------------------------------------------
;	Board not found cann't unload what cann't be found.
;----------------------------------------------------------------------------
BoardNotFound:
	mov	dx, offset CGroup:CantUnloadNoMLIDMsg
	mov	cx, offset CGroup:CantUnloadNoMLIDMsg2

;----------------------------------------------------------------------------
;	Some error occured that keeps us from unloading.
;	DX = Offset of message part 1
;	CX = Offset of Message part 2
;----------------------------------------------------------------------------
UnloadErrorExit:
	push	cs	
	pop	ds				; DS = CGroup
	push	cx				; Part 2 of the Error Message
	call	MSMPrintStringZero		; Print part one.

	mov	bx, MSMConfigTables[0]		;Pull up MLID name
	mov	dx, word ptr [bx].MCardShortName
	inc	dx				; Go past length byte
	call	MSMPrintStringZero

	pop	dx				; Get -> Message part 2
	call	MSMPrintStringZero

	mov	ax, ERROR_EXIT_4		;DOS function 4C, ErrCode=4
	int	ENTER_DOS
;============================================================================

TSRAboveResidentMLID:
	mov	dx, offset CGroup:TSRAboveMLIDMsg
	mov	cx, offset CGroup:TSRAboveMLIDMsg2
	jmp short UnloadErrorExit

;----------------------------------------------------------------------------
;	Check to see if the resident TSR is loaded above the normal 640K.
;	If it is we will assume that there is no good way to check for
;	TSR's above the resident module, therefore just unload it and allow
;	the user to screw up if they so desire.  This has been tested to 
;	work with QEMM's LOADHI program.
;----------------------------------------------------------------------------
DoTheUnload:
	mov	ax, es
	cmp	ax, 0A000h
	ja	ForceUnload

;----------------------------------------------------------------------------
;	Now make sure there are no other TSR's above the installed MLID.  
;	Scan past all unused MCB's or MCB's in use by DOS.  Then check the
;	in use MCB to see if it is our program.
;----------------------------------------------------------------------------
	dec	ax
	mov	es, ax

CheckNextMCB:
	mov	ax, es				;ES:0 -> TSR to remove
	add	ax, word ptr es:[0003h]		;-> next MCB in chain
	inc	ax
	mov	es, ax

	cmp	word ptr es:[0001h], 0		;MCB in use?
	je	CheckNextMCB

	inc	ax				;Is it our environment block?
	mov	dx, word ptr cs:[2ch]
	cmp	dx, ax
	je	CheckNextMCB

	mov	cx, word ptr es:[0001h]		;Is this MCB owned by a shell?
	mov	ds, cx
	cmp	word ptr ds:[0016h], cx		;Shell's parent PSP -> self
	je	CheckNextMCB

;----------------------------------------------------------------------------
;	Found a true life MCB used by a TSR. The next MCB must be us or
;	another TSR is loaded above the installed TSR.
;----------------------------------------------------------------------------
	mov	cx, cs				; Segments match (Is this us?)
	cmp	cx, ax
	jne	TSRAboveResidentMLID

;----------------------------------------------------------------------------
;	No one above resident MLID.  Call the MLID's shut down routine.
;	Also frees up the resident MLID.
;----------------------------------------------------------------------------
ForceUnload:
	push	cs				; Reload CGroup
	pop	ds

	mov	ax, bp				; Set the board number
	xor	cx, cx				; Set permanent shutdown flag
	mov	bx, MLID_SHUTDOWN	
	call	dword ptr MLIDControlEntryPoint ; Returns ES set to the Resident MLID 

;----------------------------------------------------------------------------
;	Now Deregister Suspend Producer from the NESL
;----------------------------------------------------------------------------
	mov	si, offset CGroup:NESL_SuspendBlock ; ES:SI -> PECB block
	mov	bx, NESL_DEREG_PRODUCER
	call	MSMCallNESL

;----------------------------------------------------------------------------
;	Now Deregister Resume Producer from the NESL
;----------------------------------------------------------------------------
	mov	si, offset CGroup:NESL_ResumeBlock ; ES:SI -> PECB block
	mov	bx, NESL_DEREG_PRODUCER
	call	MSMCallNESL

;----------------------------------------------------------------------------
;	Now Deregister Service Producer Change from the NESL
;----------------------------------------------------------------------------
	mov	si, offset CGroup:NESL_ChangeBlock ; ES:SI -> PECB block
	mov	bx, NESL_DEREG_PRODUCER
	call	MSMCallNESL


;----------------------------------------------------------------------------
;	Now exit our image.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero		; Get a fresh line.

	mov	dx, offset CGroup:MLIDUnloadSuccessMsg
	call	MSMPrintStringZero		; Tell user we are unloaded.

	mov	bx, MSMConfigTables[0]		; Pull up MLID name
	mov	dx, word ptr [bx].MCardShortName
	inc	dx				; Go past length byte
	call	MSMPrintStringZero

	mov	dx, offset CGroup:MLIDUnloadSuccessMsg2
	call	MSMPrintStringZero

	mov	ax, EXIT_NO_ERROR		; DOS function 4C, ErrCode=0
	int	ENTER_DOS
;============================================================================
UnloadDriver endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	CheckForCmdSwitch
;	Check the commandline to look for valid switch statements.
;	
;	On Entry:
;		ds=cs=CGroup
;		interrupts enabled.
;	On Exit:
;		doesn't return if CmdLine Switch is found.
;		interrupts enabled.
;	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
CheckForCmdSwitch	proc	near
;----------------------------------------------------------------------------
;	Check if there is even a commandline to check.
;----------------------------------------------------------------------------
	xor	cx, cx				; need a zero (clear ch)
	mov	cl, byte ptr ds:[0080h]		; Get the length of the parms
	jcxz	NoCmdLineSwitch

;----------------------------------------------------------------------------
;	The Command Line is present, see if Valid
;----------------------------------------------------------------------------
CommandLineHasSomething:
	mov	si, 81h			; Search from this location
	xor	bx, bx			; Clear possible char
	xor	dx, dx			; Clear Possible Message.

;----------------------------------------------------------------------------
;	See how many valid chars there are.
;	Spaces, tabs, -., / chars don't count.
;----------------------------------------------------------------------------
ScanCharsLoop:
	lodsb
	cmp	al, ' '			; Spaces
	je	NotAChar

	cmp	al, 09h			; Tab?
	je	NotAChar

	cmp	al, '/'			; Switch prefix
	je	NotAChar

	cmp	al, '-'			; Switch prefix
	je	NotAChar

	or	bh, bh			; already got a saved char
	jnz	CharAlreadyFound

	mov	bh, al			; Save only the first char.

CharAlreadyFound:
	inc	bl

NotAChar:
	loop	ScanCharsLoop

;----------------------------------------------------------------------------
;	check if bl counted more than one character.
;----------------------------------------------------------------------------
	cmp	bl, 1
	jb	NoCmdLineSwitch		; Nothing except WhiteSpace.
	je	CheckParm		; Valid Char, find out who for.
	jmp short FoundBadParm		 

;----------------------------------------------------------------------------
;	No Command Line Switch to parse
;----------------------------------------------------------------------------
NoCmdLineSwitch:
	ret

;----------------------------------------------------------------------------
;	Found the Unload Switch.
;----------------------------------------------------------------------------
FoundUnloadSwitch:
	jmp	UnloadDriver			; Go Unload the Driver.

;----------------------------------------------------------------------------
;	Found the Display Resident Driver Switch.
;----------------------------------------------------------------------------
FoundDRDSwitch:
	jmp	DisplayResidentDriver		; Go Show whats in Memory

;----------------------------------------------------------------------------
;	There is exactly one valid char to parse.
;----------------------------------------------------------------------------
CheckParm:
	cmp	bh, 'H'				; INFO switch? (UNDOCUMENTED)
  	je	FoundHelpSwitch

	cmp	bh, '?'				; INFO switch?
  	je	FoundHelpSwitch

	cmp	bh, 'R'				; UNLOAD switch? (UNDOCUMENTED)
	je	FoundUnloadSwitch

	cmp	bh, 'U'				; UNLOAD switch?
	je	FoundUnloadSwitch

	cmp	bh, 'F'				; FORCE UNLOAD switch (UNDOCUMENTED)
	je	FoundUnloadSwitch

	cmp	bh, 'S'
	je	FoundDRDSwitch			; Show loaded driver Config values.

;----------------------------------------------------------------------------
;	Bad or unkown commandline 
;----------------------------------------------------------------------------
FoundBadParm:
;	jmp	DriverCmdLineParameter	; Not for MSM or TSM
				   	; HSM developers who need a special 
					; cmd line parameter would uncomment
					; this line, and provide the DriverCmdLineParmeter
					; function to take the appropriate action.

	mov	dx, offset CGroup:BadParmMsg

;----------------------------------------------------------------------------
;	Now print out the help screen.
;----------------------------------------------------------------------------
FoundHelpSwitch:
	or	dx, dx
	jz	NoExtraErrMsg

	call	MSMPrintStringZero		; Print Invalid parameter message.

NoExtraErrMsg:
	mov	ax, word ptr DriverConfigTable.MCardShortName+0 ;AX -> short name
	inc	ax

	mov	dx, offset CGroup:HelpInfoText0	; "Available command line options"
	call	MSMPrintStringZero

	mov	dx, ax				; Driver Short Name
	call	MSMPrintStringZero

	mov	dx, offset CGroup:HelpInfoText1	; "   -Installs the MLID"
	call	MSMPrintStringZero

	mov	dx, ax				; Driver Short Name
	call	MSMPrintStringZero

	mov	dx, offset CGroup:HelpInfoText2	; "S  -Shows resident MLIDs
	call	MSMPrintStringZero		;       in memory"
	mov	dx, ax				; Driver Short Name
	call	MSMPrintStringZero

	mov	dx, offset CGroup:HelpInfoText3	; "U  -Removes resident MLID 
	call	MSMPrintStringZero		;       from memory"


	mov	dx, ax				; Driver Short Name
	call	MSMPrintStringZero

	mov	dx, offset CGroup:HelpInfoText4	; "?  -Displays this help screen"
	call	MSMPrintStringZero

	mov	ax, ERROR_EXIT_5		; DOS function 4C, ErrCode=1
	int	ENTER_DOS			; Exit
;============================================================================
CheckForCmdSwitch	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
;	ConvertCommandLineToUpperCase
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ConvertCommandLineToUpperCase	proc	near

	cld
	xor	cx, cx
	mov	cl, byte ptr ds:[0080h]		;Get the command line length
	jcxz	NoCommandLine

	mov	si, 81h				;Get -> parms
	
ConvertLoop:
	lodsb
	cmp	al, 'a'
	jb	CharOkay1
	
	cmp	al, 'z'
	ja	CharOkay1

	and	al, not 20h			;Convert to upper case
	mov	byte ptr [si-1], al

CharOkay1:
	loop	ConvertLoop

NoCommandLine:
	ret

ConvertCommandLineToUpperCase	endp


ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;****************************************************************************
;
; NAME:		MSMSetUpBitSwapTable
;
; DESCRIPTION:	Creates the BitSwapTable Starting at offset PSPTableStart
;		Table size is (100h - PSPTableStart) bytes.
;		
; ON ENTRY:	AX	N/A
;		BX	N/A
;		CX	N/A
;		DX	N/A
;		BP	N/A
;		SI	N/A
;		DI	N/A
;		CS	CGroup
;		DS	N/A
;		ES	N/A
;	
;		NOTE:	cld in effect, 
;			Interrupts are enabled
;
; ON RETURN:	AX	destroyed
;		BX	Preserved (Not Used)
;		CX	destroyed
;		DX	Preserved (Not Used)
;		BP	Preserved (Not Used)
;		SI	Destroyed
;		DI	Destroyed
;		CS	CGroup
;		DS	CGroup
;		ES	CGroup
;
;
;		NOTE:	Interrupt state is Unchanged during function.
;			Interrupt state on return is Enabled.
;	
;
; REMARKS:  Note this Table is (100h - PSPTableStart) bytes inside the PSP area.
;	
;
; SEE ALSO:
;
;****************************************************************************
;****************************************************************************

MSMSetUpBitSwapTable	proc	near

	xor	ax, ax			;256 bytes for table size 0-FFh
	mov	di, PSPTableStart	;Starts at offset PSPTableStart
	mov	cx, 100h		;get count
	
	mov	si, di			;Load SI for Later
	push	cs
	push	cs
	pop	ds			;Load ES, DS with CGroup
	pop	es

FillTable:
	stosb
	inc	al		 	;Fill Table with not swap Numbers.
	loop	FillTable		;loop till done

	xor	cx, cx		  	;Get the full 0 to ffh count.
	mov	di, si		  	;Point at the Start
	call	MSMBitSwapAddress 	;Swap the Tables Values
	ret

MSMSetUpBitSwapTable	endp



ifdef TASM
%NEWPAGE ;
endif
;****************************************************************************
;****************************************************************************
;
; NAME:		MSMBitSwapAddress
;
; DESCRIPTION:	Moves CX number of bytes from DS:SI to ES:SI and 
;		swaps the bit order in the Process.  IE. if the Source
;		bytes were in LSB form the Target bytes would be in MSB form.
;		 
;
; ON ENTRY:	AX	N/A
;		BX	N/A
;		CL	Number of Bytes to Swap
;		CH	N/A
;		DX	N/A
;		BP	N/A
;		SI	offset of Source bytes (DS:SI)
;		DI	offset of Target bytes (ES:DI)
;		CS	CGroup
;		DS	Segment of the Source bytes
;		ES	Segment of the Target bytes
;	
;		NOTE:	cld in effect, 
;			Interrupts are unknown
;
; ON RETURN:	AX	destroyed
;	    	BX	Preserved (Not Used)
;		CX	destroyed
;		DX	Preserved (Not Used)
;		BP	Preserved (Not Used)
;		SI	Destroyed
;		DI	Destroyed
;		CS	CGroup
;		DS	Preserved 
;		ES	Preserved 
;
;
;		NOTE: Interrupt state is Unchanged during function.
;		      Interrupt state is Preserved.
;****************************************************************************
MSMBitSwapAddress	proc	near
	lodsb				; Loads AL
	mov	ah, al			; Load Source byte in AH.
	mov	ch, 8			; 8 bits to a byte

MDoByte:
	shr	ah, 1			; Get a bit in Carry flag
	rcl	al, 1			; move into target register.
	dec	ch			; Keep track of number done.
	jnz	MDoByte			; Do all 8 bits

	stosb				; Save the swapped byte.
	loop	short MSMBitSwapAddress	; Do next byte.
	ret				; Node address Bit Swapped.

MSMBitSwapAddress	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	DisplayResidentDriver
;	This function displays each of the Configurations for each board 
;	loaded in Memory.  This function doesn't return.
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
DisplayResidentDriver	proc near
;----------------------------------------------------------------------------	
;	Tell the world we are just looking.
;----------------------------------------------------------------------------	
	mov	dx, offset CGroup:BoardResident0Msg
	call	MSMPrintStringZero

;----------------------------------------------------------------------------	
;	Start with board 1 (0).
;----------------------------------------------------------------------------	
	xor	bp, bp			; Start with the first board
	mov	MSMActiveBoardCount, 0	; initialize counter

;----------------------------------------------------------------------------	
;	Get Config Table.
;----------------------------------------------------------------------------	
DRDTryTheNextBoardNumber:
	mov	ax, bp
	mov	bx, PROTSUP_GET_MLID_CTL_ENTRY
	call	LSLEntryPoints.LSLProtSupEntryPt ; Call MPI entry point
	jnz	DRDNotThisBoard

;----------------------------------------------------------------------------
;	Found an Active Board, now get a -> to its config table.
;----------------------------------------------------------------------------
	mov	MLIDControlEntryPoint+0, si
	mov	MLIDControlEntryPoint+2, es	; Hold the Entry point.

	mov	ax, bp				; Must pass in board number
	mov	bx, GET_MLID_CONFIGURATION	; Setup for call using ES:SI
	call	dword ptr MLIDControlEntryPoint
	jnz	DRDNotThisBoard

;----------------------------------------------------------------------------
;	Save the Configuration info
;	ES:SI -> Config Table
;----------------------------------------------------------------------------
	mov	bx, es:[si].MBoardInstance	; BX = instance in this driver
	or	bx, bx				; is this a new physical card?
	jnz	StoreConfigOffset		; nz => Add it to the ConfigTable

;----------------------------------------------------------------------------
;	Print out the Config info on this Physical card before we go on.
;----------------------------------------------------------------------------
	call	PrintPhysicalCard

;----------------------------------------------------------------------------
;	Store the config Table Seg:Offset.
;----------------------------------------------------------------------------
StoreConfigOffset:
	add	bx, bx				; get word index
	mov	MSMConfigTables[bx], si		; Offset of Table
	mov	MLIDConfigSeg, es		; Segment of Table
	inc	MSMActiveBoardCount		; Count how many are valid.

;----------------------------------------------------------------------------
;	Try the Next board the LSL knows about
;----------------------------------------------------------------------------
DRDNotThisBoard:
	inc	bp
	cmp	ax, LSLERR_NO_MORE_ITEMS	; Any more boards?
	jne	DRDTryTheNextBoardNumber

	cmp	MSMConfigTables[0], 0
	je	DisplayedThemAll		; e => all done

	call	PrintPhysicalCard	; Get Last Config set out.

;----------------------------------------------------------------------------
;	All Loaded boards Displayed.
;----------------------------------------------------------------------------
DisplayedThemAll:
	mov	ax, EXIT_NO_ERROR		; DOS function 4C, ErrCode=0
	int	ENTER_DOS
;============================================================================

DisplayResidentDriver	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	PrintPhysicalCard
;		Prints out the Config information for a board.
;		The config table pointers are loaded in MLIDConfigTable
;	Assumes:
;		MSMActiveBoardCount = Number of Valid ConfigTables (1 based)
;		MLIDConfigSeg = 0 or valid Segment address.
;		DS = CGroup
;		
;	Returns:
;		Preserves all Regs.
;
;----------------------------------------------------------------------------
PrintPhysicalCard proc near
;----------------------------------------------------------------------------
;	Preserve what I use
;----------------------------------------------------------------------------
	push	ax
	push	bx
	push	dx
	push	es

;----------------------------------------------------------------------------
;	Make sure that there is a valid Config ptr.
;----------------------------------------------------------------------------
	mov	ax, MLIDConfigSeg	; AX = ConfigTable Segment.
	or 	ax, ax			; First Time Here?
	jz	PrintPhysicalCardExit	; If we dont have it dont tell it.

;----------------------------------------------------------------------------
;	Tell who the board is, and where its loaded.
;----------------------------------------------------------------------------
	mov	es, ax			 	; ES segment for Configtable Set.
	mov	bx, MSMConfigTables[0]		; BX -> First board of Physical card.
	mov	dx, word ptr es:[bx].MCardLongName+0	; Point at the Long Card Name
	inc	dx				; Skip length byte
	call	MSMPrintStringZeroES

;----------------------------------------------------------------------------
;	Indicate the Version of the Driver in Memory
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:BoardVersionMsg	; little v character.
	call	MSMPrintStringZeroNotMSG
	mov	ax, word ptr es:[bx].MMLIDMajorVer ; AH = Minor Ver, AL = Major Ver.
	push	ax
	xor	ah, ah
	call	MSMItoA				; Print Major Version.
	mov	dx, offset CGroup:PeriodNNL
	call	MSMPrintStringZeroNotMSG
	pop	ax
	xchg	ah, al
	xor	ah, ah
	cmp	al, 10
	jae	NoLeadingZero			; Less than 10 needs leading Zero

	push	ax
	xor	ax, ax
	call	MSMItoA				; Print Minor Version leading 0
	pop	ax

NoLeadingZero:
	call	MSMItoA				; Print Minor Version 

;----------------------------------------------------------------------------
;	Indicate where the Driver is loaded in Memory.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:BoardResident1Msg
	call	MSMPrintStringZeroNotMSG
	mov	ax, es				; Get Segment Value of Driver in Memory.
	call	MSMAtoH				; Get Segment Address in String.
	call	MSMEatLeadingZeros
	call	MSMPrintStringZeroNotMSG

	mov	dx, offset CGroup:BoardResident2Msg ; Move to next line 
	call	MSMPrintStringZeroNotMSG

;----------------------------------------------------------------------------
;	Print out the Config also
;----------------------------------------------------------------------------
	call	PrintOutBoardsConfig		; ES = Config segment
	mov	dx, offset CGroup:MSMNewLine
	call	MSMPrintStringZero
	call	MSMPrintStringZero

;----------------------------------------------------------------------------
;	Clear the Table and the counter
;----------------------------------------------------------------------------
	xor	ax, ax				; Start over on Loading another board
	mov	MSMConfigTables[0], ax
	mov	MSMConfigTables[1], ax
	mov	MSMConfigTables[2], ax
	mov	MSMConfigTables[3], ax
	mov	MSMActiveBoardCount, ax

PrintPhysicalCardExit:
	pop	es
	pop	dx
	pop	bx
	pop	ax
	ret
PrintPhysicalCard endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMPrintStringZeroES
;		Prints out a string pointed to by ES:DX
;
;	On Entry:
;		DS = CGroup
;		ES:DX -> String to print.
;
;	On Return:
;		All Registers Preserved.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMPrintStringZeroES	proc near	
	push	ds
	push	es
	pop	ds			; DS:DX -> String to print.
	call	MSMPrintStringZero
	pop	ds
	ret
MSMPrintStringZeroES	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMNESL_Reg_Suspend
;
;	Called by InitMSM to register as a NESL Producer.  This routine sets
;	up the NESL_EPB fields.  THIS routine must be
;	called prior to MSMNESL_Reg_Resume or MSMNESL_Reg_Service_Change.
;
;	On Entry:
;		DS =  CGroup
;		
;	On Return:
;		AX = Return Code
;			0 		   = Successful
;			LSLERR_BAD_COMMAND = NESL Not Loaded.
;			LSLERR_FAIL 	   = Previously Registered.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMNESL_Reg_Suspend	proc near
;----------------------------------------------------------------------------	
;	Initialize PECB
;----------------------------------------------------------------------------	
	push	cs
	pop	es 				; CGroup
	mov	ax, ds				; Make Loading faster
	mov	si, offset CGroup:NESL_SuspendBlock
	mov 	word ptr es:[si].PECB_ClassName+0, offset CGroup:NESL_Service_Suspend
	mov	word ptr es:[si].PECB_DataPtr+0,	offset CGroup:NESL_EPB
	mov 	word ptr es:[si].PECB_ClassName+2, ax
	mov	word ptr es:[si].PECB_DataPtr+2, ax

;----------------------------------------------------------------------------	
;	Initialize EPB
;----------------------------------------------------------------------------	
	mov	word ptr NESL_EPB.EPB_ClassName+2, ax	; Initialize the Segment values.
	mov	word ptr NESL_EPB.EPB_EventName+2, ax
	mov	word ptr NESL_EPB.EPB_DataPtr0+2, ax	; and DataPtr set at runtime too.
	mov	ax, word ptr DriverConfigTable.MCardLongName+0
	inc	ax
	mov	word ptr NESL_EPB.EPB_ModuleName+0, ax
	mov	ax, word ptr DriverConfigTable.MCardLongName+2
	mov	word ptr NESL_EPB.EPB_ModuleName+2, ax

;----------------------------------------------------------------------------	
;	Clear unused Data Ptr
;----------------------------------------------------------------------------	
	xor	ax, ax
	mov	word ptr NESL_EPB.EPB_DataPtr1, ax	; and DataPtr set at runtime too.
	mov	word ptr NESL_EPB.EPB_DataPtr1+2, ax	; and DataPtr set at runtime too.

;----------------------------------------------------------------------------
;	Tell the NESL
;----------------------------------------------------------------------------
	mov	bx, NESL_REG_PRODUCER
	call	MSMCallNESL
	jnz	NESL_Absent

;----------------------------------------------------------------------------
;	Print out that we were able to register the event.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:NESL_Suspend_Reg_Msg
	call	MSMPrintStringZero

NESL_Absent:
	ret
MSMNESL_Reg_Suspend	endp


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMNESL_Reg_Resume
;
;	Called by InitMSM to register as a NESL Producer.  
;	THIS routine must be called AFTER MSMNESL_Reg_Suspend is called.
;
;	On Entry:
;		DS =  CGroup
;		NESL_EPB initialized.
;		
;	On Return:
;		AX = Return Code
;			0 		   = Successful
;			LSLERR_BAD_COMMAND = NESL Not Loaded.
;			LSLERR_FAIL 	   = Previously Registered.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMNESL_Reg_Resume	proc near
;----------------------------------------------------------------------------
;	Initialize the PECB
;----------------------------------------------------------------------------
	push	cs
	pop	es 				; CGroup
	mov	ax, ds				; Make Loading faster
	mov	si, offset CGroup:NESL_ResumeBlock
	mov 	word ptr es:[si].PECB_ClassName+0, offset CGroup:NESL_Service_Resume
	mov	word ptr es:[si].PECB_DataPtr+0, offset CGroup:NESL_EPB
	mov 	word ptr es:[si].PECB_ClassName+2, ax
	mov	word ptr es:[si].PECB_DataPtr+2, ax

;----------------------------------------------------------------------------
;	Tell the NESL
;----------------------------------------------------------------------------
	mov	bx, NESL_REG_PRODUCER
	call	MSMCallNESL
	jnz	NESL_Absent_Resume

;----------------------------------------------------------------------------
;	Print out that we were able to register the event.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:NESL_Resume_Reg_Msg	
	call	MSMPrintStringZero

NESL_Absent_Resume:
	ret
MSMNESL_Reg_Resume	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	MSMNESL_Reg_Service_Change
;	Called by InitMSM to register as a NESL Producer.  
;	THIS routine must be called AFTER MSMNESL_Reg_Suspend is called.
;	This sets up the NESL_EPB for me.
;
;	On Entry:
;		DS =  CGroup
;		NESL_EPB initialized
;
;	On Return:
;		AX = Return Code
;			0 		   = Successful
;			8005h LSLERR_FAIL 	   = Previously Registered.
;			8008h LSLERR_BAD_COMMAND = NESL Not Loaded.
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MSMNESL_Reg_Service_Change	proc near
	push	cs
	pop	es 				; ES = CGroup
	mov	ax, ds				; Make Loading faster

;----------------------------------------------------------------------------
;	Initialize Change Block  PECB
;----------------------------------------------------------------------------
	mov	si, offset CGroup:NESL_ChangeBlock
	mov 	word ptr es:[si].PECB_ClassName+0, offset CGroup:NESL_ServiceStatus_Change
	mov	word ptr es:[si].PECB_DataPtr+0,	offset CGroup:NESL_EPB
	mov 	word ptr es:[si].PECB_ClassName+2, ax
	mov	word ptr es:[si].PECB_DataPtr+2, ax

;----------------------------------------------------------------------------
;	Call NESL
;----------------------------------------------------------------------------
	mov	bx, NESL_REG_PRODUCER		; Register with NESL
	call	MSMCallNESL
	jnz	NESL_Absent

;----------------------------------------------------------------------------
;	Print out that we were able to register the event.
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:NESL_Status_Reg_Msg
	jmp	MSMPrintStringZero
	
MSMNESL_Reg_Service_Change	endp

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;	SetMSMSystemFlags
;	Determines the System buses, and sets the correct bits in MSMSystemFlags.
;
;	Assumes:
;		DS = CGROUP
;	Returns: 
;		DS = CGROUP
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
SetMSMSystemFlags	proc	near
;----------------------------------------------------------------------------
;	Setup some useful variables that the MLID might need to use.
;----------------------------------------------------------------------------
	mov	ah, 0C0h			;Return system config info
	int	15h				;See if we have a MC or AT bus
	jc	NotOnAPS2

	or	ah, ah
	jnz	NotOnAPS2

	test	byte ptr es:[bx+5], 02h		;MC bit set?
	jz	NotOnAPS2

	or	MSMSystemFlags, MCAFlag

NotOnAPS2:
	push	sp
	pop	ax
	cmp	ax, sp
	je	BetterthanPCXT
	jmp	MustBeOnAPCXT

BetterthanPCXT:
	or	MSMSystemFlags, ATFlag

;----------------------------------------------------------------------------
;	See if we are running on an 80386 or better
;----------------------------------------------------------------------------
	pushf					;See if this is a 80386
	pushf
	pop	ax
	or	ah, 60h				;Set the IOPL bits to 1
	push	ax
	popf
	pushf
	pop	ax
	test	ah, 60h				;Did the bits stick?
	jnz	On386				; On 386 or better.

	jmp	NotOn386			; z = Not even as good.

On386:
	or	MSMSystemFlags, I386Flag

;----------------------------------------------------------------------------
;	Now see if this is a EISA machine.
;----------------------------------------------------------------------------
	mov	ax, 0F000h
	mov	es, ax
.386	
	cmp	dword ptr es:[0FFD9h], 'ASIE'	;'EISA'?
.8086
	jne	NotEISABus

	or	MSMSystemFlags, EISAFlag	; Flag EISA bus Found

NotEISABus:

;----------------------------------------------------------------------------
; Doing an INT 1Ah on old 80386 Acer machines blows up due to a bug
; in the BIOS's INT 1Ah handler which checks the incoming AH value
; to see if it's above 0Bh.  The bug is that after the compare
; it uses the JG instruction instead of JA, which allows the request
; through at which time the BIOS jumps off the end of a dispatch
; table.  To work around this we'll trace through the INT 1Ah handler
; and see if it's the buggy version.  As far as we know only the ACER
; machines have this bug.  If we find others we need to modify this
; detection code or something.  Note that the INT 1Ah will fail when
; trying to detect PCMCIA also.
;----------------------------------------------------------------------------

	;-------------------------------------------------------------------
	; First only do this check if we're on a 80386, we're
	; assuming that they fixed their bug in later revisions
	; of their BIOS that made it into their 80486 and higher
	; machines.
	;-------------------------------------------------------------------
.386
		cli			; Don't allow other code to run
		mov	dx, sp		; Save cur stack pointer
		and	sp, not 3	; Get stack dword aligned

		pushfd			; Push EFLAGS
		pop	eax
		mov	ecx, eax
		xor	eax, 40000h	; Toggle AC bit in EFLAGS
		push	eax
		popfd			; Try to set it in EFLAGS
		pushfd
		pop	eax
		xor	eax, ecx	; See if AC bit changed
		push	ecx
		popfd			; Restore org flag bits
		mov	sp, dx
		sti

	;-------------------------------------------------------------------
	;	If on 486 We'll skip the rest of the Acer tests.
	;-------------------------------------------------------------------
		test	eax, 40000h	; Was AC bit changeable?
		jnz short On486		; On 486 or better?


	;-------------------------------------------------------------------
	; First see if the current 1Ah vector points to the appropriate
	; BIOS entry point.
	;-------------------------------------------------------------------
	sub	ax, ax
	mov	es, ax				; ES:0 -> Int vector table
	cmp	word ptr es:[1Ah*4+2], 0F000h	; F000:FE6E ??? (BIOS compatible entry point)
	jne short NotAcerMachineWeHope

	cmp	word ptr es:[1Ah*4+0], 0FE6Eh
	jne short NotAcerMachineWeHope

	;-------------------------------------------------------------------
	; Now find the handler code that the JMP xxxx instruction goes
	; to.  The JMP xxxx instruction is the first instruction 
	; at F000:FE6E.
	;-------------------------------------------------------------------

	mov	ax, 0F000h
	mov	es, ax
	mov	di, 0FE6Eh
	cmp	byte ptr es:[di], 0E9h		; JMP xxxx instruction?
	jne short NotAcerMachineWeHope

	add	di, word ptr es:[di+1]		; ES:DI -> handler
	add	di, 3				; Account for jmp instruction itself
	lea	bx, [di+30h]

	;-------------------------------------------------------------------
	; Somewhere within 30h there will be the following code
	; sequence if we're running on a busted Acer BIOS.
	;
	; 80 FC 0B	cmp	ah, 0Bh
	; 7F 11		jg	82E4		; This is the busted instruction
	; 50		push	ax
	;-------------------------------------------------------------------

KeepLooking:
	cmp	word ptr es:[di], 0FC80h	; Look for 80 FC
	je short FoundPossibleMatch

AdvKeepLooking:
	inc	di
	cmp	di, bx
	jb short KeepLooking
	jmp short NotAcerMachineWeHope

FoundPossibleMatch:
	cmp	word ptr es:[di+2], 7F0Bh	; Look for more
	jne short AdvKeepLooking

	cmp	word ptr es:[di+4], 5011h
	jne short AdvKeepLooking

	;-------------------------------------------------------------------
	; Found a match, skip over the INT 1Ah tests.
	;-------------------------------------------------------------------
	jmp short AcerMachineDetected

;----------------------------------------------------------------------------
;  See if PCMCIA Card Services is present.
;----------------------------------------------------------------------------
NotAcerMachineWeHope:			; We Know we are at least a 386
On486:		     			; We Know we are a 486 or better
	mov     ah,0AFh                	; Set to 0AFH for CS.
	mov     al,0Bh			; GetCardServicesInfo - 0Bh.
	mov     cx,0Dh                  ; Argument length.
	push	cs
	pop	es			; ES=CGroup
	mov     bx, offset CGroup:CardServiceInfo ; ES:BX = Argument Pointer.
	int     1Ah			; Invoke Card Services.

;----------------------------------------------------------------------------
;	And next, check if Card Services is installed or not.
;----------------------------------------------------------------------------
	mov	ax, CardServiceInfo.CS_Signature
	cmp     ax,'SC' 		; Is Card Services installed?
	jne short NoCardServices

	or	MSMSystemFlags, CSFlag	; Indicate that Card Services is installed.

;----------------------------------------------------------------------------
;	Check if PCI BIOS is Available.
;----------------------------------------------------------------------------
NoCardServices:
	test	MSMSystemFlags, I386Flag
	jz short DoneWithSystemFlagsSetup

	mov	ah, 0B1h	; PCI_FUNCTION_ID
	mov	al, 01h		; PCI_BIOS_PRESENT
	int	1Ah
	jc short DoneWithSystemFlagsSetup

	or	ah, ah			; Must be zero
	jnz short DoneWithSystemFlagsSetup

	cmp	EDX, " ICP"	; Did PCI BIOS Respond
	jne short DoneWithSystemFlagsSetup

	or	MSMSystemFlags, PCIFlag

;----------------------------------------------------------------------------
;	Exit out Restoring as needed.
;----------------------------------------------------------------------------
.8086
DoneWithSystemFlagsSetup:	; not PCI, restore Flags, and exit.
AcerMachineDetected:		; Acer Machine hangs on Int 1A checks. Skip checks.
NotOn386:			; 386 or better needed for EISA,PCI, and PCMCIA.
	.popf

MustBeOnAPCXT:			; Cheep processor
	sti
	ret

SetMSMSystemFlags	endp

Init	ends

	end	MLIDStart



