;----------------------------------------------------------------------------
;   (C) Unpublished Work of Novell, Inc.  All Rights Reserved.
;
;	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, 
;	PROPRIETARY AND TRADESECRET INFORMATION OF NOVELL, INC.  ACCESS 
;	TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
;	NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS 
;	AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO APPROPRIATE 
;	LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED,
;	PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,
;	ABBRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
;	TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL. 
;	ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD 
;	SUBJECT THE PERPERTRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;----------------------------------------------------------------------------
;
;MSMTXT.INC
;
;	MSM Text Definitions File
;
;	Written by:	DCD
;	Date:		6/12/90
;
;	ODI Specification Version:	4.00
;
;    Modification History:
;	Date		By	Modification Description
;	---------------	---	------------------------------------------
;	01 August 1994   JWR,WTT  v2.00 Removed Previous history, 
;				See DOS ODI Specifcation Changes Doc for changes.
;	23 August 1994  JWR,WTT  Corrected Message "CouldntFindMlidSection2" Removed the 
;				word heading and set case correctly.
;
;	09 January 1995 JWR	v2.02 Changed NESL Signon Messages.
;
; 1 April 1996	JWR	New ToolKit. v2.10
;
; 21 Nov. 97	SMN		New ToolKit. v2.12
;
;*****************************************************************************
.8086
CGroup	group	Code,Init
	assume	cs:CGroup, ds:CGroup, es:nothing, ss:nothing

;----------------------------------------------------------------------------
;	Text needed for run-time is located in the RunCode segment.
;----------------------------------------------------------------------------
Code	segment	para public 'CODE'
	org	100h				; Space for the PSP

	public	MLIDStart

MLIDStart:
	jmp	MLIDInitialization
	db	(PSPTableStart - 3) dup (0)	;needed Space for the Bit Swap Table

Code	ends

;----------------------------------------------------------------------------
;	Text needed for init time only is located in the Init segment.
;----------------------------------------------------------------------------
Init	segment para public 'CODE'

	public	LSLSignature
	public  NESLSignature
	public	ResidentEnd
	public  InvalidMediaAddress, InvalidMediaAddress2
	public  ForgotTxFreeCount, ForgotLASegment, TooManyTCBs
	public	Proc386NeededMsg

;----------------------------------------------------------------------------
;	We must be linked first before any other modules defining an
;	Init segment.
;----------------------------------------------------------------------------
ResidentEnd	label	byte
	db	1024 dup (0)		;Reserve room for TCB and config table
					;allocations

;----------------------------------------------------------------------------
;	NET.CFG Tokens
;----------------------------------------------------------------------------
DMAKeyword		db	'DMA'
DMAKeywordLen		equ	$-DMAKeyword

INTKeyword		db	'INT'			; Old KeyWord.
INTKeywordLen		equ	$-INTKeyword

IRQKeyword		db	'IRQ'			; New KeyWord.
IRQKeywordLen		equ	$-IRQKeyword

MEMKeyword		db	'MEM'
MEMKeywordLen		equ	$-MEMKeyword

PORTKeyword		db	'PORT'
PORTKeywordLen		equ	$-PORTKeyword

SlotKeyword		db	'PS/2 SLOT'		;Old keyword
SlotKeywordLen		equ	$-SlotKeyword

SlotKeyword1		db	'SLOT'			;New keyword
SlotKeywordLen1		equ	$-SlotKeyword1

NodeKeyword		db	'NODE ADDRESS'
NodeKeywordLen		equ	$-NodeKeyword

ProtoKeyword		db	'PROTOCOL'
ProtoKeywordLen		equ	$-ProtoKeyword

FrameKeyword		db	'FRAME'	     		;New keyword
FrameKeywordLen		equ	$-FrameKeyword

FrameKeyword1		db	'ENVELOPE TYPE'		;Old keyword
FrameKeywordLen1	equ	$-FrameKeyword1

LookAheadKeyword	db	'LOOK AHEAD SIZE'
LookAheadKeywordLen	equ	$-LookAheadKeyword

LSBKeyword		db	'LSB'
LSBKeywordLen		equ	$-LSBKeyword

MSBKeyword		db	'MSB'
MSBKeywordLen		equ	$-MSBKeyword

FDMODEOFFKeyword	db	'FDMODEOFF'
FDMODEKeywordLen	equ	$-FDMODEOFFKeyword

NESLKeyword		db	'NESL'
NESLKeywordLen		equ	$-NESLKeyword

BusIDKeyword		db	'BUS ID'
BusIDKeywordLen		equ	$-BusIDKeyword


;----------------------------------------------------------------------------
;		M E S S A G E   C E N T E R 
;----------------------------------------------------------------------------
LSLSignature		db	'LINKSUP$'
NESLSignature		db	'NESL_EVENTS',0


		; Messages must have the Message number in the WORD before the String.
LSLNotAroundMsg		db	1,0,'The LSL is not loaded.',0
NoRoomForThisBoard	db	2,0,'The LSL has no more room for a board using Frame ',0

CantUnloadNoMLIDMsg	db	3,0,'Could not find ',0
CantUnloadNoMLIDMsg2	db	' driver to unload.',0dh,0ah,0

TSRAboveMLIDMsg		db	4,0,'A TSR is loaded above the ',0
TSRAboveMLIDMsg2	db	' driver.',0dh,0ah,0

NoBoardsInitedMsg	db	6,0,'The adapter did not initialize.  ',0
NoBoardsInitedMsg2	db	' did not load.',0ah,0dh,0

CouldntFindMLIDSection	db	7,0,'You need another ',0		; Short Card Name goes Here
CouldntFindMlidSection2 db	' driver section in the NET.CFG file',0Ah,0Dh
			db	'             in order to load the LAN driver again.',0dh,0ah,0   ; Spaces are required in string.

MustHaveNetcfgMsg	db	8,0,'A NET.CFG is required to load the driver again.',0Ah, 0Dh, 0

EntryIgnored		db	9,0,'The following configuration file entry was ignored:',0Ah,0Dh,'                 ',0

MLIDUnloadSuccessMsg	db	'The ',0		; MShortCardName will be next.
MLIDUnloadSuccessMsg2	db	' driver has been successfully removed.',0dh,0ah,0

BadMediaNameMsg		db	11,0,'The driver does not support frame ',0
BadMediaNameMsg2	db	'.',0Ah,0Dh,'             The protocol keyword has been ignored.',0dh,0ah,0  ;Spaces are required.

ForgotMediaName		db	12,0,'The protocol keyword must have a frame type.  Entry ignored.',0dh,0ah,0

NoRoomForPID		db	13,0,'The driver could not register Protocol ID ',0
NoRoomForStack		db	0Ah,0Dh,'               for protocol stack ',0
NoRoomForMedia		db	' for frame type ',0

DuplicateFrameTypeMsg	db	15,0,'The frame type is already activated for frame ',0 ; Number 9 used next.

InValidNodeAddressMsg	db	16,0,'The node address was incorrectly specified in NET.CFG.',0Dh,0Ah,0

InvalidKeywordMsg	db	17,0,'An invalid keyword was specified in NET.CFG on line ',0

FrameTypeNotSupported	db	18,0,'The frame type specified in the NET.CFG is not supported.',0ah,0dh,0

InvalidMediaAddress	db	19,0,'An invalid ', 0
InvalidMediaAddress2	db	' node address is specified in NET.CFG.',0Ah,0Dh
			db	'             The driver modified the incorrect address bits.',0Ah,0Dh,0

LSLWrongVersion		db	27,0,'This driver requires LSL version 2.11 or higher.',0

MSMLoadCancelMsg	db	29,0,'The driver did not load.',0

MissingValueParmMsg	db	31,0,'A missing or invalid value was specified on line ',0

;----------------------------------------------------------------------------
;	NESL Registration Messages.
;----------------------------------------------------------------------------
NESL_Suspend_Reg_Msg	db	32,0,'Driver registered as a NESL Suspend Class producer.',0Ah,0Dh,0
NESL_Resume_Reg_Msg	db	33,0,'Driver registered as a NESL Resume Class producer.',0Ah,0Dh,0
NESL_Status_Reg_Msg	db	34,0,'Driver registered as a NESL Service Change Class producer.',0Ah,0Dh,0
NESL_Required_Msg	db	35,0,'The driver requires the NetWare Event Service Layer (NESL).',0Ah,0Dh,0
NESL_Loaded_Msg		db	36,0,'NetWare Event Service Layer (NESL) is Loaded.',0Ah,0Dh,0

;----------------------------------------------------------------------------
;		Signon and Informational Messages.
;		Not Assigned a Number.
;----------------------------------------------------------------------------
HelpInfoText0		db	'Available command line options:',0dh,0ah,'   ',0
HelpInfoText1		db	'    -Installs the LAN driver',0dh,0ah,'   ',0
HelpInfoText2		db	' S  -Shows resident LAN drivers in memory',0dh,0ah,'   ',0
HelpInfoText3		db	' U  -Unloads resident LAN driver from memory',0dh,0ah,'   ',0
HelpInfoText4		db	' ?  -Displays this help screen',0dh,0ah,0

BoardResident0Msg	db	'The following LAN drivers are loaded in memory:',0dh,0ah,0dh,0ah,0
BoardVersionMsg		db	'  v',0
BoardResident1Msg	db	' is loaded at Segment ',0
BoardResident2Msg	db	'h.',0dh,0ah,0
BadParmMsg		db	'Invalid parameter.',0dh,0ah,0dh,0ah,0
MSMPlatformMsg		db	'-DOS-',0	
SlotMsg			db	'Slot ',0	
IRQMsg			db	'IRQ ',0
IOBaseMsg		db	'Port ',0
DMAMsg			db	'DMA ',0
MemBaseMsg		db	'Mem ',0
NodeMsg			db	'Node Address ',0
LSBNodeMsg		db	' L',0
MSBNodeMsg		db	' M',0
LSBModeMsg		db	', LSB Mode',0
MSBModeMsg		db	', MSB Mode',0
MaxFrameMsg		db	'Max Frame ',0
BytesMsg		db	' bytes',0
LineSpeedMsg		db	'Line Speed ',0
MbpsMsg			db	' Mbps',0
KbpsMsg			db	' Kbps',0
BusIDMsg		db	'Bus ID ',0
BoardMsg		db	'Board ',0
FrameTypeMsg		db	', Frame ',0
UnknownMsg		db	'Unknown',0
PeriodNNL		db	'.',0		; No Newline
Period			db	'.'		; terminated with MSMNewLine.
MSMNewLine		db	0dh,0ah,0
Colon			db	': ',0
Comma			db	', ',0
ClearComma		db	'  ',0

;----------------------------------------------------------------------------
; These Next Messages are for the Developer.  They won't be used by endusers.
;----------------------------------------------------------------------------
InvalidVerStatsTable	db  0E7h, 03h,'The HSM',27h,'s version of the statistics table is not supported.',0
InvalidVerConfigTable	db  0E7h, 03h,'The HSM',27h,'s version of the configuration table is not supported.',0
ForgotTxFreeCount	db  0E7h, 03h,'The HSM forgot to set the MSMTxFreeCount variable during DriverInit.',0
ForgotLASegment		db  0E7h, 03h,'The HSM forgot to set the MSMLookAheadSegment variable during DriverInit.',0
TooManyTCBs		db  0E7h, 03h,'The HSM has set the MSMTxFreeCount too High.',0
BadReturnCodeFromHSM	db  0E7h, 03h,'The HSM returned an invalid return code.',0
Proc386NeededMsg	db  0E7h, 03h,'This driver must run on a 386 processor or better.',0

Init	ends



