;****************************************************************************
;  NESLNAME.INC
;
;	Copyright Unpublished Work of Novell, Inc. All Rights Reserved
;  
;	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
;	PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.   
;	ACCESS TO THIS WORK IS RESTRICTED TO (i) NOVELL EMPLOYEES  
;	WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE  
;	OF THEIR ASSIGNMENTS AND (ii) ENTITIES OTHER THAN NOVELL   
;	WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.      
;	NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,
;	DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,      
;	CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,  
;	TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF
;	NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION
;	COULD SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;****************************************************************************
;
;	Definitions provided by Novell.
;	All Definitions are Commented out.
;	Uncomment those Definitions that are needed for the HSM.
;	Don't Comment Definitions that the MSM uses.
;
;****************************************************************************
;
;	16 Bit DOS ODI NESL event string definitions.
;
;	Written by:	WTT
;	Date:		4/25/94
;
;	ODI Specification Version:	4.00
;	NESL Specification Version:	1.00
;
;    Modification History:
;	Date		By	Modification Description
;	---------------	---	------------------------------------------
;	 1 April 1996	JWR	New ToolKit. v2.10
;
; 21 Nov. 97	SMN		New ToolKit. v2.12
;
;****************************************************************************

Code segment para public 'CODE'
;----------------------------------------------------------------------------
;	Class Names
;----------------------------------------------------------------------------
	public	NESL_Service_Suspend		; MSM uses 
	public	NESL_Service_Resume		; MSM uses 
	public	NESL_ServiceStatus_Change	; MSM uses
 ;	public	NESL_Suspend_Request

NESL_Service_Suspend		db	'Service Suspend',0	; MSM uses
NESL_Service_Resume		db	'Service Resume',0	; MSM uses
NESL_ServiceStatus_Change	db	'Service/Status Change',0
 ; NESL_Suspend_Request		db	'Suspend Request',0

;----------------------------------------------------------------------------
;	Event Names by Class
;----------------------------------------------------------------------------
;	NESL_Service_Suspend			; Class
;----------------------------------------------------------------------------
	public	NESL_MLID_ShutDown					; (MSM uses)
 ;	public	NESL_MLID_Card_Removal		
 ;	public	NESL_MLID_Out_Range		
 ;	public	NESL_MLID_HW_Failure		
 ;	public	NESL_MLID_Cable_Disconnect
 ;	public	NESL_MLID_Media_Access_Denied

NESL_MLID_ShutDown	 	db	'MLID Shutdown',0		; Event Name (MSM uses)
 ; NESL_MLID_Card_Removal	db	'MLID Card Removal',0		; Event Name
 ; NESL_MLID_Out_Range	 	db	'MLID Not In Range',0		; Event Name
 ; NESL_MLID_HW_Failure	 	db	'MLID Hardware Failure',0	; Event Name
 ; NESL_MLID_Cable_Disconnect	db	'MLID Cable Disconnect',0	; Event Name
 ; NESL_MLID_Media_Access_Denied db	'MLID Media Access Denied',0	; Event Name

;----------------------------------------------------------------------------
;	NESL_Service_Resume			; Class
;----------------------------------------------------------------------------
 ;	public	NESL_MLID_Card_Insertion_Complete
 ;	public	NESL_MLID_In_Range
 ;	public	NESL_MLID_Cable_Reconnect
	public	NESL_MLID_Reset					; (MSM uses)

NESL_MLID_Reset		    	db	'MLID Reset',0		; Event Name (MSM uses)
 ; NESL_MLID_Card_Insertion_Complete db	'MLID Card Insertion Complete',0	; Event Name
 ; NESL_MLID_In_Range	    	db	'MLID In Range',0	; Event Name
 ; NESL_MLID_Cable_Reconnect	db	'MLID Cable Reconnect',0; Event Name

;----------------------------------------------------------------------------
;	NESL_Suspend_Request			; Class
;----------------------------------------------------------------------------

; Currently there are no defined events for this class.

;----------------------------------------------------------------------------
;	NESL_ServiceStatus_Change		; Class
;----------------------------------------------------------------------------
 ;	public	NESL_MLID_Access_Point_Change
 ;	public	NESL_MLID_Speed_Change

 ; NESL_MLID_Access_Point_Change	db	'MLID Access Point Change',0	; Event Name
 ; NESL_MLID_Speed_Change 		db	'MLID Speed Change',0	; Event Name

Code ends


