ifdef TASM
%PAGESIZE 66,130
else
PAGE 66, 130
endif
;*****************************************************************************
; RXNET.ASM
;
;	(C) Copyright Unpublished Work of Novell, Inc.  All Rights Reserved.
;
;	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, 
;	PROPRIETARY AND TRADESECRET INFORMATION OF NOVELL, INC.  ACCESS 
;	TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
;	NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS 
;	AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO APPROPRIATE 
;	LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED,
;	PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,
;	ABBRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
;	TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL. 
;	ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD 
;	SUBJECT THE PERPERTRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;----------------------------------------------------------------------------
; 
;	DOS Media Support Module (MSM) for Novell Turbo RX-NET (ARCNET Media)
;
;	Written by:	DCD
;	Date:		10/04/90
;
;	ODI Specification Version:	4.00
;
;Modification History:
;	Date		By	Modification Description
;	---------------	---	------------------------------------------
;	01 August 1994	WTT 	v2.00 Removed Previous history, 
;				See DOS ODI Specifcation Changes Doc for changes.
;
;	10 January 1995  JWR    Checkin New ToolKit. v2.02
;				Added MAX FRAME SIZE keyword to Trxnet (SPD#83021)
;
;	03 April 1995	JWR	NewToolKit. v2.03.
;				added MSMGetMulticastInfo (Stubbed out.)
;
;	30 Aug 1995	JWR	v2.04.
;				Rebuild\checkin with latest include files.
;
;	25 Oct 1995	JWR	v2.05
;				Rebuild\checkin with latest include files.
;
; 1 April 1996	JWR	New ToolKit. v2.10
;			Rebuild\checkin with latest include files.
;
;       15 Jan 1997     CKP     v2.11
;                               Added Changes to accomodate Look Ahead Start
;                               Copy offset  ---- SPD- 139091
;
;       25 Jan 1997     CKP     Reset ECB Previous Link in MSMRcvComplete
;                                            ---- SPD- 147928
;
; 21 Nov. 97	SMN		New ToolKit. v2.12
;
;*****************************************************************************
.8086
%NOINCL				; See listings of Include files in MSM.asm
include	msm.inc

ifdef TASM
%NEWPAGE ;
endif
;----------------------------------------------------------------------------
RXNetTSMVersion	equ	'v2.12 (971121) '; Set November 21, 1997 SMN

CGroup	group	Code,Init
	assume	cs:CGroup, ds:CGroup, es:nothing, ss:nothing

Code	segment	para public 'CODE'

;These can be referenced by the MLID.

	public	MSMSendComplete
	public	MSMGetNextSend
	public	MSMTxFreeCount
	public	MSMRcvComplete
	public	MSMGetRCB			;Not implemented
	public	MSMReturnRCB			;Not Implemented
        public  MSMLookAheadSegment

	public	MSMMediaConfigUpdate		; Called after Hardware Initializes


ifdef DEBUG		;Internal Use Only. 
	public	MSMPoll
	public	TCBFreeList
	public	LookAheadStruct
	public	HandleOverflow
	public	PacketSizeUnknown
	public	OneOfMany
	public	AllDoneWithReceive
	public	GotRxTimeout
	public	MultipleReceive
	public	NoExtraFrag
	public	StillMoreOnQueue
	public	QueueItAndExit
endif

;Routines and variables referenced in the MLID.

	extrn	DriverSend		:near
	extrn	DriverStatTable		:byte
	extrn	DriverConfigTable	:byte
	extrn	DriverTxTimeout		:near

;Internal Routines

	public	MSMSendPacket
	public	MSMGetMulticastInfo
	public	MSMAddMulticastAddress
	public	MSMDelMulticastAddress
	public	MSMUpdateMulticast
	public	MSMMediaShutdown
	public	MSMMediaReset

	extrn	MSMEnqueueSend		:near
	extrn	MSMUpdateConfigTables	:near

	extrn	LSLSupport		:dword
	extrn	MSMTxFlags0		:byte
	extrn	MSMTxFlags1		:byte
	extrn	MSMTxQueueHead		:word
	extrn	MSMTxQueueTail		:word
	extrn	MSMActiveBoardCount	:word
	extrn	MSMConfigTables		:word
	extrn	MSMMaxActiveTx		:byte
	extrn	MSMPhysNodeAddress	:byte
	extrn	MSMTxMonPtr		:dword

;General Definitions

MaxVirtBoards		equ	1		;Support only one frame type
MaxMediaFrameSize	equ	4096+74+32	;Our max for RXNET (Table stuffed there)

MAX_FRAGS		equ	16		;This should be plenty

MediaID14		equ	14
MaxHeaderLen		equ	14		;Actually 13 (Get on word boundary)
RxTimeout               equ     2               ;Number of .5 sec's till timeout
TxTimeout               equ     2               ;Number of .5 sec's till timeout


;Arcnet short frame format structure (1st half)

ShortFrameFormat	struc
	SSourceAddress	db	?
	SDestAddress	db	?
	SByteOffset	db	?		;Never should be 0 for short frame
ShortFrameFormat	ends


;Arcnet long and exception frame formats structure (1st half)

LongFrameFormat	struc
	LSourceAddress	db	?
	LDestAddress	db	?
	LLongPacketFlag	db	?		;Should be 0
	LByteOffset	db	?
LongFrameFormat	ends


;Media Type Strings

Message	MediaName14	'NOVELL_RX-NET'

;Some general variables

	even
TCBFreeList		dw	0		;Points to a list of TCB's
ECBReceiveList		dw	2 dup (0)
CurrTransmitECB		dw	2 dup (0)
CurrSequenceNumber	dw	0
LastTxRemBytes		dw	0
CurrFragLoc		dw	2 dup (0)
CurrFragDesc		dw	2 dup (0)
CurrFragLen		dw	0

DestAddrTypeFlag	db	0		;0=Direct,1=MC,2=Broadcast
NumTxFrags		db	0
CurrSplitFlag		db	0
TxTimeoutCount		db	0
MSMTxFreeCount		db	0
MSMLookAheadSegment	dw	0


	even
LookAheadStruct		LookAheadStruc	<>

	even
AsyncECB		AESECB	<,500,,offset CGroup:MSMPoll>

	even

FragList		db	2+(6*MAX_FRAGS) dup (0)
	even


;******************************************************************************
;                  F R A M E   T R A N S M I T   C O D E
;******************************************************************************
;
;	MSMSendPacket
;
;	Called directly by the LSL when it wants us to send a packet.
;
;	assumes:	es:si	-> ECB
;			Interrupts are disabled
;
;	returns:	ax	=0 if no initial errors
;				=LSLERR_NO_SUCH_DRIVER if MLID is shut down
;			z flag	set according to ax.
;			Interrupts disabled
;			ds,bp,ss,bp preserved
;

TooManyFrags:
	mov	ax, LSLERR_BAD_PARAMETER
	jmp	short GiveItBack

CantSendRightNow:
	test	word ptr MSMTxFlags0, (TXQUEUED*100h) or CRITICAL
	jz	ShutDownCase
	jmp	short QueueItAndExit

MLIDIsAlreadyTransmitting:
QueueItAndExit:
	call	MSMEnqueueSend			;Queue it for later
	sub	ax, ax

ExitSendPacket:
	pop	ds
	pop	bp
	retf

ShutDownCase:
	mov	ax, LSLERR_NO_SUCH_DRIVER
GiveItBack:
	push	ax
	mov	es:[si].Status, ax
	call	es:[si].ESR
	pop	ax
	or	ax, ax
	jmp	ExitSendPacket


MSMSendPacket	proc	far

	push	bp				;Must save for ODI spec.
	push	ds
	mov	ax, cs
	mov	ds, ax

	cmp	es:[si].FragCount, MAX_FRAGS	;Too many frags for us?
	ja	TooManyFrags

	test	word ptr MSMTxFlags0, ((SHUTDOWN or TXQUEUED)*100h) or CRITICAL
	jnz	CantSendRightNow

	cmp	CurrTransmitECB+2, 0		;Is a tx already in progress?
	jne	MLIDIsAlreadyTransmitting

	cmp	MSMTxFreeCount, 0		;Can driver do another one?
	je	MLIDIsAlreadyTransmitting

;Enter a critical section.

	mov	bx, MLIDSUP_START_CRITICAL_SECTION
	call	LSLSupport
	inc	MSMTxFlags0			;Set critical section flag

	cld
	call	ProcessThisSend
	call	DriverSend

	cmp	cs:NumTxFrags, 0		;Fragmented send?
	je	DontDoSecond

	mov	ax, cs
	mov	ds, ax
        mov     CurrSplitFlag, 00h              ;Adjust split flag
	cmp	MSMTxFreeCount, 0		;Is there a hardware buf available?
	je	DontDoSecond

        mov     CurrSplitFlag, 02h              ;Adjust split flag 
	call	GetNextPiece
	call	DriverSend

DontDoSecond:
	dec	cs:MSMTxFlags0			;Exit critical section
	pop	ds
	pop	bp
	mov	bx, MLIDSUP_END_CRITICAL_SECTION
	call	cs:LSLSupport			;Also calls ServiceEvents
	sub	ax, ax
	retf

MSMSendPacket	endp


;
;	ProcessThisSend
;
;	This routine jumps to GetNextPiece
;
;	assumes:	es:si	-> transmit ECB
;			ds	CGroup
;			CLD has been executed
;			Interrupts are disabled
;			We are inside a critical section
;
;	returns:	Many parms returned if a single frag packet
;			Interrupts disabled
;

ProcessThisSend	proc	near
	mov	es:[si].Status, 0		;Get this out of the way

	mov	CurrTransmitECB+0, si
	mov	CurrTransmitECB+2, es

	mov	dx, es:[si].DataLen
        cmp     dx, 504                         ;Does it need to be fragmented
	ja	DoFragmentedSend

;	This frame will fit into one packet.

	sub	bl, bl				;Split flag is 00
	mov	NumTxFrags, bl			;Not a burst send (ASSUMES BL=0)
	mov	ax, word ptr es:[si].ImmAddr+4	;Load up the parameters
	add	al, 1				;Broadcast?
	adc	ah, bl				;Adjust accordingly (ASSUMES BL=0)
	mov	al, es:[si].ProtID+5
	mov	bp, CurrSequenceNumber
	lea	di, [si].FragCount		;ES:DI -> FragStruc
	jmp	short GetNextPiece

;	Figure out the number of packets that need to be sent and also
;	the number of bytes remaining in the last packet.

DoFragmentedSend:
	mov	ax, dx
	sub	dx, dx
	mov	cx, 504
	div	cx

	mov	LastTxRemBytes, 504		;Assume even multiple of 504
	or	dx, dx
	jz	NoExtraFrag

	inc	al				;We have one more fragment
	mov	LastTxRemBytes, dx		;Save remainder

NoExtraFrag:
	mov	NumTxFrags, al

	sub	al, 2
	add	al, al				; Multiply by 2
	or	al, 01h				;Set the more bit
	mov	CurrSplitFlag, al

	mov	ax, es:[si].Frag1Len
	mov	CurrFragLen, ax
	lea	ax, [si].Frag1Addr
	mov	CurrFragDesc+0, ax
	mov	CurrFragDesc+2, es
	les	ax, es:[si].Frag1Addr
	mov	CurrFragLoc+0, ax
	mov	CurrFragLoc+2, es
;;;;	ret					;Fall through to GetNextPiece

ProcessThisSend	endp


;
;	GetNextPiece
;
;	assumes:	ds	CGroup
;			Many parms passed in if not a burst send
;			Interrupts disabled
;
;	returns:	ds:si	-> TCB
;			ds	CGroup
;			Interrupts disabled
;			CLD has been executed
;

GetNextPiece	proc	near

	mov	TxTimeoutCount, TxTimeout	;Reset timeout count

	cmp	NumTxFrags, 0			;Burst send?
	je	BuildTCB

	mov	ax, 504				;All frags this size except last one
	dec	NumTxFrags			;One less frame to do
	jnz	NotLastOne

	mov	ax, LastTxRemBytes		;Get length of last frag

NotLastOne:
	mov	dx, ax				;DX gets the frame length
	sub	bp, bp				;Will hold number of frag buf's for this send
	mov	bx, 0002h

BuildNextFrag:
	les	di, dword ptr CurrFragLoc	;ES:DI first frag
	mov	word ptr FragList[bx+0], di	;Setup this fragment
	mov	word ptr FragList[bx+2], es
	inc	bp				;Bump fragment count

	mov	cx, CurrFragLen
	cmp	ax, cx				;Frag bigger than what's left of frame
	ja	StillMoreFragments

	mov	cx, ax

StillMoreFragments:
	sub	ax, cx
	mov	word ptr FragList[bx+4], cx

	add	CurrFragLoc+0, cx		;ES:DI -> new frag location
	sub	CurrFragLen, cx			;Adjust fragment length
	jnz	GotEnough

	add	bx, 6				;Advance target frag list
	add	word ptr CurrFragDesc, 6	;Advance to the next fragment
	les	di, dword ptr CurrFragDesc
	mov	cx, word ptr es:[di+4]
	les	di, dword ptr es:[di]		;ES:DI -> frag buffer
	mov	CurrFragLoc+0, di
	mov	CurrFragLoc+2, es
	mov	CurrFragLen, cx
	or	ax, ax
	jnz	BuildNextFrag

GotEnough:
	mov	word ptr FragList+0, bp		;Save frag count
	les	di, dword ptr CurrTransmitECB
	mov	ax, word ptr es:[di].ImmAddr+4
	add	al, 1				;Is it a broadcast?
	adc	ah, 0				;Adjust accordingly
	mov	al, es:[di].ProtID+5
	mov	bl, CurrSplitFlag
	mov	bp, CurrSequenceNumber
	push	cs
	pop	es
	mov	di, offset CGroup:FragList

;;;	jmp	BuildTCB			;Just fall through

GetNextPiece	endp


;
;	BuildTCB
;
;	Allocates a TCB and fills it out using the information passed
;	into this routine.
;
;	assumes:	ah	Destination node address
;			al	PID
;			bl	Split flag
;			dx	Length of this frame
;			bp	Current sequence number
;			es:di	-> FragStruc
;			ds	CGroup
;			Interrupts disabled
;
;	returns:	ds:si	-> TCB
;			ds	CGroup
;			Interrupts disabled
;			CLD has been executed
;

BuildTCB	proc	near

	dec	MSMTxFreeCount
	mov	si, TCBFreeList			     ;Allocate a TCB
	mov	cx, [si+0]
	mov	TCBFreeList, cx
	mov	[si].TCBMediaHeader.SDestAddress, ah ;Set destination address

	mov	word ptr [si].TCBFragStrucPtr+0, di    ;Set frag struc location
	mov	word ptr [si].TCBFragStrucPtr+2, es

;	Now see what kind of packet this is (short,long,or exception)

	cmp	dx, 249				     ;Short is <= 249 bytes in length
	jbe	ProcessShortFrame

	mov	[si].TCBMediaHeader.LLongPacketFlag, 0 ;Signal long packet
	cmp	dx, 252				       ;Exception frame?
	jbe	ProcessExceptionFrame

	neg	dx
	add	dx, 512-4			      ;Get 2nd half start offset
	mov	[si].TCBMediaHeaderLen, 4	      ;Set 1st half length
	mov	[si].TCBMediaHeader.LByteOffset+0, dl ;Set offset to 2nd header
	mov	[si].TCBMediaHeader.LByteOffset+1, 4  ;Set length of 2nd header
	mov	[si].TCBMediaHeader.LByteOffset+2, al ;Set the PID
	mov	[si].TCBMediaHeader.LByteOffset+3, bl ;Set split flag

	mov	word ptr [si].TCBMediaHeader.LByteOffset+4, bp ;Set sequence number
	ret

ProcessShortFrame:
	neg	dx
	add	dx, 256-4			      ;Get 2nd half start offset
	mov	[si].TCBMediaHeaderLen, 3	      ;Set 1st half length
	mov	[si].TCBMediaHeader.SByteOffset+0, dl ;Set offset to 2nd header
	mov	[si].TCBMediaHeader.SByteOffset+1, 4  ;Set length of 2nd header
	mov	[si].TCBMediaHeader.SByteOffset+2, al ;Set the PID
	mov	[si].TCBMediaHeader.SByteOffset+3, bl ;Set split flag

	mov	word ptr [si].TCBMediaHeader.SByteOffset+4, bp  ;Set sequence number
	ret

ProcessExceptionFrame:
	neg	dx
	add	dx, 512-8			       ;Get 2nd half start offset
	mov	[si].TCBMediaHeaderLen, 4	       ;Set 1st half length
	mov	[si].TCBMediaHeader.LByteOffset+0, dl  ;Set offset to 2nd header
	mov	[si].TCBMediaHeader.LByteOffset+1, 8   ;Set length of 2nd header
	mov	[si].TCBMediaHeader.LByteOffset+2, al  ;Set the PID (Pad 1)
	mov	[si].TCBMediaHeader.LByteOffset+3, 0FFh;Set split flag (Pad 2)
	mov	[si].TCBMediaHeader.LByteOffset+6, al  ;Set the PID
	mov	[si].TCBMediaHeader.LByteOffset+7, bl  ;Set split flag

	mov	word ptr [si].TCBMediaHeader.LByteOffset+8, bp     ;Set sequence number
	mov	word ptr [si].TCBMediaHeader.LByteOffset+4, 0FFFFh ;(Pad 3 & 4)
	ret

BuildTCB	endp


;
;	MSMSendComplete
;
;	Called by the MLID when it has finished with a transmit event.
;	This routine will assume control of the TCB handed to this routine.
;
;	assumes:	ds	is set to CGroup
;			si	-> TCB
;			Interrupts are disabled
;
;	returns:	ds,bp,ss,sp preserved
;			CLD preserved
;			Interrupts disabled
;

MSMSendComplete	proc	near

	mov	cx, TCBFreeList			;Free up this TCB
	mov	[si+0], cx
	mov	TCBFreeList, si

	cmp	NumTxFrags, 0			;Any left to send
	jne	StillMoreToDo

	add	DriverStatTable.MTotalTxPackets+0, 1
	adc	DriverStatTable.MTotalTxPackets+2, 0

	inc	CurrSequenceNumber		;Bump sequence number
	les	si, dword ptr CurrTransmitECB	;Get ptr to ECB
	mov	CurrTransmitECB+2, 0		;No tx active now

	cmp	word ptr MSMTxMonPtr+2, 00h	;ptr. to Rcv Monitor Tx Routine
	jz	MSMSendCompleteProceed

	call	MSMTxMonPtr			;call Rcv Monitor Tx Routine

MSMSendCompleteProceed:
	mov	bx, MLIDSUP_SEND_COMPLETE	;Hand it to the LSL
	call	LSLSupport

StillMoreToDo:
	ret

MSMSendComplete	endp


;
;	MSMGetNextSend
;
;	Called by the MLID when it is ready for another transmit 
;	request block.  This routine must check to make sure the driver
;	can handle another transmit.
;
;	assumes:	ds	is set to CGroup
;			Interrupts are disabled
;
;	returns:	si	-> TCB if there is one
;			ds	is set to CGroup
;			All other registers destroyed
;			nz flag if TCB NOT available
;			Interrupts disabled
;

MSMGetNextSend	proc	near

	cmp	MSMTxFreeCount, 0		;Can driver handle another one?
	je	DriverIsAlreadySaturated

	cmp	word ptr CurrTransmitECB+2, 0	;Transmit in progress?
	je	TryTheQueue
	
	cmp	NumTxFrags, 0			;Did drv call us before SendComplete?
	je	DriverIsAlreadySaturated

	add	CurrSplitFlag, 02h		;Adjust split flag
	call	GetNextPiece
	sub	ax, ax
	ret

TryTheQueue:
	les	si, dword ptr MSMTxQueueHead
	mov	ax, es
	or	ax, si
	jnz	QueueHasSomething

DriverIsAlreadySaturated:
	or	al, 1
	ret

QueueHasSomething:
	dec	DriverStatTable.MQueueDepth	; Decrement Queue Depth

	mov	ax, es:[si].NextLink+0		;Unlink the ECB
	mov	cx, es:[si].NextLink+2
	mov	word ptr MSMTxQueueHead+0, ax
	mov	word ptr MSMTxQueueHead+2, cx
	or	ax, cx				;Did we take the last one?
	jnz	StillMoreOnQueue

	and	MSMTxFlags1, not TXQUEUED
	mov	word ptr MSMTxQueueTail+0, offset CGroup:MSMTxQueueHead
	mov	word ptr MSMTxQueueTail+2, cs

StillMoreOnQueue:
	call	ProcessThisSend
	mov	CurrSplitFlag, 00h		;Adjust split flag
	sub	ax, ax
	ret

MSMGetNextSend	endp


;
;	MSMRcvComplete
;
;	Called by the MLID when it has a frame waiting for a buffer.
;	The MLID has passed us a pointer to the frame data.
;
;	assumes:	es:si	-> the entire received frame.
;			ds	is set to CGroup
;			CLD has been executed
;			Interrupts are disabled
;
;	NOTE THAT INTERRUPTS WILL BE ENABLED BY THIS ROUTINE.  THE RXNET
;	ADAPTER INTERRUPT MUST BE MASKED OFF BEFORE CALLING THIS ROUTINE.
;
;	returns:	ds	is set to CGroup
;			All other registers destroyed
;			CLD has been executed
;			Interrupts disabled
;

PacketTooSmall:
	add	cs:DriverStatTable.MTxTooSmall, 1
	adc	cs:DriverStatTable.MTxTooSmall+2, 0
	ret		

MSMRcvComplete	proc	near

;Only get Errors or Runt if in Promiscuous Mode

	mov	di, offset CGroup:LookAheadStruct
	mov	[di].LPacketAttrib, ax
	sti
	sub	bh, bh
	cmp	es:[si].LLongPacketFlag, bh	;Is this a long packet?
	jne	HandleShort

HandleLong:
	mov	bl, es:[si].LByteOffset
	mov	cx, 512-4
	sub	cx, bx				;Get the data length
	lea	bx, [bx+si+4]			;ES:BX -> protocol data
	mov	[di].LDataSize, cx

	cmp	byte ptr es:[bx-3], 0FFh	;Is this an exception frame?
	jne	FrameTypeDetermined

	add	bx, 4				;Go past padding bytes
	sub	cx, 4				;Adjust length
	mov	[di].LDataSize, cx
	jmp	short FrameTypeDetermined

HandleShort:
	mov	bl, es:[si].SByteOffset
	mov	cx, 256
	sub	cx, bx				;Get the data length

	cmp	cx, 4				; If less than 4 byte trash packet.
	jb	short PacketTooSmall

	sub	cx, 4				; Sub. off software header.
	mov	[di].LDataSize, cx
	lea	bx, [bx+si+4]			;ES:BX -> protocol data

FrameTypeDetermined:
	cmp	byte ptr es:[bx-3], 00h		;1 of 1 condition?
	je	FirstOne

	test	byte ptr es:[bx-3], 01h		;Is the more bit set?
	jnz	PacketSizeUnknown
	jmp	OneOfMany

NoBufferForThisFrame:
	add	sp, 4				; Clean up stack
	add	DriverStatTable.MNoECBsAvailable+0, 1
	adc	DriverStatTable.MNoECBsAvailable+2, 0
	ret

PacketSizeUnknown:
        mov     [di].LDataSize, -1            ; set to MAX_FRAME_SIZE

FirstOne:
	mov	bp, word ptr es:[si+0]		;Get the SA and DA
	mov	ah, es:[bx-4]			;Get the PID
	mov	[di].LMediaHeaderPtr, si
	mov	[di].LookAheadPtr, bx
        mov     [di].LookAheadLen, cx
	mov	[di].LProtID+5, ah
	push	word ptr [di].LProtID+4
	mov	ax, bp
        mov     [di].LImmAddress+5, al
	mov	[di].LDestType, DEST_DIRECT	;Set dest. addr type to 80h (Direct)
	cmp	MSMPhysNodeAddress+5, ah	
	je	LDestTypeSet
        mov     [di].LDestType, DEST_MULTICAST OR DEST_BROADCAST ;Signal broadcast frame
	cmp	ah, 0				;Is dest addr a broadcast?
	je	LDestTypeSet
	mov	[di].LDestType, DEST_REMOTE_UNICAST ;Signal broadcast frame

LDestTypeSet:
	push	word ptr [di].LDestType
	cli
	mov	bx, MLIDSUP_GET_STACK_ECB
	call	LSLSupport
	cld
	jnz	NoBufferForThisFrame

	sti

	pop	word ptr es:[si].DriverWS+0
	pop	word ptr es:[si].ProtID+4
	mov	di, offset CGroup:LookAheadStruct
	mov	ax, [di].LPacketAttrib
	mov	word ptr es:[si].PrevLink+0, ax

	mov	word ptr es:[si].ImmAddr+4, bp	      ;Save the SA & DA here
	mov	byte ptr es:[si].ImmAddr+1, RxTimeout ;Setup the timeout count here

	mov	es:[si].Status, 0
	mov	bp, LookAheadStruct.LookAheadLen ;Set the initial frame size
        sub     bp, word ptr [di].LStartCopyOffset   ; Set exact size to copy
        jg      cont
        add     bp, word ptr [di].LStartCopyOffset    ; If negative reset the values
        mov     word ptr [di].LStartCopyOffset, 0

cont:   mov     es:[si].DataLen, bp
	mov	word ptr es:[si].DriverWS+2, bp

	mov	bx, si
	lds	si, dword ptr LookAheadStruct.LookAheadPtr ;DS:BX -> frame data

	mov	ax, word ptr [si-2]		;Get and save the sequence number
	mov	word ptr es:[bx].BoardNum, ax
   	mov	al, byte ptr [si-3]		;Get number of fragments
	mov	ah, 1				;Default is ONE of ONE
	shr	al, 1				;Get rid of more bit
        mov     byte ptr es:[bx].PrevLink+3, 0  ;Reset this value - SPD#147928
	jnc	OneOfOne

        mov     byte ptr es:[bx].PrevLink+3, 2  ;Save next expected SplitFlag value
	mov	ah, al
	add	ah, 2	     			;Get total num frag's expected

OneOfOne:
	mov	byte ptr es:[bx].PrevLink+2, ah	;Save number of fragments in this packet

	lea	di, es:[bx].Frag1Addr
	mov	word ptr es:[bx].ProtID+0, di

	mov	ax, word ptr es:[bx].Frag1Addr	;Get 1st frag offset value
	mov	word ptr es:[bx].ProtID+2, ax	;Current offset into fragment

	mov	ax, es:[bx].Frag1Len		;Get the length left in the frag
	mov	word ptr es:[bx].ImmAddr+2, ax	;Save it

	mov	al, byte ptr es:[bx].FragCount	;Save number of fragments
	mov	es:[bx].ImmAddr+0, al		;Use this as workspace

        mov     di, offset CGroup:LookAheadStruct

	test	byte ptr [si-3], 01h		;Is this ONE of ONE?
	jnz	MultipleReceive			;Must check in case of a overflow
        add     si, word ptr cs:[di].LStartCopyOffset  ; Adjust offset to be copied from
	jmp	ReceiveFrame			;Simple case


MultipleReceive:
	push	es
	push	bx
        add     si, word ptr cs:[di].LStartCopyOffset  ; Adjust offset to be copied from 
	call	ReceiveFrame
	pop	bx
	pop	es
	jz	ECBWasHandedBack

	mov	cx, es				;Link us into the Rx ECB list
	mov	di, bx
	xchg	cs:ECBReceiveList+0, di
	xchg	cs:ECBReceiveList+2, cx
	mov	es:[bx+0], di
	mov	es:[bx+2], cx

ECBWasHandedBack:
	ret


OneOfMany:
	push	cx				;Save the frame length
	mov	ax, es:[si+0]			;Get the SA & DA
        mov     bp, es:[bx-2]                   ;Get the sequence number
	mov	cx, cs
	mov	si, offset CGroup:ECBReceiveList
	lds	di, dword ptr [si]		;Scan the list for a ECB

SearchRxECBList:
	mov	dx, ds
	or	dx, di
	jz	NotOnList

	cmp	word ptr [di].ImmAddr+4, ax	;SA & DA address match?
	jne	NextECB

	cmp	word ptr [di].BoardNum+0, bp	;Sequence numbers match?
	je	FoundReceiveECB

NextECB:
	mov	cx, ds				;New prev
	mov	si, di
	lds	di, dword ptr [di]		;Advance to next ECB
	jmp	SearchRxECBList

FoundReceiveECB:
	pop	bp				;BP = this frame's length
	mov	al, es:[bx-3]			;Get the SplitFlag
	cmp	byte ptr [di].PrevLink+3, al	;Is it what we think it is?
        jne     InvalidSplitFlag

	push	word ptr [di].NextLink+0	;Save -> next ECB on list
	push	word ptr [di].NextLink+2
	push	cx				;Save prev pointer
	push	si	

	add	byte ptr [di].PrevLink+3, 2	;Update SplitFlag value
	add	[di].DataLen, bp		;Keep running total 
	add	word ptr [di].DriverWS+2, bp

	mov	ax, ds
	mov	cx, es
	mov	es, ax
	mov	ds, cx				;Flip 'em around
	
	mov	si, bx				;DS:SI -> rx data
	mov	bx, di				;ES:BX -> ECB

	call	ReceiveFrame
	jnz	ECBStillNeeded

	pop	si
	pop	es
	pop	word ptr es:[si+2]		;Unlink the last ECB
	pop	word ptr es:[si+0]
	ret

NotOnList:
	pop	bp				;Clean the stack
	push	cs
	pop	ds
	cli
	ret

ECBStillNeeded:
	add	sp, 8				;Discard saved values
	ret
	
InvalidSplitFlag:
	mov	ax, cs
	mov	ds, ax
	inc	DriverStatTable.MRxMismatchError
	cli
	ret
	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;assumes:	ds:si	-> received data
;		es:bx	-> ECB
;		bp	number of bytes pointed to by DS:BX
;		Interrupts are enabled
;
;returns:	ds	CGroup
;		z flag set if ECB was passed back to the LSL.
;		Interrupts disabled
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ReceiveFrame:
	push	bx
	push	es
	mov	ax, es				;Save it in AX
	mov	cx, word ptr es:[bx].ImmAddr+2	;Get the amount left over in this frag
	mov	dl, es:[bx].ImmAddr+0		;Get number of frag's left
	mov	di, word ptr es:[bx].ProtID+2	;Get offset value of current frag

	mov	bx, word ptr es:[bx].ProtID+0	;Get -> current frag descriptor
	mov	es, word ptr es:[bx+2]		;ES:DI -> current frag buffer

DoMoreCopy:
	cmp	bp, cx				;See which one is smaller
	ja	MoreFragsToDo

	mov	cx, bp				;Only copy whats needed

MoreFragsToDo:
	sub	bp, cx				;Adjust (left to move count)
	shr	cx, 1
   rep	movsw
   	adc	cl, cl
   rep	movsb

   	or	bp, bp				;All the frame copied?
	jz	CopyDone

   	add	bx, 6				;Advance to the next fragment
	mov	es, ax
	mov	cx, word ptr es:[bx+4]		;Get the frag's length
	les	di, dword ptr es:[bx]
	dec	dl
	jnz	DoMoreCopy
	jmp	short HandleOverflow

;	Now save where we are fragment descriptor wise.

CopyDone:
	pop	es
	pop	si				;ES:SI -> ECB
	mov	word ptr es:[si].ProtID+0, bx	;Save curr frag descript location
	mov	word ptr es:[si].ProtID+2, di	;Save offset into frag buffer
	mov	ax, word ptr es:[bx+4]		;Get the frag's length
	sub	di, word ptr es:[bx]		;Get num bytes we have used
	sub	ax, di				;AX gets num left in fragment
	mov	word ptr es:[si].ImmAddr+2, ax	;Save it
	mov	es:[si].ImmAddr+0, dl		;Save number frags left

;	Now see if we are totally done with this receive.

	dec	byte ptr es:[si].PrevLink+2	;One more packet frag done
	jz	AllDoneWithReceive

	mov	ax, cs
	mov	ds, ax				; Restore DS to CGroup
	cli
	ret					; Z flag must be cleared

AllDoneWithReceive:
	mov	ax, cs
	mov	ds, ax
	mov	ax, DriverConfigTable.MBoardNumber
	mov	es:[si].BoardNum, ax		; Setup the board number
        sub     ax, ax
	mov	word ptr es:[si].ProtID+0, ax	; Clean up Protocol Id field.
	mov	word ptr es:[si].ProtID+2, ax
	mov	word ptr es:[si].ImmAddr+0, ax	; Clear this out
	mov	word ptr es:[si].ImmAddr+2, ax
	mov	ah, byte ptr es:[si].ImmAddr+4	; Get SA
	mov	word ptr es:[si].ImmAddr+4, ax	; Remove Dest addr and set immediate.

        add     DriverStatTable.MTotalRxPackets+0, 1      
	adc	DriverStatTable.MTotalRxPackets+2, 0

	cli
	mov	bx, MLIDSUP_HOLD_RECV_EVENT	; Give it to the LSL
	call	LSLSupport

        mov     cs:LookAheadStruct.LStartCopyOffset, 0  ; Reset it 

	sub	ax, ax				; Set z flag
	ret


;	Whoops - Packet is too big for the ECB buffers.

HandleOverflow:
	pop	es
	pop	si				; ES:SI -> ECB
        mov     es:[si].Status, LSLERR_RX_OVERFLOW
	inc	cs:DriverStatTable.MRxTooBig	; Do stat counter 

	mov	ax, es:[si].DataLen		; Adjust DataLen to reflect
	sub	ax, bp				; the actual amount of data
	mov	es:[si].DataLen, ax		; in the ECB.

	jmp	AllDoneWithReceive
	
MSMRcvComplete	endp


;
;	MSMPoll
;
;	Called approximatelly once every second.  We check our outstanding
;	receives to see if we have a timeout.  The driver must check for
;	timed out transmits.
;
;	assumes:	es:si	-> AES ECB
;			Interrupts disabled
;
;	returns:	ds,bp,ss,sp preserved
;			Interrupts disabled
;

MSMPoll	proc	far

	cmp	cs:ECBReceiveList+2, 0		;Anything on the list
	jne	CheckForRxTimeout

BackFromRxCheck:
	mov	al, cs:MSMMaxActiveTx
	cmp	cs:MSMTxFreeCount, al		;Any Tx's active?
	jne	CheckForTxTimeout

RescheduleUs:
	mov	word ptr es:[si].MSecondValue, 500 ;Reset timeout value (.5sec)
	mov	bx, MLIDSUP_SCHEDULE_AES_EVENT
	jmp	cs:LSLSupport

CheckForRxTimeout:
	push	bp
	push	ds

;	Age the list.

	mov	cx, cs				;Setup prev pointer
	mov	bx, offset CGroup:ECBReceiveList
	lds	di, dword ptr cs:[bx]		;DS:DI -> 1st ECB 

AgeList:
	mov	ax, ds
	or	ax, di
	jz	FinishedAging
	dec	byte ptr [di].ImmAddr+1		;Count down timeout value
	jz	GotRxTimeout

	mov	cx, ds
	mov	bx, di
	lds	di, dword ptr [di]		;DS:DI -> next ECB
	jmp	AgeList

FinishedAging:
	pop	ds
	pop	bp
	jmp	BackFromRxCheck
	
GotRxTimeout:
	inc	cs:DriverStatTable.MRxMiscError	;Record the error
	push	ds
	mov	[di].Status, LSLERR_CANCELLED
	push	word ptr [di+0]			;Unlink this ECB from the list
	push	word ptr [di+2]
	mov	ds, cx
	pop	word ptr [bx+2]
	pop	word ptr [bx+0]
	pop	es
	mov	si, di				;ES:SI -> ECB
	mov	bx, MLIDSUP_HOLD_RECV_EVENT
	call	cs:LSLSupport
	mov	bx, MLIDSUP_SERVICE_EVENTS
	call	cs:LSLSupport
	push	cs
	pop	es
	mov	si, offset CGroup:AsyncECB	;Reload ES:SI
	jmp	FinishedAging

CheckForTxTimeout:
	dec	cs:TxTimeoutCount
	jnz	RescheduleUs

;	A transmit has failed to be acknowledged by the NIC.

	push	es				;Save -> AES ECB
	push	si
	push	ds
	push	bp

	push	cs
	pop	ds

	call	DriverTxTimeout			;Abort transmission

	inc	DriverStatTable.MTxMiscError	;Record the error

	cmp	CurrTransmitECB+2, 0
	je	DontGiveItBack

	les	si, dword ptr CurrTransmitECB	;Give the ECB back
	mov	bx, MLIDSUP_SEND_COMPLETE
	call	LSLSupport

	mov	CurrTransmitECB+2, 0		;Flag it not used anymore

DontGiveItBack:
	mov	NumTxFrags, 0
	mov	al, MSMMaxActiveTx
	mov	MSMTxFreeCount, al		;All tx resources available
	inc	CurrSequenceNumber		;Bump sequence number

;	Now start another one going, if any.

	call	MSMGetNextSend
	jnz	NoMoreSends

	cld
	call	DriverSend			;Start it going

NoMoreSends:
	mov	bx, MLIDSUP_SERVICE_EVENTS
	call	cs:LSLSupport

	pop	bp
	pop	ds
	pop	si
	pop	es
	jmp	RescheduleUs

MSMPoll	endp


;
;	MSMMediaShutdown
;
;	Called by the MSM before it calls the driver to shutdown.
;	This routine can do anything necessary to shutdown this module
;	such as cancel outstanding AES events, etc.  The driver at this
;	point has no outstanding transmits.
;
;	assumes:	ds	CGroup
;			cx	=0 Perm shutdown flag
;				!0 Temp shutdown flag
;			CLD has been executed
;			Interrupts disabled
;
;	returns:	ds,CLD,Ints preserved
;

MSMMediaShutdown	proc	near

	or	cx, cx
	jnz	TempShutdownOnly

	push	cs				;Cancel our AES poll
	pop	es
	mov	si, offset CGroup:AsyncECB
	mov	bx, MLIDSUP_CANCEL_AES_EVENT
	call	LSLSupport

;	Clear the receive ECB list.

TempShutdownOnly:
	les	si, dword ptr ECBReceiveList

ClearReceiveList:
	mov	ax, es
	or	ax, si
	jz	ReceiveWaitingIsEmpty

	push	word ptr es:[si+2]
	push	word ptr es:[si+0]

	mov	es:[si].Status, LSLERR_CANCELLED
	mov	bx, MLIDSUP_HOLD_RECV_EVENT	;Give it to the LSL
	call	LSLSupport

	pop	si
	pop	es
	jmp	ClearReceiveList

ReceiveWaitingIsEmpty:
	mov	ECBReceiveList+0, si		;SI = 0
	mov	ECBReceiveList+2, si
	ret

MSMMediaShutdown	endp


;****************************************************************************
;  MSMMediaConfigUpdate
;
;	This function is called by the HSM after the hardware is fully
;	functional.  At Init time all HSMs must make this call to initially
;	setup the Configuration tables and Media Specific items.
;
;	At Run Time, an HSM would only call this function to update
;	the configuration tables after a HARDWARE change had occured.

;	The HSM must have the MSMTxFreeCount, MSMLookAheadSegment, and 
;	MSMPriorityQSupportPtr (if needed) initialized prior to calling.
;
;	On ENTRY:
;		DS = CS = CGroup
;		Interrupts disabled
;
;	On Return:
;		AX = Error code
;			0 = success,
;			MSMERR_TSM_FAILED => error occured.
;
;		DX = Message Offset of the Error.
;		     only the Init time can the Error Code be used to print
;		     the error message.
;
;		ES = CGroup
;
;		Interrupts disabled
;		DS,BP,SS,SP preserved.
;
;****************************************************************************
MSMMediaConfigUpdate	proc	near
;----------------------------------------------------------------------------
;	Guarentee that ES is set to CGroup
;----------------------------------------------------------------------------
	push	cs
	pop	es	; CGroup

;----------------------------------------------------------------------------
;	Check that the HSM has set the MSMTxFreeCount
;----------------------------------------------------------------------------
	mov	dx, offset CGroup:ForgotTxFreeCount	; Possible Error
	mov	al, MSMTxFreeCount		; Save a copy of the value
	mov	MSMMaxActiveTx, al
	or	al, al				; Check if even set?
	jz	HSMForgotExit

;----------------------------------------------------------------------------
;	Now check to make sure the HSM set the MSMLookAheadSegment
;----------------------------------------------------------------------------
	mov	ax, MSMLookAheadSegment
	mov	dx, offset CGroup:ForgotLASegment
	or	ax, ax
	jz	HSMForgotExit

;----------------------------------------------------------------------------
;	Initialize the Look Ahead structures Segment Values
;----------------------------------------------------------------------------
	mov	LookAheadStruct.LMediaHeaderPtr+2, ax
	mov	LookAheadStruct.LookAheadPtr+2, ax

;----------------------------------------------------------------------------
;	Set up the Node Address in all Config Tables.
;	RXNet can only be LSB.  Simply need to copy to table.
;	Set up the Best and worst Data Size Fields also
;----------------------------------------------------------------------------
	push	cs
	pop	es				; ES = CGroup

	mov	di, MSMConfigTables[0]		; Get first Config Table
	lea	si, MSMPhysNodeAddress		; We don't allow Node Address to be 
	lea	di, [di].MNodeAddress		; different. (LSB mode only)
	mov	cx, 3
 rep	movsw

;----------------------------------------------------------------------------
;	Setup the source node address in all of the media headers.
;----------------------------------------------------------------------------
	mov	bx, TCBFreeList			;Get ptr first TCB
	lea	si, MSMPhysNodeAddress		;DS:SI -> Physical node address

DoNextTCB:
	push	si
	lea	di, [bx].TCBMediaHeader.LSourceAddress	; ES:DI -> src addr field
	movsw					; Set the src address
	movsw
	movsw
	pop	si
	mov	bx, [bx+0]		; Next TCB
	or	bx, bx
	jnz	DoNextTCB

	jmp	MSMUpdateConfigTables	; No Known Errors to pass back out on ret.

;----------------------------------------------------------------------------
;	Error Exit
;----------------------------------------------------------------------------
HSMForgotExit:
	mov	ax, MSMERR_TSM_FAILED	; DX = MSG offset for init time
	or	ax, ax			; Set appropriate flags.
	ret		

MSMMediaConfigUpdate	endp


MSMAddMulticastAddress	proc	near
MSMDelMulticastAddress:
MSMGetMulticastInfo:
	mov	ax, LSLERR_BAD_COMMAND		;Not supported by RXNET
MSMUpdateMulticast:
MSMGetRCB:
MSMReturnRCB:
MSMMediaReset:
	ret
MSMAddMulticastAddress	endp


Code	ends

;*******************************************************************************
;                  M E D I A   I N I T I A L I Z A T I O N
;*******************************************************************************

Init	segment	para public 'CODE'
	assume	cs:CGroup, ds:CGroup, es:nothing, ss:nothing

	public	InitializeMedia
	public	SupportedMedias

	extrn	MSMAlloc		:near
	extrn	DriverInit		:near
	extrn	MSMPrintStringZero	:near

;----------------------------------------------------------------------------
;	Messages from MSMtxt.inc
;----------------------------------------------------------------------------
	extrn	ForgotTxFreeCount	:byte
	extrn	ForgotLASegment		:byte

;----------------------------------------------------------------------------
;		M E S S A G E   C E N T E R
;		  Media Specific Messages.
;----------------------------------------------------------------------------
		db	'MEDIA = ',RXNetTSMVersion,0 	;Must always be present
RXNetMsg	db	'RXNet', 0

;Message number is the WORD before the String.

NoNodeOverrideMsg	db	88,0,'Node address override is not supported.',0Dh,0Ah,0


;This table is required for use with the generic MSM module.

SupportedMedias		dw	MaxVirtBoards	 	  ;Num. medias supported
			dw	offset CGroup:MediaName14 ;Default is first one
			dw	MediaID14
			db	5 dup (0), 0FAh		  ;Default ProtocolID for IPX


;
;	InitializeMedia
;
;	Called by the main MSM to do any initialization of variables
;	and tables that will be used in building and stripping our media 
;	headers.
;
;	assumes:	ds	is set to CGroup
;			CLD has been executed
;			Interrupts are enabled
;
;	returns:	No registers need be preserved
;

InitializeMedia	proc	near

;test Node Address override if any correct for media.

	mov	bx, MSMConfigTables[0]		;Set raw send bit and lookahead Data Size support field
	push	cs
	pop	es
	call	MediaNodeAddressCheck		;Check for Node Address Override.

;Reset PSP Area to zero to allow for our use as no longer need Swap Table

	mov	di, PSPTableStart		;get start of Swap Table Area
	mov	cx, 100h
	xor	ax, ax
 rep	stosb					;reset area to zero.

	mov	ax, DriverConfigTable.MBoardNumber
	mov	LookAheadStruct.LBoardNum, ax	;Setup the board number

	and	DriverConfigTable.MModeFlags, NOT MNonCanonicalBit	;ensure bit is reset

	push	cs
	pop	es
	call	DriverInit
	cli
	cld
	push	cs
	push	cs
	pop	ds
	pop	es

	or	ax, ax				;Any error initializing?
	jnz	ErrorInitingBoard

	xor	cx, cx
	mov	cl, MSMMaxActiveTx		;Link the TCB's & header buf's together
	mov	ax, size TCBStruc+MaxHeaderLen
	mov	di, offset CGroup:TCBFreeList

LinkHeaderBufLoop:
	call	MSMAlloc
	mov	[di], bx			;Link it
	mov	di, bx
	loop	LinkHeaderBufLoop

	mov	word ptr [di], cx		;Terminate the list

;Now schedule a polling routine to check on transmits and fragmented receives.

	push	cs
	pop	es
	mov	si, offset CGroup:AsyncECB
	mov	[si+2].AESESR, cs
	mov	bx, MLIDSUP_SCHEDULE_AES_EVENT
	call	LSLSupport

;Enable the counter bits that we increment.

	and	word ptr DriverStatTable.MValidCounterMask+2, not 1110001011001100b

ErrorInitingBoard:
	ret

InitializeMedia	endp


;****************************************************************************
;****************************************************************************
;
; BEGIN_MANUAL_ENTRY ( MediaNodeAddressCheck, MSM/RxNet/Internal/ChkNode)
;
; NAME:		MediaNodeAddressCheck
;
; DESCRIPTION:	If Node Address Override has taken Place then
;		Prints out an Warning Message, and resets the Node Address
;		to 000000000000.  RxNet doesn't support Node Address override.
;
; ON ENTRY:	AX	N/A
;		BX	N/A
;		CX	N/A
;		DX	N/A
;		BP	N/A
;		SI	N/A
;		DI	N/A
;		CS	CGroup
;		DS	CGroup
;		ES	CGroup
;	
;		NOTE:	cld in effect, Interrupts are enabled
; ON RETURN:	AX	Destroyed
;	    	BX	Preserved (Not Used)
;		CX	Destroyed
;		DX	Destroyed
;		BP	Preserved (Not Used)
;		SI	Destroyed
;		DI	Destroyed
;		CS	CGroup
;		DS	CGroup
;		ES	CGroup
;
;
;		NOTE: Interrupt state is not changed during function.
;		      Interrupt state is preserved.
;	
;
; REMARKS:
;	The DoNodeKeyWord in the Generic MSM.asm sets the LSB/MSB mode bits
;	if nessasary.   
;	Bit 15 signals the support of the particular driver (Set by the HSM)
;			Bit 15	1 = LSB/MSB supported. 
;				0 = Not Supported (old driver)
;	Bit 14 describes the form of Node Address in the DriverconfigTable (Set by the MSM)
;			Bit 14 	1 = MSB (Non-Canonical Form)
;				0 = LSB (Canonical Form)
;
; SEE ALSO:
;
; END_MANUAL_ENTRY
;****************************************************************************
;****************************************************************************

MediaNodeAddressCheck	proc	near

	mov	ax, word ptr MSMPhysNodeAddress
	and	ax, word ptr MSMPhysNodeAddress+2
	and	ax, word ptr MSMPhysNodeAddress+4
	inc	ax
	jz	DoNodeClearExit

;We are RxNet, and we don't support Node Address Overrides.

	mov	dx, offset CGroup:NoNodeOverrideMsg
	call	MSMPrintStringZero

;Clear the Address and Exit.

DoNodeClearExit:
	xor	ax, ax
	mov	cx, 3			;3 words in address.
	lea	di, [bx].MNodeAddress	;ES:DI -> Target
 rep	stosw				;Clear the Address up to the Config Table.
	mov	cx, 3			;3 words to clear
	mov	di, offset CGroup:MSMPhysNodeAddress
 rep	stosw				;Clear the MSMPhysNodeAddress
	ret

MediaNodeAddressCheck	endp

Init	ends

	end

