#############################################################################
#	ETHERTSM.MAK controls the building of the Assembly ETHERTSM.NLM (ASM)
#
#   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
# 
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
# 
#############################################################################
$(UTIL) : $(EXEDIR)\$(UTIL).$(UTILEXT) $(DBGEXEDIR)\$(UTIL).$(UTILEXT)


$(EXEDIR)\$(UTIL).$(UTILEXT): $[f,$(OBJDIR),$(OBJS),obj] \
								$(SRCDIR)\$(UTIL).mak \
								$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DESCRIPTION)
	
	%Do Link

$(DBGEXEDIR)\$(UTIL).$(UTILEXT): $[f,$(DBGOBJDIR),$(OBJS),obj] \
									$(SRCDIR)\$(UTIL).mak \
									$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DBGDESCRIPTION)
	%Set LINKDEBUG = $(DEBUGSTRING)
	%Set REV=4						#For DEBUG use only

	%Do Link

Link:
	$(ASMLINKER)\checkerr
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Building $[f,$[p,$[m,*.obj,$**]],$<,xdc]
	$(ASMLINKER)\mpkxdc -b $[f,$[p,$[m,*.obj,$**]],$<,xdc]
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Linking $@
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do DeleteFile
	%endfor
	$(COMPILE)\wlink <@<
format Novell $(UTILEXT) '$(DESCRIP)'
$(LINKDEBUG)
name $@
file $[s,",",$[m,$[p,$[m,*.obj,$**]]*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option start = InitializeEtherTSM
option exit = RemoveEtherTSM
option map = $[f,$[d,$@],$@,map]
option caseexact
option quiet
option verbose
option nodefaultlibs
option namelen = 30
option XDCData = $[f,$[p,$[m,*.obj,$**]],$<,xdc]
%If %Defined(SYM)
option SYMFILE = $[f,$[d,$@],$@,sym]
%EndIf

module	MSM|MSM31X

import
#       MSMTrace,
    MSMPhysicalEqualsLogical,
    MSMGetPhysList,
    MSMGetPhysical,
    MSMGetPhysicalAddressOfECB,
    GetNLMVersionInfo,
    LSLFastRcvEvent,
    LSLFastSendComplete,
    LSLHoldRcvEvent,
#       LSLGetSizedRcvECBRTag,
    LSLReturnRcvECB,
    LSLSendComplete,
    MapDataOffsetToAbsoluteAddress,
	OutputToScreen,
	MSMAESProcedure,
	MSMAlert,
	MSMAlloc,
	MSMAllocateRCB,
	MSMBitSwapTable,
	MSMCallBackProcedure,
	MSMCanonicalMode,
	MSMControlStackFilter,
	MSMDriverControlCall,
	MSMDriverSendCall,
	MSMEnqueueSend,
	MSMFastRcvEventBelow16,
	MSMFileServerMajorVersionNumber,
	MSMFileServerMinorVersionNumber,
	MSMFree,
	MSMGetNextSend,
	MSMGetTSMIFLevel,
	MSMGetVersionNumber,
	MSMHoldRcvEventBelow16,
#		MSMInitAlloc,
	MSMInterruptProcedureCall,
	MSMInterrupt2ProcedureCall,
	MSMIOCTLJumpTable,
	MSMPrintStringWarning,
	MSMRegisterTSM,
	MSMReturnRcvECB,
	MSMSMPActvFlag,
	MSMMPKActvFlag,
	MSMGetMaxFragCount,
	MSMCombineFrags,
	LogicalToPhysical,
	PhysicalToLogical,
	CACSAdapterTempPtr,
	CACSAlloc,
	CACSCHSMAdapterDataSize,
	CACSDriverRegistered,
	CACSDriverTable,
	CACSFree,
	CACSFindMessages,
	CACSNumberFrames,
	CACSPrintError,
	CACSRtnCTCB,
    CACSGetCTCB,
    CACSGetNumberCustomCounters

export
	EtherTSMBuildTransmitControlBlock,
    EtherTSMCancelPrioritySend,
    EtherTSMGetConfigInfo,
    EtherTSMFastRcvComplete,
	EtherTSMFastRcvCompleteStatus,
	EtherTSMFastProcessGetRCB,
	EtherTSMFastSendComplete,
	EtherTSMGetASMHSMIFLevel,
	EtherTSMGetNextSend,
	EtherTSMGetRCB,
	EtherTSMProcessGetRCB,
	EtherTSMRcvComplete,
	EtherTSMRcvCompleteStatus,
	EtherTSMRegisterHSM,
	EtherTSMSendComplete,
	EtherTSMUpdateMulticast,
	CEtherTSMBuildTransmitControlBlock,
	CEtherTSMCancelPrioritySend,
	CEtherTSMFastProcessGetRCB,
	CEtherTSMFastRcvComplete,
	CEtherTSMFastRcvCompleteStatus,
	CEtherTSMFastSendComplete,
	CEtherTSMGetHSMIFLevel,
	CEtherTSMGetRCB,
	CEtherTSMProcessGetRCB,
	CEtherTSMRcvComplete,
	CEtherTSMRcvCompleteStatus,
	CEtherTSMRegisterHSM,
	CEtherTSMSendComplete,
    CEtherTSMUpdateMulticast,
    CEtherTSMGetConfigInfo
<
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do	AttributeAdd
	%endfor
	
	%Echo $(BEGINGREEN) Finished Building -- $(DESCRIP) in Directory $@ $(ENDANSI)

	%If %Defined(ENGTEST)
		%Echo ***************************************************************
		%Echo $(BEGINYELLOW) $(WARNINGENG) $(ENDANSI)
		%Echo ***************************************************************
	%EndIf