;
;***********************************************************************\
;
;   (c) Unpublished Work of Novell, Inc.  All rights reserved.
;
;   THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
;   PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS
;   TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
;   NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
;   AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO
;   APPROPRIATE LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED,
;   PRACTICED, PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED,
;   TRANSLATED, ABRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED,
;   LINKED,RECAST, TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN
;   CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT
;   THE PRIOR WRITTEN CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF
;   THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
;   CRIMINAL AND CIVIL LIABILITY.
;
;**********************************************************************
;                                                                       *
; ODI.INC								*
;                                                                       *
; General definitions used by protocol stacks, LSL and MLIDs.		*
;                                                                       *
; Written by:	Don Shulz.						*
; Date:		November 1990						*
;                                                                       *
;	(c) Copyright 1991 - 1997 Novell, Inc. All rights reserved.	*
;
; 5 January 1995 10:26	DGM
;	Added additions for SMP made by Jeff in his prototype code.
;	This involved adding DriverSupportsSMPBit (100h Bit 8) to the 
;	MLIDModeFlags Bit definitions.
;
; 2 February 1995 17:21	DGM
;	Added code for the NBI Error Codes and Bus Types.  
;	Added codes to GET_IRQ_ROUTING_OPTIONS and SET_PCI_IRQ to 
;	the PCI BIOS Function list and added PCI_SET_FAILED and 
;	PCI_BUFFER_TOO_SMALL to the PCI Return Code List.
;
;	Also added structure definition for layout of PCI Bios v2.1
;	IRQ Routing Table entry.
;
;
; 10 March 1995 9:59	DGM
;	Added EISA_IRQ_EL_BIT, 20h, Interrupt Edge/Level Configuration Bit
;	to EISA Equates
;
; 16 May 1995 11:01	DGM	
;	Corrected PNP_READ_DATA_PORT to be 203h and not 207h.
;
; 22 Sep 1995 13:31 JRT
;   Added 'C' style LSL return codes.
;
; 14 Mar 1996 14:47 JRT
;   Added definition EISA_FREE_FORM, free form bit, for EISA function
;   information located at EISA_FUNC_OFFSET.
;
; 30 Apr 1996 15:19 JRT
;	Removed conditional assembly for SetBreak (always off) and SG_Add
;	(always on).
;
; 09 Sept 1996 11:44 LON
;	Added equates for ODI_ASPEC_MAJOR_VER and ODI_ASPEC_MINOR_VER.
;
; 10 Sept 1996 AYD
;	Added MLIDPrioritySup field in config table structure
;	Renamed MLIDReserved to MLIDReserved1 to bring it up to spec.
;
; 11 Sept 1996 AYD
;	Added ODISTAT_MLID_SHUTDOWN return code
;	Added IOConfig structure.
;
; 16 Oct 1996 JRT
;	Added RESPONSE_DELAYED.
;
; 24 Oct 1996 JRT
;	Added EISA Interrupt Configuration bits EISA_IRQ_MORE_BIT and
;	EISA_IRQ_SHARED_BIT.
;
; 15 Nov 1996 KRA
;	Set OP_SCOPE_ADAPTER equ 0 and OP_SCOPE_LOGICAL_BOARD equ 1 to match
;	the C spec equivalent values.
;
; 15 Nov 1996 JRT
;       Added NESL structures and constants.
;
; 16 JAN 1997 LON
;       Added equates for PrioritySupBit , RAW_SEND_PRIORITY_0 -7, and
;       SEND_PRIORITY_0 -7.
;
;31 Jan 1997 JWR
;	Added equates for Promiscuous State Flags.
;
; 13 Feb 1997 JRT
;       Fixed change made on 1/31/97 to use asm comments rather than C.
;
; 19 Mar 1997 mcd
;       Added error code for BUS_SPECIFIC_ERROR to ODI return codes and
;       ODI_NBI return codes.  Also added CardBus to BUSTYPES.
;
; 20 Nov 1997 mcd
;       SPD #153015 Added RMON_NO_COMPRESS and RMON_NONCAN_ADDR to
;       RMON status equates.
;
; 18 Dec 1997 jrt
;       SPD #173871. Modified AdapterOptionDefinitionStructure to
;       initialize all fields to a defualt value of 0 rather than
;       undefined. Users can over ride the default value in their
;       structure intializer by placing appropriate values between
;       <>. Also modified MLIDConfigurationStructure to initialize
;       to reasonable values.
;
; 02 Feb 2000 mcd
;       Added MF_ECB_AUX_SUP_BIT to defn of MLIDFlags.
;
; 21 July 2000 jwr
;		Added the following definitions to support ECB extensions and
;		IPSEC support:
;			Added Protocol Config Table struc definitions
;			Added Stack_Flags definitions for MP and AUX support.
;			Added AUX Data support definitions
;			
;
;***********************************************************************/
;
;
;***************************************************************\
;                                                               *
; Assembly ODI Specification Version Numbers                    *
;                                                               *
;***************************************************************/
ODI_ASPEC_MAJOR_VER	equ     3
ODI_ASPEC_MINOR_VER	equ     31
;
;***************************************************************\
;                                                               *
; Resource Tag signatures used by MSM.				*
;                                                               *
;***************************************************************/
;
AESProcessSignature		equ	'PSEA'
AllocSignature			equ	'TRLA'
CacheBelow16MegMemorySignature	equ	'61BC'
CacheNonMovableMemorySignature	equ	'TMNC'
ECBSignature			equ	'SBCE'
EventSignature			equ	'TNVE'
InterruptSignature		equ	'PTNI'
IORegistrationSignature		equ	'SROI'
LSLDefaultStackSignature	equ	'DLSL'
LSLPreScanStackSignature	equ	'PLSL'
LSLStackSignature		equ	'SLSL'
LSLTxPreScanStackSignature	equ	'TLSL'
MLIDSignature			equ	'DILM'
NWManageObjectSignature		equ	'EJBO'
PollingProcedureSignature	equ	'RPLP'
SemiPermMemorySignature		equ	'EMPS'
TimerSignature			equ	'RMIT'

	page
;
;***************************************************************\
;                                                               *
; Receive Event Control Block structure.			*
;                                                               *
;***************************************************************/
;
ReceiveBufferStructure	struc
	RLink			dd	?
	RBLink			dd	?
	RStatus			dw	?
	RESRAddress		dd	?
	RLogicalID		dw	?           ; CSpec111 ECB_StackID
	RProtocolID		db	6 dup (?)
	RBoardNumber		dd	?
	RImmediateAddress	db	6 dup (?)
	RDriverWorkSpace	dd	?
	RProtocolWorkspace	db	8 dup (?)
	RPacketLength		dd	?
	RFragmentCount		dd	?	;always 1
	RPacketOffset		dd	?
	RPacketSize		dd	?

ReceiveBufferStructure	ends

RPacketEnvelope			equ	byte ptr RPacketSize + 4

LookAheadStructure	struc
	LMediaHeaderPtr		dd	?	; Pointer to Media Header.
	LookAheadPtr		dd	?	; Pointer to look ahead portion.
	LookAheadLen		dd	?	; Length of bytes in look ahead.
	LProtID			db	6 dup (?)	; ProtocolID
	LBoardNumber		dw	?	; Board Number of packet.
	LDataSize		dd	?	; Total Size of packet.
LookAheadStructure	ends
;
;***************************************************************\
;                                                               *
; Promiscuous Type Bit Definintions				*
;	(Passed into PromiscousChange IOCTL (EDX)		*
;                                                               *
;***************************************************************/
;
PROM_MODE_QUERY		equ	00000000h	; Query as to promiscuous mode
PROM_MODE_MAC		equ	00000001h	; MAC frames
PROM_MODE_NON_MAC	equ	00000002h	; Non-MAC frames
PROM_MODE_MACANDNON	equ	00000003h	; Both MAC and Non-MAC frames
PROM_MODE_SMT		equ	00000004h	; FDDI SMT Type MAC frames
PROM_MODE_RMC		equ	00000008h	; Remote Multicast frames
;
;***************************************************************\
;                                                               *
; Rx Destination Address Type (First byte of RDriverWorkSpace).	*
;                                                               *
;***************************************************************/
;
ECB_DIRECT		equ	0000h		; Physical destination address.
ECB_MULTICAST		equ	0001h		; Multicast destination address.
ECB_BROADCAST		equ	0002h		; Broadcast destination address.
ECB_REMOTE_UNICAST	equ	0004h		; Remote Unicast dest addr.
ECB_REMOTE_MULTICAST	equ	0008h		; Remote Multicast dest addr.
ECB_NO_SROUTE		equ	0010h		; ROUTE.NLM not loaded.
ECB_GLOBAL_ERROR	equ	0020h		; Global receive errors.
ECB_MAC_FRAME		equ	0040h		; MAC or SMT frames.
ECB_REG_DIRECT		equ	0080h		; Register for Direct frames.
ECB_PROMISCUOUS		equ	ECB_REG_DIRECT OR ECB_MULTICAST OR ECB_BROADCAST OR ECB_REMOTE_UNICAST OR ECB_REMOTE_MULTICAST OR ECB_NO_SROUTE

RAW_SEND		equ	0FFFFH		; Raw send if in RLogicalID.

RAW_SEND_PRIORITY_0	equ     0FFFFh          ; No Priority(same as RAW_SEND)
RAW_SEND_PRIORITY_1     equ     0FFFEh          ; Scale 1-7, 1 being lowest
RAW_SEND_PRIORITY_2	equ     0FFFDh
RAW_SEND_PRIORITY_3     equ     0FFFCh
RAW_SEND_PRIORITY_4     equ     0FFFBh
RAW_SEND_PRIORITY_5     equ     0FFFAh
RAW_SEND_PRIORITY_6     equ     0FFF9h
RAW_SEND_PRIORITY_7     equ     0FFF8h          ; Scale 1-7, 7 Highest Priority

SEND_PRIORITY_0       equ     0FFF7h  ; No Priority
SEND_PRIORITY_1       equ     0FFF6h	; Scale 1-7, 1 is low priority
SEND_PRIORITY_2       equ     0FFF5h
SEND_PRIORITY_3       equ     0FFF4h
SEND_PRIORITY_4       equ     0FFF3h
SEND_PRIORITY_5       equ     0FFF2h
SEND_PRIORITY_6       equ     0FFF1h
SEND_PRIORITY_7       equ     0FFF0h	; Scale 1-7, 7 is Highest Priority.

;
;***************************************************************\
;                                                               *
; 802.2 equates.						*
;                                                               *
;***************************************************************/
;
S_OR_U_FORMAT	equ	00000001b		; S or U-Format PDU.
U_FORMAT	equ	00000010b		; U-Format PDU.
TYPE_2_FLAG	equ	80000000h		; Type 2 flag.
RX_NOT_8022	equ	0			; Non 802.2 packet.
RX_8022_TYPE1	equ	1			; 802.2 Type 1 packet.
RX_8022_TYPE2	equ	2			; 802.2 Type 2 packet.
;
;***************************************************************\
;                                                               *
; Driver Configuration structure.				*
;                                                               *
;***************************************************************/
;

MLIDConfigurationStructure	struc
	MLIDCFG_Signature	db	'HardwareDriverMLID        '
	MLIDCFG_MajorVersion	db	1
	MLIDCFG_MinorVersion	db	14
	MLIDNodeAddress		db	6 dup (0FFh)
	MLIDModeFlags		dw	0
	MLIDBoardNumber		dw	0
	MLIDBoardInstance	dw	0
	MLIDMaximumSize		dd	0
	MLIDMaxRecvSize		dd	0
	MLIDRecvSize		dd	0
	MLIDCardName		dd	0
	MLIDShortName		dd	0
	MLIDFrameType		dd	0
	MLIDReserved0		dw	0
	MLIDFrameID		dw	0
	MLIDTransportTime	dw	1
	MLIDRouteHandler	dd	0
	MLIDLineSpeed		dw	10
	MLIDLookAheadSize	dw	0

	MLIDCFG_SGCount		db	0		;min value is 2
	MLIDReserved1           db	0
	MLIDPrioritySup         dw	0
	MLIDReserved2           dd	0

	MLIDMajorVersion	db	0
	MLIDMinorVersion	db	0
	MLIDFlags		dw	0
	MLIDSendRetries		dw	0
	MLIDLink		dd	0
	MLIDSharingFlags	dw	0	
	MLIDSlot		dw	0FFFFh
	MLIDIOPortsAndLengths	dw	4 dup (0)
	MLIDMemoryDecode0	dd	0
	MLIDLength0		dw	0	; In Paragraphs
	MLIDMemoryDecode1	dd	0
	MLIDLength1		dw	0
	MLIDInterrupt		db	2 dup (0FFh)
	MLIDDMAUsage		db	2 dup (0FFh)
	MLIDResourceTag		dd	0
	MLIDConfig		dd	0
	MLIDCommandString	dd	0
	MLIDLogicalName		db	18 dup (0)
	MLIDLinearMemory0	dd	0
	MLIDLinearMemory1	dd	0
	MLIDChannelNumber	dw	0
        MLIDBusTag              dd      0
        MLIDIOCfgMajorVersion   db      0
        MLIDIOCfgMinorVersion   db      0
MLIDConfigurationStructure	ends

;*************************************************************
;
;	Driver's IO Configuration Structure
;
;*************************************************************

IOConfig			struc
	IO_Link			dd	0
	IO_SharingFlags		dw	0	
	IO_Slot			dw	0

	IO_IOPort0		dw	0
	IO_IORange0		dw	0
	IO_IOPort1		dw	0
	IO_IORange1		dw	0

	IO_MemoryDecode0	dd	0
	IO_Length0		dw	0
	IO_MemoryDecode1	dd	0
	IO_Length1		dw	0

	IO_Interrupt0		db	0
	IO_Interrupt1		db	0
	IO_DMALine0		db	0
	IO_DMALine1		db	0	

	IO_ResourceTag		dd	0
	IO_Config		dd	0
	IO_CommandString	dd	0
	IO_LogicalName		db	18 dup (0)

	IO_LinearMemory0	dd	0
	IO_LinearMemory1	dd	0

	IO_ChannelNumber	dw	0
	IO_BusTag		dd	0
	IO_ConfigMajorVer	db	0
	IO_ConfigMinorVer  	db	0
IOConfig			ends

;
;***************************************************************\
;                                                               *
; MLIDModeFlags Bit definitions.				*
;                                                               *
;***************************************************************/
;
RealDriverBit			equ	1h	; Bit 0.
DriverUsesDMABit		equ	2h	; Bit 1.
DriverIs100PercentReliableBit	equ	4h	; Bit 2.
DriverSupportsMulticastBit	equ	8h	; Bit 3.
DriverIsWANBit			equ	10h	; Bit 4.
DriverNeedsPollingBit		equ	20h	; Bit 5.
DriverSupportsRawModeBit	equ	40h 	; Bit 6.
DriverSupportsSMPBit            equ     100h    ; Bit 8.
DriverSupportsRxFrags		equ	0400h	; Bit 10.
DriverSupportsPhysFrags		equ	1000h	; Bit 12.
DriverSupportsPromiscuousBit	equ	2000h	; Bit 13.
DriverNonCanonical		equ	4000h	; Bit 14.
DriverLSBMSBConfigurable	equ	8000h	; Bit 15.
;
;***************************************************************\
;                                                               *
; MLIDFlags Bit definitions.					*
;                                                               *
;***************************************************************/
;
OEMDriverBit			equ	8000h
MF_ECB_AUX_SUP_BIT      equ 2000h 					; driver supports aux data
DriverSupportsAuxBit	equ	MF_ECB_AUX_SUP_BIT		; driver supports aux data
PrioritySupBit          equ 1000h   ; Bit 12  LON
HUBDriverBit			equ	0100h
FilterMulticastBit		equ	0200h
GroupAddressingBit		equ	0400h
MCABusBit			equ	0004h
ISABusBit			equ	0002h
EISABusBit			equ	0001h

;
;***************************************************************\
;                                                               *
; MLIDSharingFlags Bit definitions.				*
;                                                               *
;***************************************************************/
;
IODetachedBit			equ	1h
IOSharePort0Bit			equ	2h
IOSharePort1Bit			equ	4h
IOShareMemory0Bit		equ	8h
IOShareMemory1Bit		equ	10h
IOShareInterrupt0Bit		equ	20h
IOShareInterrupt1Bit		equ	40h
IOShareDMA0Bit			equ	80h
IOShareDMA1Bit			equ	100h
; The driver has it's own command line info to put in the .NCF file
IOHasCommandLineInfo		equ	200h
; The driver doesn't want any of the default info put in the .NCF file
IODontDefaultCommandLine	equ	400h
	page
;
;***************************************************************\
;                                                               *
; ParseDriverParameters NeedsIO bit definitions.		*
;                                                               *
;***************************************************************/
;
NeedsIOSlotBit		equ	1h
NeedsIOPort0Bit		equ	2h
NeedsIOLength0Bit	equ	4h
NeedsIOPort1Bit		equ	8h
NeedsIOLength1Bit	equ	10h
NeedsMemoryDecode0Bit	equ	20h
NeedsMemoryLength0Bit	equ	40h
NeedsMemoryDecode1Bit	equ	80h
NeedsMemoryLength1Bit	equ	100h
NeedsInterrupt0Bit	equ	200h
NeedsInterrupt1Bit	equ	400h
NeedsDMA0Bit		equ	800h
NeedsDMA1Bit		equ	1000h
NeedsChannelBit		equ	2000h
CAN_SET_NODE_ADDRESS	equ	40000000h
MUST_SET_NODE_ADDRESS	equ	80000000h
;
;***************************************************************\
;                                                               *
; Structure required by ParseDriverParameters.			*
;                                                               *
;***************************************************************/
;
AdapterOptionDefinitionStructure	struc
	IOSlot		dd	0
	IOPort0		dd	0
	IOLength0	dd	0
	IOPort1		dd	0
	IOLength1	dd	0
	MemoryDecode0	dd	0
	MemoryLength0	dd	0
	MemoryDecode1	dd	0
	MemoryLength1	dd	0
	Interrupt0	dd	0
	Interrupt1	dd	0
	DMA0		dd	0
	DMA1		dd	0
	Channel		dd	0
AdapterOptionDefinitionStructure	ends
;
;***************************************************************\
;                                                               *
; Look ahead size equates.					*
;                                                               *
;***************************************************************/
;
DEFAULT_LOOK_AHEAD	equ	18
MAX_LOOK_AHEAD		equ	128
;
;***************************************************************\
;                                                               *
; Equates for Custom Keyword Types.				*
;                                                               *
;***************************************************************/
;
T_REQUIRED		equ	8000h		; Keyword must be entered.
T_STRING		equ	0100h		; String input(default).
T_NUMBER		equ	0200h		; Dword Decimal input.
T_HEX_NUMBER		equ	0300h		; Dword Hex input.
T_HEX_STRING		equ	0400h		; 6-byte hex string input.

UnsignedLongType	struc
	LongMinValue		dd	0	; Minimum value.
	LongMaxValue		dd	0	; Maximum value.
	LongDefaultString	dd	0	; Default string.
	LongValidString		dd	0	; Valid input string.
	LongPromptString	dd	0	; Prompt string.
UnsignedLongType	ends

SixByteType	struc
	SixByteMinValue		db	6 dup (0)	; Minimum value.
	SixByteMaxValue		db	6 dup (0)	; Maximum value.
	SixByteDefaultString	dd	0		; Default string.
	SixBytePromptString	dd	0		; Prompt string.
SixByteType	ends
;
;***************************************************************\
;                                                               *
; GetHardwareBusType return codes.				*
; also used by MSMSearchAdapter                                 *
;                                                               *
;***************************************************************/
;
ISA_BUS			equ	0
MCA_BUS                 equ	1
EISA_BUS		equ	2
PCMCIA_BUS              equ     3
PCI_BUS                 equ     4
VESA_BUS                equ     5
;
;***************************************************************\
;                                                               *
;	MLID Statistics Table (Move to ODI.INC)			*
;                                                               *
;***************************************************************/
;
MLIDStatStructure	struc
	MStatTableMajorVer	db	?
	MStatTableMinorVer	db	?
	MNumGenericCounters	dw	?
	MValidCounterMask0	dd	?
	MTotalTxPackets		dd	?
	MTotalRxPackets		dd	?
	MNoECBsAvailable	dd	?
	MTxTooBig		dd	?
	MTxTooSmall		dd	?
	MRxOverflow		dd	?
	MRxTooBig		dd	?
	MRxTooSmall		dd	?
	MTxMiscError		dd	?
	MRxMiscError		dd	?
	MTxRetryCount		dd	?
	MRxChecksumError	dd	?
	MRxMismatchError	dd	?
	MTotalTxOKByteLow	dd	?
	MTotalTxOKByteHigh	dd	?
	MTotalRxOKByteLow	dd	?
	MTotalRxOKByteHigh	dd	?
	MTotalGroupAddrTx	dd	?
	MTotalGroupAddrRx	dd	?
	MAdapterReset		dd	?
	MAdapterOprTimeStamp	dd	?
	MQDepth			dd	?
	MediaStat0		dd	?
	MediaStat1		dd	?
	MediaStat2		dd	?
	MediaStat3		dd	?
	MediaStat4		dd	?
	MediaStat5		dd	?
	MediaStat6		dd	?
	MediaStat7		dd	?
	MediaStat8		dd	?
	MediaStat9		dd	?
	MValidCounterMask1	dd	?	; Added for stats v3.00.
	MediaStat10		dd	?
	MediaStat11		dd	?
	MediaStat12		dd	?
	MediaStat13		dd	?
MLIDStatStructure	ends
;
;***************************************************************\
;                                                               *
; Token-Ring Media Specific Counters.				*
;                                                               *
;***************************************************************/
;
TRACErrorCount			equ	MediaStat0
TRAbortDelimiterCount		equ	MediaStat1
TRBurstErrorCount		equ	MediaStat2
TRFrameCopiedErrorCount		equ	MediaStat3
TRFrequencyErrorCount		equ	MediaStat4
TRInternalErrorCount		equ	MediaStat5
TRLastRingStatus		equ	MediaStat6
TRLineErrorCount		equ	MediaStat7
TRLostFrameCount		equ	MediaStat8
TRTokenErrorCount		equ	MediaStat9
TRUpstreamNodeHighDword		equ	MediaStat10
TRUpstreamNodeLowWord		equ	MediaStat11
TRLastRingID			equ	MediaStat12
TRLastBeaconType		equ	MediaStat13
;
;***************************************************************\
;                                                               *
; Ethernet Media Specific Counters.				*
;                                                               *
;***************************************************************/
;
ETxOKSingleCollisionsCount	equ	MediaStat0
ETxOKMultipleCollisionsCount	equ	MediaStat1
ETxOKButDeffered		equ	MediaStat2
ETxAbortLateCollision		equ	MediaStat3
ETxAbortExcessCollision		equ	MediaStat4
ETxAbortCarrierSense		equ	MediaStat5
ETxAbortExcessiveDeferral	equ	MediaStat6
ERxAbortFrameAligment		equ	MediaStat7
;
;***************************************************************\
;                                                               *
; FDDI Media Specific Counters.					*
;                                                               *
;***************************************************************/
;
FDDIConfigurationState		equ	MediaStat0
FDDIUpstreamNodeHiDword		equ	MediaStat1
FDDIUpstreamNodeLoWord		equ	MediaStat2
FDDIDownstreamNodeHiDword	equ	MediaStat3
FDDIDownstreamNodeLoWord	equ	MediaStat4
FDDIFrameErrorCount		equ	MediaStat5
FDDIFramesLostCount		equ	MediaStat6
FDDIRingManagementState		equ	MediaStat7
FDDILCTFailureCount		equ	MediaStat8
FDDILemRejectCount		equ	MediaStat9
FDDILemCount			equ	MediaStat10
FDDIConnectionState		equ	MediaStat11
;
;***************************************************************\
;                                                               *
; RXNet Media Specific Counters.				*
;                                                               *
;***************************************************************/
;
RNoResponseToFreeBufferEnquiry	equ	MediaStat0
RNetworkReconfigurationCount	equ	MediaStat1
RInvalidSplitFlagInPacketFrag	equ	MediaStat2
ROrphanPacketFragmentCount	equ	MediaStat3
RReceivePacketTimeout		equ	MediaStat4
RFreeBufferEnquiryNAKTimeout	equ	MediaStat5
RTotalTxPacketFragmentsOK	equ	MediaStat6
RTotalRxPacketFragmentsOK	equ	MediaStat7
;
;***************************************************************\
;                                                               *
; PC-Network II (PCNII) Media Specific Counters.		*
;                                                               *
;***************************************************************/
;
PTxOKSingleCollisionsCount	equ	MediaStat0
PTxOKMultipleCollisionsCount	equ	MediaStat1
PTxOKButDeferred		equ	MediaStat2
PTxAbortExcessCollision		equ	MediaStat3
PTxAbortCarrierSense		equ	MediaStat4
PRxBadFrameAlignment		equ	MediaStat5
;
;***************************************************************\
;                                                               *
; Real Mode Interrupt structures.				*
;                                                               *
;***************************************************************/
;
InputParametersStructure	struc
	IAXRegister	dw	?
	IBXRegister	dw	?
	ICXRegister	dw	?
	IDXRegister	dw	?
	IBPRegister	dw	?
	ISIRegister	dw	?
	IDIRegister	dw	?
	IDSRegister	dw	?
	IESRegister	dw	?
	IIntNumber	dw	?
InputParametersStructure	ends


OutputParametersStructure	struc
	OAXRegister	dw	?
	OBXRegister	dw	?
	OCXRegister	dw	?
	ODXRegister	dw	?
	OBPRegister	dw	?
	OSIRegister	dw	?
	ODIRegister	dw	?
	ODSRegister	dw	?
	OESRegister	dw	?
	OFlags		dw	?
OutputParametersStructure	ends

InputParametersStructure32	struc
	IEAXReg		dd	?
	IEBXReg		dd	?
	IECXReg		dd	?
	IEDXReg		dd	?
	IEBPReg		dd	?
	IESIReg		dd	?
	IEDIReg		dd	?
	IDSReg		dw	?
	IESReg		dw	?
	IFSReg		dw	?
	IGSReg		dw	?
	IEIntNumber	db	?
	IDummy32	db	3 dup (?)  ;Never misalign the stack
InputParametersStructure32	ends

OutputParametersStructure32	struc
	OEAXReg		dd	?
	OEBXReg		dd	?
	OECXReg		dd	?
	OEDXReg		dd	?
	OEBPReg		dd	?
	OESIReg		dd	?
	OEDIReg		dd	?
	ODSReg		dw	?
	OESReg		dw	?
	OFSReg		dw	?
	OGSReg		dw	?
	OFlags32	dd	?
OutputParametersStructure32	ends

RealModeStructureSize equ 2 * 4 + SIZE InputParametersStructure + SIZE OutputParametersStructure
RealModeStructureSize32 equ 2 * 4 + SIZE InputParametersStructure32 + SIZE OutputParametersStructure32

;
;***************************************************************\
;                                                               *
; PCI Bus FUNCTION # and Return code equates.    		*
;                                                               *
;***************************************************************/
;
PCI_FUNCTION_ID         equ     0b1h    ; placed in AH register.
PCI_BIOS_PRESENT        equ     001h    ; placed in AL register.
FIND_PCI_DEVICE         equ     002h    ; placed in AL register.
FIND_PCI_CLASS_CODE     equ     003h    ; placed in AL register.
GENERATE_SPECIAL_CYCLE  equ     006h    ; placed in AL register.
READ_CONFIG_BYTE        equ     008h    ; placed in AL register.
READ_CONFIG_WORD        equ     009h    ; placed in AL register.
READ_CONFIG_DWORD       equ     00ah    ; placed in AL register.
WRITE_CONFIG_BYTE       equ     00bh    ; placed in AL register.
WRITE_CONFIG_WORD       equ     00ch    ; placed in AL register.
WRITE_CONFIG_DWORD      equ     00dh    ; placed in AL register.
GET_IRQ_ROUTING_OPTIONS	equ	00eh	; placed in AL register.
SET_PCI_IRQ		equ	00fh	; placed in AL register.


PCI_SUCCESSFUL          equ     000h    ; PCI defined error code.
PCI_FUNC_NOT_SUPPORTED  equ     081h    ; PCI defined error code.
PCI_BAD_VENDOR_ID       equ     083h    ; PCI defined error code.
PCI_DEVICE_NOT_FOUND    equ     086h    ; PCI defined error code.
PCI_BAD_REGISTER_NUMBER equ     087h    ; PCI defined error code.
PCI_SET_FAILED		equ	088h	; PCI defined error code.
PCI_BUFFER_TOO_SMALL	equ	089h	; PCI defined error code.


PCI_DEV_VENDOR_ID       equ     00h     ; PCI defined structure offset.
PCI_STATUS_COMMAND      equ     04h     ; PCI defined structure offset.
PCI_CLASS_REVISION      equ     08h     ; PCI defined structure offset.
PCI_MISCELLANEOUS       equ     0ch     ; PCI defined structure offset.
PCI_BASE_ADDRESS_REG    equ     10h     ; PCI defined structure offset.
PCI_RESERVED1           equ     28h     ; PCI defined structure offset.
PCI_RESERVED2           equ     2ch     ; PCI defined structure offset.
PCI_ROM_BASE            equ     30h     ; PCI defined structure offset.
PCI_RESERVED3           equ     34h     ; PCI defined structure offset.
PCI_RESERVED4           equ     38h     ; PCI defined structure offset.
PCI_IRQ                 equ     3ch     ; PCI defined structure offset.
PCI_DEVICE_SPECIFIC     equ     40h     ; PCI defined structure offset.

PCI_DEVICES             equ     10h     ; default to this many devices
PCI_BASE_SIZE           equ     24      ; size of base address fields
PCI_DEVICE_SPEC_SIZE    equ     192     ; size of device specific fields


;Structure definition for layout of PCI Bios v2.1 IRQ Routing Table entry.

PCI_IRQRouteTableStruc	struc
	PCIIRQT_BusNumber	db	0	; Bus Number
	PCIIRQT_DeviceNumber	db	0	; Device Number (Upper 5 bits)
	PCIIRQT_LV_INTA		db	0	; Link Value INTA
	PCIIRQT_IRQ_BMap_INTA	dw	0	; IRQ Bit Map for INTA
	PCIIRQT_LV_INTB		db	0	; Link Value INTB
	PCIIRQT_IRQ_BMap_INTB	dw	0	; IRQ Bit Map for INTB
	PCIIRQT_LV_INTC		db	0	; Link Value INTC
	PCIIRQT_IRQ_BMap_INTC	dw	0	; IRQ Bit Map for INTC
	PCIIRQT_LV_INTD		db	0	; Link Value INTD
	PCIIRQT_IRQ_BMap_INTD	dw	0	; IRQ Bit Map for INTD
	PCIIRQT_SlotNumber	db	0	; Slot Number
	PCIIRQT_Reserved	db	0	; Reserved

PCI_IRQRouteTableStruc	ends



;***************************************************************\
;                                                               *
; PlugNPlay address port assignments                            *
;                                                               *
;***************************************************************/
;
PNP_ADDRESS_PORT        equ     0279h        
PNP_WRITE_DATA_PORT     equ     0a79h   

PNP_READ_DATA_PORT      equ     0203h           ; 200h to 3ffh

PNP_LFSR_INIT_VALUE     equ     06ah

PNP_READ_DATA_REG       equ     000h
PNP_CFG_CTRL_REG        equ     002h
PNP_WAKE_CSN_REG        equ     003h
PNP_RESOURCE_REG        equ     004h
PNP_STATUS_REG          equ     005h
PNP_LOG_DEV_REG         equ     007h

PNP_CFG_CTRL_WFK        equ     002h

MAX_MEM_REGS            equ     9
MAX_IO_PORTS            equ     20
MAX_IRQS                equ     7
MAX_DMAS                equ     7
MAX_VDS                 equ     256

MAX_EISA_MEM_REGS       equ     9
MAX_EISA_IO_PORTS       equ     20
MAX_EISA_IRQS           equ     7
MAX_EISA_DMAS           equ     4
;
;***************************************************************\
;                                                               *
; PS/2 MicroChannel equates                                     *
;                                                               *
;***************************************************************/
;
MCA_TOTAL_SLOTS         equ     10h
MCA_SLOT_SELECT_REG     equ     096h
MCA_POS0                equ     100h
MCA_POS1                equ     101h
MCA_POS2                equ     102h
;
;***************************************************************\
;                                                               *
; EISA equates                                                  *
;                                                               *
;***************************************************************/
;
EISA_TOTAL_SLOTS        equ     15
EISA_SLOT_0             equ     00c80h
EISA_SLOT_MASK          equ     0fff0h
EISA_NEXT_SLOT          equ     01000h

EISA_FUNC_OFFSET        equ     022h
EISA_ASCII_OFFSET       equ     023h
EISA_MEM_OFFSET         equ     073h
EISA_INT_OFFSET         equ     0b2h
EISA_DMA_OFFSET         equ     0c0h
EISA_PORT_OFFSET        equ     0c8h
EISA_INIT_OFFSET        equ     0104h

EISA_LAST_ENTRY         equ     080h

EISA_ASCII_ENTRY        equ     00000001b
EISA_MEMORY_ENTRY       equ     00000010b
EISA_INT_ENTRY          equ     00000100b
EISA_DMA_ENTRY          equ     00001000b
EISA_PORT_ENTRY         equ     00010000b
EISA_INIT_ENTRY         equ     00100000b
EISA_FREE_FORM          equ     01000000b

EISA_IRQ_MORE_BIT	equ	10000000b ; More interrupts in list if set
EISA_IRQ_SHARED_BIT	equ	01000000b ; Interrupt may be shared if set
EISA_IRQ_EL_BIT		equ	00100000b ; IRQ Edge/Level Configuration Bit
					  ;  Set=> Level Trigger

;
;***************************************************************\
;                                                               *
; PlugNPlay address port assignments                            *
;                                                               *
;***************************************************************/
;
PNPConfigStructure      struc

PNPBusID                dd      ?
PNPDeviceID             dd      ?
PNPSerialNumber         dd      ?
PNPLogicalID            dd      ?
PNPFlags                dd      ?
PNPCSN                  db      ?
PNPLogicalDevNum        db      ?
PNPReadDataPort         dw      ?
PNPNumMemWindows        dw      ?
PNPMemBase              dd      MAX_MEM_REGS dup (?)
PNPMemLength            dd      MAX_MEM_REGS dup (?)
PNPMemAttrib            dw      MAX_MEM_REGS dup (?)
PNPNumIOPorts           dw      ?
PNPIOPortBase           dw      MAX_IO_PORTS dup (?)
PNPIOPortLength         db      MAX_IO_PORTS dup (?)
PNPNumIRQs              dw      ?
PNPIRQRegisters         db      MAX_IRQS dup (?)
PNPIRQAttrib            db      MAX_IRQS dup (?)
PNPNumDMAs              dw      ?
PNPDMAList              db      MAX_DMAS dup (?)
PNPDMAAttrib            dw      MAX_DMAS dup (?)
PNPVendorDefined        db      MAX_VDS dup (?)

PNPConfigStructure      ends
;
;***************************************************************\
;                                                               *
; MSMSearchAdapter completion codes                             *
;                                                               *
;***************************************************************/
;
SA_SUCCESSFUL           equ     000h    ; Search Adapter successful
SA_ADAPTER_NOT_FOUND    equ     001h    ; Device/VendorID didn't match cards
SA_BUS_NOT_FOUND        equ     002h    ; The bus was not detected
SA_SERVICES_NOT_FOUND   equ     003h    ; The requested service was N/A
SA_INVALID_BUS_TYPE     equ     004h    ; The requested bus type was bogus
SA_INVALID_SLOT_NUMBER  equ     005h    ; The requested slot was bogus
SA_BAD_REAL_MODE_INT    equ     006h    ; The real mode int was unsuccessful
SA_MISC_ERROR           equ     007h    ; Miscellaneous errors

;***************************************************************\
;                                                               *
; Interrupt Controller equates.					*
;                                                               *
;***************************************************************/
;
InterruptControlRegister	equ	20h
InterruptMaskRegister		equ	21h
ATInterruptControlRegister	equ	0A0h
ATInterruptMaskRegister		equ	0A1h

EOI				equ	20h
	page
;
;***************************************************************\
;                                                               *
; C Language Stack Save/Stack Frame macros.			*
;                                                               *
;***************************************************************/
;
CPush	macro

	push	ebp
	push	ebx
	push	esi
	push	edi

	endm

CPop	macro

	pop	edi
	pop	esi
	pop	ebx
	pop	ebp

	endm

ParmOffset	equ	20
Parm0		equ	ParmOffset + 0
Parm1		equ	ParmOffset + 4
Parm2		equ	ParmOffset + 8
Parm3		equ	ParmOffset + 12
Parm4		equ	ParmOffset + 16
Parm5		equ	ParmOffset + 20
Parm6		equ	ParmOffset + 24
Parm7		equ	ParmOffset + 28
Parm8		equ	ParmOffset + 32
Parm9		equ	ParmOffset + 36
Parm10		equ	ParmOffset + 40
Parm11		equ	ParmOffset + 44
Parm12		equ	ParmOffset + 48
Parm13		equ	ParmOffset + 52
Parm14		equ	ParmOffset + 56
Parm15		equ	ParmOffset + 60
	page
;
;***************************************************************\
;                                                               *
; LSL Error Codes.						*
;                                                               *
;***************************************************************/
;
BadCommand		equ	0FFFFFF81h
BadParameters		equ	0FFFFFF82h
Cancelled		equ	0FFFFFFFCh
DuplicateEntry		equ	0FFFFFF83h
Fail			equ	0FFFFFF84h
ItemNotPresent		equ	0FFFFFF85h
NoMoreItems		equ	0FFFFFF86h
NoSuchDriver		equ	0FFFFFF87h
NoSuchHandles		equ	0FFFFFF88h
OutOfResources		equ	0FFFFFF89h
RxOverflow		equ	0FFFFFF8Ah
InCriticalSection	equ	0FFFFFF8Bh
TransmitFailed		equ	0FFFFFF8Ch
PacketUndeliverable	equ	0FFFFFF8Dh

;NOTE: any changes to these return codes should be reflected
; in the ODISTAT_ return codes below also.

SUCCESSFUL              equ	0h
RESPONSE_DELAYED	equ	1
BUS_SPECIFIC_ERROR equ 9
BAD_COMMAND 		equ	0FFFFFF81h
BAD_PARAMETERS		equ	0FFFFFF82h
BAD_PARAMETER		equ	0FFFFFF82h
CANCELLED   		equ	0FFFFFFFCh
DUPLICATE_ENTRY		equ	0FFFFFF83h
FAIL    		equ	0FFFFFF84h
ITEM_NOT_PRESENT	equ	0FFFFFF85h
NO_MORE_ITEMS		equ	0FFFFFF86h
NO_SUCH_DRIVER		equ	0FFFFFF87h
NO_SUCH_HANDLES		equ	0FFFFFF88h
OUT_OF_RESOURCES	equ	0FFFFFF89h
RX_OVERFLOW 	    	equ	0FFFFFF8Ah
IN_CRITICAL_SECTION 	equ	0FFFFFF8Bh
TRANSMIT_FAILED		equ	0FFFFFF8Ch
PACKET_UNDELIVERABLE	equ	0FFFFFF8Dh

;NOTE: any changes to the ODISTAT_ return codes should be reflected
; in the return codes above also.

ODISTAT_SUCCESSFUL		equ	0
ODISTAT_RESPONSE_DELAYED	equ	1
ODISTAT_SUCCESS_TAKEN		equ	2
ODISTAT_BUS_SPECIFIC_ERROR equ 9
ODISTAT_BAD_COMMAND		equ	-127
ODISTAT_BAD_PARAMETER		equ	-126
ODISTAT_DUPLICATE_ENTRY		equ	-125
ODISTAT_FAIL			equ	-124
ODISTAT_ITEM_NOT_PRESENT	equ	-123
ODISTAT_NO_MORE_ITEMS		equ	-122
ODISTAT_MLID_SHUTDOWN		equ	-121
ODISTAT_NO_SUCH_HANDLER		equ	-120
ODISTAT_OUT_OF_RESOURCES	equ	-119
ODISTAT_RX_OVERFLOW		equ	-118
ODISTAT_IN_CRITICAL_SECTION	equ	-117
ODISTAT_TRANSMIT_FAILED		equ	-116
ODISTAT_PACKET_UNDELIVERABLE	equ	-115
ODISTAT_CANCELED		equ	-4

ODISTAT_NO_SUCH_DRIVER equ ODISTAT_MLID_SHUTDOWN
;
;***************************************************************\
;                                                               *
; Alert Notification bit definitions.                           *
;                                                               *
;***************************************************************/
;
NOTIFY_CONNECTION_BIT	equ	1h
NOTIFY_EVERYONE_BIT	equ	2h
NOTIFY_ERROR_LOG_BIT	equ	4h
NOTIFY_CONSOLE_BIT	equ	8h
DONT_NOTIFY_NMAGENT	equ	80000000h
;
;***************************************************************\
;                                                               *
; Alert LOCUS bit used by MLID's.				*
;                                                               *
;***************************************************************/
;
LOCUS_LANBOARDS		equ	4
	page
;
;***************************************************************\
;                                                               *
; Alert ERROR CLASSES definition bits.				*
;                                                               *
;***************************************************************/
;
CLASS_UNKNOWN			equ	0
CLASS_OUT_OF_RESOURCE		equ	1
CLASS_TEMP_SITUATION		equ	2
CLASS_AUTHORIZATION_FAILURE	equ	3
CLASS_INTERNAL_ERROR		equ	4
CLASS_HARDWARE_FAILURE		equ	5
CLASS_SYSTEM_FAILURE		equ	6
CLASS_REQUEST_ERROR		equ	7
CLASS_NOT_FOUND			equ	8
CLASS_BAD_FORMAT		equ	9
CLASS_LOCKED			equ	10
CLASS_MEDIA_FAILURE		equ	11
CLASS_ITEM_EXISTS		equ	12
CLASS_STATION_FAILURE		equ	13
CLASS_LIMIT_EXCEEDED		equ	14
CLASS_CONFIGURATION_ERROR	equ	15
CLASS_LIMIT_ALMOST_EXCEEDED	equ	16
CLASS_SECURITY_AUDIT_INFO	equ	17
CLASS_DISK_INFORMATION		equ	18
CLASS_GENERAL_INFORMATION	equ	19
;
;***************************************************************\
;                                                               *
; Alert ERROR SEVERITY LEVELS.					*
;                                                               *
;***************************************************************/
;
SEVERITY_INFORMATIONAL		equ	0	; Counters or Gauges reached thresholds 
SEVERITY_WARNING		equ	1	; Configuration errors, etc. No Damage 
SEVERITY_RECOVERABLE		equ	2	; Hot Fix disk, etc. Work-around made 
SEVERITY_CRITICAL		equ	3	; Disk Mirror failure, etc. Fix-up attempted 
SEVERITY_FATAL			equ	4	; Resource fatally affected--shut down 
SEVERITY_OPERATION_ABORTED	equ	5	; the operation cannot complete...ramifications unknown
;
;***************************************************************\
;                                                               *
; Network Management Alert Flags.				*
;                                                               *
;***************************************************************/
;
QueueThisAlertMask		equ	00000001h
AlertIDValidMask		equ	00000002h
AlertLocusValidMask		equ	00000004h
AlertEventNotifyOnlyMask	equ	00000008h
AlertNoEventNotifyMask		equ	00000010h
AlertMessageNumberValid		equ	00010000h
OldStyleSystemAlertMask		equ	01000000h
OldStyleINWSystemAlertMask	equ	02000000h
TargetStationIsAPointer		equ	80000000h
;
;***************************************************************\
;                                                               *
; Alert ID codes.						*
;                                                               *
;***************************************************************/
;
ALERT_OS			equ	01030000h
ALERT_BINDERY			equ	01020000h
ALERT_LLC			equ	01040000h
ALERT_SDLC			equ	01050000h
ALERT_REMOTE			equ	01060000h
ALERT_MLID			equ	01070000h
;
;***************************************************************\
;                                                               *
; Event types used by MLID's.					*
;                                                               *
;***************************************************************/
;
EVENT_DOWN_SERVER		equ	4
EVENT_CHANGE_TO_REAL_MODE	equ	5
EVENT_RETURN_FROM_REAL_MODE	equ	6
EVENT_EXIT_TO_DOS		equ	7
;
;***************************************************************\
;                                                               *
; Event priority levels(lower priorities notified first).	*
;                                                               *
;***************************************************************/
;
EVENT_PRIORITY_OS		equ	0
EVENT_PRIORITY_APPLICATION	equ	20
EVENT_PRIORITY_DEVICE		equ	40
;
;***************************************************************\
;                                                               *
; Load Module Structure.					*
;                                                               *
;***************************************************************/
;
LoadDefinitionStructure			struc

LDLink				dd	?
LDKillLink			dd	?
LDScanLink			dd	?
LDResourceList			dd	?
LDMemoryOffset			dd	?
LDCodeImageOffset		dd	?
LDCodeImageLength		dd	?
LDDataImageOffset		dd	?
LDDataImageLength		dd	?
LDUninitializedDataLength	dd	?
LDCustomDataOffset		dd	?
LDCustomDataSize		dd	?
LDFlags				dd	?
LDType				dd	?
LDInitializationProcedure	dd	?
LDExitProcedure			dd	?
LDCheckUnloadProcedure		dd	?
LDPublics			dd	?
LDFileName			db	36 dup (?)
LDName				db	128 dup (?)
LDCLIBLoadStructure		dd	?
LDNLMDebugger			dd	?
LDSemiPermMemoryPool		dd	2 dup (?)
LDAllocatedMemoryList		dd	?
LDAllocMemoryHeaderPointer	dd	?
LDModuleObjectHandle		dd	?
LDMajorVersion			dd	?
LDMinorVersion			dd	?
LDRevision			dd	?
LDYear				dd	?
LDMonth				dd	?
LDDay				dd	?
LDCopyright			dd	?
LDNumberOfReferencedPublics	dd	?
LDReferencedPublics		dd	?	; NOTE: LDReferencedPublics 
						; must be the last item in 
						; this structure!
LoadDefinitionStructure		ends
;
;***************************************************************\
;                                                               *
; MSMCanonicalMode flag for media modules.			*
; These bits are set by MSMRegisterTSM.				*
;                                                               *
;	Bit 0 = 1 &						*
;	Bit 1 = 0 if LSB override on command line.		*
;                                                               *
;	Bit 0 = 1 &						*
;	Bit 1 = 1 if MSB override on command line.		*
;                                                               *
;	Bit 2 = 1 &						*
;	Bit 3 = 0 if NODE=xxxxL on command line.		*
;                                                               *
;	Bit 2 = 1 &						*
;	Bit 3 = 1 if NODE=xxxxM on command line.		*
;                                                               *
;	Bit 4 = 1 if FDMODEOFF on command line.			*
;                                                               *
;***************************************************************/
;
CAN_OVERRIDE		equ	00000001b	; LSB or MSB override.
CAN_OVERRIDE_MSB	equ	00000010b	; MSB override.
NODE_CAN_OVERRIDE	equ	00000100b	; L or M node override.
NODE_CAN_OVERRIDE_MSB	equ	00001000b	; M node override.
FD_MODE_OFF		equ	00010000b	; Functional Swap off.
;
;***************************************************************\
;                                                               *
; Receive Monitor status equates.				*
;                                                               *
;***************************************************************/
;
RMON_ETHER_CRC		equ	00000001h	; Packet with CRC error.
RMON_ETHER_ALIGN	equ	00000002h	; Packet with CRC/Align error.
RMON_ETHER_RUNT		equ	00000004h	; Packet with Runt error.
RMON_TOO_BIG		equ	00000100h	; Packet Too Big.
RMON_NO_BOARD		equ	00000200h	; No logical board for packet.
RMON_MALFORMED		equ	00000400h	; Malformed packet received.
RMON_SHUTDOWN		equ	80000000h	; MLID shutting down.
RMON_NO_COMPRESS equ 00004000h	; Do not compress received packet
RMON_NONCAN_ADDR equ 00008000h	; Set if Addr. in Immediate Address field is noncanonical
;
;***************************************************************\
;                                                               *
; Spare ECB flags.						*
;                                                               *
;***************************************************************/
;
SPARE_ECB_STATUS	equ	0eeeeh		; Spare ECB flag.
;
;***************************************************************\
;                                                               *
; Bridging equates.						*
;                                                               *
;***************************************************************/
;
;
ECBMACType      equ     2aH     ; offset to store MACType in ECB
                                ; (same as ProtocolWorkspace)

ECBOffset       equ     16H     ; offset in "HUB Management" ECB

;
; Brouter Request Definitions
; ===========================
;

BrouterRequestCode      equ     ECBOffset + 0   ; WORD

;
; ------------------
; - BrouterSupport -
; ------------------
;
BrouterSupport          equ     0

BrouterSupportStatus    equ     ECBOffset + 2       ; LONG       
FilterTableSize         equ     ECBOffset + 6       ; LONG

;
; -------------------
; - SelectTBridging -
; -------------------
;
SelectTBridging         equ     1

TBServiceHandler        equ     ECBOffset + 2   ; LONG (pts to tb_receive)
                                        	; NULL means end T bridging
;
; --------------------
; - SelectSRBridging -
; --------------------
;
SelectSRBridging        equ     2

SRBServiceHandler       equ     ECBOffset + 2   ; LONG (pts to srb_receive)
                                                ; NULL means end SR bridging
SRPartitionSize         equ     ECBOffset + 6   ; BYTE, nr bits in BridgeNumber
SRFilterSTE             equ     ECBOffset + 7   ; BYTE, discard STE frames
SRMaximumRDSize         equ     ECBOffset + 8   ; BYTE, maximum length of RIF
SRRingInNumber          equ     ECBOffset + 10  ; WORD

                                                ; Following is LONG [16]
SRRingOutNumber         equ     ECBOffset + 12  ; WORD (0xffff terminates)
SRBridgeNumber          equ     ECBOffset + 14  ; WORD

;
; -------------------------
; - SelectPromiscuousMode -
; -------------------------
;
SelectPromiscuousMode   equ     3

PromiscuousModeType     equ     ECBOffset + 2   ; BYTE

PMTNone                 equ     0
PMTTransparent          equ     1
PMTSourceRouting        equ     2
PMTSRTransparent        equ     3

;
; ----------------------------
; - UpdateAddressFilterTable -
; ----------------------------
;
UpdateAddressFilterTable equ    4

FilterTableAction       equ     ECBOffset + 2   ; BYTE
FilterTableAddresses    equ     ECBOffset + 3   ; BYTE, nr addresses (except for clear)
FilterTableAddress1     equ     ECBOffset + 4   ; N (nr) 6 byte addresses

FTAClearTable           equ     0
FTAAddAddresses         equ     1
FTADeleteAddresses      equ     2


; ODI NBI Error Codes

ODI_NBI_SUCCESSFUL		          equ 0
ODI_NBI_PROTECTION_VIOLATION	  equ 1
ODI_NBI_HARDWARE_ERROR		      equ 2
ODI_NBI_MEMORY_ERROR		        equ 3
ODI_NBI_PARAMETER_ERROR		    equ 4
ODI_NBI_UNSUPPORTED_OPERATION	equ 5
ODI_NBI_ITEM_NOT_PRESENT	      equ 6
ODI_NBI_NO_MORE_ITEMS          equ 7
ODI_NBI_FAIL                   equ 8
ODI_NBI_BUS_SPECIFIC_ERROR     equ 9
ODI_NBI_PARENT_INSTANCE_NONEXIST equ -1,
ODI_NBI_NO_INSTANCE_AVAIL      equ -2
ODI_NBI_INSTANCE_NONEXIST      equ -3
ODI_NBI_NO_MEM                 equ -4
ODI_NBI_INTERNAL_ERR           equ -5
ODI_NBI_NEWINSTANCE_EXIST      equ -6
ODI_NBI_INVALID_FUNCTION       equ -8
ODI_NBI_NO_SLOTIDNAME_AVAIL    equ -10
ODI_NBI_NO_INSTANCENAME_AVAIL  equ -11
ODI_NBI_INSTANCE_NOT_SAVED     equ -12


; ODI Bus Types

ODI_BUSTYPE_ISA			equ	0
ODI_BUSTYPE_MCA			equ	1
ODI_BUSTYPE_EISA		equ	2
ODI_BUSTYPE_PCMCIA		equ	3
ODI_BUSTYPE_PCI			equ	4
ODI_BUSTYPE_VESA		equ	5
ODI_BUSTYPE_CARDBUS  equ 8

;MCD ANCS start

;**************************************************************************
;
;   Equates Specific to the ODI selective unload enhancements
;
;**************************************************************************

OP_SCOPE_ADAPTER       equ 0
OP_SCOPE_LOGICAL_BOARD equ 1

;MCD ANCS end


;;JRT 961115 begin

;**************************************************************************
;
;   NESL structures and constants
;
;**************************************************************************

; NESL Event Control Block
NESL_ECB                struc
  NESL_ECBNext          dd      ?       ; reserved, used to link event lists
  NESL_ECBVersion       dw      ?       ; 1
  NESL_ECBOSILayer      dw      ?       ; determines ordering of consumers
  NESL_ECBEventName     dd      ?       ; ptr to event name string
  NESL_ECBRefData       dd      ?       ; reserved, must be set to 0
  NESL_ECBNotifyProc    dd      ?       ; ptr to event notification procedure
  NESL_ECBOwner         dd      ?       ; Module Handle of owner of ECB
  NESL_ECBWorkSpace     dd      ?       ; reserved, must be set to 0
NESL_ECB                ends

; Event Parameter Block
EPB                     struc
  EPB_MajorVersion      dd      ?       ; 1
  EPB_MinorVersion      dd      ?       ; 0
  EPB_EventName         dd      ?       ; ptr to event name string
  EPB_EventType         dd      ?       ; ptr to event type string
  EPB_ModuleName        dd      ?       ; ptr to module name generating event
  EPB_DataPtr0          dd      ?       ; used by MSM to pass frame tbl ptr
  EPB_DataPtr1          dd      ?       ; event dependent information
  EPB_EventScope        dd      ?       ; HSM sets to EPB_SPECIFIC_EVENT
  EPB_Reserved          dd      ?       ; reserved, must be 0
EPB                     ends

; Major and Minor version numbers for current EPB structure
EPBMajVer                       equ     1
EPBMinVer                       equ     00

; values used for EPB_EventScope
EPB_GLOBAL_EVENT                equ     1
EPB_SPECIFIC_EVENT              equ     2

; Maximum length of NESL strings
NESL_MAX_NAME_LENGTH    	equ     81

; NESL procedure return status values
NESL_OK                         equ     0
NESL_EVENT_CONSUMED 	        equ     0
NESL_EVENT_NOT_CONSUMED         equ     1
NESL_EVENT_BROADCAST            equ     2
NESL_EVENT_NOT_REGISTERED       equ     3
NESL_EVENT_TABLE_FULL           equ     4
NESL_EVENT_IS_CONSUMABLE        equ     5
NESL_EVENT_IS_NOT_CONSUMABLE    equ     6
NESL_NO_MORE_EVENTS             equ     7
NESL_PRODUCER_NOT_FOUND         equ     8
NESL_CONSUMER_NOT_FOUND         equ     9
NESL_INVALID_CONTEXT_HANDLE     equ     10
NESL_INVALID_DESTINATION        equ     11
NESL_REGISTERED_UNIQUE          equ     12
NESL_REGISTERED_NOT_UNIQUE      equ     13
NESL_REGISTERED_CONSUMABLE      equ     14
NESL_REGISTERED_BROADCAST       equ     15
NESL_REGISTERED_SORT_TOP_DOWN   equ     16
NESL_REGISTERED_SORT_BOTTOM_UP  equ     17
NESL_DUPLICATE_NECB             equ     18
NESL_INVALID_NOTIFY_PROC        equ     19
NESL_FIRST_ALREADY_HOOKED       equ     20

; NESL_ECBRefData flags
NESL_NOT_UNIQUE_PRODUCER        equ     00000000h
NESL_BROADCAST_EVENT            equ     00000000h
NESL_SORT_CONSUMER_BOTTOM_UP    equ	00000001h
NESL_SORT_CONSUMER_TOP_DOWN     equ     00000000h
NESL_CONSUME_EVENT              equ	00000002h
NESL_UNIQUE_PRODUCER		equ	00000004h

; NESL_ECBVersion values
NESL_VERSION1                   equ     1
NESL_VERSION2                   equ     2

; NESL_ECBOSILayer values
NESL_APPLICATION_LAYER          equ     7000h
NESL_PRESENTATION_LAYER         equ     6000h
NESL_SESSION_LAYER              equ     5000h
NESL_TRANSPORT_LAYER            equ     4000h
NESL_NETWORK_LAYER              equ     3000h
NESL_DATALINK_LAYER             equ     2000h
NESL_PHYSICAL_LAYER             equ     1000h
NESL_NIOS_LAYER                 equ     0000h

;;JRT 961115 end

ProtocolStackConfigurationTable	struc
	CFGMajorVersion		db	?
	CFGMinorVersion		db	?
	Stack_Name		dd	?
	Stack_ShortName		dd	?
	Stack_MajorVersion	db	?
	Stack_MinorVersion	db	?
	Stack_Reserved		db	16 dup(?)
	Stack_Flags		dd	?		; CFGVersion 1.1
ProtocolStackConfigurationTable	ends

; Legal Stack_Flags bits, all others set to 0
	MP_SAFE_FLAG		equ	1		; 1 if stack is MP Safe
	AUX_DATA_SUPPORT	equ	2		; 1 if recognizes Extended ECBs

; Other AUX Data in ECB (ECB Extensions) constants
	TX_AUX_DATA		equ	08100h	   	; logicalID signals AUX Data
	TX_AUX_DATA_MASK	equ	0C100h		; 
	PAE_RX_AUX_DATA		equ     00800000h      	; ECB.RBLink AUX data present bit

; auxiliary data block definitions
AUX_DATA_BLOCK_HEADER_VERSION	equ	1
AUX_DATA_START			equ	1
AUX_DATA_START_VERSION		equ	1
AUX_DATA_START_LENGTH		equ	24
AUX_DATA_END			equ	2
AUX_DATA_END_VERSION		equ	1
AUX_DATA_END_LENGTH		equ	20
AUX_DATA_MIN_LENGTH		equ	16
AUX_DATA_NULL			equ	3
AUX_DATA_NULL_VERSION		equ	1

AUX_DATA_BLOCK_HDR		struc
	auxType			dd	?	; AUX_DATA_START / AUX_DATA_END
	auxVersion		dd	?	; AUX_DATA_BLOCK_HEADER_VERSION
	auxLength		dd	?	; AUX_DATA_START_LENGTH / AUX_DATA_END_LENGTH
	auxPayloadVersion	dd	?	; AUX_DATA_START_VERSION / AUX_DATA_END_VERSION
AUX_DATA_BLOCK_HDR		ends

AUX_DATA_START_			struc
	auxStartBlkHdr		db	SIZE AUX_DATA_BLOCK_HDR dup(?)
	auxDataPhysAddr		dd	?	; physical address of the aux data blk
	auxDataSize		dd	?	; available contiguous memory for blk
AUX_DATA_START_			ends

AUX_DATA_END_		struc
	auxEndBlkHdr		db	SIZE AUX_DATA_BLOCK_HDR dup(?)
	auxTerminator		dd	0	; NULL
AUX_DATA_END_		ends
