@ECHO OFF
CLS
:: **************************************************************************
::     Generic MAKEBAT.BAT for building ODI files v11.4
::
::   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
:: 
::	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
::	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
::	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
::	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
::	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
::	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
::	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
::	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
::	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
::	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
::	CRIMINAL AND CIVIL LIABILITY.
:: 
:: **************************************************************************

:: **********************************************************************
::  Setting Default Make settings = Local/EngineeringTest/Final/NoClean
:: **********************************************************************
Set ENGTEST=YES

If [%TOOLS_DRV%] == [] Set TOOLS_DRV=N:
If [%TOOLS_SERVER%] == [] Set TOOLS_SERVER=PRV-DEV4
If [%TOOLS_VOLUME%] == [] Set TOOLS_VOLUME=DEV:
If [%TOOLS_PATH%] == [] Set TOOLS_PATH=%TOOLS_SERVER%\%TOOLS_VOLUME%
If [%POLYMAKE%] == [] Set POLYMAKE=%TOOLS_DRV%\Tools\Polymake\400

If Exist %POLYMAKE%\make.exe Set ODIBEFORE=Y
If [%ODIBEFORE%] == [Y] GoTo Parse
Set ODIBEFORE=N
@Echo Mapping Root %TOOLS_DRV%=%TOOLS_PATH%
Map Root %TOOLS_DRV%=%TOOLS_PATH%
If NOT Exist %POLYMAKE%\make.exe GoTo MapODIErr

:: *****************************************************************
:: Tools and mappings used by the ODI team
::
:: V:= PRV-PROD24\CLS1:ClsTools
:: V:= PRV-CLS-Tools\Apps:Cls
::		NWUTIL		       NWIMPORT              v	   11/13/1998
::			  		       NWEXPORT              v	   11/13/1998
::		MPX			       Mpx                   v3.02 
::
:: N:= ODI\DEV:Tools
::     Polymake\400        Polymake              V4.00
::                         Touch                 V4.00 05/16/1991
::     Novell\MSG          Novell MSG Tools
::                         Msglabel              V1.22
::                         Msgexp                V2.25
::                         Msgextr               V1.92
::                         Btrieve               V5.10a
::                         Butil                 V5.12
::     WCC\1100\Binw       Watcom Compiler       V11.0
::                         Watcom Disassembler   V11.0
::                         Watcom Linker         V11.0
::     TASM\400\Bin        Borland Assembler     V4.00
::     Pharlap\400\Bin     Pharlap Assembler     V4.00
::     Novell\NLMLinkp     NLMPACKX              V1.8
::                         Checkerr              V??? 09/01/88
:: *****************************************************************

:Parse
If [%1] == []  GoTo Build
If [%1] == [/] GoTo Help
If [%1] == [?] GoTo Help
If [%1] == [S] GoTo Sym
If [%1] == [s] GoTo Sym
If [%1] == [M] GoTo MsgSetUp
If [%1] == [m] GoTo MsgSetUp
If [%1] == [F] GoTo Final
If [%1] == [f] GoTo Final
If [%1] == [C] GoTo Clean
If [%1] == [c] GoTo Clean
GoTo Build

:Next
shift
GoTo Parse

:Help
@Echo **************************************************************************
@Echo Parse Command Line for ODI Build Options
@Echo.
@Echo           Command Line Options:
@Echo.
@Echo                 ? - This Help screen
@Echo                 S - Build CodeView Debug version w/ Symbolic Information
@Echo                     By Default the Debug version will be "NOVELL ALL"
@Echo                 M - Localization Message Menu
@Echo                 F - No debug or Engineering Test Flags (Build MGR Only!)
@Echo                 C - Clean out all .obj .lst .err .bak .tmp .old modules
@Echo **************************************************************************
GoTo End

:Sym
@Echo ********************************************************************
@Echo (S)  SYM FLAG set, Debug version will contain Symbolic Information
@Echo ********************************************************************
Set SYM=YES
GoTo Next

:MsgSetUp
::  *********************************
::  (M)  Localization Message Build 
::  *********************************
Set MSG=YES
If Exist Menu DEL Menu

Echo                Message Import/Export Menu			   > Menu
Echo.													   >> Menu
Echo       1:     Build All MSG language files             >> Menu
Echo       2:     Build LDI/INF/NDI files (IMPORT/EXPORT)  >> Menu
Echo       3:     Build Chinese Simplified   (1) MSG files >> Menu
Echo       4:     Build English (IMPORT)     (4) MSG files >> Menu
Echo       5:     Build French               (6) MSG files >> Menu
Echo       6:     Build German               (7) MSG files >> Menu
Echo       7:     Build Italian              (8) MSG files >> Menu
Echo       8:     Build Japanese             (9) MSG files >> Menu
Echo       9:     Build Korean              (10) MSG files >> Menu
Echo       A:     Build Portugues           (12) MSG files >> Menu
Echo       B:     Build Russian             (13) MSG files >> Menu 
Echo       C:     Build Spanish             (14) MSG files >> Menu
Echo       D:     Build Chinese Traditional (16) MSG files >> Menu 
Echo       E:     Continue with build                      >> Menu
Echo       Q:     QUIT                                     >> Menu 
Echo.                                                      >> Menu

:MsgDisplay
CLS
Type Menu
C:\Windows\Command\Choice /N /C:123456789ABCDEQ Choose which messages to create?
For %%x in (1,2,3,4,5,6,7,8,9,10,11,12,13,14,15) do If errorlevel %%x Set MESSAGE=%%x

If [%MESSAGE%] == [15] GoTo END
If [%MESSAGE%] == [14] GoTo Next
If [%MESSAGE%] == [1]  Set CLS_LANG=CHS CHT DEU ESN FRA ITA JPN KOR PTB RUS
If [%MESSAGE%] == [2]  Set CLS_LANG=LDI %CLS_LANG%
If [%MESSAGE%] == [3]  Set CLS_LANG=CHS %CLS_LANG%
If [%MESSAGE%] == [4]  Set CLS_LANG=ENU %CLS_LANG%
If [%MESSAGE%] == [5]  Set CLS_LANG=FRA %CLS_LANG%
If [%MESSAGE%] == [6]  Set CLS_LANG=DEU %CLS_LANG%
If [%MESSAGE%] == [7]  Set CLS_LANG=ITA %CLS_LANG%
If [%MESSAGE%] == [8]  Set CLS_LANG=JPN %CLS_LANG%
If [%MESSAGE%] == [9]  Set CLS_LANG=KOR %CLS_LANG%
If [%MESSAGE%] == [10]  Set CLS_LANG=PTB %CLS_LANG%
If [%MESSAGE%] == [11]  Set CLS_LANG=RUS %CLS_LANG%
If [%MESSAGE%] == [12]  Set CLS_LANG=ESN %CLS_LANG%
If [%MESSAGE%] == [13]  Set CLS_LANG=CHT %CLS_LANG%
GoTo MsgDisplay

:Final
@Echo ********************************************************************
@Echo (F)  Building Final Version-- No Debug or Engineering Test Message
@Echo ********************************************************************
Set CLEAN=YES
Set ENGTEST=
GoTo Next

:Clean
@Echo ********************************************************************
@Echo (C)  Cleaning FLAG set, MAKE will delete targets and leftovers
@Echo ********************************************************************
Set CLEAN=YES
GoTo Next

:Build
:: *******************************************************************
:: Building -- Setting PATH TMP TEMP variables, calling MAKE Utility
:: *******************************************************************
Set OLDTMP=%TMP%
Set TMP=.

Call specific.bat %1 %2 %3 %4 %5 %6 %7 %8 %9

@Echo *****************************************************
@Echo Finished Building -- Transfered back to MAKEBAT.BAT
@Echo *****************************************************
GoTo ErrorCheck

:ErrorCheck
:: *******************************
::      ERROR CHECKING
:: *******************************
For %%x in (1,2,3,4,5,6,7,8,11,12,13,14,15,16,17,18,19) do If errorlevel %%x GoTo Error%%x
GoTo End

:: **************************************************************************
::              ERROR ROUTINES AND MESSAGES
:: **************************************************************************

:MapODIErr
@Echo *********************************************************
@Echo [1;31m[5mThe MAPPING of the %TOOLS_PATH% FAILED! [0m
@Echo *********************************************************
GoTo End

:Error1
@Echo *****************************************************************
@Echo [1;31m[5mThe command in an operation was not on the PATH [0m
@Echo *****************************************************************
GoTo End

:Error2
@Echo ******************************************************************
@Echo [1;31m[5mInsuffucient memory to execute an operation line [0m
@Echo ******************************************************************
GoTo End

:Error3
@Echo *********************************************************************
@Echo [1;31m[5mUnable to load or execute a command in an operation [0m
@Echo *********************************************************************
GoTo End

:Error4
@Echo *****************************************
@Echo [1;31m[5mMemory allocation error [0m
@Echo *****************************************
GoTo End

:Error5
GoTo Error3

:Error6
@Echo **********************************************************************
@Echo [1;31m[5mThe command line exceeded the maximum length allowed [0m
@Echo **********************************************************************
GoTo End

:Error7
@Echo **************************************************************
@Echo [1;31m[5mEXEC function not available under MS-DOS 1.1 [0m
@Echo **************************************************************
GoTo End

:Error8
@Echo *****************************************************************
@Echo [1;31m[5mAn unknown error was reported during a DOS call [0m
@Echo *****************************************************************
GoTo End

:Error11
GoTo Error6

:Error12
@Echo *****************************************************************
@Echo [1;31m[5mAn invalid memory control block was encountered [0m
@Echo *****************************************************************
GoTo End

:Error13
@Echo ************************************************
@Echo [1;31m[5mToo many memory control blocks [0m
@Echo ************************************************
GoTo End

:Error14
@Echo ***************************************************
@Echo [1;31m[5mUnable to create a temporary file [0m
@Echo ***************************************************
GoTo End

:Error15
@Echo ***********************************************************************
@Echo [1;31m[5mAn error occured when saving memory to temporary file [0m
@Echo ***********************************************************************
GoTo End

:Error16
@Echo *********************************************************************
@Echo [1;31m[5mA Control-Break sequence was received from the user [0m
@Echo *********************************************************************
GoTo End

:Error17
@Echo ************************************************************************
@Echo [1;31m[5mAn error occured in deallocating memory control blocks [0m
@Echo ************************************************************************
GoTo End

:Error18
@Echo ************************************************************************
@Echo [1;31m[5mAn error occured in reallocating memory control blocks [0m
@Echo ************************************************************************
GoTo End

:Error19
@Echo *************************************************************************
@Echo [1;31m[5mAn error occured in reading image from a temporary file [0m
@Echo *************************************************************************
GoTo End

:End
If Exist Menu DEL Menu

:Check_N
If [%ODIBEFORE%] == [Y] GoTo Cleanup
If [%ODIBEFORE%] == [] GoTo Cleanup
@Echo DELETEing the Mapping %TOOLS_PATH%
If Exist %POLYMAKE%\make.exe Map DEL %TOOLS_DRV%

:Cleanup
Set TOOLS_DRV=
Set TOOLS_SERVER=
Set TOOLS_VOLUME=
Set TOOLS_PATH=
Set POLYMAKE=
Set ODIBEFORE=
Set MESSAGE=
Set CLS_LANG=
Set ENGTEST=
Set CLEAN=
Set MSG=
Set SYM=
Set TMP=%OLDTMP%
Set OLDTMP=

:Exit
@Echo **********************
@Echo MAKEBAT.BAT Complete
@Echo **********************