@Echo off
:: *************************************************************************
::     BATCH file for building the MSM & MSM31X ODI NLM (ASM)
::
::  Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
:: 
::	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
::	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
::	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
::	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
::	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
::	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
::	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
::	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
::	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR 
::  EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE 
::  PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
:: 
:: *************************************************************************
Set UTILEXT=NLM
Set MSGUTILNAME=NWCACS
Set TXTMSGNAME=CMSM
Set MPXEXT=
Set CDEFS=/DSVR /DNWCACS
Set CFILES=parser cmsmstr findmsgs ancs debug
Set AFILES=msmglue chsmglue
Set OBJS=msm msmglue chsmglue parser cmsmstr findmsgs ancs debug

::  MSM Version Number
Set MAJOR_VER=4
Set MINOR_VER=06
Set REV=0

::  MSG Version Number  (Version # of message database)
Set MSGMAJVER=1
Set MSGMINVER=11

::	 Message File Version Numbers (Version # of message database)
Set COPYRIGHT_TXT='Copyright (c) 1990 - 2000, by Novell, Inc. All rights reserved.'

If [%CLS_PROD_NAME%] == [] Set CLS_PROD_NAME=MOAB
If [%CLS_GROUP_NAME%] == [] Set CLS_GROUP_NAME=ODI
If [%CLS_MOD_NAME%] == [] Set CLS_MOD_NAME=%MSGUTILNAME%
If [%CLS_NILE_MOD_NAME%] == [] Set CLS_NILE_MOD_NAME=
If [%CLS_FORMAT%] == [] Set CLS_FORMAT=MDB

:MSMSMP
:: *************************************************************************
::		Setup for making the MSMSMP NLM
:: *************************************************************************
Set UTIL=MSM
Set ADEFS=MSMSMP
Set DESCRIPTION_TXT=Novell Multi-Processor Media Support Module
GoTo MakeModule

:MSM311
:: *************************************************************************
::		Setup for making the MSM31X NLM
:: *************************************************************************
Set UTIL=MSM31X
Set ADEFS=MSM311
Set DESCRIPTION_TXT=Novell Generic Media Support Module
Set OS=\311
GoTo MakeModule

:MakeModule
@Echo **********************************************************************
@Echo Making %UTIL% %MAJOR_VER%.%MINOR_VER%.%REV% %1 %2 %3 %4 %5 %6 %7 %8 %9
@Echo **********************************************************************
If [%OTHER%] == [YES] GoTo Exit
%POLYMAKE%\make -f MSM.mak %1 %2 %3 %4 %5 %6 %7 %8 %9

:ErrorCheck
:: *******************************
::      ERROR CHECKING
:: *******************************
For %%x in (1,2,3,4,5,6,7,8,11,12,13,14,15,16,17,18,19) do If errorlevel %%x GoTo End
For %%x in (160,165,170,175,180,185,190,195,200,205,210,220,250,255,260,265,270,275) do If errorlevel %%x GoTo End

:: *******************************
::      Build Manager
:: *******************************
If "%UTIL%" == "MSM" GoTo MSM311
If "%UTIL%" == "MSM31X" GoTo End

:End
Set UTIL=
Set UTILEXT=
Set MSGUTILNAME=
Set TXTMSGNAME=
Set MPXEXT=
Set CFILES=
Set AFILES=
Set OBJS=
Set MAJOR_VER=
Set MINOR_VER=
Set REV=
Set MSGMAJVER=
Set MSGMINVER=
Set CDEFS=
Set ADEFS=
Set DESCRIPTION_TXT=
Set COPYRIGHT_TXT=
Set CLS_PROD_NAME=
Set CLS_GROUP_NAME=
Set CLS_MOD_NAME=
Set CLS_NILE_MOD_NAME=
Set CLS_FORMAT=
Set OS=

:: *************************************************************************
:: SPECIFIC.BAT Complete
:: *************************************************************************
:End