############################################################################
#	NE2000.MAK is used to control the building of the NE2000.LAN (ASM)
#
#   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
# 
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
# 
############################################################################

$(UTIL) : CLSMessages $(EXEDIR)\$(UTIL).$(UTILEXT) \
			$(DBGEXEDIR)\$(UTIL).$(UTILEXT)

$(EXEDIR)\$(UTIL).$(UTILEXT): $[f,$(OBJDIR),$(OBJS),obj] \
								$(SRCDIR)\$(UTIL).mak \
								$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DESCRIPTION)
	
	%Do Link

$(DBGEXEDIR)\$(UTIL).$(UTILEXT): $[f,$(DBGOBJDIR),$(OBJS),obj] \
									$(SRCDIR)\$(UTIL).mak \
									$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DBGDESCRIPTION)
	%Set LINKDEBUG = $(DEBUGSTRING)
	%Set REV=4						#For DEBUG use only

	%Do Link

Link:
	$(ASMLINKER)\checkerr
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Linking $@
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do DeleteFile
	%endfor
	$(COMPILE)\wlink <@<
format Novell $(UTILEXT) '$(DESCRIP)'
$(LINKDEBUG)
name $@
file $[s,",",$[m,$[p,$[m,*.obj,$**]]*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option start = DriverInit
option exit  = DriverRemove
option map = $[f,$[d,$@],$@,map]
option reentrant
option caseexact
option quiet
option verbose
option nodefaultlibs
%If %Defined(SYM)
option SYMFILE = $[f,$[d,$@],$@,sym]
%EndIf

module	ETHERTSM

import  EtherTSMFastProcessGetRCB,
        EtherTSMFastRcvComplete,
        EtherTSMFastSendComplete,
        EtherTSMGetNextSend,
        EtherTSMGetRCB,
        EtherTSMMaxFrameHeaderSize,
        EtherTSMProcessGetRCB,
        EtherTSMRcvComplete,
        EtherTSMRegisterHSM,
        EtherTSMSendComplete,
        EtherTSMUpdateMulticast,
		GetCurrentTime,
        IOConfigurationList,
        MSMAlertFatal,
        MSMAlertWarning,
        MSMAlloc,
        MSMAllocateRCB,
        MSMAllocPages,
        MSMASCIIToDWord,
        MSMDeRegisterSharedMemory,
        MSMDriverRemove,
        MSMEnablePolling,
		MSMEnableWriteCombine,
        MSMFree,
        MSMFreePages,
        MSMGetMicroTimer,
        MSMParseCustomKeywords,
        MSMParseDriverParameters,
        MSMPrintString,
        MSMPrintStringFatal,
        MSMPrintStringWarning,
        MSMReadEISAConfig,
        MSMRegisterHardwareOptions,
        MSMRegisterMLID,
        MSMRegisterSharedMemory,
        MSMReturnDriverResources,
        MSMReturnRcvECB,
        MSMScanBusInfo,
        MSMScheduleIntTimeCallBack,
        MSMScheduleAESCallBack,
        MSMSetHardwareInterrupt,
		MSMYieldWithDelay

<
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do	AttributeAdd
	%endfor
	
	%Echo $(BEGINGREEN) Finished Building -- $(DESCRIP) in Directory $@ $(ENDANSI)

	%If %Defined(ENGTEST)
		%Echo ***************************************************************
		%Echo $(BEGINYELLOW) $(WARNINGENG) $(ENDANSI)
		%Echo ***************************************************************
	%EndIf