##############################################################################
#	This CNE2000.MAK is used to control the building of the CNE2000.LAN
#
#   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
# 
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION 
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
# 
##############################################################################

$(UTIL) : CLSMessages $(EXEDIR)\$(UTIL).$(UTILEXT) \
			$(DBGEXEDIR)\$(UTIL).$(UTILEXT)

$(EXEDIR)\$(UTIL).$(UTILEXT): $[f,$(OBJDIR),$(OBJS),obj] \
								$(SRCDIR)\$(UTIL).mak \
								$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DESCRIPTION)
	
	%Do Link

$(DBGEXEDIR)\$(UTIL).$(UTILEXT): $[f,$(DBGOBJDIR),$(OBJS),obj] \
									$(SRCDIR)\$(UTIL).mak \
									$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DBGDESCRIPTION)
	%Set LINKDEBUG = $(DEBUGSTRING)
	%Set REV=4						#For DEBUG use only

	%Set CMSMOutMEON = import	CMSMOutMEON
	%Set CMSMOutUINT16 = import	CMSMOutUINT16
	%Set CMSMOutUINT32 = import	CMSMOutUINT32
	%Set CMSMOutUINT8 = import	CMSMOutUINT8
	%Set NiosDebugCharOut = import	NiosDebugCharOut

	%Do Link

Link:
	$(ASMLINKER)\checkerr
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Linking $@
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do DeleteFile
	%endfor
	$(COMPILE)\wlink <@<
format Novell $(UTILEXT) '$(DESCRIP)'
$(LINKDEBUG)
name $@
file $[s,",",$[m,$[p,$[m,*.obj,$**]]*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option messages = $(ENUMSGDIR)\$(MSGUTILNAME).msg
option start = DriverInit
option exit  = DriverRemove
option map = $[f,$[d,$@],$@,map]
option reentrant
option caseexact
option quiet
option verbose
option nodefaultlibs
%If %Defined(SYM)
option SYMFILE = $[f,$[d,$@],$@,sym]
%EndIf

module	ETHERTSM

import	CMSMAlloc,
		CMSMAllocPages,
		CMSMAllocateRcb,
		CMSMCopyData,
		CMSMDeRegisterSharedMemory,
		CMSMDriverRemove,
		CMSMEnablePolling,
		CMSMEnableWriteCombine,
		CMSMFree,
		CMSMFreePages,
		CMSMGetCurrentTime,
		CMSMGetMicroTimer,
		CMSMInitAlloc,
		CMSMInitFree,
		CMSMInitParser,
		CMSMPrintString,
		CMSMPrintStringWarning,
		CMSMGetCardConfigInfo,
		CMSMGetInstanceNumber,
		CMSMGetInstanceNumberMapping,
		CMSMNESLDeRegisterProducer,
		CMSMNESLProduceEvent,
		CMSMNESLRegisterProducer,
		CMSMParseDriverParameters,
		CMSMParseSingleParameter,
		CMSMRegisterHardwareOptions,
		CMSMRegisterMLID,
		CMSMRegisterSharedMemory,
		CMSMReturnDriverResources,
		CMSMReturnRcvECB,
		CMSMScheduleAES,
        CMSMSearchAdapter,
		CMSMSetHardwareInterrupt,
		CMSMWritePhysicalMemory,
		CMSMReadPhysicalMemory,
		CMSMServiceEvents,
		CMSMRegisterTSM,
		CEtherTSMRegisterHSM,
		CEtherTSMFastSendComplete,
		CEtherTSMSendComplete,
		CEtherTSMGetRCB,
		CEtherTSMProcessGetRCB,
		CEtherTSMFastProcessGetRcb,
		CEtherTSMFastRcvComplete,
		CEtherTSMRcvComplete,
		CEtherTSMUpdateMulticast,
		In8,
		Out8,
		In16,
		Out16,
		Mov8,
		Mov16,
		Slow,

		NESL_MLID_Card_Insertion_Complete,
		NESL_Service_Resume
	
# MSM APIs imported in debug version only.
$(CMSMOutMEON)
$(CMSMOutUINT16)
$(CMSMOutUINT32)
$(CMSMOutUINT8)
$(NiosDebugCharOut)

<
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do	AttributeAdd
	%endfor
	
	%Echo $(BEGINGREEN) Finished Building -- $(DESCRIP) in Directory $@ $(ENDANSI)

	%If %Defined(ENGTEST)
		%Echo ***************************************************************
		%Echo $(BEGINYELLOW) $(WARNINGENG) $(ENDANSI)
		%Echo ***************************************************************
	%EndIf