############################################################################
#	CNEAMD.MAK controls the building of the CNEAMD.LAN (C)
#
#   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
# 
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION 
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
# 
############################################################################

$(UTIL) : CLSMessages $(EXEDIR)\$(UTIL).$(UTILEXT) \
			$(DBGEXEDIR)\$(UTIL).$(UTILEXT)

$(EXEDIR)\$(UTIL).$(UTILEXT): $[f,$(OBJDIR),$(OBJS),obj] \
								$(SRCDIR)\$(UTIL).mak \
								$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DESCRIPTION)
	
	%Do Link

$(DBGEXEDIR)\$(UTIL).$(UTILEXT): $[f,$(DBGOBJDIR),$(OBJS),obj] \
									$(SRCDIR)\$(UTIL).mak \
									$(SRCDIR)\specific.bat
	%Set DESCRIP = $(DBGDESCRIPTION)
	%Set LINKDEBUG = $(DEBUGSTRING)
	%Set REV=4						#For DEBUG use only

	%Set CMSMOutMEON = import	CMSMOutMEON
	%Set CMSMOutUINT16 = import	CMSMOutUINT16
	%Set CMSMOutUINT32 = import	CMSMOutUINT32
	%Set CMSMOutUINT8 = import	CMSMOutUINT8
	%Set NiosBreak = import		NiosBreak
	%Set NiosDprintf = import	NiosDprintf

	%Set DriverCallBack = export	DriverCallBack
    %Set DriverISRISA = export		DriverISRISA
    %Set DriverISRPCI = export		DriverISRPCI
    %Set DriverISRPCI_II = export	DriverISRPCI_II
    %Set DriverMulticastChange = export	DriverMulticastChange 
    %Set DriverReset = export	DriverReset
    %Set DriverSendLANCE = export	DriverSendLANCE
    %Set DriverSendISA = export	DriverSendISA
    %Set DriverSendPCI = export	DriverSendPCI
	%Set DriverSendPCI_II = export	DriverSendPCI_II
    %Set DriverShutdown = export	DriverShutdown
    %Set DriverPromiscuousChange = export	DriverPromiscuousChange
    %Set DriverEnableInterrupt = export	DriverEnableInterrupt 
    %Set DriverDisableInterrupt = export	DriverDisableInterrupt
	
	%Do Link

Link:
	$(ASMLINKER)\checkerr
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Linking $@
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do DeleteFile
	%endfor
	$(COMPILE)\wlink <@<
format Novell $(UTILEXT) '$(DESCRIP)'
$(LINKDEBUG)
name $@
file $[s,",",$[m,$[p,$[m,*.obj,$**]]*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option messages = $(ENUMSGDIR)\$(MSGUTILNAME).msg
option start = DriverInit
option exit  = DriverRemove
option map = $[f,$[d,$@],$@,map]
option reentrant
option caseexact
option quiet
option verbose
option nodefaultlibs
%If %Defined(SYM)
option SYMFILE = $[f,$[d,$@],$@,sym]
%EndIf

module	ETHERTSM

import	CMSMAlloc,
		CMSMAllocPages,
		CMSMAllocateRcb,
		CMSMCopyData,
		CMSMDeRegisterSharedMemory,
		CMSMDriverRemove,
		CMSMEnablePolling,
		CMSMFree,
		CMSMFreePages,
		CMSMGetBusType,
		CMSMGetCardConfigInfo,
		CMSMGetCurrentTime,
		CMSMGetInstanceNumber,
		CMSMGetInstanceNumberMapping,
		CMSMGetMicroTimer,
		CMSMNESLDeRegisterProducer,
		CMSMNESLProduceEvent,
		CMSMNESLRegisterProducer,
		CMSMInitAlloc,
		CMSMInitFree,
		CMSMInitParser,
		CMSMPrintString,
		CMSMPrintStringWarning,
		CMSMParseDriverParameters,
		CMSMParseSingleParameter,
		CMSMTCBPhysToLogFrags,
		CMSMRegisterHardwareOptions,
		CMSMRegisterMLID,
		CMSMRegisterSharedMemory,
		CMSMReturnDriverResources,
		CMSMReturnRcvECB,
		CMSMScheduleAES,
		CMSMSearchAdapter,
		CMSMSetHardwareInterrupt,
		CMSMWritePhysicalMemory,
		CMSMWrtConfigSpace16,
		CMSMRdConfigSpace32,
		CMSMReadPhysicalMemory,
		CMSMServiceEvents,
		CMSMRegisterTSM,
		CMSMReturnRCB,
		CMSMGetPhysical,
		CMSMAllocateRCB,
		CMSMUpdateConfigTables,
		CEtherTSMFastProcessGetRCB,
		CEtherTSMRegisterHSM,
		CEtherTSMFastSendComplete,
		CEtherTSMSendComplete,
		CEtherTSMGetRCB,
		CEtherTSMProcessGetRCB,
		CEtherTSMFastProcessGetRcb,
		CEtherTSMFastRcvComplete,
		CEtherTSMRcvComplete,
		CEtherTSMUpdateMulticast,
		DMAStatus,
		DMACleanup,
		DMAStart,
		In8,
		Out8,
		In16,
		Out16,
		Mov8,
		Mov16,
		Slow,
		EnterDebugger,

		NESL_MLID_Card_Insertion_Complete,
		NESL_Service_Resume

  # MSM APIs imported in debug version only.

$(NiosBreak)
$(NiosDprintf)

$(CMSMOutMEON)
$(CMSMOutUINT16)
$(CMSMOutUINT32)
$(CMSMOutUINT8)

$(DriverCallBack)
$(DriverISRISA)
$(DriverISRPCI)
$(DriverISRPCI_II)
$(DriverMulticastChange)
$(DriverReset)
$(DriverSendLANCE)
$(DriverSendISA)
$(DriverSendPCI)
$(DriverSendPCI_II)
$(DriverShutdown)
$(DriverPromiscuousChange)
$(DriverEnableInterrupt)
$(DriverDisableInterrupt)

<
	%foreach FILE in $[f,$[d,$@],$[w,$[d,$@]\$(UTIL).*],]
		%Do	AttributeAdd
	%endfor
	
	%Echo $(BEGINGREEN) Finished Building -- $(DESCRIP) in Directory $@ $(ENDANSI)

	%If %Defined(ENGTEST)
		%Echo ***************************************************************
		%Echo $(BEGINYELLOW) $(WARNINGENG) $(ENDANSI)
		%Echo ***************************************************************
	%EndIf