############################################################################
#	This CETHERTSM.MAK is used to control the building of the C ETHERTSM.NLM
#
#		CETHERTSM.MAK builds the C ETHERTSM.NLM for Client-32, NT & NWServer.
#
#   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
# 
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION 
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
# 
############################################################################

%If %Defined(ENGTEST)
$(UTIL) : $(ENUMSGDIR)\$(MSGUTILNAME).msg $(EXEDIR)\$(UTIL).nlm
%Else
$(UTIL) : $(ENUMSGDIR)\$(MSGUTILNAME).msg $(DEUMSGDIR)\$(MSGUTILNAME).msg \
			$(ESNMSGDIR)\$(MSGUTILNAME).msg $(FRAMSGDIR)\$(MSGUTILNAME).msg \
			$(PTBMSGDIR)\$(MSGUTILNAME).msg $(ITAMSGDIR)\$(MSGUTILNAME).msg	\
	        $(JPNMSGDIR)\$(MSGUTILNAME).msg $(RUSMSGDIR)\$(MSGUTILNAME).msg	\
			$(CHTMSGDIR)\$(MSGUTILNAME).msg $(CHSMSGDIR)\$(MSGUTILNAME).msg	\
			$(KORMSGDIR)\$(MSGUTILNAME).msg $(EXEDIR)\$(UTIL).nlm
%EndIf

$(ENUMSGDIR)\$(MSGUTILNAME).mdb : $[f,$(SRCDIR),$(CFILES),c] \
									$(ENUMSGDIR)\$(UTIL).TXT
	%Do MessageDataBase

$(EXEDIR)\$(UTIL).nlm : $[f,$(OBJDIR),$(OBJS),obj] $(ENUMSGDIR)\$(MSGUTILNAME).msg \
							$(SRCDIR)\cethertsm.mak $(SRCDIR)\specific.bat
	checkerr
	%If %Exists($(EXEDIR)\$(UTIL).NLM)
		Attrib -r $(EXEDIR)\$(UTIL).NLM
		DEL $(EXEDIR)\$(UTIL).NLM
	%EndIf
	%If %Exists($(EXEDIR)\$(UTIL).MAP)
		Attrib -r $(EXEDIR)\$(UTIL).MAP
		DEL $(EXEDIR)\$(UTIL).MAP
	%EndIf
	%Echo
	%Echo Linking $@
	$(COMPILE)\wlink <@<
format Novell NLM '$(DESCRIPTION)'
%If %Defined(DBG)
$(DEBUGSTRING)
%EndIf
name $(EXEDIR)\$(UTIL)
file $[s,",",$[m,*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option messages = $(ENUMSGDIR)\$(MSGUTILNAME).msg
option start = CInitializeEtherTSM
option exit = CRemoveEtherTSM
option map = $[f,$(EXEDIR),$@,map]
option caseexact
option quiet
option verbose
option nodefaultlibs
option namelen = 30
%If %Defined(DBG)
%If %Defined(SYM)
option SYMFILE = $[f,$(EXEDIR),$@,sym]
%End
%EndIf

%If "$(OS)" != "NT"
module	CMSM
%End

import	CLSL_ControlStackFilter,	   # CLSL APIs imported
		CLSL_FastHoldEvent,
		CLSL_FastSendComplete,
		CLSL_GetStackECB,
		CLSL_HoldEvent,
		CLSL_SendComplete,

   # CMSM APIs Imported
		CMSMAlloc,
		CMSMAllocateRCB,
		CMSMAcquireProtection,
		CMSMEnqueueSend,
		CMSMFree,
		CMSMGetPhysical,
		CMSMGetPhysicalECB,
		CMSMPrintString,
        CMSMParseCTSMParameters,
		CMSMRegisterTSM,
		CMSMReleaseProtection,
		CMSMReturnDriverResources,
		CMSMReturnRCB,
		CMSMReturnPhysicalECB,
        CMSMstrcspn,
        CMSMstrcmp,
        CMSMstrcpy,
        CMSMstrstr,
        CMSMstrlen,
        CMSMASCIINodeToHex,
		CurrentFrameData,
		MSMBitSwapTable,
		CMSMBuildGenericStatStrings

%If "$(OS)" == "CLIENT32"
import	CLSL_ServiceEvents,			# CLSL APIs imported
		NiosMemCpy,					# NIOS APIs Imported
		NiosMemSet,
		ReturnMessageInformation,	# OS APIs Imported
		GetNLMVersionInfo
%ElseIf "$(OS)" == "NWSERVER"
import	CMovB,		# OS APIs imported
		CSetB,
		CLSL_ControlStackFilter,	# CLSL APIs imported
		ReturnMessageInformation,	# OS APIs Imported
		GetNLMVersionInfo
%ElseIf	"$(OS)" == "NT"
import	CMSMReturnMessageInformation,
		CMSMGetNLMVersionInfo
%End

  # MSM APIs Imported in debug version only.
%If %Defined(DBG)
import	CMSMOutMEON,
		CMSMOutUINT16,
		CMSMOutUINT32,
		CMSMOutUINT8,
		EnterDebugger
%EndIf

export	CEtherTSMBuildTransmitControlBlock,
		CEtherTSMCancelPrioritySend,
		CEtherTSMFastProcessGetRCB,
		CEtherTSMFastRcvComplete,
		CEtherTSMFastRcvCompleteStatus,
		CEtherTSMFastSendComplete,
		CEtherTSMGetConfigInfo,
		CEtherTSMGetHSMIFLevel,
		CEtherTSMGetRCB,
		CEtherTSMProcessGetRCB,
		CEtherTSMRcvComplete,
		CEtherTSMRcvCompleteStatus,
		CEtherTSMRegisterHSM,
		CEtherTSMSendComplete,
		CEtherTSMUpdateMulticast,
		
		EtherTSMBuildTransmitControlBlock,
		EtherTSMCancelPrioritySend,
        EtherTSMGetNextSend,
		EtherTSMGetConfigInfo,
        EtherTSMGetRCB,
        EtherTSMProcessGetRCB,
        EtherTSMFastProcessGetRCB,
        EtherTSMRcvComplete,
        EtherTSMRcvCompleteStatus,
        EtherTSMFastRcvComplete,
        EtherTSMFastRcvCompleteStatus,
        EtherTSMRegisterHSM,
        EtherTSMSendComplete,
        EtherTSMFastSendComplete,
        EtherTSMUpdateMulticast,
        EtherTSMGetASMHSMIFLevel
<
	%If %File($(EXEDIR)\$(UTIL).NLM)
		Attrib +r $(EXEDIR)\$(UTIL).NLM
		Attrib +r $(EXEDIR)\$(UTIL).MAP
	%Else
		%Exit 255
	%End

	%Echo Finished Building -- "$(DESCRIPTION)"
	%Echo in Directory $@
   	%Echo
