/*--------------------------------------------------------------------------*
*  Copyright Unpublished Work of Novell, Inc. All Rights Reserved
*
*  THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
*  PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.
*  ACCESS TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES
*  WHO HAVE A NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE
*  OF THEIR ASSIGNMENTS AND (ii) ENTITIES OTHER THAN NOVELL
*  WHO HAVE ENTERED INTO APPROPRIATE LICENSE AGREEMENTS.
*  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,
*  DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,
*  CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
*  TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF
*  NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION
*  COULD SUBJECT THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
*--------------------------------------------------------------------------*/
/*****************************************************************************
*
* Title:		Generic Function Prototypes provided by OS.
*
* Filename:		generic.h
*
* ODI Spec Ver:	1.11
*
* Modification History:
*
* 11-14-96 KRA	Moved MLIDShutdown prototype to here.
*
* 11-10-96 MPK	Put ShutdownAESCallback prototype to here.
*
* 02-18-97 WTT	Added prototype for NBIRequest.
*
* 04-30-97 MPK	Added HSM_BASED_SHUTDOWN define to make code using the value
*               readable.
*
* 01-30-98 KRA	Added externs for NESL_MLID_ShutDown[], NESL_MLID_Reset[],
*					NESL_Service_Suspend[], NESL_Service_Resume[],
*					CMSMServiceSuspendNECBPtr, and CMSMServiceResumeNECBPtr.
*					Added Ioctl entry function prototypes.  Added #defines for
*					CMSMAcquireSpinLock, CMSMReleaseSpinLock, and
*					CMSMDelayExecutionThread.  Changed MlidIoctls to MLIDIoctls.
****************************************************************************/

#define  HSM_BASED_SHUTDOWN      0x02
#define  HSM_PERMANENT_SHUTDOWN  0x02
#define  HSM_TEMPORARY_SHUTDOWN  0x03

#define  CHAIN_SHARE_BIT       0x01      /* 1=chain, 0=nochain */
#define  CHAIN_IRET_BIT        0x02      /* 1=iret, 0=ret INTERNAL OS USE ONLY! */
#define  CHAIN_SET_REAL_MODE   0x04      /* 1=set both protected and real mode vectors */
#define  SHARE_REAL_MODE       0x08      /* 1=share with real mode vector */


#define  DRIVER_ISR_0      1
#define  DRIVER_ISR_1      2

#ifdef IAPX386

#define        CMSM_MLID_CFG_MAJOR     1
#define        CMSM_MLID_CFG_MINOR     21			/* Set to match current Spec. */

#define        CMSM_ORIG_CFG_MAJOR     1        /* this will never change */
#define        CMSM_ORIG_CFG_MINOR     20       /* this will never change */

#define        AMSM_MLID_CFG_MAJOR     1
#define        AMSM_MLID_CFG_MINOR     12

#define        CMSM_IO_CFG_MAJOR       1
#define        CMSM_IO_CFG_MINOR       0

#define        ASM_STAT_WAIT_TIME      4 * 18
#define        ASM_STYLE_TABLE_FLAG    0x10000000

#endif

#define FORMAT_STRING_LEN 512					/* size for FormatString */

/***********************************************************************\
*                                                                       *
* NetWare OS function prototypes.                                       *
*                                                                       *
************************************************************************/

UINT32      AddPollingProcedureRTag(
               void              (*Procedure)(void),
               RTAG_HANDLE       *RTag);

void        *Alloc(
               UINT32            numberOfBytes,
               RTAG_HANDLE       *RTag);


void        *AllocateMappedPages(
               UINT32            NumberOf4KPages,
               UINT32            SleepOKFlag,
               UINT32            Below16MegFlag,
               RTAG_HANDLE       *RTag,
               UINT32            *SleptFlag);


RTAG_HANDLE *AllocateResourceTag(
               MODULE_HANDLE     *LoadRecord,
               MEON              *ResourceDescriptionString,
               UINT32            ResourceSignature);

RTAG_HANDLE *CFindResourceTag(
               MODULE_HANDLE     *LoadRecord,
               UINT32            ResourceSignature);

void        CDoBusEndOfInterrupt(
               void		*busTag,
					UINT8		hardwareInterruptLevel);

UINT32      CheckHardwareOptions(
               IO_CONFIG         *IOConfig);

UINT32      CheckSlot(
               UINT32            SlotNumber);

UINT32      ClearBusInterrupt(
               void              *BusTag,
               UINT8             hardwareInterruptLevel,
               UINT32            (*InterruptProcedure)(void *MagicNumber),
               void              *MagicNumber);

void        CCancelInterruptTimeCallBack(
               struct _INT_AES_  *TimerNode);

void        CancelSleepAESProcessEvent(
               struct _AES_      *AESNode);

void        ConvertToUpperCase(
               MEON_STRING       *string);

void        CScheduleInterruptTimeCallBack(
               struct _INT_AES_  *TimerNode);

void        DeAllocateMappedPages(
               void              *MPtr);


void        DeRegisterHardwareOptions(
               IO_CONFIG         *IOConfiguration);

void        Free(
               void              *MPtr);

UINT32      GetCurrentTime(void);

UINT32      GetFileServerMinorVersionNumber(void);

UINT32      GetFileServerMajorVersionNumber(void);

UINT32      GetNestedInterruptLevel(void);

UINT32      GetPollSupportLevel(void);

UINT32      GetNLMNames(
               MODULE_HANDLE     *moduleHandle,
               MEON              *fileName,
               MEON              *moduleDescription);

UINT32      GetNLMVersionInfo(
               MODULE_HANDLE     *moduleHandle,
               UINT32            *majorVersion,
               UINT32            *minorVersion,
               UINT32            *revision,
               UINT32            *year,
               UINT32            *month,
               UINT32            *day,
               MEON              *copyright);


UINT32      GetSuperHighResolutionTimer(void);

UINT32      GetSystemMemoryMap(
               UINT32            *ArrayOfOffsetLengths,
               UINT32            ArraySize);

UINT32        InputFromScreen(
               SCREEN_HANDLE     *screenID,
               void              *allowedCharacterSet,
               UINT16            bufferLength,
               UINT16            editWidth,
               MEON_STRING       *buffer,
               UINT32            linesToProtect,
               MEON              hasDefaultString,
               void              *defaultString,
               void              *promptText,
               ...);

UINT32        MapAbsoluteAddressToDataOffset(
               UINT32              AbsoluteAddress);

UINT32        MapDataOffsetToAbsoluteAddress(
               UINT32              address);

void        NetWareAlert(
               MODULE_HANDLE           *nlm,
               NetWareAlertStructure   *nwAlert,
               UINT32                  ParameterCount,
               ...);

void        OutputToScreen(
               SCREEN_HANDLE     *ScreenHandle,
               MEON_STRING       *Message,
               ...);

void        OutputToString(
               UINT32            destinationStringLength,
               MEON              *destinationString,
               void              *controlString,
               ...);

UINT32      ParseDriverParameters(
               IO_CONFIG                                 *IOConfig,
               CONFIG_TABLE                              *configuration,
               struct AdapterOptionDefinitionStructure   *adapterOptions,
               void                                      *configLimits,
               MEON                                      *frameTypeDescription[],
               UINT32                                    needBitMap,
               MEON                                      *commandLine,
               struct ScreenStruct                       *screenID);

UINT32      ReadPhysical(
               void   *physicalAddress,
               void   *destination,
               UINT32 numberOfBytes);

UINT32      RegisterForEventNotification(
               RTAG_HANDLE       *resourceTag,
               UINT32            eventType,
               UINT32            priority,
               UINT32            (*warnProcedure)(
                                    void (*OutputRoutine)(
                                       void *controlString,
                                       ...),
                                    UINT32 parameter,
                                    UINT32 callerContext),
               void              (*reportProcedure)(
                                    UINT32 parameter,
                                    UINT32 callerContext),
               UINT32            warnProcCallerContext,
               UINT32            reportProcCallerContext);

REG_TYPE    RegisterHardwareOptions(
               IO_CONFIG         *IOConfig,
               CONFIG_TABLE      *configTable);

void        RemovePollingProcedure(
               void              (*Procedure)(void));



UINT32      SetBusInterrupt(
               void              *BusTag,
               UINT8             hardwareInterruptLevel,
               UINT32            (*InterruptProcedure)(void *MagicNumber),
               RTAG_HANDLE       *RTag,
               UINT8             endOfChainFlag,
               UINT8             shareFlag,
               UINT8             edgeTriggeredFlag,
               UINT8             saveFPUStateFlag,
               void              *MagicNumber);

void        ScheduleSleepAESProcessEvent(
               AES               *AESECB);

void        ShutdownAESCallback(
		struct _DRIVER_DATA_ *driverData,
		CONFIG_TABLE   *configTable);

void        UnRegisterEventNotification(
               UINT32            EventID);

UINT32      WritePhysical(
               const void *source,
               void   *physicalAddress,
               UINT32 numberOfBytes);

/***********************************************************************\
*                                                                       *
* CMSM function prototypes not exported to other modules.               *
*                                                                       *
************************************************************************/
#define CMSMAcquireSpinLock(_spinLock, _sflags)							\
{																						\
  	(_sflags) = DisableAndRetFlags();										\
}
#define CMSMReleaseSpinLock(_spinLock, _sflags)							\
{																						\
	SetFlags((_sflags));															\
}
#define CMSMDelayExecutionThread(_waitTime)								\
{																						\
	CYieldWithDelay();															\
}

ODISTAT	GetMLIDConfiguration(
				UINT32 			boardNumber,
				CONFIG_TABLE	**configTable,
				ECB				*ecb);


ODISTAT	GetMLIDStatistics(
				UINT32 				boardNumber,
				MLID_STATS_TABLE	**statsTable,
				ECB					*ecb);

ODISTAT	AddMulticastAddress (
            UINT32   boardNumber,
				NODE_ADDR *mcAddress,
				ECB		*ecb);


ODISTAT	DeleteMulticastAddress (
				UINT32   boardNumber,
				NODE_ADDR *mcAddress,
				ECB		*ecb);


ODISTAT   MLIDShutdown (
            UINT32 	boardNumber,
            UINT32 	shutdownType,
				ECB		*ecb);


ODISTAT  MLIDReset (
				UINT32 	boardNumber,
				ECB		*ecb);


ODISTAT	SetLookAheadSize (
            UINT32   boardNumber,
            UINT32	requestedSize,
				ECB		*ecb);


ODISTAT	PromiscuousChange(
				UINT32   BoardNumber,
				UINT32   PromiscuousState,
				UINT32   *PromiscuousModes,
				ECB		*ecb);


ODISTAT	RegisterMonitor (
            UINT32   boardNumber,
				void     (_cdecl * TXRMonRoutine)(TCB *),
				ECB		*ecb,
            BOOLEAN  monitorState);


ODISTAT	MLIDManagement (
            UINT32   boardNumber,
            ECB     	*managementECB);

ODISTAT	GetMulticastInfo (
				UINT32	boardNumber,
				ECB		*MulticastInfoECB);

ODISTAT	RemoveNetworkInterface(
				UINT32	boardNumber,
				ECB		*AsyncECB);

ODISTAT	ShutdownNetworkInterface(
				UINT32	boardNumber,
				ECB		*AsyncECB);

ODISTAT	ResetNetworkInterface(
				UINT32	boardNumber,
				ECB		*AsyncECB);

ODISTAT	Reserved(void);

void        CMSMExitToDOS(
               UINT32,
               UINT32);

RTAG_HANDLE *GetResourceTag (
               MODULE_HANDLE        *ModuleHandle,
               const CONFIG_TABLE   *configTable,
               MEON                 *rTagMessage,
               UINT32               rTagSignature);

UINT32      CMSMInterruptProcedure0(
               void *MagicNumber);

UINT32      CMSMInterruptProcedure1(
               void *MagicNumber);

UINT32      CMSMExtraInterruptProcedure(
               void *MagicNumber);

void        CMSMPollingProcedure(void);

void        CMSMAESPollingProcedure(AES_ECB *);	/* TNL 4/10/95	*/

ODISTAT     CMSMRegisterMLIDInternal(
               ADAPTER_DATA      *adapterData,
               CONFIG_TABLE      *configTable);

/* IOCTL routine moved to here for easier access within CMSM.C */
ODISTAT           MLIDShutdown (
                     UINT32               BoardNumber,
                     UINT32               ShutdownType,
                     ECB                  *AsyncECB);


/***********************************************************************\
*                                                                       *
* ODI NBI function prototypes not exported to other modules.               *
*                                                                       *
************************************************************************/

UINT32 GetAlignment(
			UINT32		type);

ODI_NBI	GetBusInfo(
			void			*busTag,
			UINT32		*physicalMemAddrSize,
			UINT32		*IOAddrSize);

ODI_NBI GetBusName(
			void		   *busTag,
			MEON_STRING	**busName);

ODI_NBI GetBusSpecificInfo(
				void 	 *busTag,
				UINT32 size,
				void	 *busSpecificInfo);

ODI_NBI GetBusTag(
			const MEON_STRING	*busName,
			void		**busTag);

ODI_NBI	GetBusType (
				void		*busTag,
				UINT32	*busType );

ODI_NBI	GetCardConfigInfo(
				void			*busTag,
				UINT32		uniqueIdentifier,
				UINT32		size,
				UINT32		parm1,
				UINT32		parm2,
				void			*configInfo);

ODI_NBI GetInstanceNumber(
				void 	 *busTag,
				UINT32 uniqueIdentifier,
				UINT16 *instanceNumber);

ODI_NBI GetInstanceNumberMapping(
				UINT16 instanceNumber,
				void 	 **busTag,
				UINT32 *uniqueIdentifier);

struct NBIConfiguration *GetNBIConfiguration(void);

ODI_NBI	GetSlot(
				void			*busTag,
				MEON_STRING	*slotName,
				UINT16		*slot);

ODI_NBI	GetSlotName(
				void			*busTag,
				UINT16		slot,
				MEON_STRING	**slotName);

ODI_NBI	GetUniqueIdentifier (
           void     *busTag,
			  UINT32   *parameters,
			  UINT32   parameterCount,
			  UINT32   *uniqueIdentifier);

ODI_NBI GetUniqueIdentifierParameters(
				void   *busTag,
				UINT32 uniqueIdentifier,
				UINT32 parameterCount,
				UINT32 *parameters);

ODI_NBI	NBIRequest(
			void *requestInfo);


UINT8    RdConfigSpace8 (
				void		*busTag,
				UINT32	uniqueIdentifier,
				UINT32	offset );

UINT16	RdConfigSpace16 (
				void		*busTag,
				UINT32	uniqueIdentifier,
				UINT32	offset );

UINT32	RdConfigSpace32 (
				void		*busTag,
				UINT32	uniqueIdentifier,
				UINT32	offset );

ODI_NBI	ScanBusInfo (
				UINT32		*scanSequence,
				void			**busTag,
				UINT32		*busType,
				MEON_STRING	**busName );

ODI_NBI	SearchAdapter (
				UINT32		*scanSequence,
				UINT32		busType,
				UINT32		productIDLen,
				const MEON  *productID,
				void        **busTag,
				UINT32      *uniqueIdentifier);

void	WrtConfigSpace8 (
  			void		*busTag,
			UINT32	uniqueIdentifier,
			UINT32	offset,
  			UINT8		writeVal );

void	WrtConfigSpace16 (
  			void		*busTag,
			UINT32	uniqueIdentifier,
			UINT32	offset,
  			UINT16		writeVal );

void	WrtConfigSpace32 (
  			void		*busTag,
			UINT32	uniqueIdentifier,
			UINT32	offset,
  			UINT32		writeVal );


/***********************************************************************\
*                                                                       *
* EXTERNALS					                                                *
*                                                                       *
************************************************************************/

extern	MEON                 **DriverMessages;
extern	FRAME_DATA           **CMSMVirtualBoardArray;
extern	SCREEN_HANDLE   		*CMSMScreenID;

extern	INFO_BLOCK  MLIDIoctls;

extern	ADAPTER_DATA   adapterDataTemplate;	
extern	ADAPTER_DATA	*InstanceListHead;
extern	ADAPTER_DATA	*PollingListHead;
extern	MEON				**DriverMessages;
extern	UINT8				BroadcastAddress[];
extern	UINT32			PollingReIntFlag;
extern	FRAME_DATA     FrameDataTemplate;

extern	UINT32			gBelow16;
extern	UINT32			gBuffersBelow16;

extern	MODULE_HANDLE		*MSMModuleHandle;

extern	LSL_CONFIG_TABLE		*LSLConfigTableptr;

extern   IO_CONFIG            *IOConfigurationList;

extern	EPB               *CMSM_NESL_EPBPtr;
extern	NESL_ECB 			*CMSMConfigTableChangeNECBPtr;
extern	NESL_ECB 			*CMSMDeRegisterResourceNECBPtr;
extern	NESL_ECB 			*CMSMReRegisterHardwareOptionsNECBPtr;
extern   MEON_STRING      NESL_MLID_ShutDown[];
extern   MEON_STRING      NESL_MLID_Reset[];
extern   MEON_STRING      NESL_Service_Suspend[];
extern   MEON_STRING      NESL_Service_Resume[];
extern   NESL_ECB         *CMSMServiceSuspendNECBPtr;
extern   NESL_ECB         *CMSMServiceResumeNECBPtr;
