/***********************************************************************\
*
*   (c) Unpublished Work of Novell, Inc.  All rights reserved.
*
*   THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
*   PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS
*   TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
*   NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
*   AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO
*   APPROPRIATE LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED,
*   PRACTICED, PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED,
*   TRANSLATED, ABRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED,
*   LINKED,RECAST, TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN
*   CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT
*   THE PRIOR WRITTEN CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF
*   THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
*   CRIMINAL AND CIVIL LIABILITY.
*
***********************************************************************
*
*  Name:          	NESL Class and Event Name Definitions
*
*  FileName:	  	NESL_STR.H
*
*  ODI Spec Ver:	1.11
*
*  Description:   	C version of the NESL string header file
*
*  Modification History:
*
*  09-04-96 KRA		Added Service/Status Changed Type of MLID Config Table Change.
*
\***********************************************************************/
#ifndef NESL_STR_H
#define NESL_STR_H

/***********************************************************************
*	Class Names
***********************************************************************/

extern MEON_STRING NESL_Service_Suspend[];
extern MEON_STRING NESL_Service_Resume[];
extern MEON_STRING NESL_ServiceStatus_Change[];
extern MEON_STRING NESL_Suspend_Request[];

/***********************************************************************
*	Event Names for Service Suspend Class
***********************************************************************/

extern MEON_STRING NESL_MLID_ShutDown[];
extern MEON_STRING NESL_MLID_Card_Removal[];
extern MEON_STRING NESL_MLID_Out_Range[];
extern MEON_STRING NESL_MLID_HW_Failure[];
extern MEON_STRING NESL_MLID_Cable_Disconnect[];
extern MEON_STRING NESL_MLID_Media_Access_Denied[];

/***********************************************************************
*	Event Names for Service Resume Class
***********************************************************************/

extern MEON_STRING NESL_MLID_Reset[];
extern MEON_STRING NESL_MLID_Card_Insertion_Complete[];
extern MEON_STRING NESL_MLID_In_Range[];
extern MEON_STRING NESL_MLID_Cable_Reconnect[];

/***********************************************************************
*	Event Names for Service/Status Class
***********************************************************************/

extern MEON_STRING NESL_MLID_Access_Point_Change[];
extern MEON_STRING NESL_MLID_Speed_Change[];
extern MEON_STRING NESL_MLID_Config_Table_Change[];
extern MEON_STRING NESL_MLID_DeRegister_Resource_Change[];
extern MEON_STRING NESL_MLID_ReRegister_Hardware_Options_Change[];
extern MEON_STRING NESL_MLID_Power_Cycle_Hardware[];

/***********************************************************************
*	Event Names for Service Request Class
***********************************************************************/

/* Currently there are no defined events for this class */


#endif
