/***********************************************************************\
*                                                                       *
*   (c) Unpublished Work of Novell, Inc.  All rights reserved.
*
*   THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
*   PROPRIETARY AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS
*   TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A
*   NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
*   AND (II) ENTITIES OTHER THAN NOVELL WHO HAVE ENTERED INTO
*   APPROPRIATE LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED,
*   PRACTICED, PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED,
*   TRANSLATED, ABRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED,
*   LINKED,RECAST, TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN
*   CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF THIS WORK WITHOUT
*   THE PRIOR WRITTEN CONSENT OF NOVELL.  ANY USE OR EXPLOITATION OF
*   THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
*   CRIMINAL AND CIVIL LIABILITY.
*                                                                      
***********************************************************************
*
*  Name:          Parser Header File
*
*  Filename:	  parser.h
*
*  ODI Spec Ver   1.11
*
*  Description:   C version of the Parser Header File
*
*  Modification History:
*
*	05-28-97 KRA	Added #define NO_PARAM_TYPE_SPECIFIED.
*
*	06-03-97 KRA	Added #define MAX_CONV_SPEC_LEN.	
*
\***********************************************************************/


/* Type field defines	*/

#define CUSTOMPARAM    0x0000
#define INTPARAM       0x0001
#define INT1PARAM      0x0002
#define PORTPARAM      0x0003
#define PORT1PARAM     0x0004
#define DMAPARAM       0x0005
#define DMA1PARAM      0x0006
#define MEMPARAM       0x0007
#define MEM1PARAM      0x0008
#define SLOTPARAM      0x0009
#define NODEPARAM      0x000A
#define CHANNELPARAM   0x000B
#define FRAMEPARAM     0x000C
#define BUSPARAM       0x000D
#define NAMEPARAM      0x000E
#define RETRIESPARAM   0x000F
#define BELOW16PARAM   0x0010
#define BUFFERS16PARAM 0x0011

/* Flags field defines	*/

#define NO_PARAM_TYPE_SPECIFIED 0x0000
#define	OPTIONALPARAM		0x0000
#define	REQUIREDPARAM		0x0001
#define	DEFAULTPRESENT		0x0002
#define	KEYWORDPARAM		0x0010 /* KRA */
#define	ENUMPARAM			0x0020
#define	RANGEPARAM			0x0040
#define	STRINGPARAM			0x0080
#define	SHARABLE   			0x0100
#define  PARAMMASK         0x00F3 /* KRA use to be E3 */

/* Needs Bit defines	*/

#define	NEEDS_SLOT				0x00000001
#define	NEEDS_PORT0				0x00000002
#define	NEEDS_PORT_LENGTH0		0x00000004
#define	NEEDS_PORT1				0x00000008
#define	NEEDS_PORT_LENGTH1		0x00000010
#define	NEEDS_MEMORY0			0x00000020
#define	NEEDS_MEMORY_LENGTH0	0x00000040
#define	NEEDS_MEMORY1			0x00000080
#define	NEEDS_MEMORY_LENGTH1	0x00000100
#define	NEEDS_INTERRUPT0		0x00000200
#define	NEEDS_INTERRUPT1		0x00000400
#define	NEEDS_DMA0				0x00000800
#define	NEEDS_DMA1				0x00001000
#define	NEEDS_CHANNEL			0x00002000
#define	CAN_SET_NODE_ADDRESS	0x40000000
#define	MUST_SET_NODE_ADDRESS	0x80000000


/* Parse Types					*/
#define	BADTYPE				0x0000
#define	STRINGTYPE			0x0004
#define	INTTYPE				0x0008
#define	UINTTYPE				0x0010
#define	XINTTYPE				0x0020
#define	TYPEMASK				0x003C



#define	MAX_PROMPT_SIZE	512
#define	MAX_PARAM_LEN		80
#define MAX_CONV_SPEC_LEN	80

#define	ASK_FRAME_DONE			0x000F
#define 	CHECK_MULTICARD_DONE	0x00F0
#define	TSM_FLAG					0xFF00

struct   _CONFIG_TABLE_;

typedef struct _MODULE_TRACK_
{
	struct _MODULE_TRACK_	*NextLink;
   struct _MODULE_HANDLE_	*ModuleHandle;
   struct _CONFIG_TABLE_   *OriginalConfig;
	UINT32						Count;
} MODULE_TRACK;

/* The following declaration is intented to illustrate the form of		*/
/*  a parameter option structure.  An actual declartion will 				*/
/*  probably not include the union since there is no real use for it.*/

typedef struct _PARAMETER_OPTIONS_
{
	UINT32	OptionCount;
	union
	{
		int			NumOptVal[1];
		UINT32	UNumOptVal[1];
		MEON_STRING		*StrOptVal[1];
		MEON_STRING		CharOptVal[1];
	} ENUM_LIST;
} PARAMETER_OPTIONS;

typedef struct _DRIVER_OPTION_
{
	struct _DRIVER_OPTION_	*Link;
	MEON_STRING								*ParseString;
	union
	{
		PARAMETER_OPTIONS	*OptionPtr;
		int								Min;
	} Parameter0;

	union
	{
		UINT32						Range;
		int								Max;
	} Parameter1;

	union
	{
		int								Default;
		MEON_STRING				*StringDefault;
	} Parameter2;

	UINT16							Type;
	UINT16							Flags;
	MEON_STRING								String[MAX_PARAM_LEN];
} DRIVER_OPTION;



