############################################################################
#	Builtins.mak is a generic file used with ODI makefiles. v11.5
#
#  Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
#
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
#
############################################################################
.SILENT 		# Don't echo commands to STDOUT,makes errors easier to spot.
#.SUFFIXES		# Don't use rules not found in makefile.mak
.LIS_COMMENTS	# Strip MAKE comments from Local Input Script.
#.KEEP_LIS       # Keep the temporary file created for the LIS.

TASMOPTIONS		= /l /m /ml /n /q /t /w+ /zi /s /dTASM /d$(UTIL)
TASMDBGOPTIONS	= $(TASMOPTIONS) $(ADBGDEFS)
TASMLINKOPTIONS	= /s /c /n /t

WATCOMCOPTIONS		= /mf /oabehiklmrt /ei /6s /s /we /wx /za /zq /zp1
WATCOMDBGCOPTIONS	= $(WATCOMCOPTIONS)
WATCOMOPTIONS		= /d1 $(WATCOMCOPTIONS)
WATCOMDBGOPTIONS	= /d1+ /d2 $(WATCOMDBGCOPTIONS)

WATCOMDEFINES		= /DIAPX386 /D_WATCOMC_ $(CDEFS)
WATCOMDBGDEFINES	= $(WATCOMDEFINES) $(DBGCDEFS) /DDEBUG

%If %Defined(SYM)
DEBUGSTRING	= Debug Codeview
%Else
DEBUGSTRING	= Debug Novell ALL
%End

# $(DESCRIPTION_TXT) is defined in $(UTIL).MAK
DBGDESCRIPTION =  DEBUG ENG TEST - $(DESCRIPTION_TXT)
ENGDESCRIPTION =  ENG TEST - $(DESCRIPTION_TXT)

%If %Defined(ENGTEST)
    DESCRIPTION = $(ENGDESCRIPTION)
%Else
	DESCRIPTION = $(DESCRIPTION_TXT)
%EndIf

%If %Defined(TXTMSGNAME)
TXT_ONE = $(ENUMSGDIR)\$(TXTMSGNAME).TXT
%EndIf

%If %Defined(TXTMSGNAMETWO)
TXT_TWO = $(ENUMSGDIR)\$(TXTMSGNAMETWO).TXT
%EndIf

#-------------------------------------------------------
#  Macros, Common Directories, Paths and Tool Mappings
#-------------------------------------------------------
SRCDIR = ..\src

EXEDIR = ..\final$(OS)
LSTDIR = ..\lst$(OS)
OBJDIR = ..\obj$(OS)

DBGEXEDIR = ..\final\debug$(OS)
DBGLSTDIR = ..\lst\debug$(OS)
DBGOBJDIR = ..\obj\debug$(OS)

ASMDIR = ..\i386;$(SRCDIR)

MSGDIR = ..\msg

CHTMSGDIR = $(MSGDIR)\cht
CHSMSGDIR = $(MSGDIR)\chs
DEUMSGDIR = $(MSGDIR)\deu
ENUMSGDIR = $(MSGDIR)\enu
ESNMSGDIR = $(MSGDIR)\esn
FEUMSGDIR = $(MSGDIR)\feu
FJPMSGDIR = $(MSGDIR)\fjp
FRAMSGDIR = $(MSGDIR)\fra
ITAMSGDIR = $(MSGDIR)\ita
JPNMSGDIR = $(MSGDIR)\jpn
KORMSGDIR = $(MSGDIR)\kor
PTBMSGDIR = $(MSGDIR)\ptb
RUSMSGDIR = $(MSGDIR)\rus

INCDIR = ..\Shared
IMPDIR = $(SRCDIR)
EXPDIR = $(SRCDIR)

.PATH.nlm = $(EXEDIR);$(DBGEXEDIR)
.PATH.ldi = $(LDIMSGDIR)
.PATH.asm = $(SRCDIR);$(ASMDIR)
.PATH.386 = $(SRCDIR)
.PATH.c   = $(SRCDIR)
.PATH.obj = $(OBJDIR);$(DBGOBJDIR)
.PATH.BIN = $(OBJDIR);$(DBGOBJDIR)
.PATH.xdc = $(OBJDIR);$(DBGOBJDIR)
.PATH.h   = $(INCLUDE);$(INCDIR);$(INDIR)\vinc
.PATH.inc = $(INCLUDE);$(INCDIR);$(INDIR)\vinc
.PATH.txt = $(ENUMSGDIR);
.PATH.msg = $(ENUMSGDIR);$(FJPMSGDIR);$(FEUMSGDIR);$(DEUMSGDIR);$(ESNMSGDIR);$(FRAMSGDIR);$(PTBMSGDIR);$(ITAMSGDIR);$(JPNMSGDIR);$(KORMSGDIR);$(RUSMSGDIR);$(CHTMSGDIR);$(CHSMSGDIR);
.PATH.mdb = $(ENUMSGDIR);$(FJPMSGDIR);$(FEUMSGDIR);$(DEUMSGDIR);$(ESNMSGDIR);$(FRAMSGDIR);$(PTBMSGDIR);$(ITAMSGDIR);$(JPNMSGDIR);$(KORMSGDIR);$(RUSMSGDIR);$(CHTMSGDIR);$(CHSMSGDIR);
.PATH.lst = $(LSTDIR);$(DBGLSTDIR)
.PATH.def = $(SRCDIR)
.PATH.exp = $(SRCDIR)
.PATH.imp = $(SRCDIR)
.PATH.mps = $(SRCDIR)
.PATH.mak = $(SRCDIR)
.PATH.tmp = $(SRCDIR)

%If ("$(SYSVER)" <= "$(DOSVER)")
%If ("$(SYSTEM)" != "OS/2")
MSG16 = YES
%End
%EndIf

%If !%Defined(TOOLS_DRV)
TOOLS_DRV = N:
%EndIf
%If !%Defined(TOOLS_SERVER)
TOOLS_SERVER = PRV-DEV4
%EndIf
%If !%Defined(TOOLS_VOLUME)
TOOLS_VOLUME = DEV:
%EndIf
%If !%Defined(TOOLS_PATH)
TOOLS_PATH = $(TOOLS_SERVER)\$(TOOLS_VOLUME)
%EndIf

%If !%Defined(MSG_TOOLS_DRV)
MSG_TOOLS_DRV = V:
%EndIf
%If !%Defined(MSG_TOOLS_SERVER)
#MSG_TOOLS_SERVER = PRV-CLS-TOOLS
MSG_TOOLS_SERVER = PRV-PROD24
%EndIf
%If !%Defined(MSG_TOOLS_VOLUME)
#MSG_TOOLS_VOLUME = APPS:
MSG_TOOLS_VOLUME = CLS1:
%EndIf
%If !%Defined(MSG_TOOLS_DIR)
#MSG_TOOLS_DIR = Cls
MSG_TOOLS_DIR = ClsTools
%EndIf
%If !%Defined(MSG_TOOLS_PATH)
MSG_TOOLS_PATH = $(MSG_TOOLS_SERVER)\$(MSG_TOOLS_VOLUME)
%EndIf

DOSVER = 7.00
WCC = $(TOOLS_DRV)\Tools\WCC\1100
COMPILE = $(WCC)\Binw
BTCASM = $(TOOLS_DRV)\Tools\Btc\Cpp310.pat\Bin
TASM = $(TOOLS_DRV)\Tools\Tasm\400\Bin
386ASM = $(TOOLS_DRV)\Tools\Pharlap\400\Bin
ASMLINKER = $(TOOLS_DRV)\Tools\Novell\Nlmlinkp
POLYMAKE = $(TOOLS_DRV)\Tools\Polymake\400
CLS_MDB = MDB
CLS_OTHER = OTHER

%If !%Defined(LOC_PATH)
LOC_PATH = $(MSG_TOOLS_DRV)\$(MSG_TOOLS_DIR)\Loc
%EndIf

%If %Defined(MSG16)
MSGTOOLDIR = $(TOOLS_DRV)\Tools\Novell\Msg\16bit
MSGEXTR = $(MSGTOOLDIR)\MSGEXTR
MSGLABEL = $(MSGTOOLDIR)\MSGLABEL
MSGMAKE = $(MSGTOOLDIR)\MSGMAKE
MSGTRAN = $(MSGTOOLDIR)\MSGTRAN
MSGEXP = $(MSGTOOLDIR)\MSGEXP
MSGCHECK = $(MSGTOOLDIR)\MSGCHECK
%Else
MSGTOOLDIR = $(TOOLS_DRV)\Tools\Novell\Msg\32bit
MSGEXTR = $(MSGTOOLDIR)\MSGEXT~1
MSGLABEL = $(MSGTOOLDIR)\MSGLAB~1
MSGMAKE = $(MSGTOOLDIR)\MSGMAK~1
MSGTRAN = $(MSGTOOLDIR)\MSGTRA~1
MSGEXP = $(MSGTOOLDIR)\MSGEXP32
MSGCHECK = $(MSGTOOLDIR)\MSGCHE~1
%EndIf

#-------------------------------------
#       Warning and Error Codes
#-------------------------------------
BEGINRED = [1;31m[5m
BEGINYELLOW = [1;33m[5m
BEGINGREEN = [1;32m[5m
ENDANSI = [0m

WARNINGENG = Not for release!  ENG TEST has been placed in the description!
ERROR275 = Failed, MPX.exe had problems
ERROR270 = Failed, MPX.exe NOT found in $(MPX)
ERROR265 = NWExport Failed, NWExport.exe NOT found in $(NWUTILTOOL)
ERROR260 = NWImport Failed, NWImport.exe NOT found in $(NWUTILTOOL)
ERROR255 = Failed Compiling
ERROR250 = File Not Built
ERROR220 = File Was Not Changed to Read Only, Attrib +r Failed!
ERROR215 = File Was Not Changed to Read-Write, Attrib -r Failed!
ERROR210 = File Does Not Exist!
ERROR205 = File Should Not Exist or Was NOT Deleted!
ERROR200 = File Not Copied
ERROR195 = The MAPPING of $(TOOLS_DRV)$(TOOLS_PATH) FAILED!
ERROR190 = The MAPPING of $(MSG_TOOLS_DRV)$(MSG_TOOLS_PATH) FAILED!
ERROR185 = The MAP DEL of $(TOOLS_DRV)$(TOOLS_PATH) FAILED!
ERROR180 = The MAP DEL of $(MSG_TOOLS_DRV)$(MSG_TOOLS_PATH) FAILED!
ERROR175 = The Variable "CLS_PROD_NAME" was not defined!
ERROR170 = The Variable "CLS_GROUP_NAME" was not defined!
ERROR165 = The Variable "CLS_MOD_NAME" was not defined!
ERROR160 = The Variable "CLS_FORMAT" was not defined!

#------------------------------------
#       Global initializations
#------------------------------------
.PROLOG:  #Performed after reading build script, before comparing timestamps.
#	%Echo $(BEGINYELLOW) Starting PROLOG Routine. $(ENDANSI)
#	%SetEnv TMPSWAP = C:\
	%SetEnv PATH = $(MSGTOOLDIR);$(COMPILE);$(ASMLINKER);$(PATH)
	%SetEnv INCLUDE = $(INCDIR);$(INCDIR)\vinc;..\inc;$(WCC)\h;$(ENUMSGDIR);$(SRCDIR);
	%SetEnv WATCOM = $(WCC)
#	%SetEnv CLS_NO_CLEAN = 1	#Save the temp files created during import/export process.
	%SetEnv CLS_DRIVE = $[c,$(MSG_TOOLS_DRV),1,1]
	%SetEnv CLS_CURRENT_DIR = ..\$(SRCDIR)
	%SetEnv CLS_RESOURCE_DIR = $(MSGDIR)
	%SetEnv CLS_PROD_NAME =	$(CLS_PROD_NAME)
	%SetEnv CLS_GROUP_NAME = $(CLS_GROUP_NAME)
	%SetEnv CLS_MOD_NAME = $(CLS_MOD_NAME)
	%SetEnv CLS_FORMAT = $(CLS_FORMAT)
	%SetEnv CLS_NILE_MOD_NAME = $(CLS_NILE_MOD_NAME)

	%If %Defined(CLEAN)
#		%Echo $(BEGINYELLOW) Starting CLEAN Routine. $(ENDANSI)
		# ---------------------------------------------------------
	    #   Cleaning up the $(UTIL)'s SRC, OBJ and LST directorys
		# ---------------------------------------------------------
		%foreach FILE in $[f,$(SRCDIR),$[w,$(SRCDIR)\*.err],] \
							$[f,$(SRCDIR),$[w,$(SRCDIR)\*.bak],] \
							$[f,$(SRCDIR),$[w,$(SRCDIR)\*.tmp],] \
							$[f,$(SRCDIR),$[w,$(SRCDIR)\*.old],] \
							$[f,$(OBJDIR),$[w,$(OBJDIR)\*.obj],] \
							$[f,$(OBJDIR),$[w,$(OBJDIR)\*.lst],] \
							$[f,$(OBJDIR),$[w,$(OBJDIR)\*.xdc],] \
							$[f,$(OBJDIR),$[w,$(OBJDIR)\*.map],] \
							$[f,$(OBJDIR),$[w,$(OBJDIR)\*.bin],] \
							$[f,$(DBGOBJDIR),$[w,$(DBGOBJDIR)\*.obj],] \
							$[f,$(DBGOBJDIR),$[w,$(DBGOBJDIR)\*.lst],] \
							$[f,$(DBGOBJDIR),$[w,$(DBGOBJDIR)\*.xdc],] \
							$[f,$(DBGOBJDIR),$[w,$(DBGOBJDIR)\*.map],] \
							$[f,$(DBGOBJDIR),$[w,$(DBGOBJDIR)\*.bin],] \
							$[f,$(LSTDIR),$[w,$(LSTDIR)\*.lst],] \
							$[f,$(DBGLSTDIR),$[w,$(DBGLSTDIR)\*.lst],]
			%Do DeleteFile
		%endfor
	%Endif

	%If %Defined(MSG16)
		%Echo Running 16 bit MSG tools
		-@$(MSGTOOLDIR)\btrieve /p:1536 > nul
	%EndIf

#	%Echo $(BEGINYELLOW) Ending PROLOG Routine. $(ENDANSI)

.INIT:	#Performed after reading build script, after comparing timestamps.
	#----------------------------
	#       Drive Mappings
	#----------------------------
	%If %File($(POLYMAKE)\make.exe)
		%Set TOOLS_DRV_EXIST = Y
	%Else
		%Set TOOLS_DRV_EXIST = N
		%Echo MAP ROOT $(TOOLS_DRV)=$(TOOLS_PATH)
		:MAP ROOT $(TOOLS_DRV)=$(TOOLS_PATH)
		%If !%File($(POLYMAKE)\make.exe)
			%Echo ******************************************************
			%Echo $(BEGINRED) $(ERROR195) $(ENDANSI)
			%Echo ******************************************************
			%Exit 195
		%EndIf
	%EndIf

	%If %Defined(MSG)
		%If %File($(LOC_PATH)\loc_in.bat)
			%Set MSG_TOOLS_DRV_EXIST = Y
		%Else
			%Set MSG_TOOLS_DRV_EXIST = N
			%Echo MAP ROOT $(MSG_TOOLS_DRV)=$(MSG_TOOLS_PATH)
			:MAP ROOT $(MSG_TOOLS_DRV)=$(MSG_TOOLS_PATH)
			%If !%File($(LOC_PATH)\loc_in.bat)
				%Echo ******************************************************
				%Echo $(BEGINRED) $(ERROR190) $(ENDANSI)
				%Echo ******************************************************
				%Exit 190
			%EndIf
		%EndIf
	%EndIf

#-------------------------------------------------------------
#       Implicit rules for changing the Attributes for files
#-------------------------------------------------------------
AttributeMinus:
#	%Echo $(BEGINYELLOW) Starting AttributeMinus Routine. $(ENDANSI)
	%If %Exists($(FILE))
		%If !%Writable($(FILE))
			%Set BEFORE += $(FILE)
#			%Echo $(BEGINYELLOW) FILE to ATTRIB -r is $(FILE) $(ENDANSI)
			-Start /m /wait Attrib -r $(FILE)
			%If !%Writable($(FILE))
				%Echo ******************************************************
				%Echo $(BEGINRED) $(FILE) $(ERROR215) $(ENDANSI)
				%Echo ******************************************************
				%Exit 215
			%EndIf
		%EndIf
	%Else
		%Echo **************************************************************
		%Echo $(BEGINRED) $(FILE) $(ERROR210) $(ENDANSI)
		%Echo **************************************************************
		%Exit 210
	%EndIf
#	%Echo $(BEGINYELLOW) Ending AttributeMinus Routine. $(ENDANSI)

AttributeAdd:
#	%Echo $(BEGINYELLOW) Starting AttributeAdd Routine. $(ENDANSI)
	%If %Exists($(FILE))
		%If %member($(FILE),$(BEFORE))
			-Start /m /wait Attrib +r $(FILE)
			%If %Writable($(FILE))
				%Echo ******************************************************
				%Echo $(BEGINRED) $(FILE) $(ERROR220) $(ENDANSI)
				%Echo ******************************************************
				%Exit 220
			%EndIf
			%foreach ADDFILE in $(BEFORE)
				%If "$(FILE)" != "$(ADDFILE)"
					%Set BEFORETEMP += $(ADDFILE)
				%EndIf
			%endfor
			%Set BEFORE = $(BEFORETEMP)
			%Set BEFORETEMP =
		%EndIf
 	%Else
		%Echo **************************************************************
		%Echo $(BEGINRED) $(FILE) $(ERROR210) $(ENDANSI)
		%Echo **************************************************************
		%Exit 210
	%EndIf
#	%Echo $(BEGINYELLOW) Ending AttributeAdd Routine. $(ENDANSI)

DeleteFile:
#	%Echo $(BEGINYELLOW) Starting DeleteFile Routine. $(ENDANSI)
	%If %File($(FILE))
		%Do AttributeMinus
#		%Echo $(BEGINYELLOW) FILE to delete is $(FILE) $(ENDANSI)
		-@DEL $(FILE)
	%EndIf
	%If %File($(FILE))
		%Do AttributeAdd
		%Echo **********************************************************
		%Echo $(BEGINRED) $(FILE), $(ERROR205) $(ENDANSI)
		%Echo **********************************************************
		%Exit 205
	%EndIf
#	%Echo $(BEGINYELLOW) Ending DeleteFile Routine. $(ENDANSI)

#-----------------------------------------------
#       Implicit rules for Compiling .C files
#-----------------------------------------------
.c.obj:
	%Echo
	%Echo ------------------------------------------------------------------
	%If "$[l,$[d,$@]]" != "$[l,$(DBGOBJDIR)]"
		%Set COPT = $(WATCOMOPTIONS) $(WATCOMDEFINES)
		%SetEnv COPT = $(WATCOMOPTIONS) $(WATCOMDEFINES)
		%Echo wcc386 $< /fo=$(OBJDIR)\ /fr=$(SRCDIR)\ $(COPT)
		-$(COMPILE)\wcc386 $< /fo=$(OBJDIR)\ /fr=$(SRCDIR)\ @COPT
		%Do ErrTest
		%Echo $(BEGINGREEN) Watcom WCC386 made $@ $(ENDANSI)
		-$(COMPILE)\wdis $@ /fi /fu /s /l=$[f,$(LSTDIR),$*,lst]
		%Do ErrTest
		%Echo $(BEGINGREEN) Watcom WDIS made $[f,$(LSTDIR),$*,lst] $(ENDANSI)
	%Else
		%Set COPT = $(WATCOMDBGOPTIONS) $(WATCOMDBGDEFINES)
		%SetEnv COPT = $(WATCOMDBGOPTIONS) $(WATCOMDBGDEFINES)
		%Echo wcc386 $< /fo=$(DBGOBJDIR)\ /fr=$(SRCDIR)\ $(COPT)
		-$(COMPILE)\wcc386 $< /fo=$(DBGOBJDIR)\ /fr=$(SRCDIR)\ @COPT
		%Do ErrTest
		%Echo $(BEGINGREEN) Debug version of Watcom WCC386 made $@ $(ENDANSI)
		-$(COMPILE)\wdis $@ /fi /fu /s /l=$[f,$(DBGLSTDIR),$*,lst]
		%Do ErrTest
		%Echo $(BEGINGREEN) Debug version of Watcom WDIS made $[f,$(DBGLSTDIR),$*,lst] $(ENDANSI)
	%EndIf

#------------------------------------------------------
#       Implicit rules for Assembling TASM .ASM files
#------------------------------------------------------
.asm.obj:
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Borland TASM Assembling $< TO $@

	%If "$[l,$[d,$@]]" != "$[l,$(DBGOBJDIR)]"
#		%Echo $(BEGINYELLOW) tasmx $(TASMOPTIONS) /i$(INCDIR) /i$(ENUMSGDIR) $< $@ $(LSTDIR)\$[r, $<] $(ENDANSI)
		-$(TASM)\tasmx $(TASMOPTIONS) <@< 
/i$(INCDIR) /i$(ENUMSGDIR) 
$<
$@
$(LSTDIR)\$[r, $<];
< > $[f,$(SRCDIR),$<,err]
	 	%Do ErrTest
		%Echo $(BEGINGREEN) Borland TASM made $@ $(ENDANSI)

	%Else
#		%Echo $(BEGINYELLOW) tasmx $(TASMDBGOPTIONS) /i$(INCDIR) /i$(ENUMSGDIR) $< $@ $(DBGLSTDIR)\$[r, $<] $(ENDANSI)
		-$(TASM)\tasmx $(TASMDBGOPTIONS) <@< 
/i$(INCDIR) /i$(ENUMSGDIR) 
$<
$@
$(DBGLSTDIR)\$[r, $<];
< > $[f,$(SRCDIR),$<,err]
	 	%Do ErrTest
		%Echo $(BEGINGREEN) Debug version of Borland TASM made $@ $(ENDANSI)
	
	%EndIf

#---------------------------------------------------------
#       Implicit rules for Assembling Pharlap .386 files
#---------------------------------------------------------
.386.obj:
	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Pharlap 386ASM Assembling $< to $@
	%If "$[l,$[d,$@]]" != "$[l,$(DBGOBJDIR)]"
#	%Echo -Object $@ -el $[f,$(SRCDIR),$<,err] -l $[f,$(LSTDIR),$<,lst] -d $(ADEFS) -fullwarn -Twoc -80486P 
    -$(386ASM)\386asm <@<
$<
-Object $@
-Errorlist $[f,$(SRCDIR),$<,err]
-List $[f,$(LSTDIR),$<,lst]
-Include $(INCDIR)\,$(INCDIR)\vinc\\
%If %Defined(ADEFS)
-Define $(ADEFS)
%EndIf
-fullwarn
-Twocase
-80486P
< 
 		%Do ErrTest
		%Echo $(BEGINGREEN) Pharlap 386ASM made $@ $(ENDANSI)

	%Else
#		%Echo -Object $@ -el $[f,$(SRCDIR),$<,err] -l $[f,$(DBGLSTDIR),$<,lst] -d $(DBGADEFS) -fullwarn -Twoc -80486P 
	    -$(386ASM)\386asm <@<
$<
-Object $@
-Errorlist $[f,$(SRCDIR),$<,err]
-List $[f,$(DBGLSTDIR),$<,lst]
-Include $(INCDIR)\,$(INCDIR)\vinc\\
%If %Defined(ADEFS)
-Define $(ADEFS)
%EndIf
%If %Defined(DBGADEFS)
-Define $(DBGADEFS)
%EndIf
-fullwarn
-Twocase
-80486P
< 
	 	%Do ErrTest
		%Echo $(BEGINGREEN) Debug version of Pharlap 386ASM made $@ $(ENDANSI)
	%EndIf

#-----------------------------------------------
#       Implicit rules for Linking .BIN files
#-----------------------------------------------
.asm.bin:

	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Borland TLINK Linking $@
#	%Echo $(BEGINYELLOW) -$(BTCASM)\tlink $(TASMLINKOPTIONS) <@< $(ENDANSI)
	-$(BTCASM)\tlink $(TASMLINKOPTIONS) <@<
$*.obj
$@
$*.map
< > $[f,$(SRCDIR),$<,err]
 		%Do ErrTest
		%Echo $(BEGINGREEN) Borland TLINK made $@ $(ENDANSI)

#----------------------------------------------------
#       Testing for Error Codes, will exit if found
#----------------------------------------------------
ErrTest:
 	%If %Status != 0
		%If %File($[f,$(SRCDIR),$<,err])
#			TYPE $(BEGINYELLOW) $[f,$(SRCDIR),$<,err] $(ENDANSI)
		%End
		%If %File($@)
			-+DEL $@
		%End
		%Echo ********************************************************
		%Echo $(BEGINRED) $< had problems, $< $(ERROR255) $(ENDANSI)
		%Echo ********************************************************
		%Exit 255
	%ElseIf %File($@)
		%If %File($[f,$(SRCDIR),$<,err])
			-+DEL $[f,$(SRCDIR),$<,err]
		%End
	%Else
		%If %File($[f,$(SRCDIR),$<,err])
#			$(BEGINYELLOW) TYPE $[f,$(SRCDIR),$<,err] $(ENDANSI)
		%End
		%Echo ********************************************************
		%Echo $(BEGINRED) $@ had problems, $@ $(ERROR250) $(ENDANSI)
		%Echo ********************************************************
		%Exit 250
	%EndIf

#-------------------------------------------------
#       Rule for building the Localization files
#-------------------------------------------------
CLSMessages:
#	%Echo $(BEGINYELLOW) Starting CLSMessages Routine. $(ENDANSI)
	%If %Defined(MSG)
		%If %Defined(CLS_PROD_NAME)
			%If %Defined(CLS_GROUP_NAME)
				%If %Defined(CLS_MOD_NAME)
					%If %Defined(CLS_FORMAT)
						%If %Member(LDI, $(CLS_LANG))
							%Set CLS_FORMAT_TEMP = $(CLS_FORMAT)
							%Set CLS_MOD_NAME_TEMP = $(CLS_MOD_NAME)
							%Set CLS_CURRENT_DIR_TEMP = $(CLS_CURRENT_DIR)
							%SetEnv CLS_FORMAT = $(CLS_OTHER)
							%SetEnv CLS_MOD_NAME = $(MSGUTILNAME).$(MPXEXT)
							%SetEnv CLS_CURRENT_DIR = $(SRCDIR)
							%SetEnv CLS_ENU_NAME = $(MSGDIR)
#							%Echo $(BEGINYELLOW) Starting -$(LOC_PATH)\loc_in.bat (LDI) $(ENDANSI)
							-$(LOC_PATH)\loc_in.bat
							%Set CLS_LANG_TEMP = $(CLS_LANG)
							%SetEnv CLS_LANG = FRA
							%SetEnv CLS_FRA_NAME = $(MSGDIR)
							%foreach FILE in $[f,$(MSGDIR),$[w,$(MSGDIR)\*.$(MPXEXT)],]
								%Do AttributeMinus
							%endfor
#							%Echo $(BEGINYELLOW) Starting -$(LOC_PATH)\loc_out.bat (LDI) $(ENDANSI)
							-$(LOC_PATH)\loc_out.bat
							%foreach FILE in $[f,$(MSGDIR),$[w,$(MSGDIR)\*.$(MPXEXT)],]
								%Do AttributeAdd
							%endfor
							%SetEnv CLS_FORMAT = $(CLS_FORMAT_TEMP)
							%Set CLS_FORMAT = $(CLS_FORMAT_TEMP)
							%Set CLS_FORMAT_TEMP =
							%SetEnv CLS_MOD_NAME = $(CLS_MOD_NAME_TEMP)
							%Set CLS_MOD_NAME = $(CLS_MOD_NAME_TEMP)
							%Set CLS_MOD_NAME_TEMP =
							%SetEnv CLS_CURRENT_DIR = $(CLS_CURRENT_DIR_TEMP)
							%Set CLS_CURRENT_DIR = $(CLS_CURRENT_DIR_TEMP)
							%Set CLS_CURRENT_DIR_TEMP =
							%SetEnv CLS_LANG = $(CLS_LANG_TEMP)
							%Set CLS_LANG = $(CLS_LANG_TEMP)
							%Set CLS_LANG_TEMP =
							%SetEnv CLS_ENU_NAME =
							%SetEnv CLS_FRA_NAME =
							%foreach LANG in $(CLS_LANG)
								%If "$[l,$(LANG)]" != "$[l,LDI]"
									%Set CLS_LANG_TEMP += $(LANG)
								%EndIf
							%endfor
							%SetEnv CLS_LANG=$(CLS_LANG_TEMP)
							%Set CLS_LANG=$(CLS_LANG_TEMP)
							%Set CLS_LANG_TEMP =
						%EndIf
						%If %Member(ENU, $(CLS_LANG))
#							%Echo $(BEGINYELLOW) Starting -$(LOC_PATH)\loc_in.bat (MBD) $(ENDANSI)
							-$(LOC_PATH)\loc_in.bat
							%Echo
							set | more
							%foreach LANG in $(CLS_LANG)
								%If "$[l,$(LANG)]" != "$[l,ENU]"
									%Set CLS_LANG_TEMP += $(LANG)
								%EndIf
							%endfor
							%SetEnv CLS_LANG=$(CLS_LANG_TEMP)
							%Set CLS_LANG=$(CLS_LANG_TEMP)
							%Set CLS_LANG_TEMP=
						%EndIf
						%If "$[l,$(CLS_LANG)]" != ""
							%foreach FILE in $[f,$(MSGDIR),$[w,$(MSGDIR)\*.$(MPXEXT)],]
								%Do AttributeMinus
							%endfor
#							%Echo $(BEGINYELLOW) Starting -$(LOC_PATH)\loc_out.bat (MBD) $(ENDANSI)
							-:$(LOC_PATH)\loc_out.bat
							%Echo
							%foreach FILE in $[f,$(MSGDIR),$[w,$(MSGDIR)\*.$(MPXEXT)],]
								%Do AttributeAdd
							%endfor
						%EndIf
					%Else
						%Echo ***********************************************
						%Echo $(BEGINRED) $(ERROR160) $(ENDANSI)
						%Echo ***********************************************
						%Exit 160
					%EndIf
				%Else
					%Echo ***************************************************
					%Echo $(BEGINRED) $(ERROR165) $(ENDANSI)
					%Echo ***************************************************
					%Exit 165
				%EndIf
			%Else
				%Echo *******************************************************
				%Echo $(BEGINRED) $(ERROR170) $(ENDANSI)
				%Echo *******************************************************
				%Exit 170
			%EndIf
		%Else
			%Echo ***********************************************************
			%Echo $(BEGINRED) $(ERROR175) $(ENDANSI)
			%Echo ***********************************************************
			%Exit 175
		%EndIf
	%EndIf
#	%Echo $(BEGINYELLOW) Ending CLSMessages Routine. $(ENDANSI)

#--------------------------------------------------
#       Implicit rules for building the mdb files
#--------------------------------------------------
$(ENUMSGDIR)\$(MSGUTILNAME).mdb: $(TXT_ONE) $(TXT_TWO) $[f,$(SRCDIR),$(CFILES),c]
	%Echo ------------------------------------------------------------------
    %Echo Updating and Extracting Messages for the $(ENUMSGDIR)\$(MSGUTILNAME).MDB

	%foreach FILE in $[f,$(ENUMSGDIR),$[w,$(ENUMSGDIR)\$(MSGUTILNAME).MDB],]
		%Do AttributeMinus
	%endfor

	%foreach FILE in $?
		%Do AttributeMinus
			%If !%File($(ENUMSGDIR)\$(MSGUTILNAME).MDB)
				$(MSGMAKE) $(ENUMSGDIR)\$(MSGUTILNAME) $(FILE) $(MSGMAJVER).$(MSGMINVER) 4 v1.0
			%EndIf
		    $(MSGEXTR) -m$(ENUMSGDIR)\$(MSGUTILNAME) -e -r -w -s$(FILE)
			%Do AttributeMinus
	%endfor

	%foreach FILE in $[f,$(ENUMSGDIR),$[w,$(ENUMSGDIR)\$(MSGUTILNAME).MDB],]
		%Do AttributeAdd
	%endfor

#--------------------------------------------------
#       Implicit rules for building the msg files
#--------------------------------------------------
$(CHSMSGDIR)\$(MSGUTILNAME).msg : $(CHSMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = CHINESE-SIMPLIFIED
	%Set LANGID = 1
	%Set BLDMSGDIR = $(CHSMSGDIR)
	%Do Message

$(ENUMSGDIR)\$(MSGUTILNAME).msg : $(ENUMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = ENGLISH
	%Set LANGID = 4
	%Set BLDMSGDIR = $(ENUMSGDIR)
	%Set VAR =
	%Do Message

	%Set LANGUAGE = Europe
	%Set LANGID = 99
	%Set BLDMSGDIR = $(FEUMSGDIR)
	%Do Message

	%Set LANGUAGE = WideRoman
	%Set LANGID = 100
	%Set BLDMSGDIR = $(FJPMSGDIR)
	%Do Message

$(FRAMSGDIR)\$(MSGUTILNAME).msg : $(FRAMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = FRENCH
	%Set LANGID = 6
	%Set BLDMSGDIR = $(FRAMSGDIR)
	%Do Message

$(DEUMSGDIR)\$(MSGUTILNAME).msg : $(DEUMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = GERMAN
	%Set LANGID = 7
	%Set BLDMSGDIR = $(DEUMSGDIR)
	%Do Message

$(ITAMSGDIR)\$(MSGUTILNAME).msg : $(ITAMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = ITALIAN
	%Set LANGID = 8
	%Set BLDMSGDIR = $(ITAMSGDIR)
	%Do Message

$(JPNMSGDIR)\$(MSGUTILNAME).msg : $(JPNMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = JAPANESE
	%Set LANGID = 9
	%Set BLDMSGDIR = $(JPNMSGDIR)
	%Do Message

$(KORMSGDIR)\$(MSGUTILNAME).msg : $(KORMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = KOREAN
	%Set LANGID = 10
	%Set BLDMSGDIR = $(KORMSGDIR)
	%Do Message

$(PTBMSGDIR)\$(MSGUTILNAME).msg : $(PTBMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = PORTUGUESE-BRAZIL
	%Set LANGID = 12
	%Set BLDMSGDIR = $(PTBMSGDIR)
	%Do Message

$(RUSMSGDIR)\$(MSGUTILNAME).msg : $(RUSMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = RUSSIAN
	%Set LANGID = 13
	%Set BLDMSGDIR = $(RUSMSGDIR)
	%Do Message

$(ESNMSGDIR)\$(MSGUTILNAME).msg : $(ESNMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = SPANISH
	%Set LANGID = 14
	%Set BLDMSGDIR = $(ESNMSGDIR)
	%Do Message

$(CHTMSGDIR)\$(MSGUTILNAME).msg : $(CHTMSGDIR)\$(MSGUTILNAME).mdb
	%Set LANGUAGE = CHINESE-TRADITIONAL
	%Set LANGID = 16
	%Set BLDMSGDIR = $(CHTMSGDIR)
	%Do Message

Message:
	%Echo ------------------------------------------------------------------
	%foreach FILE in $[f,$(BLDMSGDIR),$[w,$(BLDMSGDIR)\$(MSGUTILNAME).M*],]
		%Do AttributeMinus
	%endfor

	%If "$[l,$(BLDMSGDIR)]" != "$[l,$(ENUMSGDIR)]"
		%Set VAR = /t
		%If "$[l,$(BLDMSGDIR)]" == "$[l,$(FJPMSGDIR)]" || "$[l,$(BLDMSGDIR)]" == "$[l,$(FEUMSGDIR)]"
			%foreach FILE in $[f,$(BLDMSGDIR),$[w,$(BLDMSGDIR)\$(MSGUTILNAME).MDB],]
				%Do DeleteFile
				-@COPY $[f,$(ENUMSGDIR),$(FILE),] $(BLDMSGDIR) /Y > nul
				%If !%File($(FILE))
					%Do AttributeAdd
					%Echo **********************************************************
					%Echo $(BEGINRED) $(FILE), $(ERROR200) $(ENDANSI)
					%Echo **********************************************************
					%Exit 200
				%EndIf
			%endfor
			%Echo
			%Echo Creating $(BLDMSGDIR)\$(MSGUTILNAME).mdb Translations for $(LANGUAGE)
			$(MSGTRAN) $(BLDMSGDIR)\$(MSGUTILNAME).mdb $(LANGUAGE)
		%End
	%EndIf

	%Echo Update Database Label in $(BLDMSGDIR)\$(MSGUTILNAME).MDB for $(LANGUAGE) ($(LANGID))
	%Echo ------------------------------------------------------------------
		$(MSGLABEL) $(BLDMSGDIR)\$(MSGUTILNAME) $(UTIL).$(UTILEXT) $(MSGMAJVER).$(MSGMINVER) $(LANGID) v1.0

	%Echo
	%Echo ------------------------------------------------------------------
	%Echo Creating the $(BLDMSGDIR)\$(MSGUTILNAME).msg for $(LANGUAGE) ($(LANGID))
	$(MSGEXP) $(BLDMSGDIR)\$(MSGUTILNAME).mdb cstring nlm $(BLDMSGDIR)\$(MSGUTILNAME).msg $(VAR)

	%Echo
	%Echo -------------------------------------------------------------------
	%Echo Checking $(BLDMSGDIR)\$(MSGUTILNAME).MDB Messages for $(LANGUAGE) ($(LANGID))
	$(MSGCHECK) $(BLDMSGDIR)\$(MSGUTILNAME).mdb

	%foreach FILE in $[f,$(BLDMSGDIR),$[w,$(BLDMSGDIR)\$(MSGUTILNAME).M*],]
		%Do AttributeAdd
	%endfor

#----------------------------
#       Global Cleanup
#----------------------------
.EPILOG:	# Performs at the end of the MAKE file.
	%If %Defined(MSG16)
		-@$(MSGTOOLDIR)\butil -stop > nul
	%EndIf

	%If "$[l,$(TOOLS_DRV_EXIST)]" == "$[l,N]"
#		%Echo TOOLS_DRV_EXIST macro is defined as $(TOOLS_DRV_EXIST)
		%Echo DELETEing the Mapping $(TOOLS_PATH)
		:MAP C $(TOOLS_DRV)
		:MAP DEL $(TOOLS_DRV)
		%If %File($(POLYMAKE)\make.exe)
			%Echo ******************************************************
			%Echo $(BEGINRED) $(ERROR185) $(ENDANSI)
			%Echo ******************************************************
			%Exit 185
		%EndIf
	%EndIf

	%If "$[l,$(MSG_TOOLS_DRV_EXIST)]" == "$[l,N]"
#		%Echo MSG_TOOLS_DRV_EXIST macro is defined as $(MSG_TOOLS_DRV_EXIST)
		%Echo DELETEing the Mapping $(MSG_TOOLS_PATH)
#		:MAP C $(MSG_TOOLS_DRV)
		:MAP DEL $(MSG_TOOLS_DRV)
		%If %File($(MPX_PATH)\mpx.exe)
			%Echo ******************************************************
			%Echo $(BEGINRED) $(ERROR180) $(ENDANSI)
			%Echo ******************************************************
			%Exit 180
		%EndIf
	%EndIf