@echo off
cls
REM *******************************************************************
REM     Generic MAKEBAT.BAT for building ODI files
REM
REM   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
REM 
REM	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
REM	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
REM	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
REM	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
REM	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
REM	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
REM	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
REM	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
REM	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION 
REM	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
REM	CRIMINAL AND CIVIL LIABILITY.
REM 
REM *******************************************************************

REM *******************************************************************
REM  Set Default Make settings = Local/EngineeringTest/Final/NoClean
REM *******************************************************************
Set INCFILE=INCFILE.MAK
Set ENGTEST=YES
Set LOCAL=YES
Set DBG=
Set CLEAN=
ECHO INCLUDEFILE=YES > %INCFILE%
goto Parse

:Help
@Echo *******************************************************************
@Echo Parse Command Line for ODI Build Options
@Echo.
@Echo           Command Line Options:
@Echo.
@Echo                 S - Build CodeView Debug version w/ Symbolic Information
@Echo                     By Default the Debug version will be "NOVELL ALL"
@Echo                 L - Build locally on server ODI (Default)
@Echo                 F - No debug or Engineering Test Flags
@Echo                 C - Clean out all .obj modules
@Echo                 A - Build using tools on ATM
@Echo *******************************************************************
goto End

:Parse
if "%1" == ""  goto Build
if "%1" == "/" goto Help
if "%1" == "?" goto Help
if "%1" == "S" goto Sym
if "%1" == "s" goto Sym
if "%1" == "L" goto Local
if "%1" == "l" goto Local
if "%1" == "F" goto Final
if "%1" == "f" goto Final
if "%1" == "C" goto Clean
if "%1" == "c" goto Clean
if "%1" == "a" goto ATM
if "%1" == "A" goto ATM
goto Build

:Next
shift
goto Parse

:Sym
@Echo *****************************************************************
@Echo (S)  Build Debug version with Symbolic Information
@Echo *****************************************************************
ECHO SYM=YES >> %INCFILE%
goto Next

:Local
@Echo *****************************************************************
@Echo (L)  Local tools from server ODI
@Echo *****************************************************************
Set LOCAL=YES
goto Next

:Final
@Echo *******************************************************************
@Echo (F)  Building Final Version-- No Debug or Engineering Test Message
@Echo *******************************************************************
ECHO CLEAN=YES >> %INCFILE%
Set ENGTEST=
Set DBG=

@echo. [1;31m******************************************************************* [0m
@echo. [1;31mVirus scanning directory [0m
@echo. [1;31m******************************************************************* [0m
map n:=.tool.atm.novell: > nul
if exist n:scan\scan.exe goto Scan
if not exist n:scan\scan.exe map DEL n:
goto MapErr

:Scan
n:scan\scan ..\*.* /all /sub /nomem /clean
if not errorlevel 1 goto Ok
goto VirusErr

:Ok
shift
goto Build

:Clean
@Echo *****************************************************************
@Echo (C)  Cleaning pass to delete targets and leftovers
@Echo *****************************************************************
ECHO CLEAN=YES >> %INCFILE%
goto Next

:ATM
@Echo *****************************************************************
@Echo (A)  Build using tools on ATM
@Echo *****************************************************************
Set LOCAL=NO
goto Next

:Build
REM *******************************************************************
REM This Section sets up the Tools and Include Files
REM
REM N:= .Tool.ATM.Novell:
REM       OR
REM N:= ODI\DEV:Tools
REM             
REM     Polymake\400    Polymake                V4.00
REM     Novell\MSG      Novell MSG Tools
REM                         Msglabel            V1.22
REM                         Msgexp              V2.25
REM                         Msgextr             V1.92
REM                         Btrieve             V5.10a
REM                         Butil               V5.12
REM     WCC\1100\Binw   Watcom Compiler         V11.0
REM                     Watcom Disassembler     V11.0
REM                     Watcom Linker           V11.0
REM TASM\400\Bin        Borland Assembler       V4.00
REM Pharlap\400\Bin     Pharlap Assembler       V4.00
REM Novell\NLMLinkp     NLMPACKX                V1.8
REM                     Checkerr                V????
REM Dos\Public          Checkfor                V????
REM *******************************************************************
if "%LOCAL%" == "YES" goto LocalSetup

if exist n:polymake\400\make.exe goto Begin
Map Root n:=.tool.atm.novell:
goto Begin

:LocalSetup
if exist n:polymake\400\make.exe goto Begin
Map Root n:=ODI\Dev:Tools
goto Begin

:Begin
if not exist n:polymake\400\make.exe goto MapErr

Set OLDTMP=%TMP%
Set OLDTEMP=%TEMP%
Set OLDPATH=%PATH%

Set TMP=.
Set TEMP=.
Set PATH=n:Polymake\400;n:Dos\Public;n:WCC\1100\Binw;n:Novell\Nlmlinkp;%PATH%;

call specific.bat %1 %2 %3 %4 %5 %6 %7 %8 %9

REM ******************************************************************
REM      ERROR CHECKING
REM ******************************************************************
If "%E1%" == "YES" goto ErrorOne

if "%ENGTEST%" == "YES" goto EngMsg
goto End

REM ******************************************************************
REM              ERROR ROUTINES
REM ******************************************************************

:ErrorOne
@Echo ******************************************************************
@Echo [1;31m[5mFailed Compiling [0m
@Echo ******************************************************************
goto End

:EngMsg
@Echo *************************************************************************
@Echo [1;31m[5mNot for Release! This file has ENG TEST in the description[0m
@Echo *************************************************************************
goto End

:MapErr
@Echo ******************************************************************
@Echo [1;31m[5mThe MAPPING of the network drive FAILED! [0m
@Echo ******************************************************************
goto End

:VirusErr
@echo. [1;31m******************************************************************* [0m
@echo. [1;31mVirus scanning has found a Virus [0m
@echo. [1;31m******************************************************************* [0m
goto End

:End
If not "%OLDPATH%" == "" Set TMP=%OLDTMP%
If not "%OLDPATH%" == "" Set TEMP=%OLDTEMP%
If not "%OLDPATH%" == "" Set PATH=%OLDPATH%
Set OLDTMP=
Set OLDTEMP=
Set OLDPATH=
Set ENGTEST=
Set DBG=
Set CLEAN=
Set LOCAL=
Set UTIL=
Set MSGUTILNAME=
Set CDEFS=
Set DBGCDEFS=
Set ADEFS=
Set CFILES=
Set AFILES=
Set DESCRIPTION_TXT=
Set COPYRIGHT_TXT=
Set MAJOR_VER=
Set MINOR_VER=
Set REV=
Set MSGMAJVER=
Set MSGMINVER=
Set OS=
Set HFILES=
Set FIRMWARE=
Set FOBJS=
Set OBJS=
Set DEPMODULES=
Set EDIR=
Set ODIR=
Set LDIR=
Set PRODUCT=
Set GROUP=
Set E1=

If exist n:\polymake\400\make.exe map DEL n: > nul
If exist %INCFILE% del %INCFILE%

Set INCFILE=

:Exit
@Echo ******************************************************************
@Echo MAKEBAT.BAT Complete
@Echo ******************************************************************
