############################################################################
#	This CTOKENTSM.MAK is used to control the building of the CTOKENTSM.NLM
#
#		CTOKENTSM.MAK builds the C TOKENTSM.NLM for Client-32, NT & NWServer.
#
#   Copyright (c) Unpublished Work of Novell, Inc. All Rights Reserved
# 
#	THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARTY
#	AND TRADE SECRET INFORMATION OF NOVELL, INC.  ACCESS TO THIS WORK IS
#	RESTRICTED TO (I) NOVELL, INC. EMPLOYEES WHO HAVE A NEED TO KNOW HOW TO
#	PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS AND (II) ENTITIES 
#	OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO APPROPRIATE LICENSE 
#	AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, 
#	COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,
#	EXPANDED, COLLECTED COMPILED LINKED, RECAST, TRANSFORMED OR ADAPTED
#	WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION 
#	OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO 
#	CRIMINAL AND CIVIL LIABILITY.
# 
############################################################################

%If %Defined(ENGTEST)
$(UTIL) : $(ENUMSGDIR)\$(MSGUTILNAME).msg $(EXEDIR)\$(UTIL).nlm
%Else
$(UTIL) : $(ENUMSGDIR)\$(MSGUTILNAME).msg $(DEUMSGDIR)\$(MSGUTILNAME).msg \
			$(ESNMSGDIR)\$(MSGUTILNAME).msg $(FRAMSGDIR)\$(MSGUTILNAME).msg \
			$(PTBMSGDIR)\$(MSGUTILNAME).msg $(ITAMSGDIR)\$(MSGUTILNAME).msg	\
	        $(JPNMSGDIR)\$(MSGUTILNAME).msg $(RUSMSGDIR)\$(MSGUTILNAME).msg	\
			$(CHTMSGDIR)\$(MSGUTILNAME).msg $(CHSMSGDIR)\$(MSGUTILNAME).msg	\
			$(KORMSGDIR)\$(MSGUTILNAME).msg $(EXEDIR)\$(UTIL).nlm
%EndIf

$(ENUMSGDIR)\$(MSGUTILNAME).mdb: $[f,$(SRCDIR),$(CFILES),c] $(ENUMSGDIR)\$(MSGUTILNAME).TXT
	%Do MessageDataBase

$(EXEDIR)\$(UTIL).nlm: $[f,$(OBJDIR),$(OBJS),obj] $(ENUMSGDIR)\$(MSGUTILNAME).msg \
							$(SRCDIR)\ctokentsm.mak $(SRCDIR)\specific.bat
	checkerr
	%If %Exists($(EXEDIR)\$(UTIL).NLM)
		Attrib -r $(EXEDIR)\$(UTIL).NLM
		DEL $(EXEDIR)\$(UTIL).NLM
	%EndIf
	%If %Exists($(EXEDIR)\$(UTIL).MAP)
		Attrib -r $(EXEDIR)\$(UTIL).MAP
		DEL $(EXEDIR)\$(UTIL).MAP
	%EndIf
	%Echo
	%Echo Linking $@
	$(COMPILE)\wlink <@<
format Novell NLM '$(DESCRIPTION)'
%If %Defined(DBG)
$(DEBUGSTRING)
%EndIf
name $(EXEDIR)\$(UTIL)
file $[s,",",$[m,*.obj,$**]]
option copyright $(COPYRIGHT_TXT)
option version = $(MAJOR_VER).$(MINOR_VER).$(REV)
option messages = $(ENUMSGDIR)\$(MSGUTILNAME).msg
option start = CInitializeTokenTSM
option exit = CRemoveTokenTSM
option map = $[f,$(EXEDIR),$@,map]
option caseexact
option quiet
option verbose
option nodefaultlibs
option namelen = 30
%If %Defined(DBG)
%If %Defined(SYM)
option SYMFILE = $[f,$(EXEDIR),$@,sym]
%End
%EndIf

%If "$(OS)" != "NT"
module	CMSM
%End

import	CLSL_ControlStackFilter,	# CLSL APIS imported
		CLSL_FastHoldEvent,
		CLSL_FastSendComplete,
		CLSL_GetStackECB,
		CLSL_HoldEvent,
		CLSL_SendComplete,
		
		CMSMAlloc,	   				# CMSM APIs Imported
		CMSMAllocateRCB,
		CMSMAcquireProtection,
		CMSMEnqueueSend,
		CMSMFree,
		CMSMGetPhysical,
		CMSMGetPhysicalECB,
		CMSMGetNLMVersionInfo,
		CMSMPrintString,
        CMSMParseCTSMParameters,
		CMSMRegisterTSM,
		CMSMReleaseProtection,
		CMSMReturnDriverResources,
		CMSMReturnRCB,
		CMSMReturnPhysicalECB,
        CMSMstrcspn,
        CMSMstrcmp,
        CMSMstrcpy,
        CMSMstrlen,
        CMSMstrstr,
        CMSMstrspn,
		CMSMstrupr,
        CMSMASCIINodeToHex,
		CurrentFrameData,
		CMSMBuildGenericStatStrings,

		MSMBitSwapTable				# Global Variables

%If "$(OS)" == "CLIENT32"
import	CLSL_ServiceEvents,			# CLSL APIS imported
		NiosMemCpy,					# NIOS APIs Imported
		NiosMemSet,
		ReturnMessageInformation,	# OS APIs Imported
		GetNLMVersionInfo
%ElseIf "$(OS)" == "NWSERVER"
import	CMovB,						# OS APIs Added
		CSetB,
		ReturnMessageInformation,
		GetNLMVersionInfo,
		CLSL_ServiceEvents,			# CLSL APIS imported
		NiosMemCpy,					# NIOS APIs Imported
		NiosMemSet
%ElseIf	"$(OS)" == "NT"
import	CMSMReturnMessageInformation
%End

%If %Defined(DBG)
import	CMSMOutMEON,
		CMSMOutUINT16,
		CMSMOutUINT32,
		CMSMOutUINT8 
%endif

export	CTokenTSMBuildTransmitControlBlock,
		CTokenTSMCancelPrioritySend,
		CTokenTSMFastProcessGetRCB,
		CTokenTSMFastRcvComplete,
		CTokenTSMFastRcvCompleteStatus,
		CTokenTSMFastSendComplete,
		CTokenTSMGetConfigInfo,
		CTokenTSMGetHSMIFLevel,
		CTokenTSMGetRCB,
		CTokenTSMProcessGetRCB,
		CTokenTSMRcvComplete,
		CTokenTSMRcvCompleteStatus,
		CTokenTSMRegisterHSM,
		CTokenTSMSendComplete,
		CTokenTSMUpdateMulticast,

		TokenTSMBuildTransmitControlBlock,
		TokenTSMCancelPrioritySend,
		TokenTSMGetConfigInfo,
		TokenTSMGetNextSend,
		TokenTSMGetRCB,
		TokenTSMProcessGetRCB,
		TokenTSMFastProcessGetRCB,
		TokenTSMRcvComplete,
		TokenTSMRcvCompleteStatus,
		TokenTSMFastRcvComplete,
		TokenTSMFastRcvCompleteStatus,
		TokenTSMRegisterHSM,
		TokenTSMSendComplete,
		TokenTSMFastSendComplete,
		TokenTSMUpdateMulticast,
		TokenTSMGetASMHSMIFLevel

%If "$(OS)" == "NWSERVER"
export	CTokenTSMGetNextSend
%Else
%If %Defined(DBG)
export	MediaAddMulticast,
		MediaDeleteMulticast
%endif
%End

<
	%If %File($(EXEDIR)\$(UTIL).NLM)
		Attrib +r $(EXEDIR)\$(UTIL).NLM
		Attrib +r $(EXEDIR)\$(UTIL).MAP
	%Else
		%Exit 255
	%End

	%Echo Finished Building -- "$(DESCRIPTION)"
	%Echo in Directory $@
   	%Echo
